/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     TYPE_NAME = 259,
     LITERAL = 260,
     STRING_LITERAL = 261,
     ELLIPSES = 262,
     MUL_ASSIGN = 263,
     DIV_ASSIGN = 264,
     MOD_ASSIGN = 265,
     ADD_ASSIGN = 266,
     SUB_ASSIGN = 267,
     LEFT_ASSIGN = 268,
     RIGHT_ASSIGN = 269,
     AND_ASSIGN = 270,
     XOR_ASSIGN = 271,
     OR_ASSIGN = 272,
     EQ_OP = 273,
     NE_OP = 274,
     PTR_OP = 275,
     AND_OP = 276,
     OR_OP = 277,
     DEC_OP = 278,
     INC_OP = 279,
     LE_OP = 280,
     GE_OP = 281,
     LEFT_SHIFT = 282,
     RIGHT_SHIFT = 283,
     SIZEOF = 284,
     TYPEDEF = 285,
     EXTERN = 286,
     STATIC = 287,
     AUTO = 288,
     REGISTER = 289,
     CONST = 290,
     VOLATILE = 291,
     VOID = 292,
     INLINE = 293,
     CHAR = 294,
     SHORT = 295,
     INT = 296,
     LONG = 297,
     SIGNED = 298,
     UNSIGNED = 299,
     FLOAT = 300,
     DOUBLE = 301,
     BOOL = 302,
     STRUCT = 303,
     UNION = 304,
     ENUM = 305,
     CASE = 306,
     DEFAULT = 307,
     IF = 308,
     ELSE = 309,
     SWITCH = 310,
     WHILE = 311,
     DO = 312,
     FOR = 313,
     GOTO = 314,
     CONTINUE = 315,
     BREAK = 316,
     RETURN = 317,
     ASM = 318
   };
#endif
#define IDENTIFIER 258
#define TYPE_NAME 259
#define LITERAL 260
#define STRING_LITERAL 261
#define ELLIPSES 262
#define MUL_ASSIGN 263
#define DIV_ASSIGN 264
#define MOD_ASSIGN 265
#define ADD_ASSIGN 266
#define SUB_ASSIGN 267
#define LEFT_ASSIGN 268
#define RIGHT_ASSIGN 269
#define AND_ASSIGN 270
#define XOR_ASSIGN 271
#define OR_ASSIGN 272
#define EQ_OP 273
#define NE_OP 274
#define PTR_OP 275
#define AND_OP 276
#define OR_OP 277
#define DEC_OP 278
#define INC_OP 279
#define LE_OP 280
#define GE_OP 281
#define LEFT_SHIFT 282
#define RIGHT_SHIFT 283
#define SIZEOF 284
#define TYPEDEF 285
#define EXTERN 286
#define STATIC 287
#define AUTO 288
#define REGISTER 289
#define CONST 290
#define VOLATILE 291
#define VOID 292
#define INLINE 293
#define CHAR 294
#define SHORT 295
#define INT 296
#define LONG 297
#define SIGNED 298
#define UNSIGNED 299
#define FLOAT 300
#define DOUBLE 301
#define BOOL 302
#define STRUCT 303
#define UNION 304
#define ENUM 305
#define CASE 306
#define DEFAULT 307
#define IF 308
#define ELSE 309
#define SWITCH 310
#define WHILE 311
#define DO 312
#define FOR 313
#define GOTO 314
#define CONTINUE 315
#define BREAK 316
#define RETURN 317
#define ASM 318




/* Copy the first part of user declarations.  */
#line 1 "./parse.y"

/***************************************
  $Header: /home/amb/cxref/src/RCS/parse.y 1.49 2004/09/04 16:15:40 amb Exp $

  C Cross Referencing & Documentation tool. Version 1.6.

  C parser.
  ******************/ /******************
  Written by Andrew M. Bishop

  This file Copyright 1995,96,97,98,99,2000,01,02,03,04 Andrew M. Bishop
  It may be distributed under the GNU Public License, version 2, or
  any higher version.  See section COPYING of the GNU Public license
  for conditions under which this file may be redistributed.
  ***************************************/

#include <string.h>
#include "parse-yy.h"
#include "cxref.h"
#include "memory.h"

/*+ A structure to hold the information about an object. +*/
typedef struct _stack
{
 char *name;                    /*+ The name of the object. +*/
 char *type;                    /*+ The type of the object. +*/
 char *qual;                    /*+ The type qualifier of the object. +*/
}
stack;

#define yylex cxref_yylex

static int cxref_yylex(void);

static void yyerror(char *s);

/*+ When in a header file, some stuff can be skipped over quickly. +*/
extern int in_header;

/*+ A flag that is set to true when typedef is seen in a statement. +*/
int in_typedef=0;

/*+ The scope of the function / variable that is being examined. +*/
static int scope;

/*+ The variable must be LOCAL or EXTERNAL or GLOBAL, so this checks and sets that. +*/
#define SCOPE ( scope&(LOCAL|EXTERNAL|EXTERN_H|EXTERN_F) ? scope : scope|GLOBAL )

/*+ When in a function or a function definition, the behaviour is different. +*/
static int in_function=0,in_funcdef=0,in_funcbody=0;

/*+ The parsing stack +*/
static stack first={NULL,NULL,NULL},  /*+ first value. +*/
            *list=NULL,               /*+ list of all values. +*/
            *current=&first;          /*+ current values. +*/

/*+ The depth of the stack +*/
static int depth=0,             /*+ currently in use. +*/
           maxdepth=0;          /*+ total malloced. +*/

/*+ Declarations that are in the same statement share this comment. +*/
static char* common_comment=NULL;

/*+ When inside a struct / union / enum definition, this is the depth. +*/
static int in_structunion=0;

/*+ When inside a struct / union definition, this is the component type. +*/
static char *comp_type=NULL;

/*+ To solve the problem where a type name is used as an identifier. +*/
static int in_type_spec=0;


/*++++++++++++++++++++++++++++++++++++++
  Reset the current level on the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void reset(void)
{
 current->name=NULL;
 current->type=NULL;
 current->qual=NULL;
}


/*++++++++++++++++++++++++++++++++++++++
  Push a level onto the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void push(void)
{
 if(list==NULL)
   {
    list=(stack*)Malloc(8*sizeof(struct _stack));
    list[0]=first;
    maxdepth=8;
   }
 else if(depth==(maxdepth-1))
   {
    list=Realloc(list,(maxdepth+8)*sizeof(struct _stack));
    maxdepth+=8;
   }

 depth++;
 current=&list[depth];

 reset();
}


/*++++++++++++++++++++++++++++++++++++++
  Pop a level from the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void pop(void)
{
 reset();

 depth--;
 current=&list[depth];
}


/*++++++++++++++++++++++++++++++++++++++
  Reset the Parser, ready for the next file.
  ++++++++++++++++++++++++++++++++++++++*/

void ResetParser(void)
{
 in_typedef=0;
 scope=0;
 in_function=0;
 in_funcdef=0;
 in_funcbody=0;
 depth=0;
 maxdepth=0;
 if(list) Free(list);
 list=NULL;
 current=&first;
 reset();
 common_comment=NULL;
 in_structunion=0;
 comp_type=NULL;
 in_type_spec=0;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 361 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  92
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1744

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  88
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  172
/* YYNRULES -- Number of rules. */
#define YYNRULES  383
/* YYNRULES -- Number of states. */
#define YYNSTATES  582

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    87,     2,     2,     2,    85,    79,     2,
      73,    74,    75,    82,    65,    83,    70,    84,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    69,    64,
      80,    66,    81,    76,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    71,     2,    72,    78,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    67,    77,    68,    86,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    13,    15,    17,
      19,    21,    24,    28,    31,    33,    35,    38,    40,    43,
      45,    48,    50,    51,    56,    58,    60,    63,    66,    70,
      73,    75,    78,    82,    87,    89,    93,    95,    99,   104,
     109,   115,   117,   121,   123,   126,   128,   132,   135,   139,
     143,   148,   151,   155,   159,   164,   166,   169,   171,   174,
     177,   181,   183,   187,   189,   191,   193,   197,   198,   199,
     206,   208,   210,   212,   214,   216,   218,   220,   222,   225,
     227,   229,   231,   233,   235,   237,   239,   241,   243,   245,
     247,   249,   251,   254,   257,   259,   262,   265,   267,   269,
     271,   273,   275,   277,   279,   281,   283,   285,   288,   290,
     292,   293,   299,   300,   307,   309,   312,   314,   318,   320,
     324,   326,   329,   331,   333,   335,   337,   338,   344,   345,
     352,   355,   357,   359,   361,   363,   364,   370,   371,   378,
     381,   383,   385,   386,   388,   390,   393,   395,   398,   401,
     403,   404,   409,   410,   416,   417,   423,   425,   429,   431,
     433,   435,   438,   442,   444,   446,   448,   449,   453,   455,
     457,   460,   463,   467,   469,   471,   475,   478,   483,   484,
     490,   492,   493,   495,   497,   499,   503,   505,   509,   511,
     515,   518,   520,   523,   525,   527,   529,   531,   533,   535,
     537,   539,   541,   543,   545,   547,   548,   549,   555,   556,
     558,   560,   563,   565,   567,   569,   571,   579,   585,   587,
     589,   591,   599,   605,   608,   612,   616,   620,   625,   630,
     635,   641,   647,   650,   653,   656,   659,   664,   666,   668,
     670,   676,   679,   682,   685,   689,   691,   694,   698,   700,
     702,   706,   708,   710,   714,   720,   722,   724,   726,   728,
     730,   732,   734,   736,   738,   740,   742,   744,   750,   755,
     757,   761,   763,   767,   769,   773,   775,   779,   781,   785,
     787,   791,   793,   795,   797,   801,   803,   805,   807,   809,
     811,   815,   817,   819,   821,   825,   827,   829,   831,   835,
     837,   839,   841,   843,   845,   847,   849,   851,   853,   855,
     857,   859,   861,   863,   866,   869,   874,   881,   888,   891,
     894,   897,   900,   905,   908,   911,   914,   916,   918,   920,
     922,   924,   926,   928,   930,   932,   936,   940,   944,   949,
     953,   958,   961,   964,   969,   971,   973,   975,   977,   979,
     982,   986,   987,   988,   994,   996,   998,  1002,  1008,  1016,
    1026,  1038,  1040,  1043,  1046,  1047,  1049,  1053,  1058,  1059,
    1061,  1065,  1070,  1073,  1075,  1079,  1080,  1082,  1086,  1090,
    1096,  1101,  1108,  1110
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      89,     0,    -1,    -1,    90,    -1,    91,    -1,    90,    91,
      -1,    93,    -1,   162,    -1,   249,    -1,   200,    -1,    93,
      -1,    92,    93,    -1,    94,    96,    64,    -1,    94,    64,
      -1,    95,    -1,   115,    -1,   115,    95,    -1,   118,    -1,
     118,    95,    -1,   117,    -1,   117,    95,    -1,    98,    -1,
      -1,    96,    65,    97,    98,    -1,    99,    -1,   107,    -1,
     107,   254,    -1,   107,   100,    -1,   107,   254,   100,    -1,
      66,   101,    -1,   204,    -1,    67,    68,    -1,    67,   102,
      68,    -1,    67,   102,    65,    68,    -1,   103,    -1,   102,
      65,   103,    -1,   101,    -1,   161,    69,   101,    -1,    70,
     161,    66,   101,    -1,    71,   104,    72,   101,    -1,    71,
     104,    72,    66,   101,    -1,   247,    -1,   247,     7,   247,
      -1,   108,    -1,   108,   106,    -1,   106,    -1,    73,   105,
      74,    -1,    71,    72,    -1,   106,    71,    72,    -1,    71,
     247,    72,    -1,   106,    71,   247,    72,    -1,    73,    74,
      -1,   106,    73,    74,    -1,    73,   173,    74,    -1,   106,
      73,   173,    74,    -1,   109,    -1,   108,   109,    -1,    75,
      -1,    75,   116,    -1,    75,   108,    -1,    75,   116,   108,
      -1,   110,    -1,    73,   107,    74,    -1,   111,    -1,   168,
      -1,     3,    -1,   109,    71,    72,    -1,    -1,    -1,   109,
      71,   112,   247,   113,    72,    -1,     3,    -1,    33,    -1,
      31,    -1,    34,    -1,    32,    -1,    30,    -1,    38,    -1,
     117,    -1,   116,   117,    -1,    35,    -1,    36,    -1,   119,
      -1,   127,    -1,   120,    -1,   121,    -1,   123,    -1,   137,
      -1,   124,    -1,   143,    -1,   125,    -1,    45,    -1,    46,
      -1,    46,    42,    -1,    42,    46,    -1,   122,    -1,   122,
     117,    -1,   121,   122,    -1,    43,    -1,    44,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    47,    -1,     4,
      -1,    37,    -1,    94,    -1,    94,   105,    -1,   128,    -1,
     135,    -1,    -1,    50,    67,   129,   131,    68,    -1,    -1,
      50,   136,    67,   130,   131,    68,    -1,   132,    -1,   132,
      65,    -1,   133,    -1,   132,    65,   133,    -1,   134,    -1,
     134,    66,   204,    -1,     3,    -1,    50,   136,    -1,     3,
      -1,     4,    -1,   138,    -1,   141,    -1,    -1,    48,    67,
     139,   149,    68,    -1,    -1,    48,   142,    67,   140,   149,
      68,    -1,    48,   142,    -1,     3,    -1,     4,    -1,   144,
      -1,   147,    -1,    -1,    49,    67,   145,   149,    68,    -1,
      -1,    49,   148,    67,   146,   149,    68,    -1,    49,   148,
      -1,     3,    -1,     4,    -1,    -1,   150,    -1,   151,    -1,
     150,   151,    -1,    64,    -1,   138,    64,    -1,   144,    64,
      -1,   152,    -1,    -1,   118,   153,   156,    64,    -1,    -1,
     116,   118,   154,   156,    64,    -1,    -1,   118,   116,   155,
     156,    64,    -1,   157,    -1,   156,    65,   157,    -1,   158,
      -1,   159,    -1,   107,    -1,    69,   160,    -1,   107,    69,
     160,    -1,   204,    -1,     3,    -1,     4,    -1,    -1,   164,
     163,   177,    -1,   165,    -1,   166,    -1,    94,   166,    -1,
     166,    92,    -1,    94,   166,    92,    -1,   167,    -1,   168,
      -1,    73,   168,    74,    -1,   108,   168,    -1,   108,    73,
     168,    74,    -1,    -1,   170,    73,   169,   171,    74,    -1,
     109,    -1,    -1,   173,    -1,   172,    -1,     3,    -1,   172,
      65,     3,    -1,   174,    -1,   174,    65,     7,    -1,   175,
      -1,   174,    65,   175,    -1,    94,   107,    -1,    94,    -1,
      94,   105,    -1,   249,    -1,   177,    -1,   183,    -1,   186,
      -1,   191,    -1,   195,    -1,   196,    -1,   197,    -1,   198,
      -1,   199,    -1,   200,    -1,   201,    -1,    -1,    -1,    67,
     178,   180,   179,    68,    -1,    -1,   181,    -1,   182,    -1,
     181,   182,    -1,   176,    -1,    93,    -1,   185,    -1,   184,
      -1,    53,    73,   202,    74,   176,    54,   176,    -1,    53,
      73,   202,    74,   176,    -1,   187,    -1,   188,    -1,   190,
      -1,    57,   176,    56,    73,   202,    74,    64,    -1,    58,
      73,   189,    74,   176,    -1,    64,    64,    -1,   202,    64,
      64,    -1,    64,   202,    64,    -1,    64,    64,   202,    -1,
      64,   202,    64,   202,    -1,   202,    64,    64,   202,    -1,
     202,    64,   202,    64,    -1,   202,    64,   202,    64,   202,
      -1,    56,    73,   202,    74,   176,    -1,   192,    69,    -1,
     194,    69,    -1,   193,    69,    -1,    51,   247,    -1,    51,
     247,     7,   247,    -1,    52,    -1,     3,    -1,     4,    -1,
      55,    73,   202,    74,   176,    -1,    61,    64,    -1,    60,
      64,    -1,   202,    64,    -1,    59,     3,    64,    -1,    64,
      -1,    62,    64,    -1,    62,   202,    64,    -1,   203,    -1,
     204,    -1,   203,    65,   204,    -1,   206,    -1,   255,    -1,
     222,   205,   204,    -1,   222,   205,    67,   256,    68,    -1,
      66,    -1,     8,    -1,     9,    -1,    10,    -1,    11,    -1,
      12,    -1,    13,    -1,    14,    -1,    15,    -1,    16,    -1,
      17,    -1,   207,    -1,   207,    76,   202,    69,   206,    -1,
     207,    76,    69,   206,    -1,   208,    -1,   207,    22,   208,
      -1,   209,    -1,   208,    21,   209,    -1,   210,    -1,   209,
      77,   210,    -1,   211,    -1,   210,    78,   211,    -1,   212,
      -1,   211,    79,   212,    -1,   214,    -1,   212,   213,   214,
      -1,    18,    -1,    19,    -1,   216,    -1,   214,   215,   216,
      -1,    80,    -1,    25,    -1,    81,    -1,    26,    -1,   218,
      -1,   216,   217,   218,    -1,    27,    -1,    28,    -1,   220,
      -1,   218,   219,   220,    -1,    82,    -1,    83,    -1,   222,
      -1,   220,   221,   222,    -1,    75,    -1,    84,    -1,    85,
      -1,   223,    -1,   224,    -1,   225,    -1,   226,    -1,   227,
      -1,   228,    -1,   229,    -1,   230,    -1,   231,    -1,   232,
      -1,   233,    -1,    79,   222,    -1,    86,   222,    -1,    73,
     126,    74,   222,    -1,    73,   126,    74,    67,   256,    68,
      -1,    73,   126,    74,    67,   259,    68,    -1,    75,   222,
      -1,    87,   222,    -1,    23,   222,    -1,    24,   222,    -1,
      29,    73,   126,    74,    -1,    29,   222,    -1,    83,   222,
      -1,    82,   222,    -1,   234,    -1,   237,    -1,   238,    -1,
     239,    -1,   240,    -1,   241,    -1,   242,    -1,   235,    -1,
     236,    -1,   233,    70,   161,    -1,   233,    20,   161,    -1,
     233,    73,    74,    -1,   233,    73,   248,    74,    -1,   114,
      73,    74,    -1,   114,    73,   248,    74,    -1,   233,    23,
      -1,   233,    24,    -1,   233,    71,   202,    72,    -1,   114,
      -1,     5,    -1,   243,    -1,   244,    -1,     6,    -1,   243,
       6,    -1,    73,   202,    74,    -1,    -1,    -1,    73,   245,
     177,   246,    74,    -1,   202,    -1,   204,    -1,   248,    65,
     204,    -1,   250,    73,   243,    74,    64,    -1,   250,    73,
     243,    69,   251,    74,    64,    -1,   250,    73,   243,    69,
     251,    69,   251,    74,    64,    -1,   250,    73,   243,    69,
     251,    69,   251,    69,   253,    74,    64,    -1,    63,    -1,
      63,    36,    -1,    36,    63,    -1,    -1,   252,    -1,   251,
      65,   252,    -1,   243,    73,   202,    74,    -1,    -1,   243,
      -1,   253,    65,   243,    -1,    63,    73,   243,    74,    -1,
      21,   194,    -1,   257,    -1,   256,    65,   257,    -1,    -1,
     204,    -1,    67,   256,    68,    -1,   161,    69,   204,    -1,
     161,    69,    67,   256,    68,    -1,    70,   161,    66,   204,
      -1,    70,   161,    66,    67,   256,    68,    -1,   258,    -1,
     259,    65,   258,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   168,   168,   170,   174,   175,   179,   181,   183,   184,
     190,   192,   198,   200,   205,   211,   212,   214,   216,   219,
     220,   227,   228,   228,   232,   278,   279,   280,   281,   285,
     289,   290,   291,   292,   296,   297,   301,   302,   303,   304,
     305,   309,   310,   317,   318,   320,   324,   327,   329,   331,
     333,   335,   337,   339,   341,   348,   350,   355,   356,   358,
     360,   365,   366,   370,   371,   375,   382,   384,   384,   384,
     391,   395,   397,   402,   404,   406,   410,   415,   416,   421,
     423,   430,   435,   436,   437,   438,   439,   440,   441,   442,
     446,   447,   448,   450,   455,   456,   458,   463,   464,   465,
     466,   467,   468,   472,   476,   480,   484,   486,   493,   494,
     499,   498,   512,   511,   527,   528,   532,   533,   538,   540,
     545,   549,   554,   555,   561,   562,   567,   566,   580,   579,
     595,   600,   601,   607,   608,   613,   612,   626,   625,   641,
     646,   647,   652,   654,   658,   659,   664,   665,   668,   671,
     676,   675,   680,   679,   684,   683,   690,   692,   698,   699,
     703,   708,   710,   715,   719,   720,   729,   728,   735,   757,
     758,   760,   761,   768,   773,   774,   775,   777,   783,   782,
     793,   802,   804,   805,   809,   811,   817,   818,   824,   827,
     833,   835,   837,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   862,   864,   861,   868,   870,
     874,   875,   879,   880,   887,   888,   892,   896,   902,   903,
     904,   908,   912,   916,   917,   918,   919,   920,   921,   922,
     923,   927,   933,   934,   935,   939,   940,   944,   948,   949,
     955,   961,   965,   969,   973,   977,   981,   982,   988,   994,
     995,  1002,  1003,  1004,  1005,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1024,  1025,  1027,  1034,
    1035,  1042,  1043,  1050,  1051,  1058,  1059,  1066,  1067,  1074,
    1075,  1079,  1080,  1086,  1087,  1091,  1092,  1093,  1094,  1100,
    1101,  1105,  1106,  1112,  1113,  1117,  1118,  1124,  1125,  1129,
    1130,  1131,  1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,  1146,  1147,  1151,  1155,  1160,  1162,  1163,  1167,  1171,
    1176,  1180,  1184,  1186,  1191,  1196,  1203,  1204,  1205,  1207,
    1208,  1209,  1210,  1214,  1215,  1219,  1223,  1227,  1228,  1232,
    1233,  1237,  1241,  1245,  1249,  1251,  1252,  1253,  1256,  1257,
    1261,  1263,  1263,  1263,  1269,  1273,  1274,  1282,  1283,  1284,
    1285,  1289,  1290,  1291,  1294,  1296,  1297,  1301,  1304,  1306,
    1307,  1311,  1317,  1323,  1324,  1327,  1329,  1330,  1334,  1335,
    1336,  1337,  1341,  1342
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "TYPE_NAME", "LITERAL",
  "STRING_LITERAL", "ELLIPSES", "MUL_ASSIGN", "DIV_ASSIGN", "MOD_ASSIGN",
  "ADD_ASSIGN", "SUB_ASSIGN", "LEFT_ASSIGN", "RIGHT_ASSIGN", "AND_ASSIGN",
  "XOR_ASSIGN", "OR_ASSIGN", "EQ_OP", "NE_OP", "PTR_OP", "AND_OP", "OR_OP",
  "DEC_OP", "INC_OP", "LE_OP", "GE_OP", "LEFT_SHIFT", "RIGHT_SHIFT",
  "SIZEOF", "TYPEDEF", "EXTERN", "STATIC", "AUTO", "REGISTER", "CONST",
  "VOLATILE", "VOID", "INLINE", "CHAR", "SHORT", "INT", "LONG", "SIGNED",
  "UNSIGNED", "FLOAT", "DOUBLE", "BOOL", "STRUCT", "UNION", "ENUM", "CASE",
  "DEFAULT", "IF", "ELSE", "SWITCH", "WHILE", "DO", "FOR", "GOTO",
  "CONTINUE", "BREAK", "RETURN", "ASM", "';'", "','", "'='", "'{'", "'}'",
  "':'", "'.'", "'['", "']'", "'('", "')'", "'*'", "'?'", "'|'", "'^'",
  "'&'", "'<'", "'>'", "'+'", "'-'", "'/'", "'%'", "'~'", "'!'", "$accept",
  "file", "program", "top_level_declaration", "declaration_list",
  "declaration", "declaration_specifiers", "declaration_specifiers1",
  "initialized_declarator_list", "@1", "initialized_declarator",
  "initialized_declarator1", "initializer_part", "initializer",
  "initializer_list", "named_initializer", "named_initializer_index",
  "abstract_declarator", "direct_abstract_declarator", "declarator",
  "pointer", "direct_declarator", "simple_declarator", "array_declarator",
  "@2", "@3", "name", "storage_class_specifier", "type_qualifier_list",
  "type_qualifier", "type_specifier", "type_specifier1",
  "floating_type_specifier", "integer_type_specifier",
  "integer_type_specifier_part", "boolean_type_specifier", "typedef_name",
  "void_type_specifier", "type_name", "enumeration_type_specifier",
  "enumeration_type_definition", "@4", "@5", "enumeration_definition_list",
  "enumeration_definition_list1", "enumeration_constant_definition",
  "enumeration_constant", "enumeration_type_reference", "enumeration_tag",
  "structure_type_specifier", "structure_type_definition", "@6", "@7",
  "structure_type_reference", "structure_tag", "union_type_specifier",
  "union_type_definition", "@8", "@9", "union_type_reference", "union_tag",
  "field_list", "field_list1", "field_list2", "component_declaration",
  "@10", "@11", "@12", "component_declarator_list", "component_declarator",
  "simple_component", "bit_field", "width", "component_name",
  "function_definition", "@13", "function_specifier",
  "function_specifier1", "function_declarator", "function_declarator0",
  "function_direct_declarator", "@14", "function_declarator1",
  "function_declarator2", "identifier_list", "parameter_type_list",
  "parameter_list", "parameter_declaration", "statement",
  "compound_statement", "@15", "@16", "compound_statement_body",
  "block_item_list", "block_item", "conditional_statement",
  "if_else_statement", "if_statement", "iterative_statement",
  "do_statement", "for_statement", "for_expressions", "while_statement",
  "labeled_statement", "case_label", "default_label", "named_label",
  "switch_statement", "break_statement", "continue_statement",
  "expression_statement", "goto_statement", "null_statement",
  "return_statement", "expression", "comma_expression",
  "assignment_expression", "assignment_op", "conditional_expression",
  "logical_or_expression", "logical_and_expression",
  "bitwise_or_expression", "bitwise_xor_expression",
  "bitwise_and_expression", "equality_expression", "equality_op",
  "relational_expression", "relational_op", "shift_expression", "shift_op",
  "additive_expression", "add_op", "multiplicative_expression", "mult_op",
  "unary_expression", "address_expression", "bitwise_negation_expression",
  "cast_expression", "indirection_expression",
  "logical_negation_expression", "predecrement_expression",
  "preincrement_expression", "sizeof_expression", "unary_minus_expression",
  "unary_plus_expression", "postfix_expression",
  "component_selection_expression", "direct_component_selection",
  "indirect_component_selection", "function_call", "function_call_direct",
  "postdecrement_expression", "postincrement_expression",
  "subscript_expression", "primary_expression", "string_literal",
  "parenthesized_expression", "@17", "@18", "constant_expression",
  "expression_list", "asm_statement", "asm_type", "asm_inout_list",
  "asm_inout", "asm_clobber_list", "asm_label", "named_label_address",
  "assignment_expression_list", "assignment_expression_list_item",
  "named_assignment", "named_assignment_list", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    59,    44,    61,   123,   125,    58,
      46,    91,    93,    40,    41,    42,    63,   124,    94,    38,
      60,    62,    43,    45,    47,    37,   126,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short yyr1[] =
{
       0,    88,    89,    89,    90,    90,    91,    91,    91,    91,
      92,    92,    93,    93,    94,    95,    95,    95,    95,    95,
      95,    96,    97,    96,    98,    99,    99,    99,    99,   100,
     101,   101,   101,   101,   102,   102,   103,   103,   103,   103,
     103,   104,   104,   105,   105,   105,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   107,   107,   108,   108,   108,
     108,   109,   109,   109,   109,   110,   111,   112,   113,   111,
     114,   115,   115,   115,   115,   115,   115,   116,   116,   117,
     117,   118,   119,   119,   119,   119,   119,   119,   119,   119,
     120,   120,   120,   120,   121,   121,   121,   122,   122,   122,
     122,   122,   122,   123,   124,   125,   126,   126,   127,   127,
     129,   128,   130,   128,   131,   131,   132,   132,   133,   133,
     134,   135,   136,   136,   137,   137,   139,   138,   140,   138,
     141,   142,   142,   143,   143,   145,   144,   146,   144,   147,
     148,   148,   149,   149,   150,   150,   151,   151,   151,   151,
     153,   152,   154,   152,   155,   152,   156,   156,   157,   157,
     158,   159,   159,   160,   161,   161,   163,   162,   164,   165,
     165,   165,   165,   166,   167,   167,   167,   167,   169,   168,
     170,   171,   171,   171,   172,   172,   173,   173,   174,   174,
     175,   175,   175,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   178,   179,   177,   180,   180,
     181,   181,   182,   182,   183,   183,   184,   185,   186,   186,
     186,   187,   188,   189,   189,   189,   189,   189,   189,   189,
     189,   190,   191,   191,   191,   192,   192,   193,   194,   194,
     195,   196,   197,   198,   199,   200,   201,   201,   202,   203,
     203,   204,   204,   204,   204,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   205,   205,   206,   206,   206,   207,
     207,   208,   208,   209,   209,   210,   210,   211,   211,   212,
     212,   213,   213,   214,   214,   215,   215,   215,   215,   216,
     216,   217,   217,   218,   218,   219,   219,   220,   220,   221,
     221,   221,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   223,   224,   225,   225,   225,   226,   227,
     228,   229,   230,   230,   231,   232,   233,   233,   233,   233,
     233,   233,   233,   234,   234,   235,   236,   237,   237,   238,
     238,   239,   240,   241,   242,   242,   242,   242,   243,   243,
     244,   245,   246,   244,   247,   248,   248,   249,   249,   249,
     249,   250,   250,   250,   251,   251,   251,   252,   253,   253,
     253,   254,   255,   256,   256,   257,   257,   257,   258,   258,
     258,   258,   259,   259
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     3,     2,     1,     1,     2,     1,     2,     1,
       2,     1,     0,     4,     1,     1,     2,     2,     3,     2,
       1,     2,     3,     4,     1,     3,     1,     3,     4,     4,
       5,     1,     3,     1,     2,     1,     3,     2,     3,     3,
       4,     2,     3,     3,     4,     1,     2,     1,     2,     2,
       3,     1,     3,     1,     1,     1,     3,     0,     0,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       0,     5,     0,     6,     1,     2,     1,     3,     1,     3,
       1,     2,     1,     1,     1,     1,     0,     5,     0,     6,
       2,     1,     1,     1,     1,     0,     5,     0,     6,     2,
       1,     1,     0,     1,     1,     2,     1,     2,     2,     1,
       0,     4,     0,     5,     0,     5,     1,     3,     1,     1,
       1,     2,     3,     1,     1,     1,     0,     3,     1,     1,
       2,     2,     3,     1,     1,     3,     2,     4,     0,     5,
       1,     0,     1,     1,     1,     3,     1,     3,     1,     3,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     0,     5,     0,     1,
       1,     2,     1,     1,     1,     1,     7,     5,     1,     1,
       1,     7,     5,     2,     3,     3,     3,     4,     4,     4,
       5,     5,     2,     2,     2,     2,     4,     1,     1,     1,
       5,     2,     2,     2,     3,     1,     2,     3,     1,     1,
       3,     1,     1,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     4,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     4,     6,     6,     2,     2,
       2,     2,     4,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     4,     3,
       4,     2,     2,     4,     1,     1,     1,     1,     1,     2,
       3,     0,     0,     5,     1,     1,     3,     5,     7,     9,
      11,     1,     2,     2,     0,     1,     3,     4,     0,     1,
       3,     4,     2,     1,     3,     0,     1,     3,     3,     5,
       4,     6,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short yydefact[] =
{
       2,    65,   104,    75,    72,    74,    71,    73,    79,    80,
     105,    76,    99,   100,   101,   102,    97,    98,    90,    91,
     103,     0,     0,     0,   361,   245,     0,    57,     0,     3,
       4,     6,     0,    14,     0,   180,    61,    63,    15,    19,
      17,    81,    83,    84,    94,    85,    87,    89,    82,   108,
     109,    86,   124,   125,    88,   133,   134,     7,   166,   168,
     169,   173,   174,     0,     9,     8,     0,   363,    93,    92,
     131,   132,   126,   130,   140,   141,   135,   139,   122,   123,
     110,   121,   362,     0,     0,     0,    55,    64,    80,    59,
      58,    77,     1,     5,    13,     0,    21,    24,    25,     0,
     170,     0,   176,    67,    16,    20,    18,   102,    96,    95,
       0,   171,    10,     0,   178,     0,   142,   128,   142,   137,
       0,   112,    64,    62,    56,   175,    60,    78,    12,    22,
       0,     0,    27,    26,   172,    64,    66,     0,   205,   167,
      11,   181,   348,     0,   146,     0,   150,   124,   133,     0,
     143,   144,   149,   142,     0,   142,   120,     0,   114,   116,
     118,     0,     0,     0,    70,   345,     0,     0,     0,     0,
       0,   351,     0,     0,     0,     0,     0,     0,    29,   344,
      30,   251,   266,   269,   271,   273,   275,   277,   279,   283,
     289,   293,   297,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   326,   333,   334,   327,   328,   329,
     330,   331,   332,   346,   347,   252,    28,   177,   354,   248,
     249,    68,   208,   184,   191,     0,   183,   182,   186,   188,
     349,   364,     0,   152,   154,     0,   147,   148,   127,   145,
       0,   136,     0,   111,   115,     0,     0,    23,     0,   238,
     239,   372,   320,   321,   351,   323,    70,   165,    31,     0,
       0,    36,     0,    34,     0,   106,     0,     0,     0,   318,
     313,   325,   324,   314,   319,     0,     0,     0,     0,     0,
       0,     0,   281,   282,     0,   286,   288,   285,   287,     0,
     291,   292,     0,   295,   296,     0,   299,   300,   301,     0,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     255,     0,     0,   341,   342,     0,     0,     0,     0,     0,
      70,   104,     0,   237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   213,   212,   194,   206,   209,   210,   195,
     215,   214,   196,   218,   219,   220,   197,     0,     0,     0,
     198,   199,   200,   201,   202,   203,   204,     0,   193,     0,
       0,   192,    45,   190,    43,   179,     0,     0,     0,     0,
     365,   357,     0,     0,     0,   160,     0,   156,   158,   159,
     129,   138,   117,   119,   113,   371,     0,   164,     0,     0,
      41,     0,    32,     0,     0,   107,    43,     0,   350,   352,
     339,   355,     0,   270,   297,     0,     0,   272,   274,   276,
     278,   280,   284,   290,   294,   298,   375,   253,   336,   335,
       0,   337,     0,   250,    69,   235,     0,     0,     0,     0,
       0,     0,     0,   242,   241,   246,     0,     0,   211,   232,
     234,   233,   243,    47,     0,    51,     0,     0,     0,     0,
      44,   185,   187,   189,     0,     0,   364,     0,     0,     0,
     161,   163,     0,   151,     0,   322,     0,     0,     0,    33,
      35,    37,   375,   315,     0,     0,   340,   268,     0,   375,
     376,     0,   373,   343,   338,     0,     0,     0,     0,     0,
       0,     0,     0,   244,   247,   207,    49,    46,    53,    48,
       0,    52,     0,     0,   366,     0,   358,   153,   155,   162,
     157,    38,     0,    39,    42,     0,     0,     0,   382,     0,
     353,   356,   267,     0,   375,   254,   236,     0,     0,     0,
       0,   223,     0,     0,     0,    50,    54,   367,   368,     0,
      40,     0,     0,   316,     0,   317,   377,   374,   217,   240,
     231,     0,   226,   225,   222,   224,     0,   369,     0,   359,
       0,   375,   378,   383,     0,     0,   227,   228,   229,     0,
       0,   375,   380,     0,   216,   221,   230,   370,   360,     0,
     379,   381
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    28,    29,    30,   111,    31,   113,    33,    95,   162,
      96,    97,   132,   261,   262,   263,   389,   446,   362,    84,
      85,    86,    36,    37,   137,   319,   179,    38,   145,    39,
      40,    41,    42,    43,    44,    45,    46,    47,   266,    48,
      49,   120,   161,   157,   158,   159,   160,    50,    81,    51,
      52,   116,   153,    53,    73,    54,    55,   118,   155,    56,
      77,   149,   150,   151,   152,   235,   372,   373,   376,   377,
     378,   379,   460,   264,    57,   110,    58,    59,    60,    61,
     122,   141,    63,   225,   226,   447,   228,   229,   334,   335,
     222,   437,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   491,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   219,   220,   311,   181,   182,
     183,   184,   185,   186,   187,   284,   188,   289,   189,   292,
     190,   295,   191,   299,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   268,   474,   221,
     402,   358,    66,   369,   370,   558,   133,   215,   481,   482,
     518,   519
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -458
static const short yypact[] =
{
    1436,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,   -44,
    -458,  -458,  -458,  -458,  -458,   -13,  -458,  -458,  -458,     2,
    -458,    70,   130,   140,    35,  -458,    46,   124,    50,  1436,
    -458,  -458,    15,  -458,    29,    68,  -458,  -458,  1694,  1694,
    1694,  -458,  -458,   237,    22,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,
    1694,  -458,   354,    19,  -458,  -458,    79,  -458,  -458,  -458,
    -458,  -458,  -458,    91,  -458,  -458,  -458,    95,  -458,  -458,
    -458,   110,  -458,    46,   118,    32,    55,   126,  -458,  -458,
     124,  -458,  -458,  -458,  -458,   131,  -458,  -458,   -43,    29,
    1694,    46,   354,   134,  -458,  -458,  -458,  -458,  -458,  -458,
     154,  1694,  -458,    18,  -458,   219,   666,  -458,   666,  -458,
     226,  -458,  -458,  -458,    55,  -458,  -458,  -458,  -458,  -458,
     170,   768,  -458,   182,  1694,   209,  -458,  1344,  -458,  -458,
    -458,  1626,  -458,    41,  -458,  1501,    22,   192,   247,   258,
     666,  -458,  -458,   666,   261,   666,  -458,   264,   257,  -458,
     269,   226,    46,   219,  -458,  -458,   213,   151,   151,  1378,
     304,   520,   151,   151,   151,   151,   151,   151,  -458,   272,
    -458,  -458,     4,   303,   259,   268,   271,   255,   123,   263,
     211,   127,   396,  -458,  -458,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,   216,  -458,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,   347,  -458,  -458,  -458,  -458,  -458,   290,
    -458,  -458,   435,  -458,    25,   282,   292,  -458,   293,  -458,
    -458,   219,   296,  -458,    22,    38,  -458,  -458,  -458,  -458,
     294,  -458,   295,  -458,   226,  1344,   298,  -458,    21,  -458,
    -458,  -458,  -458,  -458,   520,  -458,   300,  -458,  -458,   310,
    1344,  -458,    57,  -458,   301,   178,   302,   306,   154,  -458,
    -458,  -458,  -458,  -458,  -458,   793,   151,   868,   151,   151,
     151,   151,  -458,  -458,   151,  -458,  -458,  -458,  -458,   151,
    -458,  -458,   151,  -458,  -458,   151,  -458,  -458,  -458,   151,
    -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,
    -458,   890,   310,  -458,  -458,   310,  1344,   915,  1344,   309,
     313,   316,  1344,  -458,   291,   305,   315,   568,   319,   386,
     329,   333,   990,  -458,  -458,  -458,  -458,   435,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -458,  -458,   346,   352,   357,
    -458,  -458,  -458,  -458,  -458,  -458,  -458,   334,  -458,  1012,
    1484,  -458,   189,  -458,    14,  -458,   399,  1647,    45,    76,
    -458,  -458,    38,    38,  1344,   359,   251,  -458,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -458,   342,  -458,   363,   358,
     424,   653,  -458,   768,  1531,  -458,   196,  1313,  -458,  -458,
    -458,  -458,    62,   303,  -458,   151,   366,   259,   268,   271,
     255,   123,   263,   211,   127,  -458,  1037,  -458,  -458,  -458,
     364,  -458,    90,  -458,  -458,   437,  1344,  1344,  1344,   -44,
     389,  1108,   378,  -458,  -458,  -458,   382,   379,  -458,  -458,
    -458,  -458,  -458,  -458,   376,  -458,   375,   377,  1130,  1578,
     189,  -458,  -458,  -458,  1344,   219,   219,   388,   254,   256,
    -458,  -458,  1344,  -458,    38,  1313,   768,   746,  1344,  -458,
    -458,  -458,   675,  -458,   381,  1344,  -458,  -458,   151,  1037,
    -458,   105,  -458,  -458,  -458,  1344,   383,   387,   415,   380,
    1155,   426,   439,  -458,  -458,  -458,  -458,  -458,  -458,  -458,
     391,  -458,   427,   430,  -458,   119,  -458,  -458,  -458,  -458,
    -458,  -458,   768,  -458,  -458,   310,   436,   113,  -458,   176,
    -458,  -458,  -458,   193,  1037,  -458,  -458,   568,   568,   568,
    1344,  1344,   442,   568,  1226,  -458,  -458,  -458,   219,   443,
    -458,   394,  1248,  -458,    42,  -458,  -458,  -458,   455,  -458,
    -458,   438,  -458,  1344,  -458,  1344,   447,   347,   158,  -458,
    1273,  1037,  -458,  -458,   568,   449,  -458,  -458,  1344,   219,
     451,  1037,  -458,   203,  -458,  -458,  -458,   347,  -458,   217,
    -458,  -458
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -458,  -458,  -458,   487,   419,   -35,     1,   266,  -458,  -458,
     365,  -458,   395,  -118,  -458,   129,  -458,  -104,  -327,   -30,
       7,     9,  -458,  -458,  -458,  -458,  -458,  -458,   -22,   -15,
      97,  -458,  -458,  -458,   486,  -458,  -458,  -458,   276,  -458,
    -458,  -458,  -458,   370,  -458,   288,  -458,  -458,  -458,  -458,
     104,  -458,  -458,  -458,  -458,  -458,   148,  -458,  -458,  -458,
    -458,   -87,  -458,   384,  -458,  -458,  -458,  -458,   -42,    69,
    -458,  -458,    73,  -245,  -458,  -458,  -458,  -458,   504,  -458,
      52,  -458,  -458,  -458,  -458,  -137,  -458,   171,  -319,   -99,
    -458,  -458,  -458,  -458,   200,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -458,   373,  -458,  -458,  -458,
    -458,  -458,    24,  -458,  -131,  -458,  -128,  -458,  -389,  -458,
     270,   262,   297,   265,   267,  -458,   299,  -458,   253,  -458,
     283,  -458,   252,  -458,  -113,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,  -458,
    -458,  -458,  -458,  -458,  -458,  -115,  -458,  -458,  -458,  -250,
     260,    77,  -458,   122,   125,  -458,  -458,  -458,  -457,    58,
      37,  -458
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -240
static const short yytable[] =
{
     143,    32,    98,   180,   227,    90,   218,    34,   430,    35,
     390,   139,    91,   178,   388,   517,   477,     1,     1,    67,
     130,     1,   523,   131,    64,   112,   276,   230,     1,   109,
      32,   154,     1,    68,    89,     1,    34,   450,    35,    99,
     267,     1,   180,    35,    69,   387,   257,   230,   248,     1,
      92,   230,    62,    64,   252,   253,   255,     8,    88,   269,
     270,   271,   272,   273,   274,   112,   240,   418,   242,   450,
     419,    82,   425,    70,    71,   127,   140,    65,    87,    94,
     277,    62,    94,    98,    62,   359,   102,   360,    26,   522,
      27,    83,   114,    27,   124,   385,   359,   126,   360,   140,
      27,    91,   101,    91,   573,    83,    65,   374,   124,   444,
     231,    83,   515,    27,   579,   232,   368,   383,   454,    83,
     361,    27,   391,   267,   234,   392,   103,   475,  -180,   218,
     127,    91,    98,    74,    75,    91,   476,    72,    91,   103,
      91,   455,   224,    78,    79,   456,   406,   401,   285,   286,
     457,   102,   115,   135,   164,   475,   165,   142,   117,     8,
      88,   395,   119,   404,   484,   404,   404,   404,   404,   399,
     524,   404,   265,   525,   167,   168,   404,   121,   524,   404,
     169,   543,   404,   417,   455,   420,   415,   333,   538,   401,
     423,   218,   123,   539,   363,   128,   129,    76,   500,    27,
     125,   436,   296,   287,   288,   375,   136,    80,   548,   549,
     550,   297,   298,   146,   554,   146,   249,   250,   514,   127,
     147,   138,   147,   569,   171,   142,   172,   516,   218,   156,
     173,   364,   570,   174,   175,   526,   312,   176,   177,   313,
     314,   544,   233,   163,   545,   574,   461,   146,   131,   359,
     146,   394,   146,    27,   147,   265,   236,   147,   524,   147,
     448,   546,   449,   180,   148,   180,   148,   359,   524,   394,
     541,   580,   396,   282,   283,   471,    12,    13,    14,   107,
      16,    17,   524,   217,   473,   581,   315,   316,   480,   317,
     290,   291,   404,   293,   294,   486,   487,   488,   148,   516,
     492,   148,   333,   148,   104,   105,   106,   256,   257,   165,
     142,   237,   502,   387,   257,   463,   464,   218,   507,   464,
     508,   464,   244,   503,   278,   166,   238,   167,   168,   241,
     458,   459,   243,   169,   461,   245,   279,   218,   180,   180,
     368,   368,   375,   375,   480,   275,   280,   521,   511,   513,
     281,   480,   473,   230,   218,   318,   365,   366,   367,   532,
     371,   224,   380,   381,   426,   404,   384,   364,   224,  -164,
     393,   170,   258,   124,   259,   260,   397,   171,   427,   172,
     398,   424,  -238,   173,   180,  -239,   174,   175,   428,   432,
     176,   177,   431,   433,   540,   224,   480,   434,   442,   551,
     552,   396,   451,   556,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   562,   439,   465,   -64,   -64,   -64,
     -64,   440,   566,   557,   567,   -64,   441,   -64,   462,   466,
     467,   468,   572,   480,   375,   478,   483,   576,   320,   321,
     165,   142,   493,   480,   485,   489,   494,   495,   496,   497,
     224,   498,   506,   530,   577,   520,   166,   527,   167,   168,
     560,   528,   310,   535,   169,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,   322,   323,   324,   529,
     325,   326,   327,   328,   329,   330,   331,   332,    24,    25,
     533,   536,   138,   534,   537,   542,   553,   559,   171,   564,
     172,   568,   565,   575,   173,   578,    93,   174,   175,   134,
     470,   176,   177,   164,     2,   165,   142,   247,   216,   108,
     386,   246,   382,   510,   239,   509,   100,   438,   453,   251,
     407,   166,   412,   167,   168,   409,   403,   414,   410,   169,
       3,     4,     5,     6,     7,     8,    88,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,   320,   250,   165,   142,   413,   408,   422,   505,     0,
     504,   563,   547,   411,     0,     0,     0,     0,     0,   166,
       0,   167,   168,   171,     0,   172,     0,   169,     0,   173,
       0,     0,   174,   175,   429,     0,   176,   177,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   322,
     323,   324,     0,   325,   326,   327,   328,   329,   330,   331,
     332,    24,    25,     0,     0,   138,     0,     0,     0,     0,
       0,   171,     0,   172,     0,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,   256,   257,   165,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     0,     0,   166,     0,   167,   168,   256,   257,
     165,   142,   169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   166,     0,   167,   168,
       0,     8,    88,    10,   169,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,     0,     0,     0,
     170,   469,     0,   259,   260,     0,   171,     0,   172,     0,
     144,     0,   173,     0,     0,   174,   175,     0,     0,   176,
     177,     0,   479,     0,     0,   515,     0,     0,   171,   164,
     172,   165,   142,     0,   173,     0,     0,   174,   175,     0,
       0,   176,   177,     0,     0,     0,     0,   166,     0,   167,
     168,   164,     0,   165,   142,   169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   166,
       0,   167,   168,     0,     0,     0,   164,   169,   165,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   512,   170,   166,     0,   167,   168,     0,   171,
       0,   172,   169,     0,     0,   173,     0,     0,   174,   175,
       0,     0,   176,   177,     0,   170,     0,     0,     0,     0,
       0,   171,     0,   172,     0,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   400,   172,     0,
       0,   164,   173,   165,   142,   174,   175,     0,     0,   176,
     177,     0,     0,     0,     0,     0,     0,     0,     0,   166,
       0,   167,   168,   164,     0,   165,   142,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   166,     0,   167,   168,     0,     0,     0,   164,   169,
     165,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   166,   405,   167,   168,
       0,   171,     0,   172,   169,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,     0,   416,     0,     0,
       0,     0,     0,   171,     0,   172,     0,     0,     0,   173,
       0,     0,   174,   175,     0,     0,   176,   177,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   421,
     172,     0,     0,   164,   173,   165,   142,   174,   175,     0,
       0,   176,   177,     0,     0,     0,     0,     0,     0,     0,
       0,   166,     0,   167,   168,   164,     0,   165,   142,   169,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   166,     0,   167,   168,     0,     0,     0,
     164,   169,   165,   142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   435,     0,     0,     0,   166,     0,
     167,   168,     0,   171,     0,   172,   169,     0,     0,   173,
       0,     0,   174,   175,     0,     0,   176,   177,     0,     0,
       0,     0,     0,     0,   443,   171,     0,   172,     0,     0,
       0,   173,     0,     0,   174,   175,     0,     0,   176,   177,
       0,     0,     0,     0,   479,     0,     0,     0,     0,     0,
     171,   164,   172,   165,   142,     0,   173,     0,     0,   174,
     175,     0,     0,   176,   177,     0,     0,     0,     0,   166,
       0,   167,   168,   164,     0,   165,   142,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   166,     0,   167,   168,     0,     0,     0,   164,   169,
     165,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   490,     0,     0,     0,   166,     0,   167,   168,
       0,   171,     0,   172,   169,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,     0,     0,     0,     0,
       0,     0,   499,   171,     0,   172,     0,     0,     0,   173,
       0,     0,   174,   175,     0,     0,   176,   177,     0,   531,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   164,
     172,   165,   142,     0,   173,     0,     0,   174,   175,     0,
       0,   176,   177,     0,     0,     0,     0,   166,     0,   167,
     168,   164,     0,   165,   142,   169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   166,
       0,   167,   168,     0,     0,     0,   164,   169,   165,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     555,     0,     0,     0,   166,     0,   167,   168,     0,   171,
       0,   172,   169,     0,     0,   173,     0,     0,   174,   175,
       0,     0,   176,   177,     0,   561,   164,     0,   165,   142,
       0,   171,     0,   172,     0,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,   167,   168,     0,     0,
     571,     0,   169,     0,     0,     0,   171,   164,   172,   165,
     142,     0,   173,     0,     0,   174,   175,     0,     0,   176,
     177,     0,     0,     0,     0,   166,     0,   167,   168,     0,
       0,     0,     0,   169,     0,     0,     0,     0,     0,     0,
     472,   164,     0,   165,   142,     0,   171,     0,   172,     0,
       0,     0,   173,     0,     0,   174,   175,     0,     0,   176,
     177,   167,   168,     0,     0,     0,     0,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,     0,   172,
       0,     0,     0,   173,     0,     0,   174,   175,     0,     0,
     176,   177,     0,     0,     0,     0,     0,     0,     0,     1,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   254,     0,   172,     0,     0,     0,   173,     0,     0,
     174,   175,     0,     0,   176,   177,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,     1,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    24,
      25,     0,     0,     0,     0,     2,     0,     0,     0,    26,
       0,    27,     0,     0,     3,     4,     5,     6,     7,     8,
      88,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     2,     8,    88,    10,     0,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,     0,     0,     0,   359,     0,   360,   445,    27,
       0,     3,     4,     5,     6,     7,     8,    88,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,     2,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   359,     0,   394,   445,    27,     0,     3,     4,
       5,     6,     7,     8,    88,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,   223,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,   501,     0,   452,     0,     3,     4,     5,     6,
       7,     8,    88,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,     3,     4,     5,
       6,     7,     8,    88,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     3,     4,     5,     6,     7,     8,
      88,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23
};

static const short yycheck[] =
{
     115,     0,    32,   131,   141,    27,   137,     0,   327,     0,
     260,   110,    27,   131,   259,   472,   405,     3,     3,    63,
      63,     3,   479,    66,     0,    60,    22,     6,     3,    44,
      29,   118,     3,    46,    27,     3,    29,   364,    29,    32,
     171,     3,   170,    34,    42,     3,     4,     6,   163,     3,
       0,     6,     0,    29,   167,   168,   169,    35,    36,   172,
     173,   174,   175,   176,   177,   100,   153,   312,   155,   396,
     315,    36,   322,     3,     4,    90,   111,     0,    26,    64,
      76,    29,    64,   113,    32,    71,    34,    73,    73,   478,
      75,    73,    73,    75,    85,    74,    71,    90,    73,   134,
      75,   116,    73,   118,   561,    73,    29,    69,    99,   359,
      69,    73,    70,    75,   571,    74,   231,   245,    73,    73,
     224,    75,    65,   254,   146,    68,    71,    65,    73,   260,
     145,   146,   162,     3,     4,   150,    74,    67,   153,    71,
     155,    65,   141,     3,     4,    69,   277,   275,    25,    26,
      74,    99,    73,   101,     3,    65,     5,     6,    67,    35,
      36,   265,    67,   276,    74,   278,   279,   280,   281,   268,
      65,   284,   171,    68,    23,    24,   289,    67,    65,   292,
      29,    68,   295,   311,    65,   316,   299,   222,    69,   317,
     318,   322,    74,    74,   224,    64,    65,    67,   448,    75,
      74,   332,    75,    80,    81,   235,    72,    67,   527,   528,
     529,    84,    85,   116,   533,   118,     3,     4,   468,   234,
     116,    67,   118,    65,    73,     6,    75,   472,   359,     3,
      79,   224,    74,    82,    83,   485,    20,    86,    87,    23,
      24,    65,   145,    73,    68,   564,   374,   150,    66,    71,
     153,    73,   155,    75,   150,   254,    64,   153,    65,   155,
      71,    68,    73,   391,   116,   393,   118,    71,    65,    73,
     515,    68,   265,    18,    19,   393,    39,    40,    41,    42,
      43,    44,    65,    74,   397,    68,    70,    71,   416,    73,
      27,    28,   405,    82,    83,   426,   427,   428,   150,   544,
     431,   153,   337,   155,    38,    39,    40,     3,     4,     5,
       6,    64,   449,     3,     4,    64,    65,   448,    64,    65,
      64,    65,    65,   454,    21,    21,    68,    23,    24,    68,
     372,   373,    68,    29,   462,    66,    77,   468,   466,   467,
     455,   456,   372,   373,   472,    73,    78,   475,   466,   467,
      79,   479,   465,     6,   485,    65,    74,    65,    65,   490,
      64,   360,    68,    68,    73,   478,    68,   360,   367,    69,
      69,    67,    68,   364,    70,    71,    74,    73,    73,    75,
      74,    72,    69,    79,   512,    69,    82,    83,    73,     3,
      86,    87,    73,    64,   512,   394,   524,    64,    64,   530,
     531,   394,     3,   534,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,   542,    69,    74,    63,    64,    65,
      66,    69,   553,   538,   555,    71,    69,    73,    69,    66,
      72,     7,   560,   561,   464,    69,    72,   568,     3,     4,
       5,     6,    64,   571,     7,    56,    64,    68,    72,    74,
     449,    74,    64,    73,   569,    74,    21,    74,    23,    24,
      66,    74,    66,    72,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    74,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      74,    74,    67,    64,    74,    69,    64,    64,    73,    54,
      75,    64,    74,    64,    79,    64,    29,    82,    83,   100,
     391,    86,    87,     3,     4,     5,     6,   162,   133,    43,
     254,   161,   244,   464,   150,   462,    32,   337,   367,   166,
     278,    21,   289,    23,    24,   280,   276,   295,   281,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,     3,     4,     5,     6,   292,   279,   317,   456,    -1,
     455,   544,   524,   284,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,    73,    -1,    75,    -1,    29,    -1,    79,
      -1,    -1,    82,    83,    36,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       4,    -1,    -1,    -1,    21,    -1,    23,    24,     3,     4,
       5,     6,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,
      -1,    35,    36,    37,    29,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    -1,    -1,
      67,    68,    -1,    70,    71,    -1,    73,    -1,    75,    -1,
      64,    -1,    79,    -1,    -1,    82,    83,    -1,    -1,    86,
      87,    -1,    67,    -1,    -1,    70,    -1,    -1,    73,     3,
      75,     5,     6,    -1,    79,    -1,    -1,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    21,    -1,    23,
      24,     3,    -1,     5,     6,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,    -1,    -1,    -1,     3,    29,     5,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    21,    -1,    23,    24,    -1,    73,
      -1,    75,    29,    -1,    -1,    79,    -1,    -1,    82,    83,
      -1,    -1,    86,    87,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    -1,
      -1,     3,    79,     5,     6,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,     3,    -1,     5,     6,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    23,    24,    -1,    -1,    -1,     3,    29,
       5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    69,    23,    24,
      -1,    73,    -1,    75,    29,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
      75,    -1,    -1,     3,    79,     5,     6,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    23,    24,     3,    -1,     5,     6,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    23,    24,    -1,    -1,    -1,
       3,    29,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    21,    -1,
      23,    24,    -1,    73,    -1,    75,    29,    -1,    -1,    79,
      -1,    -1,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    73,    -1,    75,    -1,    -1,
      -1,    79,    -1,    -1,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      73,     3,    75,     5,     6,    -1,    79,    -1,    -1,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,     3,    -1,     5,     6,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    23,    24,    -1,    -1,    -1,     3,    29,
       5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    -1,    -1,    21,    -1,    23,    24,
      -1,    73,    -1,    75,    29,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    73,    -1,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    83,    -1,    -1,    86,    87,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,     3,
      75,     5,     6,    -1,    79,    -1,    -1,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    21,    -1,    23,
      24,     3,    -1,     5,     6,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,    -1,    -1,    -1,     3,    29,     5,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,    73,
      -1,    75,    29,    -1,    -1,    79,    -1,    -1,    82,    83,
      -1,    -1,    86,    87,    -1,    67,     3,    -1,     5,     6,
      -1,    73,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,    23,    24,    -1,    -1,
      67,    -1,    29,    -1,    -1,    -1,    73,     3,    75,     5,
       6,    -1,    79,    -1,    -1,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,
      -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      67,     3,    -1,     5,     6,    -1,    73,    -1,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    -1,    -1,    86,
      87,    23,    24,    -1,    -1,    -1,    -1,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,
      -1,    -1,    -1,    79,    -1,    -1,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    -1,    -1,    86,    87,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,     3,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      64,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,    73,
      -1,    75,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,     4,    35,    36,    37,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    -1,    -1,    71,    -1,    73,    74,    75,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    73,    74,    75,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     4,    74,    -1,     7,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short yystos[] =
{
       0,     3,     4,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    63,    64,    73,    75,    89,    90,
      91,    93,    94,    95,   108,   109,   110,   111,   115,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   127,   128,
     135,   137,   138,   141,   143,   144,   147,   162,   164,   165,
     166,   167,   168,   170,   200,   249,   250,    63,    46,    42,
       3,     4,    67,   142,     3,     4,    67,   148,     3,     4,
      67,   136,    36,    73,   107,   108,   109,   168,    36,   108,
     116,   117,     0,    91,    64,    96,    98,    99,   107,   108,
     166,    73,   168,    71,    95,    95,    95,    42,   122,   117,
     163,    92,    93,    94,    73,    73,   139,    67,   145,    67,
     129,    67,   168,    74,   109,    74,   108,   117,    64,    65,
      63,    66,   100,   254,    92,   168,    72,   112,    67,   177,
      93,   169,     6,   243,    64,   116,   118,   138,   144,   149,
     150,   151,   152,   140,   149,   146,     3,   131,   132,   133,
     134,   130,    97,    73,     3,     5,    21,    23,    24,    29,
      67,    73,    75,    79,    82,    83,    86,    87,   101,   114,
     204,   206,   207,   208,   209,   210,   211,   212,   214,   216,
     218,   220,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   255,   100,    74,   202,   203,
     204,   247,   178,     3,    94,   171,   172,   173,   174,   175,
       6,    69,    74,   118,   116,   153,    64,    64,    68,   151,
     149,    68,   149,    68,    65,    66,   131,    98,   243,     3,
       4,   194,   222,   222,    73,   222,     3,     4,    68,    70,
      71,   101,   102,   103,   161,    94,   126,   202,   245,   222,
     222,   222,   222,   222,   222,    73,    22,    76,    21,    77,
      78,    79,    18,    19,   213,    25,    26,    80,    81,   215,
      27,    28,   217,    82,    83,   219,    75,    84,    85,   221,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      66,   205,    20,    23,    24,    70,    71,    73,    65,   113,
       3,     4,    51,    52,    53,    55,    56,    57,    58,    59,
      60,    61,    62,    93,   176,   177,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   249,    71,
      73,   105,   106,   107,   108,    74,    65,    65,   243,   251,
     252,    64,   154,   155,    69,   107,   156,   157,   158,   159,
      68,    68,   133,   204,    68,    74,   126,     3,   161,   104,
     247,    65,    68,    69,    73,   105,   108,    74,    74,   177,
      74,   204,   248,   208,   222,    69,   202,   209,   210,   211,
     212,   214,   216,   218,   220,   222,    67,   204,   161,   161,
     202,    74,   248,   204,    72,   247,    73,    73,    73,    36,
     176,    73,     3,    64,    64,    64,   202,   179,   182,    69,
      69,    69,    64,    72,   247,    74,   105,   173,    71,    73,
     106,     3,     7,   175,    73,    65,    69,    74,   156,   156,
     160,   204,    69,    64,    65,    74,    66,    72,     7,    68,
     103,   101,    67,   222,   246,    65,    74,   206,    69,    67,
     204,   256,   257,    72,    74,     7,   202,   202,   202,    56,
      64,   189,   202,    64,    64,    68,    72,    74,    74,    72,
     247,    74,   173,   202,   252,   251,    64,    64,    64,   160,
     157,   101,    66,   101,   247,    70,   161,   256,   258,   259,
      74,   204,   206,   256,    65,    68,   247,    74,    74,    74,
      73,    64,   202,    74,    64,    72,    74,    74,    69,    74,
     101,   161,    69,    68,    65,    68,    68,   257,   176,   176,
     176,   202,   202,    64,   176,    64,   202,   243,   253,    64,
      66,    67,   204,   258,    54,    74,   202,   202,    64,    65,
      74,    67,   204,   256,   176,    64,   202,   243,    64,   256,
      68,    68
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 180 "./parse.y"
    { scope=0; reset(); common_comment=NULL; in_typedef=0; GetCurrentComment(); }
    break;

  case 7:
#line 182 "./parse.y"
    { scope=0; reset(); common_comment=NULL; in_typedef=0; GetCurrentComment(); }
    break;

  case 10:
#line 191 "./parse.y"
    { scope=0; reset(); common_comment=NULL; in_typedef=0; }
    break;

  case 11:
#line 193 "./parse.y"
    { scope=0; reset(); common_comment=NULL; in_typedef=0;
                  yyval=yyvsp[0]; }
    break;

  case 12:
#line 199 "./parse.y"
    { in_type_spec=0; }
    break;

  case 13:
#line 201 "./parse.y"
    { in_type_spec=0; }
    break;

  case 14:
#line 206 "./parse.y"
    { if(!in_structunion && !in_typedef && !in_function && !common_comment)
                  {common_comment=CopyString(GetCurrentComment()); SetCurrentComment(common_comment);} }
    break;

  case 16:
#line 213 "./parse.y"
    { if(yyvsp[-1]) yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); else yyval=yyvsp[0]; }
    break;

  case 17:
#line 215 "./parse.y"
    { if(!current->type) current->type=yyvsp[0]; }
    break;

  case 18:
#line 217 "./parse.y"
    { if(!current->type) current->type=yyvsp[-1];
                  yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 20:
#line 221 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 22:
#line 228 "./parse.y"
    { in_type_spec=1; }
    break;

  case 24:
#line 233 "./parse.y"
    {
                 if((in_function==0 || in_function==3) && !in_funcdef && !in_structunion)
                   {
                    char* specific_comment=GetCurrentComment();
                    if(!common_comment)   SetCurrentComment(specific_comment); else
                    if(!specific_comment) SetCurrentComment(common_comment);   else
                    if(strcmp(common_comment,specific_comment)) SetCurrentComment(ConcatStrings(3,common_comment," ",specific_comment)); else
                                          SetCurrentComment(common_comment);
                   }

                 if(in_typedef)
                   {
                    char* vname=strstr(yyvsp[0],current->name);
                    SeenTypedefName(current->name,vname[strlen(current->name)]=='('?-1:1);
                    if(!in_header)
                       SeenTypedef(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                    if(in_function==3)
                       DownScope();
                   }
                 else if(in_function==2)
                    SeenFunctionArg(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                 else
                   {
                    char* vname=strstr(yyvsp[0],current->name);
                    if(vname[strlen(current->name)]!='(' && IsATypeName(current->type)!='f')
                      {
                       if((in_funcbody==0 || scope&EXTERN_F) && !in_structunion && !(in_header==GLOBAL && scope&EXTERN_H))
                          SeenVariableDefinition(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]),SCOPE);
                       else
                          if(in_funcbody)
                             SeenScopeVariable(current->name);
                      }
                    else
                      {
                       SeenFunctionProto(current->name,in_funcbody);
                       if(in_function==3)
                          DownScope();
                      }
                   }

                 if(in_function==3 && !in_structunion) in_function=0;
                }
    break;

  case 44:
#line 319 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 46:
#line 325 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  { int i=0; while(yyvsp[-1][i] && yyvsp[-1][i]=='*') i++; if(!yyvsp[-1][i]) in_type_spec=0; } }
    break;

  case 47:
#line 328 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 48:
#line 330 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 49:
#line 332 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 50:
#line 334 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 51:
#line 336 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 52:
#line 338 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 53:
#line 340 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 54:
#line 342 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 55:
#line 349 "./parse.y"
    { in_type_spec=0; }
    break;

  case 56:
#line 351 "./parse.y"
    { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 58:
#line 357 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 59:
#line 359 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 60:
#line 361 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-2]," ",yyvsp[-1],yyvsp[0]); }
    break;

  case 62:
#line 367 "./parse.y"
    { if(yyvsp[-1][0]=='*' && yyvsp[-1][1]==' ') { yyvsp[-1]=&yyvsp[-1][1]; yyvsp[-1][0]='*'; }
                  yyval=ConcatStrings(4," ",yyvsp[-2],yyvsp[-1],yyvsp[0]);
                }
    break;

  case 65:
#line 376 "./parse.y"
    { yyval=ConcatStrings(2," ",yyvsp[0]); current->name=yyvsp[0];
                  if(!current->type) current->type="int";
                  if(in_funcdef==1 && in_function!=3 && !in_structunion) SeenScopeVariable(yyvsp[0]); }
    break;

  case 66:
#line 383 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 67:
#line 384 "./parse.y"
    { in_type_spec=0; }
    break;

  case 68:
#line 384 "./parse.y"
    { in_type_spec=1; }
    break;

  case 69:
#line 385 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-5],yyvsp[-4],yyvsp[-2],yyvsp[0]); }
    break;

  case 71:
#line 396 "./parse.y"
    { yyval=NULL; }
    break;

  case 72:
#line 398 "./parse.y"
    { yyval=NULL;
                  if(in_funcbody) scope|=EXTERN_F;
                  else if(in_header) scope|=EXTERN_H;
                  else scope|=EXTERNAL; }
    break;

  case 73:
#line 403 "./parse.y"
    { yyval=NULL; }
    break;

  case 74:
#line 405 "./parse.y"
    { yyval=NULL; scope |= LOCAL; }
    break;

  case 75:
#line 407 "./parse.y"
    { yyval=NULL;
                  in_typedef=1; if(!in_header) SeenTypedef(NULL,NULL);
                  common_comment=CopyString(GetCurrentComment()); }
    break;

  case 76:
#line 411 "./parse.y"
    { yyval=NULL; scope |= INLINED; }
    break;

  case 78:
#line 417 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 79:
#line 422 "./parse.y"
    { if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); }
    break;

  case 80:
#line 424 "./parse.y"
    { if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); }
    break;

  case 81:
#line 431 "./parse.y"
    { in_type_spec=1; }
    break;

  case 92:
#line 449 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 93:
#line 451 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 95:
#line 457 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 96:
#line 459 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 106:
#line 485 "./parse.y"
    { in_type_spec=0; }
    break;

  case 107:
#line 487 "./parse.y"
    { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 110:
#line 499 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
    break;

  case 111:
#line 507 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 112:
#line 512 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
    break;

  case 113:
#line 520 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 117:
#line 534 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 118:
#line 539 "./parse.y"
    { if(!in_header) SeenStructUnionComp(yyvsp[0],in_structunion); }
    break;

  case 119:
#line 541 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); if(!in_header) SeenStructUnionComp(yyvsp[-2],in_structunion); }
    break;

  case 121:
#line 550 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 126:
#line 567 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
    break;

  case 127:
#line 575 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 128:
#line 580 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
    break;

  case 129:
#line 588 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 130:
#line 596 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 135:
#line 613 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
    break;

  case 136:
#line 621 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 137:
#line 626 "./parse.y"
    { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
    break;

  case 138:
#line 634 "./parse.y"
    { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 139:
#line 642 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 145:
#line 660 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 147:
#line 666 "./parse.y"
    { yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); }
    break;

  case 148:
#line 669 "./parse.y"
    { yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); }
    break;

  case 150:
#line 676 "./parse.y"
    { comp_type=yyvsp[0]; }
    break;

  case 151:
#line 678 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
    break;

  case 152:
#line 680 "./parse.y"
    { comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 153:
#line 682 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
    break;

  case 154:
#line 684 "./parse.y"
    { comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
    break;

  case 155:
#line 686 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
    break;

  case 156:
#line 691 "./parse.y"
    { if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); }
    break;

  case 157:
#line 693 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); }
    break;

  case 160:
#line 704 "./parse.y"
    { if(in_function==2 && !in_structunion) { DownScope(); pop(); in_function=0; } }
    break;

  case 161:
#line 709 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 162:
#line 711 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 166:
#line 729 "./parse.y"
    { pop(); in_funcbody=1; in_function=0; }
    break;

  case 167:
#line 731 "./parse.y"
    { in_funcbody=in_function=0; DownScope(); SeenFunctionDefinition(NULL); }
    break;

  case 168:
#line 736 "./parse.y"
    { char *func_type,*fname=strstr(yyvsp[0],(current-1)->name),*parenth=strstr(yyvsp[0],"(");
                  if(parenth>fname)
                     {parenth[0]=0;func_type=ConcatStrings(3,(current-1)->qual,(current-1)->type,yyvsp[0]);}
                  else
                    {
                     int open=1;
                     char *argbeg=strstr(&parenth[1],"("),*argend;
                     argbeg[1]=0;
                     for(argend=argbeg+2;*argend;argend++)
                       {
                        if(*argend=='(') open++;
                        if(*argend==')') open--;
                        if(!open) break;
                       }
                     func_type=ConcatStrings(4,(current-1)->qual,(current-1)->type,yyvsp[0],argend);
                    }
                  SeenFunctionDefinition(func_type);
                }
    break;

  case 170:
#line 759 "./parse.y"
    { yyval=ConcatStrings(3,current->qual,current->type,yyvsp[0]); }
    break;

  case 172:
#line 762 "./parse.y"
    { yyval=ConcatStrings(3,current->qual,current->type,yyvsp[-1]); }
    break;

  case 173:
#line 769 "./parse.y"
    { if(!in_structunion) { push(); in_function=2; } }
    break;

  case 176:
#line 776 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 177:
#line 778 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-3],yyvsp[-1]); }
    break;

  case 178:
#line 783 "./parse.y"
    { if(!in_structunion)
                  { push(); if(in_function==0) UpScope();
                    if(in_function==0 && !in_funcdef) in_function=1; if(in_function!=3) in_funcdef++; } }
    break;

  case 179:
#line 787 "./parse.y"
    { if(!in_structunion)
                    { pop();  if(in_function!=3) in_funcdef--; if(in_funcdef==0) in_function=3; }
                  yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); }
    break;

  case 180:
#line 794 "./parse.y"
    {
                  if(!in_funcdef && !in_function && !in_funcbody && !in_structunion) SeenFunctionDeclaration(current->name,SCOPE);
                  in_type_spec=0;
                }
    break;

  case 181:
#line 802 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && !in_structunion) SeenFunctionArg("void","void");
                  if(in_structunion) yyval=NULL; else yyval="void"; }
    break;

  case 184:
#line 810 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); } }
    break;

  case 185:
#line 812 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); }
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 187:
#line 819 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(yyvsp[0],yyvsp[0]);
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 188:
#line 825 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(strcmp("void",yyvsp[0])?current->name:"void",yyvsp[0]);
                  in_type_spec=0; }
    break;

  case 189:
#line 828 "./parse.y"
    { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(current->name,yyvsp[0]);
                  in_type_spec=0; yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 190:
#line 834 "./parse.y"
    { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 191:
#line 836 "./parse.y"
    { in_type_spec=0; }
    break;

  case 192:
#line 838 "./parse.y"
    { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 205:
#line 862 "./parse.y"
    { UpScope(); reset(); }
    break;

  case 206:
#line 864 "./parse.y"
    { DownScope(); }
    break;

  case 213:
#line 881 "./parse.y"
    { scope=0; reset(); common_comment=NULL; in_typedef=0; }
    break;

  case 250:
#line 996 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 267:
#line 1026 "./parse.y"
    { yyval=ConcatStrings(5,yyvsp[-4],yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 268:
#line 1028 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 270:
#line 1036 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 272:
#line 1044 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 274:
#line 1052 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 276:
#line 1060 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 278:
#line 1068 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 280:
#line 1076 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 284:
#line 1088 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 290:
#line 1102 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 294:
#line 1114 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 298:
#line 1126 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 314:
#line 1156 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 315:
#line 1161 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 319:
#line 1172 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 322:
#line 1185 "./parse.y"
    { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 323:
#line 1187 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 324:
#line 1192 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 325:
#line 1197 "./parse.y"
    { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
    break;

  case 328:
#line 1206 "./parse.y"
    { if(!IsAScopeVariable(yyvsp[0])) SeenFunctionCall(yyvsp[0]); }
    break;

  case 344:
#line 1250 "./parse.y"
    { CheckFunctionVariableRef(yyvsp[0],in_funcbody); }
    break;

  case 350:
#line 1262 "./parse.y"
    { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
    break;

  case 351:
#line 1263 "./parse.y"
    { push(); }
    break;

  case 352:
#line 1263 "./parse.y"
    { pop(); }
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2916 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1345 "./parse.y"


#if YYDEBUG

static int   last_yylex[11];
static char *last_yylval[11];
static int count=0,modcount=0;

#endif /* YYDEBUG */


 /*++++++++++++++++++++++++++++++++++++++
  Stop parsing the current file, due to an error.

  char *s The error message to print out.
  ++++++++++++++++++++++++++++++++++++++*/

static void yyerror( char *s )
{
#if YYDEBUG
 int i;
#endif

 fflush(stdout);
 fprintf(stderr,"%s:%d: cxref: %s\n\n",parse_file,parse_line,s);

#if YYDEBUG

 fprintf(stderr,"The previous 10, current and next 10 symbols are:\n");

 for(i=count>10?count-11:0,modcount=i%11;i<count-1;i++,modcount=i%11)
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1-count,last_yylex[modcount],yytname[YYTRANSLATE(last_yylex[modcount])],last_yylval[modcount]);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1-count,last_yylex[modcount],last_yylval[modcount]);
#endif

#ifdef YYBISON
 fprintf(stderr,"  0 | %3d : %16s : %s\n",yychar,yytname[YYTRANSLATE(yychar)],yylval);
#else
 fprintf(stderr,"  0 | %3d : %s\n",yychar,yylval);
#endif

 for(i=0;i<10;i++)
   {
    yychar=yylex();
    if(!yychar)
      {fprintf(stderr,"END OF FILE\n");break;}
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1,yychar,yytname[YYTRANSLATE(yychar)],yylval);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1,yychar,yylval);
#endif
   }

 fprintf(stderr,"\n");

#endif /* YYDEBUG */

 /* Finish off the input. */

#undef yylex

 if(yychar)
    while((yychar=yylex()));
}


 /*++++++++++++++++++++++++++++++++++++++
  Call the lexer, the feedback from the parser to the lexer is applied here.

  int cxref_yylex Returns the value from the lexer, modified due to parser feedback.
  ++++++++++++++++++++++++++++++++++++++*/

static int cxref_yylex(void)
{
 static int last_yyl=0;
 int yyl=yylex();

 if(yyl==TYPE_NAME)
    if(in_type_spec || (in_structunion && last_yyl=='}') || last_yyl==TYPE_NAME ||
       last_yyl==GOTO ||
       last_yyl==CHAR || last_yyl==SHORT || last_yyl==INT || last_yyl==LONG ||
       last_yyl==SIGNED || last_yyl==UNSIGNED ||
       last_yyl==FLOAT || last_yyl==DOUBLE ||
       last_yyl==BOOL)
       yyl=IDENTIFIER;

 last_yyl=yyl;

#if YYDEBUG

 last_yylex [modcount]=yyl;
 last_yylval[modcount]=yylval;

 if(yyl)
   {
    count++;
    modcount=count%11;
   }
 else
   {
    count=0;
    modcount=0;
   }

#if YYDEBUG == 2

 if(yyl)
#ifdef YYBISON
    printf("#parse.y# %6d | %16s:%4d | %3d : %16s : %s\n",count,parse_file,parse_line,yyl,yytname[YYTRANSLATE(yyl)],yylval);
#else
    printf("#parse.y# %6d | %16s:%4d | %3d : %s\n",count,parse_file,parse_line,yyl,yylval);
#endif /* YYBISON */
 else
    printf("#parse.y# %6d | %16s:%4d | END OF FILE\n",count,parse_file,parse_line);

 fflush(stdout);

#endif /* YYDEBUG==2 */

#endif /* YYDEBUG */

 return(yyl);
}

