//---------------------------------------------------------------------------
#pragma hdrstop

#include "Parametre.h"

//---------------------------------------------------------------------------

#include <string.h>

/**
 * Proc�ure de conversion.
 * Convertit une chaine de caract�es en une varaible de type Loi.
 * @param Nom[] (cha�e de caract�es) de type char*.
 * @param NomLoi de type Loi.
 * @return NomLoi de type Loi.
 */
void StringToLoi(char Nom[],Loi &NomLoi)
{
	NomLoi = Inconnue;
	if (strcmp(Nom,"Normale")==0)
		NomLoi = Normale;
	if (strcmp(Nom,"Lognormale")==0)
		NomLoi = Lognormale;
	if (strcmp(Nom,"Chi2")==0)
		NomLoi = Chi2;
	if (strcmp(Nom,"Student")==0)
		NomLoi = Student;
	if (strcmp(Nom,"Beta")==0)
		NomLoi = Beta1espece;
	if (strcmp(Nom,"Beta1espece")==0)
		NomLoi = Beta1espece;
	if (strcmp(Nom,"Gamma")==0)
		NomLoi = LoiGamma;
	if (strcmp(Nom,"Exponentielle")==0)
		NomLoi = Exponentielle;
	if (strcmp(Nom,"Weibull")==0)
		NomLoi = Weibull;
	if (strcmp(Nom,"Pareto")==0)
		NomLoi = Pareto;
	if (strcmp(Nom,"GPD")==0)
		NomLoi = GPD;
	if (strcmp(Nom,"Uniforme")==0)
		NomLoi = UniformeContinue;
	if (strcmp(Nom,"UniformeContinue")==0)
		NomLoi = UniformeContinue;
	if (strcmp(Nom,"Import")==0)
		NomLoi = Import;
}

// IMPLEMENTATION DES METHODES

// Constructeur
Parametre::Parametre()
{
   tete = NULL;
   queue = NULL;
}

// Destructeur
Parametre::~Parametre()
{
   CELL *ptr = tete;
   while (ptr!=NULL)
   {
      tete = ptr->suivant;
      free(ptr);
      ptr = tete;
   }
}

// Test pour savoir si une Parametre est vide
bool Parametre::Vide()
{
	if (tete == NULL)
   	return(true);
   else
   	return(false);
}

// Insertion en tete d'une cell
void Parametre::InsereTete(double x)
{
        CELL *nouveau = (CELL *) malloc (sizeof(CELL));
        nouveau->Param = x;

   if (queue == NULL)
   	queue = nouveau;
   else
   	tete->precedent = nouveau;

   nouveau->precedent = NULL;
   nouveau->suivant = tete;
   tete = nouveau;
   //return 0;
}

// Insertion en queue d'une cell
void Parametre::InsereQueue(double x)
{
   CELL *nouveau = (CELL *) malloc (sizeof(CELL));

   nouveau->Param = x;

   if (tete == NULL)
   	tete = nouveau;
   else
   	queue->suivant = nouveau;

   nouveau->precedent = queue;
   nouveau->suivant = NULL;
   queue = nouveau;
   //return 0;
}

double Parametre::element(int i)
{
CELL *courant;
int j;
double Temporaire;

courant = tete;
for (j=1;j<i;j++)
{
courant = courant->suivant;
}

Temporaire = courant->Param;
//delete(courant);

return(Temporaire);
}

int Parametre::Comptage()
{
int Nombre;
CELL *courant;

Nombre = 0;
courant = tete;
while (courant != NULL)
{
        courant = courant->suivant;
        Nombre = Nombre + 1;
}
return(Nombre);
}

/*bool Parametre::Triee()
{
CELL *courant, *courant2;

if (Vide()) return(false);

courant = tete;
courant2 = courant->suivant;
if (courant2==NULL) return(true);

while (courant2 != NULL)
{
        if (courant2->Param<courant->Param) return(false);
        courant = courant2;
        courant2 = courant2->suivant;
}
return(true);
}*/

/*Parametre::Copie(TList &MyList)
{
CELL *courant;

courant = tete;
while (courant != NULL)
{
        //MyList->Add(courant->Param);
        courant = courant->suivant;
}
//return MyList;
}
*/

bool Parametre::VerifParam(Loi Nomloi)
{
	switch(Nomloi)
	{
	case Normale : {
						if (element(2)<=0)
							return(false);
						else
							return(true);
						break;
				   }
	case Lognormale : {
						if (element(2)<=0)
							return(false);
						else
							return(true);
						break;
					  }
	case LoiGamma : {
						if ((element(1)<=0) || (element(2)<0))
							return(false);
						else
							return(true);
						break;
					}
	case Exponentielle : {
							if (element(1)<=0)
								return(false);
							else
								return(true);
							break;
						 }
	case Weibull : {
						if ((element(1)<=0) || (element(2)<=0))
							return(false);
						else
							return(true);
						break;
				   }
	case Pareto : {
						if ((element(1)<=0) || (element(2)<=0))
							return(false);
						else
							return(true);
						break;
				  }
	case GPD : {
					if (element(2)<=0)
						return(false);
					else
						return(true);
					break;
			   }
	case Chi2 : {
					if (element(1)<=0)
						return(false);
					else
						return(true);
					break;
				}
	case Beta1espece : {
							if ((element(1)<=0) || (element(2)<=0))
							return(false);
						else
							return(true);
						break;
					   }
	case UniformeContinue : {
								if (element(1)>=element(2))
									return(false);
								else
									return(true);
								break;
							}
	case Student : { 
						return(true);
						break;
				   }
	default : {
					return(false);
			  }
	}
}
							

Parametre & Parametre::operator = (const Parametre &P)
{
 CELL *courant;

 tete = NULL;
 courant = P.tete;
 while (courant != NULL)
 {
        InsereQueue(courant->Param);
        courant = courant->suivant;
 }
 return *this;
}
