//---------------------------------------------------------------------------
#pragma hdrstop

#include "Simulations.h"


//---------------------------------------------------------------------------


#include <stdlib.h>
#include <math.h>
#include <time.h>

#define pi 3.14159265358979

/**
 * Procdure de gnration alatoire.
 * Initialisation de la gnration par une variable de temps,
 * reprsentant le nombre de seconde depuis le temps 0 de la machine  l'instant o dmarre le programme.
 * Utilise pour que toutes les simulations soient diffrentes.
 */
void randomize()
{
	srand(time(NULL));
}

Simulation::Simulation()
{
Y=0;
}

Simulation::~Simulation()
{
}

/*int Simulation::SimulBernoulli(double p)
{double U;
  U=SimulUniformeContinue(0,1);
  if (U<p) return(1);
  else return(0);
 }


int Simulation::SimulBinomiale(int n, double p)
{double X,Y=0;

  for (int i=0;i<n;i++)
   {X=SimulBernoulli(p);
    Y=Y+X;
   }
  return(Y);
}


int Simulation::SimulBernoulliSymetrique(double p)
{
double U;
  U=SimulUniformeContinue(0,1);
  if (U<p) return(1);
  else return(-1);
}

int Simulation::SimulBinomialeNegative(int r, double p)
{
return(0);
}

int Simulation::SimulGeometrique(double p)
{double U;
  int n;
  n=1;
  U=SimulUniformeContinue(0,1);
  while (U>p)
   {n=n+1;
    U=SimulUniformeContinue(0,1);
   }
  return(n);
 }

int Simulation::SimulHypergeometrique(int n, int n1, int n2)
{
return (0);
}


int Simulation::SimulPoisson(double alpha)
{double X,Y=0;
  int n=0;

  while (Y<1)
   {X=SimulExponentielle(alpha);
    Y=Y+X;
    n++;
   }
  return(n-1);
}


int Simulation::SimulUniformeDiscrete(int n)
{
double U;
int i,res;
double trans;

U=SimulUniformeContinue(0,1);
for (i=1;i<=n;i++)
{
        trans =i;
        if (((trans-1)/n<=U) && (U<=(trans/n)))
        {res = i;
        break;}
}
return(res);
}*/

double Simulation::SimulUniformeContinue(double a, double b)
 { double U;
   U=rand();
   U=U/RAND_MAX;
   while ((U == 0) || (U == 1))
   {
	   U = rand();
	   U=U/RAND_MAX;
   }
   return((b-a)*U+a);
 }

double Simulation::SimulExponentielle(double alpha)
{double U;

  U=SimulUniformeContinue(0,1);
  return(-log(U)*alpha);
 }

double Simulation::SimulGamma(double a, double b)
{
double r,c,d,u,v,x,y,e,bb,w,z;

	r = 0;
	if (a==1)
		return(SimulExponentielle(b));
	else
	{
		if ((a>0) && (a<1))
		{
			c = 1 / a;
			d = 1 / (1 - a);
			r = 0;
			while (r == 0)
			{
			u = SimulUniformeContinue(0,1);
			v = SimulUniformeContinue(0,1);
			x = pow(u,c);
			y = pow(v,d);
			if ((x + y)<=1) 
			{
				e = -log(SimulUniformeContinue(0,1)); 
				r = e * x / (x + y);
			}
			}
			return(r * b);
		}
		else
		{
			r = 0;
			bb = a - 1;
			c = 3 * a - 0.75;
			//count = 1;
			while (r == 0)
			{
			u = SimulUniformeContinue(0,1);
			v = SimulUniformeContinue(0,1);
			w = u * (1 - u);
			y = sqrt(c / w) * (u - 0.5);
			x = bb + y;
			if (x>=0)
			{
				z = 64 * (pow(w,3)) * v * v;
				if (z<=1-2*y*y/x)
					r = x;
				else
				{
					if (log(z) <= (2 * (bb * log(x / bb) - y)))
						r = x;
				}
				
			}
			}
			return(r * b);
		}
	}
}
			
/*			while ((z<=1-2*y*y/x) || (log(z)<=2*(bb*log(x/bb)-y))) 
			{
				u = SimulUniformeContinue(0,1);
				while(u == 0)
					u = SimulUniformeContinue(0,1);
				v = SimulUniformeContinue(0,1);
				while(v == 0)
					v = SimulUniformeContinue(0,1);
				w = u * (1 - u);
				y = sqrt(c / w) * (u - 0.5);
				x = bb + y;
				while (x<0)
				{
					u = SimulUniformeContinue(0,1);
					v = SimulUniformeContinue(0,1);;
					w = u * (1 - u);
					y = sqrt(c / w) * (u - 0.5);
					x = bb + y;
				}
				z = 64 * (pow(w,3)) * v * v;
			}
			r = x;
			return(r * b);
		}
	}*/




/*double W,U,Y,c,T,dec;

 int i,ent;
 if (a<1 && b==1)
  {Y=0;
   W=2;
   while((Y<1 && exp(-Y)<W)||(Y>=1 && pow(Y,a-1)<W))
    {U=SimulUniformeContinue(0,1);
     W=SimulUniformeContinue(0,1);
     c=(a+exp(1))/exp(1);
     if (U<1/c) Y=pow(U*c,1/a);
     else Y=-log((1-U)*c/a);
    }
   return (Y);
  }
 else
  {ent=floor(a);
   dec=a-ent;
   W=1;
   T = 1;
   for (i=0;i<ent;i++)
   {
	   T = SimulUniformeContinue(0,1); 
	   while (T == 0)
		   T = SimulUniformeContinue(0,1);
	   W = W * T;
   }

   while (W==0)
   {
		W=1;
		T = 1;
		for (i=0;i<ent;i++)
		{
			T = SimulUniformeContinue(0,1); 
			while (T == 0)
				T = SimulUniformeContinue(0,1);
			W = W * T;
		}
   }
   Y=-log(W);
   if (dec!=0) Y+=SimulGamma(dec,1);
   return (Y*b);
  }
}*/


double Simulation::SimulChi2(int n)
{double Ui,X,Y;

 int i;
 Ui=0;
 if (fmod(n,2)==0)
  {for(i=0;i<n/2;i++)
    Ui=Ui+SimulExponentielle(2.0);
   return(Ui);
  }
 else
  {for(i=0;i<(n-1)/2;i++)
   Ui=Ui+SimulExponentielle(2.0);
   SimulNormale(0,1,X,Y);
   return(Ui+X*X);
  }
}

/*double Simulation::SimulCauchy(double a)
{
double U1,U2,V;

U1 = SimulUniformeContinue(0,1);
U2 = SimulUniformeContinue(0,1);
V = 2*U2 - 1;
while ((U1*U1+V*V)>=1)
{
        U1 = SimulUniformeContinue(0,1);
        while (U1 == 0 )
                U1 = SimulUniformeContinue(0,1);
        U2 = SimulUniformeContinue(0,1);
        V = 2*U2 - 1;
}
return (V/U1);
}*/

// Marsiglia et Bray
void  Simulation::SimulNormale(double m, double r, double &X, double &Y)
 {double U,V,W1,W2,W;

  W=2;
  while(W>1)
   {U=SimulUniformeContinue(0,1);
    V=SimulUniformeContinue(0,1);
    W1=2*U-1;
    W2=2*V-1;
    W=W1*W1+W2*W2;
    if (W==0) W=2;
   }
   X = r*(sqrt((-2*log(W))/W)*W1)+m;//sqrt(r)
   Y = r*(sqrt((-2*log(W))/W)*W2)+m;//sqrt(r)
 }

double Simulation::SimulStudent(int n)
 {double X,Y,Z;

 SimulNormale(0,1,X,Y);
 Z=SimulChi2(n);
 return(X/sqrt(Z/n));
}

/*double Simulation::SimulFisherSnedecor(int m, int n)

{double Y,Z;

 Y=SimulChi2(n);
 Z=SimulChi2(m);
 return((Y/n)/(Z/m));
}*/

double Simulation::SimulBeta1espece(double p, double q)
{
double X,Y;

X = SimulGamma(p,1);
Y = SimulGamma(q,1);
while (Y == 0)
        Y = SimulGamma(q,1);

return (X/(X + Y));
}

/*double Simulation::SimulBeta2espece(double p, double q)
{
double X,Y,Z;

X = SimulGamma(p,1);
Y = SimulGamma(q,1);
while (Y == 0)
        Y = SimulGamma(q,1);

Z = X/Y;

return (Z);
}*/

double Simulation::SimulWeibull(double a, double b)
{
return (pow(SimulExponentielle(a),1/b));
}

void Simulation::SimulLognormale(double a, double b, double &X, double &Y)
{
double n1,n2;
	SimulNormale(0,1,n1,n2);
	X = exp(n1 * b + a);
	Y = exp(n2 * b + a);
}

/*double Simulation::SimulRayleigh(double v)
{
double U;

U = SimulUniformeContinue(0,1);
while (U == 0)
        U = SimulUniformeContinue(0,1);

return (sqrt(-2*v*v*log(U)));
}*/

double Simulation::SimulPareto(double x0, double alpha)
{
double U;

	U = SimulUniformeContinue(0,1);
	return(x0/pow(U,1/alpha));
}

double Simulation::SimulGPD(double gam, double sigma)
{
double U, Temp;

	U = SimulUniformeContinue(0,1);
	Temp = sigma/gam;
	if (gam!=0)
		return(Temp/pow(U,gam)-Temp);
	else
		return(SimulExponentielle(sigma));
}

double Simulation::SimulStudentApprochee(double mu, double STAP2, double STAP3)
{
double Gamma(double x);
Densite D;
double K,U,V,W,Temp1,Temp2,C;
int Accept;

	K = Gamma(STAP2 + 0.5) / sqrt(2 * pi * STAP3) * Gamma(STAP2);
	C = sqrt(2 * STAP3 / (STAP2 + 0.5));
	Accept = 0;
	while (Accept == 0)
	{
		U = SimulUniformeContinue(0,1);
		V = - C / tan(pi * U);
		W = SimulUniformeContinue(0,1);
		Temp1 = K * W * C * C / (C * C + V * V);
		Temp2 = D.DensiteStudentApprochee(V,0,STAP2,STAP3);
		if (Temp1 <= Temp2)
			Accept = 1;
	}
	return(V + mu);
}

double Simulation::SimulCalcul(Loi NomLoi, Parametre &P)
{
switch (NomLoi)
        {
        case UniformeContinue : return(SimulUniformeContinue(P.element(1),P.element(2)));
        case Chi2 : return (SimulChi2((int)P.element(1)));
        case Exponentielle : return (SimulExponentielle(P.element(1)));
//        case Cauchy : return (SimulCauchy(P.element(1)));
//        case FisherSnedecor : return (SimulFisherSnedecor(P.element(1),P.element(2)));
        case Student : return (SimulStudent((int)P.element(1)));
        case Weibull : return (SimulWeibull(P.element(1),P.element(2)));
/*        case UniformeDiscrete : return (SimulUniformeDiscrete(P.element(1)));
        case Bernoulli : return (SimulBernoulli(P.element(1)));
        case Binomiale : return (SimulBinomiale(P.element(1),P.element(2)));
        case Poisson : return (SimulPoisson(P.element(1)));*/
        case LoiGamma : return (SimulGamma(P.element(1),P.element(2)));
/*        case Hypergeometrique : return (SimulHypergeometrique(P.element(1),P.element(2),P.element(3)));
        case Geometrique : return (SimulGeometrique(P.element(1)));
        case BinomialeNegative : return (SimulBinomialeNegative(P.element(1),P.element(2)));
        case BernoulliSymetrique : return (SimulBernoulliSymetrique(P.element(1)));*/
//        case Lognormale : return (SimulLognormale(P.element(1),P.element(2)));
        case Beta1espece : return (SimulBeta1espece(P.element(1),P.element(2)));
//        case Beta2espece : return (SimulBeta2espece(P.element(1),P.element(2)));
//        case Rayleigh : return (SimulRayleigh(P.element(1)));
		case Pareto : return (SimulPareto(P.element(1),P.element(2)));
		case GPD : return (SimulGPD(P.element(1),P.element(2)));
		case StudentApprochee : return(SimulStudentApprochee(P.element(1),P.element(2),P.element(3)));
        default : return (0);
        }
}


