% ********************************************************************************
%         Fichier d'interface graphique associe au logiciel EXTREMES
% 
%                             Jerome Ecarnot
%                              INRIA - IS2
%                                 2002
% ********************************************************************************

function varargout = Extremes(varargin)
% EXTREMES Application M-file for Extremes.fig
%    FIG = EXTREMES launch Extremes GUI.
%    EXTREMES('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 03-Aug-2005 15:16:41

if nargin == 0  % LAUNCH GUI
    
    fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	
    handles = guihandles(fig);
    
    % Initialisation des variables globales
    
    handles.NbParam = [0];      % Nb de parametres d'une loi
    handles.Tache = [0];        % Numero de tache
    handles.NomFichier = '';    % Nom du fichier de donnees
    handles.Workspace = '';     % Liste des espaces de travail
    handles.Action = '';        % Nom de l'action
    handles.Nomloi = '';        % Nom de la loi
    handles.Taille = [0];       % Taille (nb d'elements) du fichier de donnees
    handles.Suite = [0];        % Variable pour aspect graphique (Regularisation bayesienne)
    handles.ParamPred = [0];    % Parametres de la loi predictive
    handles.ParamAPriori = [0]; % Parametres de la loi a priori
    handles.ZoomMoins = [];     % Variable de zoom 
    handles.CouleurHisto = [1 0 0]; % Couleur des histogramme
    
    Chemin = which('launch');
    [a,b,c] = fileparts(Chemin);
    [a,b,c] = fileparts(a);
    handles.Aide = [a '/Doc/ManU.htm'];
    Chemin = [a '/Temp'];
%    handles.path = 'z:/extremes/Temp';  % PATH (chemin) general
    handles.path = Chemin;
    %Chemin = ['"' a '/Debug/liste.exe" ' '"'];
    Chemin = [a '/Source/bin/main'];
%    handles.Prog = 'z:/extremes/Debug/liste.exe "';
    handles.Prog = Chemin;
%     pa = pwd;
%     cd ..
%     handles.path = [pwd '/Temp'];  % PATH (chemin) general
%     handles.Prog = [pwd '/Debug/liste.exe "'];
    handles.CheminLangue = [a '/Matlab/langues.txt'];
    handles.CheminLangueFr = [a '/Matlab/MenuFr.txt'];
    handles.CheminLangueEn = [a '/Matlab/MenuEn.txt'];
    handles.langue = DemandeLangue([a '/Matlab/langues.txt']);
    if handles.langue == 1
        ChargeMenus(handles,[a '/Matlab/MenuFr.txt']);
    else
        ChargeMenus(handles,[a '/Matlab/MenuEn.txt']);
    end

    % Visibilite ou invisibilite des menus
    
    set(handles.MenuEstim,'Enable','off');
    set(handles.GraphHistogramme,'Enable','off');
    set(handles.MenuSimulationsPred,'Enable','off');
    set(handles.MenuTests,'Enable','off');
    set(handles.RegBay,'Enable','off');
    
    % Menu contextuel du graphique
    
    set(handles.DensitesRB,'Enable','off');
    set(handles.SurvieRB,'Enable','off');
    set(handles.DensiteEstim,'Enable','off');
    set(handles.SurvieEstim,'Enable','off');
    set(handles.Histo1Param,'Enable','off');
    set(handles.Histo2Param,'Enable','off');
    set(handles.Histo3Param,'Enable','off');
    set(handles.Pente,'Enable','off');
    set(handles.QQPlotGPD,'Enable','off');
    set(handles.CourbeGamma,'Enable','off');
    set(handles.CourbeSigma,'Enable','off');
    
    % position de la fenetre
    Pos = get(0,'Screensize');
    set(handles.Extremes,'Position',[(Pos(3) - 800) / 2, (Pos(4) - 600) / 2, 800, 600]);
    
    % Creation d'un repertoire "Temp"
    
	[path,name] = fileparts(handles.path);
    if exist(handles.path,'dir')==0
        [s,t]=mkdir([path '/'],'Temp');
    end
    
    % Sauvegarde des variables globales
    
    guidata(fig, handles);

    if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------

function varargout = Extremes_CreateFcn(h, eventdata, handles, varargin)
% Stub for CreateFcn of the figure handles.Extremes.

% --------------------------------------------------------------------

function varargout = MenuSimulations_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uimenu handles.MenuSimulations.


% --------------------------------------------------------------------
% QUITTER
% Destruction du repertoire "Temp" et de tous ses sous-repertoires.

function varargout = MenuFichiersQuitter_Callback(h, eventdata, handles, varargin)
[status,result] = unix(['rm -rf ' handles.path]);
clear all;
closereq;

% --------------------------------------------------------------------
% PREPARATION SIMULATION NORMALE

function varargout = MenuSimulationsNormale_Callback(h, eventdata, handles, varargin)
% Affichage de l'action en cours
AfficheActionEnCours(handles,'Simulation Normale');

% Creation d'un nouvel espace de travail si new == 1
[new,EspaceDeTravail] = NouvelEspace(handles);

% Si nouvel espace
if new == 1
    
    % Invisibilite des Frames non concernees
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Affectation des variables globales
    handles.NbParam = 2;
    handles.Tache = 1;
    handles.Nomloi = 'Normale';
    
    % Liste des espaces de travail
    handles.Workspace = cellstr(EspaceDeTravail);
    
    % Affectation de la liste des espaces
    set(handles.PopupTravail,'String',handles.Workspace);
    
    % Environnement graphique
    set(handles.BtLancer,'Enable','on');
%     set(handles.TextParam4,'String','Taille de l''echantillon');
%     set(handles.TextParam5,'String','Nb de jeux de donnees');   
%     set(handles.TextParam6,'String','Nb de classes');
    ConfigLangueParam(handles);
    
    % Affectation des valeurs par defaut
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    
    % Affichage de la Frame pour la saisie des parametres
    AfficheFrameParam(handles,'m','sigma','',2);
    
    % Aucune action encore effectuee
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
%     set(handles.PopupAction,'String','Aucune action');
    
    % Sauvegarde des varaibles
    guidata(handles.Extremes,handles);
else
    % si new == 0, annulation
    set(handles.TextEnCours,'String','');
end

% Cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION LOGNORMALE

function varargout = MenuSimulationsLognormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Lognormale');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Lognormale';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'m','sigma','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION CHI2

function varargout = MenuSimulationsChi2_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Chi2');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Chi2';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'n','','',1);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION STUDENT

function varargout = MenuSimulationsStudent_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Student');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Student';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'n','','',1);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION BETA

function varargout = MenuSimulationsBeta_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Beta');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Beta1espece';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'a','b','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION GAMMA

function varargout = MenuSimulationsGamma_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Gamma');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Gamma';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'a','teta','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION EXPONENTIELLE

function varargout = MenuSimulationsExponentielle_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Exponentielle');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Exponentielle';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'alpha','','',1);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION WEIBULL

function varargout = MenuSimulationsWeibull_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Weibull');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Weibull';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'eta','beta','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION PARETO

function varargout = MenuSimulationsPareto_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Pareto');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Pareto';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'x0','alpha','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION GPD

function varargout = MenuSimulationsGPD_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation GPD');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'GPD';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'gamma','sigma','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION UNIFORME

function varargout = MenuSimulationsUniforme_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Simulation Uniforme');
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    handles.Tache = 1;
    handles.Nomloi = 'Uniforme';
    ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    AfficheFrameParam(handles,'a','b','',2);
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end
%cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------
% PREPARATION SIMULATION LOI PREDICTIVE

function varargout = MenuSimulationsPred_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Simulation predictive');

% Lecture du repertoire de travail "Rep"
Rep = LitRepEDT(handles);

% DEBUT Recuperation des bons fichiers

    % Recuperation de la liste des actions
ListeAction = get(handles.PopupAction,'String');

    % rang occupe dans la liste
Index = get(handles.PopupAction,'Value');

    % Recuperation du numero de fichiers, inversion de la liste
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Regularisation bayesienne';
else
    X = 'Bayesian regularisation';
end

    % si l'action recherchee est celle affichee 
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    % recherche de l'action 'Regularisation bayesienne' dans la liste
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end

    % bon numero de fichiers
k1 = int2str(k(end));

    % construction des noms de fichiers concernes
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];

% FIN Recuperation

% Lecture du fichier Tmp
RTmp=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Lecture du fichier resultat
R = load(FichierResult);

% Lecture du fichier de donnees
Rdonnees = load(FichierDonnees);

% Creation d'un nouvel espace si new == 1
[new,EspaceDeTravail] = NouvelEspace(handles);
if new == 1
    
    % Invisibilite des Frames concernees
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameInfoInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Actualisation de la liste des espaces de travail
    handles.Workspace = cellstr(EspaceDeTravail);
    set(handles.PopupTravail,'String',handles.Workspace);
    
    % Environnement graphique
    set(handles.BtLancer,'Enable','on');
    ConfigLangueParam(handles);
    
    % Affectation du numero de tache, du nom de loi et du nom de fichier de donnees
    handles.Tache = 27;
    handles.Nomloi = char(RTmp(5));
    handles.NomFichier = FichierDonnees;
    
    % Affichage des parametres recuperes de la loi predictive suivant le modele choisi
    switch(char(RTmp(5)))
    case 'Normale'
        Loi = 'StudentApprochee';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        set(handles.EditParam3,'String',sprintf('%f',R(9)));
        
        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8);R(9)];
        
    case 'Lognormale'
        Loi = 'StudentApprocheeTrans';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        set(handles.EditParam3,'String',sprintf('%f',R(9)));

        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8);R(9)];
        
    case 'Exponentielle'
        Loi = 'GPD';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        
        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8)];
        
    case 'Gamma'
        Loi = 'Beta2Prop';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        set(handles.EditParam3,'String',sprintf('%f',R(9)));
        
        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8);R(9)];
        
    case 'WeibullEchelle'
        Loi = 'GPDTrans';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        set(handles.EditParam3,'String',sprintf('%f',R(9)));
        
        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8);R(9)];
        
    case 'WeibullForme'
        Loi = 'WeibPred';
        set(handles.EditParam1,'String',sprintf('%f',R(7)));
        set(handles.EditParam2,'String',sprintf('%f',R(8)));
        set(handles.EditParam3,'String',sprintf('%f',R(9)));
        
        % Affectation des parametres de la loi predictive
        handles.ParamPred = [R(7);R(8);R(9)];
        
    end
    
    % Affectation des parametres recuperes de la loi a priori
    handles.ParamAPriori = [R(5);R(6)];
    
    % Affectation des bornes recuperees de la loi beta a priori (weibull parametre de forme)
    handles.BorneBeta = [RTmp(6);RTmp(7)];
    
    % Parametres par defaut de la taille de l'echantillon, nb de jeux de donnees et nb de classes de l'histogramme
    set(handles.EditParam4,'String',size(Rdonnees,1));
    set(handles.EditParam5,'String',1);
    set(handles.EditParam6,'String',20);
    
    % Nom des parametres suivant la loi predictive
    [P1,P2,P3,NbParam] = NomDesParametres(handles,Loi);
    
    % Affichage de la Frame de saisie
    AfficheFrameParam(handles,P1,P2,P3,NbParam);
    
    % Affectation du nombre de parametres de la loi a priori 
    handles.NbParam = 2;
    
    % Aucune action effectuee
    handles.Action = '';
    set(handles.PopupAction,'Value',1);
    %set(handles.PopupAction,'String','Aucune action');
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
else
    % si new == 0, annulation
    set(handles.TextEnCours,'String','');
end

% Cree un nouveau repertoire de travail sur le disque si new == 1
CreeRepEDT(handles,new);

% --------------------------------------------------------------------

function varargout = EditParam1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam1.

% --------------------------------------------------------------------

function varargout = EditParam2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam2.

% --------------------------------------------------------------------

function varargout = EditParam4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam4.

% --------------------------------------------------------------------

function varargout = EditParam5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam4.

% --------------------------------------------------------------------

function varargout = BtLancer_CreateFcn(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
% LANCEMENT DE SIMULATION, DENSITES, FDR, SURVIE, ESTIMATION PAR NOYAU

function varargout = BtLancer_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLancer.

% Verification des entrees saisies par l'utilisateur
V = VerifParam(handles);
switch (V)
case 0
    if handles.langue == 1
        errordlg('Un ou plusieurs champs sont vides ou presence de caracteres non numeriques.','Erreur de saisie','modal');
    else
        errordlg('Empty entry or non numerical value found.','Error','modal');
    end
case 2
    if handles.langue == 1
        errordlg('La borne inferieure de l''intervalle doit etre inferieure ou egale e la borne superieure.','Erreur de saisie','modal');
    else
        errordlg('Inferior limit must be smaller or equal than superior limit.','Error','modal');
    end
case 3
    if handles.langue == 1
        errordlg('Le nombre de points doit etre egal e 1.','Erreur de saisie','modal');
    else
        errordlg('Number of points must be equal to 1.','Error','modal');
    end
case 4
    if handles.langue == 1
        errordlg('Le nombre de points doit etre strictement positif','Erreur de saisie','modal');
    else
        errordlg('Number of points must be strictly a positive integer.','Error','modal');
    end
case 5
    if handles.langue == 1
        errordlg('Le nombre de classes doit etre strictement positif','Erreur de saisie','modal');
    else
        errordlg('Number of bins must be strictly a positive integer.','Error','modal');
    end
case 6
    if handles.langue == 1
        errordlg('Le parametre de lissage doit etre strictement positif','Erreur de saisie','modal');
    else
        errordlg('Smoothing parameter must be strictly a positive real.','Error','modal');
    end
case 7
    if handles.langue == 1
        errordlg('Les bornes doivent etre comprise strictement entre 0 et 1','Erreur de saisie','modal');
    else
        errordlg('Limits must be strictly between 0 and 1.','Error','modal');
    end
case 8
    if handles.langue == 1
        errordlg('La taille de l''echantillon doit etre strictement positive','Erreur de saisie','modal');
    else
        errordlg('Sample size must be strictly a positive integer.','Error','modal');
    end
case 9
    if handles.langue == 1
        errordlg('Le nombre d''echantillons souhaites doit etre superieur ou egal e 1','Erreur de saisie','modal');
    else
        errordlg('Number of samples must be greater than 1','Error','modal');
    end
otherwise
    
    % Remplissage de l'espace des actions avec une nouvelle action
    EspaceAction = strvcat(char(handles.Action));
    Action = TacheToAction(handles);
    EspaceAction = strvcat(Action,EspaceAction);
    
    % DEBUT Construction du fichier de donnees
    
        % lecture de l'espace de travail
    Rep = LitRepEDT(handles);
    
        % Construction
    if isempty(handles.NomFichier)
        FichierDonnees = [Rep '/' 'Donnees.txt'];
    else
        FichierDonnees = handles.NomFichier;
    end
        % si le fichier n'existe pas, on le remplace par "*"
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
    
    % FIN construction
    
    % Construction du fichier resultat
    N = int2str(size(EspaceAction,1));
    FichierResultat = [Rep '/' 'Result' N '.txt'];
    
    % DEBUT Construction des parametres
    
    % si estimation par noyau
    if handles.Tache == 6
        
        % choix de la densite
        if get(handles.Radio1,'Value') == 1
            
            % Normale
            Param1 = '1';
            
        else
            % 0.75(1 - xe)
            Param1 = '2';
        end
    else
        % si ce n'est pas simulation de la loi predictive
        if  handles.Tache ~= 27
            
            % Affectation du premier parametre de la loi
            Param1 = get(handles.EditParam1,'String');
        
        % si simulation loi predictive
        else
            
            % Affectation du 1er parametre de la loi a priori
            Param1 = num2str(handles.ParamAPriori(1));
        end
    end
    
    % si 1 seul parametre, on met "*" pour les 2 autres
    if strcmp(get(handles.EditParam2,'Visible'),'off')==1
        Param2 = '*';
    
    % si au moins 2 parametres
    else
        if handles.Tache ~= 27
            Param2 = get(handles.EditParam2,'String');
        else
            Param2 = num2str(handles.ParamAPriori(2));
        end
    end
    
    % si 2 parametres
    if strcmp(get(handles.EditParam3,'Visible'),'off')==1
        Param3 = '*';
    
    % si 3 parametres
    else
        if handles.Tache ~= 27
            Param3 = get(handles.EditParam3,'String');
        else
            Param3 = '*';
        end
    end
    
    % FIN construction des parametres
    
    % Construit le nombre d'iterations et le nombre de simulations ou BorneInf, BorneSup et Nb de points. 
    if handles.Tache ~= 0
        NbIterBI = get(handles.EditParam4,'String');
        NbSimulBS = get(handles.EditParam5,'String');
        NbPointsCL = get(handles.EditParam6,'String');
    else
        NbIterBI = '*';
        NbSimulBS = '*';
        NbPointsCL = '*';
    end
    
    % DEBUT Creation du fichier d'echange "Tmp"
    
        % nom du fichier d'echange
    FichierEchange = [Rep '/' 'Tmp' N '.txt'];
    
        % ouverture en ecriture de ce fichier
    fid3 = fopen(FichierEchange,'w');
    Rep1 = [Rep '/'];
    fprintf(fid3,'%s\n',Rep1);
    fprintf(fid3,'%s\n',FichierDonnees);
    t = handles.Tache;
    t1 = int2str(t);
    fprintf(fid3,'%s\n',t1);
    fprintf(fid3,'%s\n',FichierResultat);
    Loi = char(handles.Nomloi);
    fprintf(fid3,'%s\n',Loi);
    fprintf(fid3,'%s\n',Param1);
    fprintf(fid3,'%s\n',Param2);
    fprintf(fid3,'%s\n',Param3);
    fprintf(fid3,'%s\n',NbIterBI);
    fprintf(fid3,'%s\n',NbSimulBS);
    fprintf(fid3,'%s\n',NbPointsCL);
    
    % si simulation de loi predictive, ecriture des bornes inf et sup de la loi beta a priori
    % et des parametres prdedictifs
    if handles.Tache == 27
        fprintf(fid3,'%s\n',char(handles.BorneBeta(1)));
        fprintf(fid3,'%s\n',char(handles.BorneBeta(2)));
        fprintf(fid3,'%s\n',num2str(handles.ParamPred(1)));
        fprintf(fid3,'%s\n',num2str(handles.ParamPred(2)));
        if size(handles.ParamPred,1) ~= 2
            fprintf(fid3,'%s\n',num2str(handles.ParamPred(3)));
        else
            fprintf(fid3,'%s\n','*');
        end
    end
    fclose(fid3);
    
    % affectation de la taille de l'echantillon e handles.Taille
    if t == 1
        handles.Taille = str2num(NbIterBI);
    end
    
    % Le bouton lancer devient inaccessible
    set(handles.BtLancer,'Enable','off');
    
    % Lancement du prog C++ suivant la tache e effectuer
    if handles.Tache ~= 27
        %[status result] = dos(['z:\extremes\Debug\liste.exe "' FichierEchange '"' ' ' '"' '1' '"']);
        %[status result] = dos([handles.Prog FichierEchange '"' ' ' '"' '1' '"']);
        [status result] = unix([handles.Prog ' ' FichierEchange ' 1']);
    else
        [status result] = unix([handles.Prog ' ' FichierEchange ' 4']);
    end
    
    % RECUPERATION DES RESULTATS
    
    % Construction du fichier d'erreur
    FichierErreur = [Rep '/' 'Erreur.txt'];
    
    % on regarde si le prog C++ a cree un fichier d'erreur (0 == n'existe pas)
    if exist(FichierErreur)==0
        
        % Actualisation de la liste des actions et affectattion de celle-ci
        handles.Action = cellstr(EspaceAction);
        set(handles.PopupAction,'String',handles.Action);
        set(handles.PopupAction,'Value',1);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
        % question pour l'utilisateur
        if handles.langue == 1
            GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
        else
            GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
        end
        
        switch (GardeGraph)
        case {'Oui','Yes'}
            
            % on affiche sur le meme graphe
            hold on;
            couleur = 'b';
        case {'Non','No'}
            % nouveau graphe
            hold off;
            couleur = 'r';
        end
        
        % Recuperations des resultats selon la tache
        switch (t)
            
        case 1  % Simulation
            
            % Recuperation du fichier resultat
            R = load(FichierResultat);
            
            % Recuperation du fichier de donnees
            FichierDonnees = [Rep '/' 'Donnees.txt'];
            Rbis = load(FichierDonnees);

            % pas de moments thoriques
            if R(3) == -1 & R(1) == -1  
                if handles.langue == 1
                    R1 = 'non';
                    R3 = 'non';
                else
                    R1 = 'no';
                    R3 = 'no';
                end
            else
                % 1 ou 2 moments theoriques definis
                % pas de variance
                if R(3) == -1
                    if handles.langue == 1
                        R3 = 'non';
                    else
                        R3 = 'no';
                    end
                else
                    % moyenne et variance
                    R3 = sprintf('%f',R(3));
                    R3 = num2str(R3);
                end
                R1 = sprintf('%f',R(1));
                R1 = num2str(R1);
            end
            
            % Affectation de la Frame Info
            set(handles.EditMoyTheo,'String',R1);   % moyenne theorique
            R2 = sprintf('%f',R(2));                
            R2 = num2str(R2);
            set(handles.EditMoyCal,'String',R2);    % moyenne estimee
            set(handles.EditVarTheo,'String',R3);   % variance theorique
            R4 = sprintf('%f',R(4));                
            R4 = num2str(R4);
            set(handles.EditVarCal,'String',R4);    % variance calculee    
            R5 = sprintf('%f',R(5));
            R5 = num2str(R5);
            set(handles.EditQuartile1,'String',R5); % 1er quartile
            R6 = sprintf('%f',R(6));
            R6 = num2str(R6);
            set(handles.EditQuartile3,'String',R6); % 3eme quartile
            R7 = sprintf('%f',R(7));
            R7 = num2str(R7);
            set(handles.EditMediane,'String',R7);   % Mediane
            
            % DEBUT Histogramme
            NbClasse = round(str2double(get(handles.EditParam6,'String')));
                % effectifs de chaque classe (N) et centres des classes (X)
            [N,X] = hist(Rbis,NbClasse);
            
                % Amplitude entre 2 classes
            Amp = X(2)-X(1);
            
                % Normalisation des effectifs
            N = N/size(Rbis,1)/Amp;
            
                % Affichage de l'histogramme avec une couleur colormap
            bar(X,N,'hist');
            colormap(handles.CouleurHisto);
            
            % FIN Histogramme
            
            % Affichage de la Frame Info
            FrameInfoVisible(handles);
            
            % Titre du graphique
            if handles.langue == 1
                title(['Simulation de VA de loi ' Loi ' - Histogramme'],'Color','r');
            else
                LoiEn = LoiFrToEn(Loi);
                title(['Random numbers from ' LoiEn ' distribution - Histogram'],'Color','r');
            end

            % Accessibilite aux menus Estimation, Histogramme, tests et reg bay
            set(handles.MenuEstim,'Enable','on');
            set(handles.GraphHistogramme,'Enable','on');
            set(handles.MenuTests,'Enable','on');
            set(handles.RegBay,'Enable','on');
            
        case {2,3,4,6,8} % Densites, FDR, Fonction quantile, Estimation par noyau et Survie
            
            % Recuperation du fichier resultat
            R = load(FichierResultat);
            
            % Affichage de la courbe
            plot(R(:,1),R(:,2),couleur);
            
            % Titre du graphique suivant la tache
            switch(t)
            case 2  % densites
                if handles.langue == 1
                    title(['Densite de la loi ' Loi],'Color','r');
                else
                    LoiEn = LoiFrToEn(Loi);
                    title([LoiEn ' probability density function'],'Color','r');
                end
            case 3  % FDR
                if handles.langue == 1
                    title(['Fonction de repartition de la loi ' Loi],'Color','r');
                else
                    LoiEn = LoiFrToEn(Loi);
                    title([LoiEn ' cumulative distribution function'],'Color','r');
                end
            case 4  % fonction quantile
                if handles.langue == 1
                    title(['Fonction quantile de la loi ' Loi],'Color','r');
                else
                    LoiEn = LoiFrToEn(Loi);
                    title([LoiEn ' quantile function'],'Color','r');
                end
            case 6  % estimation par noyau
                if handles.langue == 1
                    title('Estimation de la densite','Color','r');
                else
                    title('Density estimate','Color','r');
                end
            case 8  % survie
                if handles.langue == 1
                    title(['Fonction de survie de la loi ' Loi],'Color','r');
                else
                    LoiEn = LoiFrToEn(Loi);
                    title([LoiEn ' survival function'],'Color','r');
                end
            end
            
        case 27     % simulation de la loi predictive
            
            % Recuperation du fichier resultat
            R = load(FichierResultat);
            
            % Recuperation du fichier de donnees
            FichierDonnees = [Rep '/' 'Donnees.txt'];
            Rbis = load(FichierDonnees);
            
            % Pas de moments thoriques
            if R(3) == -1 & R(1) == -1
                if handles.langue == 1
                    R1 = 'non';
                    R3 = 'non';
                else
                    R1 = 'no';
                    R3 = 'no';
                end
            else
                % pas de variance
                if R(3) == -1
                    if handles.langue == 1
                        R3 = 'non';
                    else
                        R3 = 'no';
                    end
                else
                    % moyenne et variance
                    R3 = sprintf('%f',R(3));
                    R3 = num2str(R3);
                end
                R1 = sprintf('%f',R(1));
                R1 = num2str(R1);
            end
            
            % Affectation de la Frame Info
            set(handles.EditMoyTheo,'String',R1);
            R2 = sprintf('%f',R(2));
            R2 = num2str(R2);
            set(handles.EditMoyCal,'String',R2);
            set(handles.EditVarTheo,'String',R3);
            R4 = sprintf('%f',R(4));
            R4 = num2str(R4);
            set(handles.EditVarCal,'String',R4);
            R5 = sprintf('%f',R(5));
            R5 = num2str(R5);
            set(handles.EditQuartile1,'String',R5);
            R6 = sprintf('%f',R(6));
            R6 = num2str(R6);
            set(handles.EditQuartile3,'String',R6);
            R7 = sprintf('%f',R(7));
            R7 = num2str(R7);
            set(handles.EditMediane,'String',R7);
            
            % Histogramme normalise
            NbClasse = round(str2num(NbPointsCL));
            [K,X] = hist(Rbis,NbClasse);
            Amp = X(2)-X(1);
            K = K/size(Rbis,1)/Amp;
            bar(X,K,'hist');
            colormap(handles.CouleurHisto);
            
            % Affichage de la Frame Info
            FrameInfoVisible(handles);
            
            % Titre du graphique
            if handles.langue == 1
                title(['Simulation selon la loi predictive d''un modele ' Loi],'Color','r');
            else
                LoiEn = LoiFrToEn(Loi);
                title(['Random numbers from predictive distribution of ' LoiEn ' model'],'Color','r');
            end
        end
        
        % Actualise le fichier des actions
        FichierAction = [Rep '/' 'Action.txt'];
        fid1 = fopen(FichierAction,'a');
        fprintf(fid1,'%s\n',Action);
        fclose(fid1);
         
        % Actualise le fichier des numeros de taches
        FichierTache = [Rep '/' 'Tache.txt'];
        fid2 = fopen(FichierTache,'a');
        fprintf(fid2,'%d\n',t);
        fclose(fid2);
        
    else
        % lecture du fichier d'erreur
        fid4 = fopen(FichierErreur,'r');
        Message = fgets(fid4);
        fclose(fid4);
        
        % Suppression du fichier
        delete(FichierErreur);
        
        % Affichage du message
        if handles.langue == 1
            errordlg(Message,'Erreur de saisie utilisateur','modal');
        else
            errordlg(Message,'User write error','modal');
        end
        
        % Bouton Lancer accessible
        set(handles.BtLancer,'Enable','on');
        
    end
end
% Aucune action en cours
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% LANCEMENT DE ESTIMATION DES PARAMETRES

function varargout = BtLanceEstim_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLanceEstim.

% Remplissage de l'espace des actions
EspaceAction = strvcat(char(handles.Action));
Action = TacheToAction(handles);
EspaceAction = strvcat(Action,EspaceAction);

% Construit le fichier de donnees
% Lit l'espace de travail dans lequel on se trouve
Rep = LitRepEDT(handles);

% Donnees multiples
if handles.Tache == 26
    FichierDonnees = 'Tous';
else
    % Donnees simples
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
end

% Construit le fichier resultat
N = int2str(size(EspaceAction,1));
FichierResultat = [Rep '/' 'Result' N '.txt'];

% Construit les parametres
Param1 = '*';
Param2 = '*';
Param3 = '*';
NbIterBI = '0';
NbSimulBS = '0';
NbPointsCL = '0';

% Cree le fichier d'echange Tmp
FichierEchange = [Rep '/' 'Tmp' N '.txt'];
fid3 = fopen(FichierEchange,'w');
Rep1 = [Rep '/'];
fprintf(fid3,'%s\n',Rep1);
fprintf(fid3,'%s\n',FichierDonnees);
t = handles.Tache;
t1 = int2str(t);
fprintf(fid3,'%s\n',t1);
fprintf(fid3,'%s\n',FichierResultat);
Loi = char(handles.Nomloi);
fprintf(fid3,'%s\n',Loi);
fprintf(fid3,'%s\n',Param1);
fprintf(fid3,'%s\n',Param2);
fprintf(fid3,'%s\n',Param3);
fprintf(fid3,'%s\n',NbIterBI);
fprintf(fid3,'%s\n',NbSimulBS);
fprintf(fid3,'%s\n',NbPointsCL);
fclose(fid3);
% Bouton Lancer inaccessible
set(handles.BtLanceEstim,'Enable','off');

% Lancement du prog C++
[status result] = unix([handles.Prog ' ' FichierEchange ' 1']);

% Recuperation des resultats
FichierErreur = [Rep '/' 'Erreur.txt'];
if exist(FichierErreur)==0
    
    % Si donnees multiples
    if handles.Tache == 26
        % Chargement des resultats
        R = load(FichierResultat);
        
        % Recuperations du nombres de fichiers traites
        NbFichiers = round(R(end));
        
        % Actualisation de la liste des actions
        handles.Action = cellstr(EspaceAction);
        set(handles.PopupAction,'String',handles.Action);
        set(handles.PopupAction,'Value',1);
        
        % Sauvegarde des variables globales
        guidata(handles.Extremes,handles);
        
        % Noms et nombre des parametres de la loi choisie
        [param1,param2,param3,NbParam] = NomDesParametres(handles,Loi);
        
        % Nouveau graphe
        hold off;
        
        % Histogramme des estimateurs
        if handles.langue == 1
            NbClasse = inputdlg('Nombre de classes :','Histogramme');
        else
            NbClasse = inputdlg('Number of bins :','Histogram');
        end
        NbClasse = str2num(char(NbClasse));
        [K,X] = hist(R(1:NbFichiers),NbClasse);
        Amp = X(2)-X(1);
        K = K/size(R(1:NbFichiers),1)/Amp;
        bar(X,K,'hist');
        colormap(handles.CouleurHisto);
        
        % Affectation des moyennes et variances des parametres calcules selon le nombre de parametres de la loi
        switch(NbParam)
        case 1
            set(handles.TextEstimP1,'String',sprintf('%f',R(NbFichiers+1)));
            set(handles.TextEstimP4,'String',sprintf('%f',R(NbFichiers+2)));
            % Menu contextuel du graphe accessible
            set(handles.Histo1Param,'Enable','on');
            
        case 2
            set(handles.TextEstimP1,'String',sprintf('%f',R(2*NbFichiers+1)));
            set(handles.TextEstimP4,'String',sprintf('%f',R(2*NbFichiers+2)));
            set(handles.TextEstimP2,'String',sprintf('%f',R(2*NbFichiers+3)));
            set(handles.TextEstimP5,'String',sprintf('%f',R(2*NbFichiers+4)));
            % Menu contextuel du graphe accessible
            set(handles.Histo1Param,'Enable','on');
            set(handles.Histo2Param,'Enable','on');
            
        case 3
            set(handles.TextEstimP1,'String',sprintf('%f',R(3*NbFichiers+1)));
            set(handles.TextEstimP4,'String',sprintf('%f',R(3*NbFichiers+2)));
            set(handles.TextEstimP2,'String',sprintf('%f',R(3*NbFichiers+3)));
            set(handles.TextEstimP5,'String',sprintf('%f',R(3*NbFichiers+4)));
            set(handles.TextEstimP3,'String',sprintf('%f',R(3*NbFichiers+5)));
            set(handles.TextEstimP6,'String',sprintf('%f',R(3*NbFichiers+6)));
            % Menu contextuel du graphe accessible
            set(handles.Histo1Param,'Enable','on');
            set(handles.Histo2Param,'Enable','on');
            set(handles.Histo3Param,'Enable','on');
            
        end
        
        % Titre du graphique
        if handles.langue == 1
            title(['Histogramme du parametre ' param1],'Color','r');
        else
            title(['Parameter ' param1 ' histogram'],'Color','r');
        end
        
        % Actualise le fichier des actions 
        FichierAction = [Rep '/' 'Action.txt'];
        fid1 = fopen(FichierAction,'a');
        fprintf(fid1,'%s\n',Action);
        fclose(fid1);
        
        % Actualise le fichier des numeros de taches
        FichierTache = [Rep '/' 'Tache.txt'];
        fid2 = fopen(FichierTache,'a');
        fprintf(fid2,'%d\n',t);
        fclose(fid2);
        
        % Action en cours terminee
        set(handles.TextEnCours,'String','');
        
    % 1 seul fichier de donnees    
    else
        
        % Determination des taches realisees en plus par le prog C++
        if handles.langue == 1
            ActionEnPlus = ['Densite ' Loi];
            ActionEnPlus = strvcat(ActionEnPlus,['Fonction de survie ' Loi]);
        else
            LoiEn = LoiFrToEn(Loi);
            ActionEnPlus = [LoiEn ' PDF'];
            ActionEnPlus = strvcat(ActionEnPlus,[LoiEn ' CDF']);
        end
        
        % Actualisation de la liste des actions
        ActionEnPlus = flipud(ActionEnPlus);
        EspaceAction = strvcat(ActionEnPlus,EspaceAction);
        handles.Action = cellstr(EspaceAction);
        set(handles.PopupAction,'String',handles.Action);
        set(handles.PopupAction,'Value',1);
        
        % Recuperation des resultats
        [R]=textread(FichierResultat,'%s','delimiter','\n','whitespace','');
        
        % Affichage des parametres estimes selon le nombre de ceux-ci
        R1 = str2num(char(R));
        if size(R,1)==1
            set(handles.TextEstimP1,'String',R1(1));
        end
        if size(R,1)==2
            set(handles.TextEstimP1,'String',R1(1));
            set(handles.TextEstimP2,'String',R1(2));    
        end
        if size(R,1)==3
            set(handles.TextEstimP1,'String',R1(1));
            set(handles.TextEstimP2,'String',R1(2));
            set(handles.TextEstimP2,'String',R1(3));
        end
        
        % Nouveau graphe
        hold off;
        
        % Histogramme normalise des donnees
        if handles.langue == 1
            NbClasse = inputdlg('Nombre de classes :','Histogramme');   % demande un nombre de classes
        else
            NbClasse = inputdlg('Number of bins :','Histogram');   % demande un nombre de classes
        end
        NbClasse = str2num(char(NbClasse));
        Rdonnees = load(FichierDonnees);
        [K,X] = hist(Rdonnees,NbClasse);
        Amp = X(2)-X(1);
        K = K/size(Rdonnees,1)/Amp;
        bar(X,K,'hist');
        colormap(handles.CouleurHisto);
        
        % Fichier Resultat suivant qui contient le calcul de la densite
        j = int2str(str2num(N)+1);
        FichierResultat = [Rep '/' 'Result' j '.txt'];
        
        % Chargement du fichier
        R = load(FichierResultat);
        
        % on garde le meme graphique
        hold on;
        
        % graphe de la densite
        plot(R(:,1),R(:,2),'b');
        
        % Titre du graphique
        if handles.langue == 1
            title(['Histogramme et densite de la loi ' Loi],'Color','r');
        else
            title(['Histogram and ' Loi ' probability density function'],'Color','r');
        end
        
        % Accessibilite aux menus contextuels du graphique
        set(handles.DensiteEstim,'Enable','on');
        set(handles.SurvieEstim,'Enable','on');
        
        % Actualise le fichier des actions
        ActionEnPlus = flipud(ActionEnPlus);
        ActionEnPlus = cellstr(ActionEnPlus);
        FichierAction = [Rep '/' 'Action.txt'];
        fid1 = fopen(FichierAction,'a');
        fprintf(fid1,'%s\n',Action);
        fprintf(fid1,'%s\n',char(ActionEnPlus(1)));
        fprintf(fid1,'%s\n',char(ActionEnPlus(2)));
        fclose(fid1);
        
        % Actualise le fichier des numeros de taches
        FichierTache = [Rep '/' 'Tache.txt'];
        fid2 = fopen(FichierTache,'a');
        fprintf(fid2,'%d\n',t);
        fprintf(fid2,'%d\n',2);
        fprintf(fid2,'%d\n',8);
        fclose(fid2);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
        % Action en cours terminee
        set(handles.TextEnCours,'String','');
        
    end
else
    % Lecture du fichier d'erreur
    fid4 = fopen(FichierErreur,'r');
    Message = fgets(fid4);
    fclose(fid4);
    
    % Supression du fichier 
    delete(FichierErreur);
    
    % Affichage du message
    if handles.langue == 1
        errordlg(Message,'Erreur de saisie utilisateur','modal');
    else
        errordlg(Message,'User write error','modal');
    end
    
    % Bouton Lancer accessible
    set(handles.BtLanceEstim,'Enable','on');
end

%---------------------------------------------------------------------

function varargout = Extremes_CloseRequestFcn(h, eventdata, handles, varargin)
% Stub for CloseRequestFcn of the figure handles.Extremes.
closereq

% --------------------------------------------------------------------
% CHANGEMENT D'ESPACE DE TRAVAIL

function varargout = popupmenu4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.popupmenu4.

% Lecture du nouvel espace de travail
Rep = LitRepEDT(handles);

% Nom des fichiers d'actions et de donnees
FichierAction = [Rep '/' 'Action.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];

% Menu contextuel du graphique desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');

% si le fichier d'action existe
if exist(FichierAction)~=0
    
    % Toutes frames invisibles
    % Invisibilte des frames concernees
    FrameParamInvisible(handles)
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameInfoInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % efface graphique
    cla;
    title('');
    
    % Chargement des donnes
    R = load(FichierDonnees);
    
    % Affectation du nombre d'elements
    handles.Taille = size(R,1);
    
    % Chargement des actions
    [names]=textread(FichierAction,'%s','delimiter','\n','whitespace','');
    
    % Affectation des actions
    EA = names(size(names,1):-1:1);
    handles.Action = cellstr(EA);
    set(handles.PopupAction,'Value',1);
    set(handles.PopupAction,'String',handles.Action);
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
    % Frame Info devient vide
    ViderEditInfo(handles);
end

% --------------------------------------------------------------------
% RAPPEL DE TOUTES LES ACTIONS

function varargout = popupmenu5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.popupmenu5.
% Aucune action en cours
set(handles.TextEnCours,'String','');

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Lecture de l'action recherchee et numero de celle ci
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);

% Construction des fichiers
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTache = [Rep '/' 'Tache.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];

% Lecture du fichier Tache
[T]=textread(FichierTache,'%d','delimiter','\n','whitespace','');

% numero de tache selectionne
Tache = T(k);

% Lecture du fichier tmp correspondant
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Affectation des variables
handles.NomFichier = char(Param(2));
handles.Tache = str2num(char(Param(3)));
handles.Nomloi = char(Param(5));

% Sauvegarde des variables
guidata(handles.Extremes,handles);

% Nouveau graphe
hold off;

% Affectation des parametres (parametres de la loi, taille de l'echantillon...) pour les taches 1..8
if Tache <= 8
    set(handles.EditParam1,'String',num2str(sprintf('%f',str2num(char(Param(6))))));
    set(handles.EditParam2,'String',num2str(sprintf('%f',str2num(char(Param(7))))));
    set(handles.EditParam3,'String',num2str(sprintf('%f',str2num(char(Param(8))))));
    if Tache == 1
        set(handles.EditParam4,'String',num2str(sprintf('%d',str2num(char(Param(9))))));
        set(handles.EditParam5,'String',num2str(sprintf('%d',str2num(char(Param(10))))));
    else
        set(handles.EditParam4,'String',num2str(sprintf('%f',str2num(char(Param(9))))));
        set(handles.EditParam5,'String',num2str(sprintf('%f',str2num(char(Param(10))))));
    end
    set(handles.EditParam6,'String',num2str(sprintf('%d',str2num(char(Param(11))))));
end

% Menu contextuel du graphique desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');

% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% Suivant la tache selectionnee
switch (Tache)

% Simulation
case 1
    
    % Invisibilte des frames concernees
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Environment graphique pour les simulations
    if handles.langue == 1
        set(handles.TextParam4,'String','Taille de l''echantillon');
        set(handles.TextParam5,'String','Nb de jeux de donnees');
        set(handles.TextParam6,'String','Nb de classes');
    else
        set(handles.TextParam4,'String','Sample size');
        set(handles.TextParam5,'String','Nb of data files');
        set(handles.TextParam6,'String','Nb of bins');
    end
    
    % lecture du fichier de donnees
    Rbis = load(FichierDonnees);
    
    % Nom et nb des parametres de la loi
    [param1,param2,param3,NbParam] = NomDesParametres(handles,handles.Nomloi);
    
    % Affichage de la Frame Param
    AfficheFrameParam(handles,param1,param2,param3,NbParam);

    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Affectation des infos
    R1 = sprintf('%f',R(1));
    R1 = num2str(R1);
    set(handles.EditMoyTheo,'String',R1);
    R2 = sprintf('%f',R(2));
    R2 = num2str(R2);
    set(handles.EditMoyCal,'String',R2);
    R3 = sprintf('%f',R(3));
    R3 = num2str(R3);
    set(handles.EditVarTheo,'String',R3);
    R4 = sprintf('%f',R(4));
    R4 = num2str(R4);
    set(handles.EditVarCal,'String',R4);
    R5 = sprintf('%f',R(5));
    R5 = num2str(R5);
    set(handles.EditQuartile1,'String',R5);
    R6 = sprintf('%f',R(6));
    R6 = num2str(R6);
    set(handles.EditQuartile3,'String',R6);
    R7 = sprintf('%f',R(7));
    R7 = num2str(R7);
    set(handles.EditMediane,'String',R7);
    
    % Histogramme normalise
    NbClasse = round(str2double(get(handles.EditParam6,'String')));
    [N,X] = hist(Rbis,NbClasse);
    Amp = X(2)-X(1);
    N = N/size(Rbis,1)/Amp;        
    bar(X,N,'hist');
    colormap(handles.CouleurHisto);
    
    % Frame Info visible
    FrameInfoVisible(handles);
    
    % Titre du graphique
    if handles.langue == 1
        title(['Simulation de VA de loi ' handles.Nomloi ' - Histogramme'],'Color','r');
    else
        LoiEn = LoiFrToEn(handles.Nomloi);
        title(['Random numbers from ' LoiEn ' distribution - Histogram'],'Color','r');
    end
    
    
% Densites, FDR, fction quantile, Survie
case {2,3,4,8}
    
    % Invisiblites des frames
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Environnment graphique
    if handles.langue == 1
        set(handles.TextParam4,'String','Borne inferieure');
        set(handles.TextParam5,'String','Borne superieure');
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam4,'String','Inferior limit');
        set(handles.TextParam5,'String','Superior limit');
        set(handles.TextParam6,'String','Nb of points');
    end
    
    % Noms et nb des parametres de la loi
    [param1,param2,param3,NbParam] = NomDesParametres(handles,handles.Nomloi);
    
    % Affichage de la Frame Param
    AfficheFrameParam(handles,param1,param2,param3,NbParam);
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % courbe
    plot(R(:,1),R(:,2),'r');
    
    % Titre selon tache
    switch(Tache)
        case 2  % densites
            if handles.langue == 1
                title(['Densite de la loi ' handles.Nomloi],'Color','r');
            else
                LoiEn = LoiFrToEn(handles.Nomloi);
                title([LoiEn ' probability density function'],'Color','r');
            end
        case 3  % FDR
            if handles.langue == 1
                title(['Fonction de repartition de la loi ' handles.Nomloi],'Color','r');
            else
                LoiEn = LoiFrToEn(handles.Nomloi);
                title([LoiEn ' cumulative distribution function'],'Color','r');
            end
        case 4  % fonction quantile
            if handles.langue == 1
                title(['Fonction quantile de la loi ' handles.Nomloi],'Color','r');
            else
                LoiEn = LoiFrToEn(handles.Nomloi);
                title([LoiEn ' quantile function'],'Color','r');
            end
        case 8  % survie
            if handles.langue == 1
                title(['Fonction de survie de la loi ' handles.Nomloi],'Color','r');
            else
                LoiEn = LoiFrToEn(handles.Nomloi);
                title([LoiEn ' survival function'],'Color','r');
            end  
    end
    
% Histogramme
case 5
    
    % Insibilites des Frames
    FrameTestInvisible(handles);
    FrameParamInvisible(handles);
    FrameTestETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Lecture du fichier de donnees   
    Rbis = load(FichierDonnees);
    
    % lecture du fichier resultat
    [R]=textread(FichierResult,'%s','delimiter','\n','whitespace','');
    
    % Remplissage de la frame Info
    set(handles.EditMoyTheo,'String',R(1));
    R2 = sprintf('%f',str2num(char(R(2))));
    set(handles.EditMoyCal,'String',R2);
    set(handles.EditVarTheo,'String',R(3));
    R4 = sprintf('%f',str2num(char(R(4))));
    set(handles.EditVarCal,'String',R4);
    R5 = sprintf('%f',str2num(char(R(5))));
    set(handles.EditQuartile1,'String',R5);
    R6 = sprintf('%f',str2num(char(R(6))));
    set(handles.EditQuartile3,'String',R6);
    R7 = sprintf('%f',str2num(char(R(7))));
    set(handles.EditMediane,'String',R7);
    
    % Histogramme normalise
    NbClasse = str2num(char(Param(11)));
    [N,X] = hist(Rbis,NbClasse);
    Amp = X(2)-X(1);
    N = N/size(Rbis,1)/Amp;
    bar(X,N,'hist');
    colormap(handles.CouleurHisto);
    
    % Frame Info visible
    FrameInfoVisible(handles);
    
    % Titre du graphique
    if handles.langue == 1
        title(['Histogramme - ' char(Param(11)) ' classes'],'Color','r');
    else
        title(['Histogram - ' char(Param(11)) ' bins'],'Color','r');
    end
    
% Estimation par noyau
case 6
    
    % Invisibilites des frames
    FrameTestInvisible(handles);
    FrameParamInvisible(handles);
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Environnment graphique
    if handles.langue == 1
        set(handles.TextParam4,'String','Borne inferieure');
        set(handles.TextParam5,'String','Borne superieure');
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam4,'String','Inferior limit');
        set(handles.TextParam5,'String','Superior limit');
        set(handles.TextParam6,'String','Nb of points');
    end
    
    % Noms et nb des parametres de la loi
    [param1,param2,param3,NbParam] = NomDesParametres(handles,handles.Nomloi);
    
    % Affichage de la Frame des parametres
    AfficheFrameParam(handles,param1,param2,param3,NbParam);
    
    % Designation de la densite choisie
    if str2num(char(Param(6)))==1
        % Normale
        set(handles.Radio1,'Value',1);
        set(handles.Radio2,'Value',0);
        
    else
        % 0.75(1 - xe)
        set(handles.Radio2,'Value',1);
        set(handles.Radio1,'Value',0);
        
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % courbe obtenue
    plot(R(:,1),R(:,2),'r');
    
    % Titre du graphique
    if handles.langue == 1
        title('Estimation de la densite','Color','r');
    else
        title('Density estimate','Color','r');
    end
    
    
% ESTIMATION DES PARAMETRES PAR MAXIMUM DE VRAISEMBLANCE
case 7
    
    % Invisibilite des frames concernees
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameParamInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Retrouve le nombre de classes pour tracer l'histogramme ou demande e l'utilisateur
    w = find(T==1 | T==5);
    if isempty(w)
        if handles.langue == 1
            NbClasse = inputdlg('Nombre de classes :','Histogramme');
        else
            NbClasse = inputdlg('Number of bins :','Histogram');
        end
        NbClasse = str2num(char(NbClasse));
    else
        w = int2str(w(1));
        FichierTmp2 = [Rep '/' 'Tmp' w '.txt'];
        [T2]=textread(FichierTmp2,'%s','delimiter','\n','whitespace','');
        NbClasse = str2num(char(T2(11)));
    end
    
    % Lecture du fichier resultat
    [R]=textread(FichierResult,'%s','delimiter','\n','whitespace','');
    
    % Conversion des resultats
    R1 = str2num(char(R));
    
    % Lecture du fichier de donnees
    Rbis = load(FichierDonnees);
    
    % Indice du fichier resultat suivant
    k2 = int2str(k+1);
    
    % Lecture du fichier de resultat suivant = densite calcule e partir des param estimes
    FichierResultSuivant = [Rep '/' 'Result' k2 '.txt'];
    Rsuivant = load(FichierResultSuivant);
    
    % Nom et nb des parametres de la loi
    [param1,param2,param3,NbParam] = NomDesParametres(handles,handles.Nomloi);
    
    % Environnment graphique selon la loi
    NomLoi = char(Param(5));
    switch(NomLoi)
    case 'Normale'
        set(handles.PopupEstim,'Value',2);
    case 'Lognormale'
        set(handles.PopupEstim,'Value',3);
    case 'Gamma'
        set(handles.PopupEstim,'Value',4);
    case 'Exponentielle'
        set(handles.PopupEstim,'Value',5);
    case 'Weibull'
        set(handles.PopupEstim,'Value',6);
    case 'Pareto'
        set(handles.PopupEstim,'Value',7);
    end
    
    % Affichage de la frame estimation
    FrameEstimationVisible(handles);
    switch(NbParam)
    case 1
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','off');
        set(handles.TextEstimP3,'Visible','off');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','off');
        set(handles.TextP3,'Visible','off');
        set(handles.TextP1,'String',param1);
    case 2
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','on');
        set(handles.TextEstimP3,'Visible','off');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','on');
        set(handles.TextP3,'Visible','off');
        set(handles.TextP1,'String',param1);
        set(handles.TextP2,'String',param2);
    case 3
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','on');
        set(handles.TextEstimP3,'Visible','on');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','on');
        set(handles.TextP3,'Visible','on');
        set(handles.TextP1,'String',param1);
        set(handles.TextP2,'String',param2);
        set(handles.TextP3,'String',param3);
    end
    
    % Affichage des resultats
    if size(R,1)==1
        set(handles.TextEstimP1,'String',R1(1));
    end
    if size(R,1)==2
        set(handles.TextEstimP1,'String',R1(1));
        set(handles.TextEstimP2,'String',R1(2));
    end
    if size(R,1)==3
        set(handles.TextEstimP1,'String',R1(1));
        set(handles.TextEstimP2,'String',R1(2));
        set(handles.TextEstimP2,'String',R1(3));
    end
    
    % Histogramme normalise
    [N,X] = hist(Rbis,NbClasse);
    Amp = X(2)-X(1);
    N = N/size(Rbis,1)/Amp;
    bar(X,N,'hist');
    colormap(handles.CouleurHisto);
    
    % On garde le meme graphique
    hold on;
    
    % courbe de la densite
    plot(Rsuivant(:,1),Rsuivant(:,2),'b');
    
    % Titre du graphique
    if handles.langue == 1
        title(['Histogramme et densite de la loi ' handles.Nomloi],'Color','r');
    else
        LoiEn = LoiFrToEn(handles.Nomloi);
        title(['Histogram and ' LoiEn ' probability density function'],'Color','r');
    end
    
    % Menu contextuel du graphique actif
    set(handles.DensiteEstim,'Enable','on');
    set(handles.SurvieEstim,'Enable','on');
    
% TESTS CENTRAUX : ANDERSON-DARLING ET CRAMER-VON MISES
case {9,10}
    
    % Invisibiltes des frames
    FrameTestETInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    FrameParamInvisible(handles);
    
    % Reinitialisation de la boite de lois e cocher 
    CBDecocheLois(handles);
    
    % Nb de lois selectionnees
    NbLoi = size(Param(5:end-7),1);
    
    % Affichage des lois selectionnees par l'utilisateur
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
            set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
            set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
            set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
            set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
            set(handles.CBCLGamma,'Value',1);
        case 'Chi2'
            set(handles.CBCLChi2,'Value',1);
        case 'Student'
            set(handles.CBCLStudent,'Value',1);
        case 'Pareto'
            set(handles.CBCLPareto,'Value',1);
        case 'GPD'
            set(handles.CBCLGPD,'Value',1);
        case 'Uniforme'
            set(handles.CBCLUnif,'Value',1);
        case 'Beta'
            set(handles.CBCLBeta,'Value',1);
        end
    end
    
    % Si toutes les lois ont ete selectionnees, on coche la case "Toutes"
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage du niveau du test
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveau,'Value',1);
    case 0.1
        set(handles.PopupNiveau,'Value',2);
    case 0.05
        set(handles.PopupNiveau,'Value',3);
    case 0.025
        set(handles.PopupNiveau,'Value',4);
    case 0.01
        set(handles.PopupNiveau,'Value',5);
    end
    
    % Affichage de la frame Test
    set(handles.BtLancerTest,'Enable','off');
    FrameTestVisible(handles);
    set(handles.BtChoixLoisTests,'Enable','on');
    
    % Affectation de la PopupResultat avec les lois selectionnees
    set(handles.PopupResultat,'Value',1);
    LoiFr = Param(5:end-7);
    if handles.langue == 1
        set(handles.PopupResultat,'String',LoiFr);
    else
        LoiEn = [];
        for i=1:size(LoiFr,1)
            LoiEnTemp = LoiFrToEn(char(LoiFr(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultat,'String',LoiEn);
    end
    
    % Affichage des noms et des valeurs des parametres de la 1ere loi
    [P1,P2,P3,NbParam]=NomDesParametres(handles,char(Param(5)));
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Affichage des resultats
    % cas d'un seul parametre
    if NbParam == 1
        R1 = sprintf('%f',R(1));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);  % Affiache du parametre estime
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);  % Affiache du parametre estime
        if R(2) == 1
            if handles.langue == 1
                R2 = 'Accepte';
            else
                R2 = 'Accepted';
            end
        else
            if handles.langue == 1
                R2 = 'Rejete';
            else
                R2 = 'Rejected';
            end 
        end
        set(handles.TextResultatDecision,'String',R2);  % Affichage de la decision
        R3 = sprintf('%f',R(3));
        if str2num(R3) ~= 0
            set(handles.TextResultatStat,'String',R3);      % affichage de la statistique de test
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatStat,'String',R3);      % affichage de la statistique de test
        R4 = sprintf('%f',R(4));
        if str2num(R4) ~= 0
            set(handles.TextResultatRejet,'String',R4);     % Affichage de la valeur de rejet
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatRejet,'String',R4);     % Affichage de la valeur de rejet
    end
    if NbParam == 2
        R1 = sprintf('%f',R(1));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        if R(3) == 1
            if handles.langue == 1
                R3 = 'Accepte';
            else
                R3 = 'Accepted';
            end
        else
            if handles.langue == 1
                R3 = 'Rejete';
            else
                R3 = 'Rejected';
            end 
        end
        set(handles.TextResultatDecision,'String',R3);
        R4 = sprintf('%f',R(4));
        if str2num(R4) ~= 0
            set(handles.TextResultatStat,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatStat,'String',R4);
        R5 = sprintf('%f',R(5));
        if str2num(R5) ~= 0
            set(handles.TextResultatRejet,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatRejet,'String',R5);
    end    
    if NbParam == 3
        R1 = sprintf('%f',R(1));
        if str2num(R1)
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        R3 = sprintf('%f',R(3));
        if str2num(R3) ~= 0
            set(handles.TextResultatValeurP3,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP3,'String','non');
            else
                set(handles.TextResultatValeurP3,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatValeurP3,'String',R3);
        if R(4) == 1
            if handles.langue == 1
                R4 = 'Accepte';
            else
                R4 = 'Accepted';
            end
        else
            if handles.langue == 1
                R4 = 'Rejete';
            else
                R4 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R4);
        R5 = sprintf('%f',R(5));
        if str2num(R5) ~= 0
            set(handles.TextResultatStat,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatStat,'String',R5);
        R6 = sprintf('%f',R(6));
        if str2num(R6) ~= 0
            set(handles.TextResultatRejet,'String',R6);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R6 = num2str(R6);
        %set(handles.TextResultatRejet,'String',R6);
    end
    
    % Enviroonement graphique
    if handles.langue == 1
        P1 = [P1 ' estime'];
        if ~isempty(P2)
            P2 = [P2 ' estime'];
        end
        if ~isempty(P3)
            P3 = [P3 ' estime'];
        end
    else
        P1 = ['estimated ' P1];
        if ~isempty(P2)
            P2 = ['estimated ' P2];
        end
        if ~isempty(P3)
            P3 = ['estimated ' P3];
        end
    end
    
    set(handles.TextResultatP1,'String',P1);
    set(handles.TextResultatP2,'String',P2);
    set(handles.TextResultatP3,'String',P3);
    
    % Designation du test
    if Tache == 9
        set(handles.TextTest,'String','Anderson-Darling');
    else
        set(handles.TextTest,'String','Cramer-Von Mises');
    end
    
    % Affichage des resultats
    FrameResultatVisible(handles);
    switch(NbParam)
    case 1
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','off');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','off');
        set(handles.TextResultatValeurP3,'Visible','off');
    case 2
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','off');
    case 3
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','on');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','on');
    end

    % Lecture du fichier de donnees
    Rdonnees = load(FichierDonnees);
    
    % Nb de lois
%    M = size(Param(5:end-7),1);
    
%     % Recherche de donnees negatives
%     kk = find(R <= 0);
%     
%     % Si presence de donnees negatives
%     if ~isempty(kk)
%         
%         % cherche si la loi normale est selectionnee
%         L = strvcat(char(Param(5:end-7)));
%         if length('Normale') <= size(L,2)
%             kk = find(sum(L~=repmat(['Normale' 32*ones(1,size(L,2)-length('Normale'))],size(L,1),1),2)==0);
%         else
%             kk = [];
%         end
%         
%         % si oui, une seule densite sera affichee
%         if ~isempty(kk)
%             M = 1;
%         end
%     end

    NbLoiNonPDF = round(R(end));
    ListeLoiPDF = R(end - (NbLoi - NbLoiNonPDF) : (end - 1));
    Loi = Param(5:end-7);
    
    
    % Nombre de classes
    w = find(T==1 | T==5);
    if isempty(w)
        if handles.langue == 1
            NbClasse = inputdlg('Nombre de classes :','Histogramme');
        else
            NbClasse = inputdlg('Number of bins :','Histogram');
        end
        NbClasse = str2num(char(NbClasse));
    else
        w = int2str(w(1));
        FichierTmp2 = [Rep '/' 'Tmp' w '.txt'];
        [T2]=textread(FichierTmp2,'%s','delimiter','\n','whitespace','');
        NbClasse = str2num(char(T2(11)));
    end
    
    % Histogramme normalise
    [N,X] = hist(Rdonnees,NbClasse);
    Amp = X(2)-X(1);
    N = N/size(Rdonnees,1)/Amp;
    bar(X,N,'hist');
    colormap(handles.CouleurHisto);
    
    % on garde la graphique
    hold on;
    
    % courbes des densites
    couleur = strvcat('r','g','b','c','m','y','k','g:','b:','m:','k:');
    compt = 1;
    for i=k+1:k+(NbLoi - NbLoiNonPDF)
        j = int2str(i);
        FichierResultat = [Rep '/' 'Result' j '.txt'];
        R = load(FichierResultat);
        plot(R(:,1),R(:,2),couleur(compt,:));
        compt = compt + 1;
    end
    
    % Titre du graphique
    if NbLoiNonPDF ~= NbLoi
        if handles.langue == 1
            title('Histogramme - Densites avec parametres estimes','Color','r');
        else
            title('Histogram - Probability density function with estimated parameters','Color','r');
        end
    else
        if handles.langue == 1
            title('Histogramme','Color','r');
        else
            title('Histogram','Color','r');
        end
    end
    
    % Legende selon le nombre de lois selectionnees
%     switch(M)
%     case 1
%         legend(char(Param(5)));
%     case 2
%         legend(char(Param(5)),char(Param(6)));
%     case 3
%         legend(char(Param(5)),char(Param(6)),char(Param(7)));
%     case 4
%         legend(char(Param(5)),char(Param(6)),char(Param(7)),char(Param(8)));
%     case 5
%         legend(char(Param(5)),char(Param(6)),char(Param(7)),char(Param(8)),char(Param(9)));
%     end
    if NbLoiNonPDF ~= NbLoi
        if NbLoiNonPDF ~= 0
            legende = strvcat(char(Loi(ListeLoiPDF,:)));
            if handles.langue == 1
                legend(legende);
            else
                LoiEn = [];
                legende = cellstr(legende);
                for i=1:size(legende,1)
                    LoiTemp = LoiFrToEn(char(legende(i)));
                    LoiEn = strvcat(LoiEn,LoiTemp);
                end
                legend(LoiEn);
            end
        else
            if handles.langue == 1
                legend(char(Loi));
            else
                LoiEn = [];
                for i=1:size(Loi,1)
                    LoiTemp = LoiFrToEn(char(Loi(i)));
                    LoiEn = strvcat(LoiEn,LoiTemp);
                end
                legend(LoiEn);
            end
        end
    end

% Tests AD, CVM et Exponentialite des exces - Donnees multiples
case {11,12,14}
    
    % Invisibilites des frames
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    FrameParamInvisible(handles);
    
    % lecture du fichier resultat
    [R]=textread(FichierResult,'%s','delimiter','\n','whitespace','');
    
    % Nb de lois selectionnes
    NbLoi = size(Param(5:end-7),1);
    
    % affichage du niveau du test
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveau,'Value',1);
    case 0.1
        set(handles.PopupNiveau,'Value',2);
    case 0.05
        set(handles.PopupNiveau,'Value',3)
    case 0.025
        set(handles.PopupNiveau,'Value',4);
    case 0.01
        set(handles.PopupNiveau,'Value',5);
    end
    
    % Test d'exponentialite
    if Tache == 14
        set(handles.TextTest,'String','Anderson-Darling');
        % Affichage du nombre d'exces
        set(handles.EditExces,'String',Param(6));
        
        % Frame test visible
        FrameTestExpoVisible(handles);
        set(handles.BtLancerTest,'Enable','off');
        
    else    % test AD ou CVM
        
        % On decoche toutes les lois
        CBDecocheLois(handles);
        
        % Affichage des lois selectionnees
        for (i=0:NbLoi-1)
            NomLoi = char(Param(5+i));
            switch(NomLoi)
            case 'Normale'
                set(handles.CBCLNormale,'Value',1);
            case 'Lognormale'
                set(handles.CBCLLognormale,'Value',1);
            case 'Exponentielle'
                set(handles.CBCLExpo,'Value',1);
            case 'Weibull'
                set(handles.CBCLWeibull,'Value',1);
            case 'Gamma'
                set(handles.CBCLGamma,'Value',1);
            case 'Chi2'
                set(handles.CBCLChi2,'Value',1);
            case 'Student'
                set(handles.CBCLStudent,'Value',1);
            case 'Pareto'
                set(handles.CBCLPareto,'Value',1);
            case 'GPD'
                set(handles.CBCLGPD,'Value',1);
            case 'Uniforme'
                set(handles.CBCLUnif,'Value',1);
            case 'Beta'
                set(handles.CBCLBeta,'Value',1);
            end
        end
        if NbLoi == 11
            set(handles.CBCLToutes,'Value',1);
        end
        
        % Frame test visible
        set(handles.BtLancerTest,'Enable','off');
        FrameTestVisible(handles);
    end
    
    % Construction du graphique
    X = [0,1,2];
    R1 = str2num(char(R));
    bar(X,R1,'r');
    bar(X(1:2),R1(1:2),'r');    % pourcentage de rejet et d'acceptation
    hold on;
    bar(X(3),R1(3),'y');        % pourcentage d'ecart-type
    if handles.langue == 1
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % de rejet'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % d''acceptation'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % d''ecart-type'],'HorizontalAlignment','center','Color','r');
    else
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % rejection'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % acceptance'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % standard deviation'],'HorizontalAlignment','center','Color','r');
    end
    axis([-1 3 0 110]);         % Echelle du graphique
    
    % Titre du graphique
    if handles.langue == 1
        title('Pourcentage d''acceptation et de rejet et Ecart-type','Color','r');
    else
        title('Acceptance and rejection percentage and standard deviation','Color','r');
    end
    
% QQ-Plot
case 13
    
    % Invisibilite des frames
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    FrameParamInvisible(handles);
    
    % Affichage du nombre d'exces et du type de test utilise
    set(handles.EditExces,'String',Param(6));
    set(handles.TextTest,'String','Anderson-Darling');
    
    % Affichage du niveau du test
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveau,'Value',1);
    case 0.1
        set(handles.PopupNiveau,'Value',2);
    case 0.05
        set(handles.PopupNiveau,'Value',3)
    case 0.025
        set(handles.PopupNiveau,'Value',4);
    case 0.01
        set(handles.PopupNiveau,'Value',5);
    end
    
    % Affichage de la frame test
    FrameTestExpoVisible(handles);
    set(handles.BtLancerTest,'Enable','off');
    
    % lecture du fichier resultat
    R = load(FichierResult);
    
    % droite y = muchap * x
    Abscisse = 0:0.1:R(end-2,1);
    plot(Abscisse,R(end-1,1)*Abscisse,'b');
    
    % on garde le meme graphe
    hold on;
   
    % Affichage du qq-plot
    if R(end,1) == 1
        plot(R(1:end-2,1),R(1:end-2,2),'g.');
        
        % legende
        if handles.langue == 1
            legend('droite y = muchap * x','test accepte');
        else
            legend('curve y = muchap * x','test accepted');
        end
        
    else
        plot(R(1:end-2,1),R(1:end-2,2),'r.');
        
        % legende
        if handles.langue == 1
            legend('droite y = muchap * x','test rejete');
        else
            legend('curve y = muchap * x','test rejected');
        end    
    end
    
    % Titre du grahique
    if handles.langue == 1
        title('Graphe QQ-Plot','Color','r');
    else
        title('QQ-Plot graph','Color','r');
    end
    
% Test d'exponentialite, plusieurs exces
case 15
    
    % Invisibilites des frames
    FrameTestExpoVisible(handles);
    set(handles.BtLancerTest,'Enable','off');
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    set(handles.TextExces,'Visible','off');
    set(handles.EditExces,'Visible','off');
    FrameQuantileParamInvisible(handles);
    FrameParamInvisible(handles);
    
    % type de test utilise
    set(handles.TextTest,'String','Anderson-Darling');
    
    % Affichage du niveau du test
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveau,'Value',1);
    case 0.1
        set(handles.PopupNiveau,'Value',2);
    case 0.05
        set(handles.PopupNiveau,'Value',3)
    case 0.025
        set(handles.PopupNiveau,'Value',4);
    case 0.01
        set(handles.PopupNiveau,'Value',5);
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Coloriage des parties oe le test est accepte (vert)
    area(R(:,1),R(:,2),'FaceColor','g','EdgeColor','g');
    hold on;
    
    % Coloriage des parties oe le test est rejete (rouge)
    area(R(:,1),1-R(:,2),'FaceColor','r','EdgeColor','r');
    
    % Echelle du graphique
    axis([R(1,1) R(end,1) -0.5 1.5]);
    
    % Titre
    if handles.langue == 1
        title('Plage d''acceptation du test','Color','r');
        
        % Legende
        legend('Test accepte','Test rejete');
    else
        title('Test acceptance region','Color','r');
        
        % Legende
        legend('Test accepted','Test rejected');
    end
    
% Test ET - Donnees multiples
case {16,17,18}
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois
    CBDecocheLois(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-7),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
        set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
        set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
        set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
        set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
        set(handles.CBCLGamma,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test (Asymptotique, BP ou BPS)
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-2))));
    
    % Affichage du nombre d'exces
    if handles.langue == 1
        set(handles.TextExcesSup,'String','Nb d''exces');
    else
        set(handles.TextExcesSup,'String','Nb of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-6));
    
    % Affichage de l'ordre qu quantile ET
    set(handles.EditPET,'String',Param(end));
    
    % Affichage de la Frame ET
    if handles.langue == 1
        set(handles.TextTestET,'String','Test ET');
    else
        set(handles.TextTestET,'String','ET test');
    end
    FrameTestETVisible(handles,'ET');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nombre d'echantillons de bootstrap si test != Asymptotique
    if Tache ~= 16
        set(handles.EditBootstrapET,'String',Param(end-1));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Lecture du fichier resultat
    [R]=textread(FichierResult,'%s','delimiter','\n','whitespace','');
    
    % Conversion
    R1 = str2num(char(R));
    
    % Affichage du % de rejet et d'acceptation
    X = [0,1,2];
    bar(X(1:2),R1(1:2),'r');
    
    % on garde le meme graphe
    hold on;
    
    % Affichage du % d'ecart-type
    bar(X(3),R1(3),'y');
    
    if handles.langue == 1
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % de rejet'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % d''acceptation'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % d''ecart-type'],'HorizontalAlignment','center','Color','r');
    else
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % rejection'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % acceptance'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % standard deviation'],'HorizontalAlignment','center','Color','r');
    end
    
    % Borne du graphe
    axis([-1 3 0 110]);
    
    % Titre
    if handles.langue == 1
        title('Pourcentage d''acceptation et de rejet et Ecart-type','Color','r');
    else
        title('Acceptance and rejection percentage and standard deviation','Color','r');
    end
    
% Test ET - 1 seul nombre d'exces
case {19,20,21}
    
    % Invisibilite des frames
    FrameTestInvisible(handles);
    FrameParamInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois
    CBDecocheLois(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-7),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
        set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
        set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
        set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
        set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
        set(handles.CBCLGamma,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-2))));
    
    % Affichage du nombre d'exces
    if handles.langue == 1
        set(handles.TextExcesSup,'String','Nb d''exces');
    else
        set(handles.TextExcesSup,'String','Nb of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-6));
    
    % Affichage de l'ordre du quantile ET
    set(handles.EditPET,'String',Param(end));
    
    % Affichage de la Frame ET
    if handles.langue == 1
        set(handles.TextTestET,'String','Test ET');
        set(handles.TextResultatET,'String','Test ET');
    else
        set(handles.TextTestET,'String','ET test');
        set(handles.TextResultatET,'String','ET test');
    end
    FrameTestETVisible(handles,'ET');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nombre d'echantillons de bootstrap si test != Asymptotique
    if Tache ~= 19
        set(handles.EditBootstrapET,'String',Param(end-1));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Affectation des lois slectionnees dans la popupresultatET
    Loi = Param(5:end-7);
    set(handles.PopupResultatET,'Value',1);
  
    if handles.langue == 1
        set(handles.PopupResultatET,'String',Loi);
    else
        LoiEn = [];
        for i=1:size(Loi,1)
            LoiEnTemp = LoiFrToEn(char(Loi(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultatET,'String',LoiEn);
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Affichage des resultats pour la 1ere loi
    R2 = sprintf('%f',R(2));
    R2 = num2str(R2);
    set(handles.TextResultatQET,'String',R2);   % qET
    R3 = sprintf('%f',R(3));
    R3 = num2str(R3);
    set(handles.TextResultatQParam,'String',R3);    % q parametrique
    qET = R(2);
    qParam = R(3);
    D = num2str(qET - qParam);
    set(handles.TextResultatStatET,'String',D);     % qET - q param
    R4 = sprintf('%f',R(4));
    R4 = num2str(R4);
    R5 = sprintf('%f',R(5));
    R5 = num2str(R5);
    Intervalle = ['[ ' R4 ' ; ' R5 ' ]'];
    set(handles.TextResultatIntervalle,'String',Intervalle);    % Intervalle de confiance
    
    % Affichage de la decision
    if R(1) == 1
        if handles.langue == 1
            R1 = 'Accepte';
        else
            R1 = 'Accepted';
        end
    else
        if handles.langue == 1
            R1 = 'Rejete';
        else
            R1 = 'Rejected';
        end
    end
    set(handles.TextResultatDecisionET,'String',R1);
    
    % La statistique de test est affichee en rouge et change suivant la version du test
    switch(Tache)
    case 19
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[1 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    case 20
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[1 0 0]);
    case 21
        set(handles.TextQET,'ForegroundColor',[1 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    end
    
    % Affichage de la frame resultat ET
    FrameResultatETVisible(handles,'ET');
    
% Test ET - plusieurs exces
case {22,23,24}
    
    % Invisibilite des frames
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameParamInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois
    CBDecocheLois(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-7),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
        set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
        set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
        set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
        set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
        set(handles.CBCLGamma,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-5))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test ET
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-2))));
    
    % Affichage de l'intervalle des exces
    if handles.langue == 1
        set(handles.TextExcesInf,'String','Borne Inf des exces');
        set(handles.TextExcesSup,'String','Borne Sup des exces');
    else
        set(handles.TextExcesInf,'String','Inf limit of excesses');
        set(handles.TextExcesSup,'String','Sup limit of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-3));
    set(handles.EditExcesInf,'String',Param(end-4));
    
    % Affichage de l'ordre du quantile ET
    set(handles.EditPET,'String',Param(end));
    
    % Affichage de la frame test
    if handles.langue == 1
        set(handles.TextTestET,'String','Test ET');
    else
        set(handles.TextTestET,'String','ET test');
    end
    FrameTestETVisible(handles,'ET');
    set(handles.TextExcesInf,'Visible','on');
    set(handles.EditExcesInf,'Visible','on');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nb d'echantillons de bootstrap si test != asymptotique
    if Tache ~= 22
        set(handles.EditBootstrapET,'String',Param(end-1));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Determinantion du nombre totral d'exces
    E1 = str2num(char(Param(end-4)));
    E2 = str2num(char(Param(end-3)));
    NbExces = E2 - E1 + 1;
    
    % Nombre de lois selectionnees
    M = size(Param(5:end-7),1);
    
    couleur = strvcat('r','g','b','c','m','y','k','g:','b:','m:','k:');
    Leg = [];
    if M == 1
        area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
        axis([E1 E2 -0.5 1.5]);
        legend(char(Param(5)));
    else
        for i=M:-1:1
            area(R((i-1)*NbExces+1:i*NbExces,1),R((i-1)*NbExces+1:i*NbExces,2) + 2 *(i-1),'FaceColor',couleur(i,:),'EdgeColor',couleur(i,:));
            hold on;
            area(R(NbExces+1:2*NbExces,1),repmat(2*(i-1),NbExces,1),'FaceColor','w','EdgeColor','w');
            Leg = strvcat(Leg,char(Param(5+(i-1))),' ');
        end
        LimiteAxe = -0.5 + 2 * M;
        axis([E1 E2 -0.5 LimiteAxe]);
        legend(Leg);
    end
    
%     % Affichage des plages d'acceptation du test
%     switch(M)
%     case 1
%         area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 1.5]);
%         legend(char(Param(5)));
%     case 2
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 3.5]);
%         legend(char(Param(6)),'',char(Param(5)));
%     case 3
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 5.5]);
%         legend(char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     case 4
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 7.5]);
%         legend(char(Param(8)),'',char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     case 5
%         area(R(4*NbExces+1:5*NbExces,1),R(4*NbExces+1:5*NbExces,2) + 8,'FaceColor','k','EdgeColor','k');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(8,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 9.5]);
%         legend(char(Param(9)),'',char(Param(8)),'',char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     end
    
    % Titre
    if handles.langue == 1
        title('Plage d''acceptation du test pour chaque modele','Color','r');
    else
        title('Test acceptance region for each model','Color','r');
    end
    
% Regularisation bayesienne
case 25
    
    % Invisiblite des frames
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameParamInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    ViderFrameRegBay(handles);
    FrameQuantileParamInvisible(handles);
    
    % Initialisation de la variable qui permet de faire defiler les fenetres par le bouton Suite
    handles.Suite = 0;
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
    % Definition du modele
    LoiModele = char(Param(5));
    
    % Affichage du modele
    switch(LoiModele)
    case 'Normale'
        set(handles.PopupModeleRB,'Value',1);
    case 'Lognormale'
        set(handles.PopupModeleRB,'Value',2);
    case 'Exponentielle'
        set(handles.PopupModeleRB,'Value',3);
    case 'WeibullEchelle'
        set(handles.PopupModeleRB,'Value',4);
    case 'WeibullForme'
        set(handles.PopupModeleRB,'Value',5);
        % Affichage des bornes inf et sup de la loi berta a priori
        set(handles.EditBinfRB,'String',Param(6));
        set(handles.EditBsupRB,'String',Param(7));
        set(handles.TextBetaRB,'Visible','on');
        set(handles.TextBinfRB,'Visible','on');
        set(handles.TextBsupRB,'Visible','on');
        set(handles.EditBinfRB,'Visible','on');
        set(handles.EditBsupRB,'Visible','on');
    case 'Gamma'
        set(handles.PopupModeleRB,'Value',6);
    end
    
    % Si il y a une loi de simulation
    if str2num(char(Param(8))) == 1
        
        set(handles.RBOui,'Value',1);
        set(handles.RBNon,'value',0);
        % Definition de la vraie loie
        VraieLoi = char(Param(9));
        
        % Affichage de la vraie loi et de ses parametres
        switch(VraieLoi)
        case 'Normale'
            set(handles.PopupVraieLoiRB,'Value',1);
            set(handles.EditParam1RB,'String',Param(10))
            set(handles.EditParam2RB,'String',Param(11))
        case 'Lognormale'
            set(handles.PopupVraieLoiRB,'Value',2);
            set(handles.EditParam1RB,'String',Param(10))
            set(handles.EditParam2RB,'String',Param(11))
        case 'Exponentielle'
            set(handles.PopupVraieLoiRB,'Value',3);
            set(handles.EditParam1RB,'String',Param(10))
        case 'Weibull'
            set(handles.PopupVraieLoiRB,'Value',4);
            set(handles.EditParam1RB,'String',Param(10))
            set(handles.EditParam2RB,'String',Param(11))
        case 'Gamma'
            set(handles.PopupVraieLoiRB,'Value',5);
            set(handles.EditParam1RB,'String',Param(10))
            set(handles.EditParam2RB,'String',Param(11))
        case 'Student'
            set(handles.PopupVraieLoiRB,'Value',6);
            set(handles.EditParam1RB,'String',Param(10))
        end
    else
        set(handles.RBOui,'Value',0);
        set(handles.RBNon,'value',1);
    end
    
    % Si il y a un avis d'expert
    if str2num(char(Param(13))) == 1
        
        set(handles.RBExpertOui,'Value',1);
        set(handles.RBExpertNon,'Value',0);
        % Affichage de la valeur donnee par l'expert et de l'encadrementy en terme d'ordre de quantile
        set(handles.EditQmax,'String',Param(14));
        set(handles.EditOrdrep1,'String',Param(15));
        set(handles.EditOrdrep2,'String',Param(16));
        set(handles.EditConfiance,'String',Param(17));
%         set(handles.TextQmax,'Visible','on');
%         set(handles.EditQmax,'Visible','on');
%         set(handles.TextOrdrep1,'Visible','on');
%         set(handles.EditOrdrep1,'Visible','on');
%         set(handles.TextOrdrep2,'Visible','on');
%         set(handles.EditOrdrep2,'Visible','on');
        
        % si le modele est weibull parametre de forme
        if strcmp(LoiModele,'WeibullForme')
            
            % Determinantion de la confiance en l'expert
            Confiance = char(Param(18));
            
            % Affichage de la confiance
            switch(Confiance)
            case Faible
                set(handles.PopupConfianceWeibull,'Value',1);
            case Moyenne
                set(handles.PopupConfianceWeibull,'Value',2);
            case Forte
                set(handles.PopupConfianceWeibull,'Value',3);
            end
        end
    else
        set(handles.RBExpertOui,'Value',0);
        set(handles.RBExpertNon,'Value',1);
        % Affichage du niveau de defiance
        set(handles.EditConfiance,'String',Param(17));
        
    end
    
    % Affichage du test central choisi
    if strcmp(char(Param(19)),'AD') == 1
        set(handles.PopupTypeTest,'Value',1);
    else
        set(handles.PopupTypeTest,'Value',2);
    end
    
    % Determination du niveau du test central
    NiveauCentral = str2num(char(Param(20)));
    
    % affichage du niveau du test central
    switch(NiveauCentral)
    case 0.25
        set(handles.PopupNiveauCentraux,'Value',1);
    case 0.1
        set(handles.PopupNiveauCentraux,'Value',2);
    case 0.05
        set(handles.PopupNiveauCentraux,'Value',3);
    case 0.025
        set(handles.PopupNiveauCentraux,'Value',4);
    case 0.01
        set(handles.PopupNiveauCentraux,'Value',5);
    end
    
    % Determination du niveau du test ET
    NiveauET = str2num(char(Param(21)));
    
    % Affichage du niveau du test ET
    switch(NiveauET)
    case 0.25
        set(handles.PopupNiveauETRB,'Value',1);
    case 0.1
        set(handles.PopupNiveauETRB,'Value',2);
    case 0.05
        set(handles.PopupNiveauETRB,'Value',3);
    case 0.025
        set(handles.PopupNiveauETRB,'Value',4);
    case 0.01
        set(handles.PopupNiveauETRB,'Value',5);
    end
    
    % Affichage du nombre d'exces
    set(handles.EditExcesRB,'String',Param(22));
    
    % Affichage de l'ordre du quantile ET
    set(handles.EditPETRB,'String',Param(23));
    
    % Determination des quantiles et affichage
    Quantiles = [];
    set(handles.EditQuantileP1,'String',Param(24));
    Quantiles = strvcat(Quantiles,char(Param(24)));
    if str2num(char(Param(25))) == 0
        set(handles.EditQuantileP2,'String','');
    else
        set(handles.EditQuantileP2,'String',Param(25));
        Quantiles = strvcat(Quantiles,char(Param(25)));
    end
    if str2num(char(Param(26))) == 0
        set(handles.EditQuantileP3,'String','');
    else
        set(handles.EditQuantileP3,'String',Param(26));
        Quantiles = strvcat(Quantiles,char(Param(26)));
    end
    if str2num(char(Param(27))) == 0
        set(handles.EditQuantileP4,'String','');
    else
        set(handles.EditQuantileP4,'String',Param(27));
        Quantiles = strvcat(Quantiles,char(Param(27)));
    end
    if str2num(char(Param(28))) == 0
        set(handles.EditQuantileP5,'String','');
    else
        set(handles.EditQuantileP5,'String',Param(28));
        Quantiles = strvcat(Quantiles,char(Param(28)));
    end
    
    % Affichage de la frame regbay
    FrameRegBayVisible(handles);
    if handles.langue == 1
        set(handles.BtSuiteRB,'String','Suite>>');
    else
        set(handles.BtSuiteRB,'String','Next>>');
    end
    set(handles.BtSuiteRB,'Enable','on');
    
    % lecture du fichier resultat
    R = load(FichierResult);
    R1 = sprintf('%f',R(1));    % Theta 1
    R2 = sprintf('%f',R(2));    % Theta 2
    if str2num(R1) < str2num(R2)
        Intervalle = ['[ ' num2str(R1) ' ; ' num2str(R2) ' ]']; % Intervalle Theta1 Theta2
    else
        Intervalle = ['[ ' num2str(R2) ' ; ' num2str(R1) ' ]']; % Intervalle Theta1 Theta2
    end    
    set(handles.TextIntervalleTheta,'String',Intervalle);
    
    % Environnement graphique pour weibull parametre de forme
    if strcmp(LoiModele,'WeibullForme') == 1
        if handles.langue == 1
            set(handles.TextLoiAPriori,'String','Loi a priori Beta');
        else
            set(handles.TextLoiAPriori,'String','A priori Beta model');
        end
    else
        if handles.langue == 1
            set(handles.TextLoiAPriori,'String','Loi a priori Gamma');
        else
            set(handles.TextLoiAPriori,'String','A priori Gamma model');
        end
    end
    
    % Affichage des parametres de la loi a priori
    R5 = sprintf('%f',R(5));
    set(handles.TextResultatP1LAP,'String',R5);
    R6 = sprintf('%f',R(6));
    set(handles.TextResultatP2LAP,'String',R6);
    
    % Variable permettant de recuperer les bons resultats dans le fichier resultat
    if strcmp(LoiModele,'Exponentielle') == 1
        Decale = 0;
    else
        Decale = 1;
    end
    
    %R9 = sprintf('%f',R(9+Decale));
    if R(9+Decale) == 1
        if handles.langue == 1
            set(handles.TextResultatTestCentral,'String','Accepte');   % Affichage de la decision du test central
        else
            set(handles.TextResultatTestCentral,'String','Accepted');
        end
    else
        if handles.langue == 1
            set(handles.TextResultatTestCentral,'String','Rejete');   % Affichage de la decision du test central
        else
            set(handles.TextResultatTestCentral,'String','Rejected');
        end    
    end
    R10 = sprintf('%f',R(10+Decale));                   
    set(handles.TextResultatDistModele,'String',R10);   % Affichage de la distance CVM pour le modele
    R11 = sprintf('%f',R(11+Decale));
    set(handles.TextResultatDistRejet,'String',R11);    % Affichage de la distance de rejet
    R12 = sprintf('%f',R(12+Decale));
    set(handles.TextResultatDistPred,'String',R12);     % Affichage de la distance CVM pour la loi predictive
    %R13 = sprintf('%f',R(13+Decale));
    if R(13+Decale) == 1
        if handles.langue == 1
            set(handles.TextResultatTestETRB,'String','Accepte');   % Affichage de la decision du test ET
        else
            set(handles.TextResultatTestETRB,'String','Accepted');
        end
    else
        if handles.langue == 1
            set(handles.TextResultatTestETRB,'String','Rejete');   % Affichage de la decision du test ET
        else
            set(handles.TextResultatTestETRB,'String','Rejected');
        end
    end
    %R14 = sprintf('%f',R(14+Decale));
    if R(14+Decale) == 1
        if handles.langue == 1
            set(handles.TextResultatTestETLoiPred,'String','Accepte');    % Affichage de la decision du test ET pour la loi predictive
        else
            set(handles.TextResultatTestETLoiPred,'String','Accepted');
        end
    else
        if handles.langue == 1
            set(handles.TextResultatTestETLoiPred,'String','Rejete');    % Affichage de la decision du test ET pour la loi predictive
        else
            set(handles.TextResultatTestETLoiPred,'String','Rejected');
        end
    end
    R15 = sprintf('%f',R(15+Decale));
    set(handles.TextResultatQETPred,'String',R15);      % Affichage de q ET
    R16 = sprintf('%f',R(16+Decale));
    R17 = sprintf('%f',R(17+Decale));
    Intervalle = ['[ ' num2str(R16) ' ; ' num2str(R17) ' ]'];       % Affichage de l'intervalle de confiance
    set(handles.TextResultatICPred,'String',Intervalle);
        
    % Affectation des quantiles calcules e la PopupResultatQuantilesRB
    Quantiles = cellstr(Quantiles);
    set(handles.PopupResultatQuantilesRB,'Value',1);
    set(handles.PopupResultatQuantilesRB,'String',Quantiles);

    % Affichage du premier quantile calcule
     DecaleQuantile = size(Quantiles,1);
     R18 = sprintf('%f',R(18+Decale));
     set(handles.TextResultatQEstime,'String',R18); % Affichage du quantile du modele
     R19 = sprintf('%f',R(18+Decale+DecaleQuantile));
     set(handles.TextResultatqET,'String',R19);     % Affichage q ET
     R20 = sprintf('%f',R(18+Decale+2*DecaleQuantile));
     set(handles.TextResultatqPred,'String',R20);   % Affichage du quantile predictif
     
     % Si simulation
     if str2num(char(Param(8))) == 1
         R21 = sprintf('%f',R(18+Decale+3*DecaleQuantile));
         set(handles.TextResultatQVrai,'String',R21); % Affichage du quantile pour la loi simulee avec ses vrais parametres
         R22 = sprintf('%f',R(18+Decale+4*DecaleQuantile));
         set(handles.TextResultatQVraiEstime,'String',R22); % Affichage qu quantile pour la loi simulee avec ses parametres estimes
         set(handles.TextQVrai,'Visible','on');
         set(handles.TextResultatQVrai,'Visible','on');
         set(handles.TextQVraiEstime,'Visible','on');
         set(handles.TextResultatQVraiEstime,'Visible','on');
     end
     
     % Affichage de la frame regbay resultat
     FrameResultatRegBayVisible(handles);
     
     % Histogramme
     hold off;
     Rdonnees = load(FichierDonnees);
     if handles.langue == 1
         NbClasse = inputdlg('Nombre de classes :','Histogramme');
     else
         NbClasse = inputdlg('Number of bins :','Histogram');
     end
     NbClasse = str2num(char(NbClasse));
     [K,X] = hist(Rdonnees,NbClasse);
     Amp = X(2)-X(1);
     K = K/size(Rdonnees,1)/Amp;
     bar(X,K,'hist');
     colormap(handles.CouleurHisto);
     hold on;
     
     % Affichage des densites
     couleur = strvcat('m','b','g','c','k');
     compt = 1;
     
     % Recherche des indices des bons fichiers
     if str2num(char(Param(8))) == 1
         Debut = k+1;
         Fin = k+3;
         Loi = strvcat(LoiModele,VraieLoi,'predictive');
     else
         Debut = k+1;
         Fin = k+2;;
         Loi = strvcat(LoiModele,'predictive');
     end
        
     % densites
     for i=Debut:Fin
         j = int2str(i);
         FichierResultat = [Rep '/' 'Result' j '.txt'];
         R = load(FichierResultat);
         plot(R(:,1),R(:,2),couleur(compt));
         compt = compt + 1;
     end
     
     % Legende
     if str2num(char(Param(8))) == 1
         if handles.langue == 1
             legend('Densite du modele','Densite de simulation','Densite predictive');
         else
             legend('Model PDF','Simulation PDF','Predictive PDF');
         end
     else
         if handles.langue == 1
             legend('Densite du modele','Densite predictive');
         else
             legend('Model PDF','Predictive PDF');
         end
     end
     
     % Titre
     if handles.langue == 1
         title(['Regularisation bayesienne - Modele ' LoiModele],'Color','r');
     else
         LoiEn = LoiFrToEn(LoiModele)
         title(['Bayesian regularisation - ' LoiEn ' model'],'Color','r');
     end
     
     % Menu contextuel active
     set(handles.DensitesRB,'Enable','on');
     set(handles.SurvieRB,'Enable','on'); 
     
     % simulation selon loi predictive permise
     set(handles.MenuSimulationsPred,'Enable','on');

% Estimation des parametres - Donnees multiples     
case 26
    
    % Invisibilite des frames
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameParamInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % lecture du fichier resultat
    R = load(FichierResult);
    
    % Nb de fichiers traites
    NbFichiers = round(R(end));
    
    % Noms et nombre des parametres de la loi choisie
    [param1,param2,param3,NbParam] = NomDesParametres(handles,handles.Nomloi);
    
    % Affichage de la loi choisie
    NomLoi = char(Param(5));
    switch(NomLoi)
    case 'Normale'
        set(handles.PopupEstim,'Value',2);
    case 'Lognormale'
        set(handles.PopupEstim,'Value',3);
    case 'Gamma'
        set(handles.PopupEstim,'Value',4);
    case 'Exponentielle'
        set(handles.PopupEstim,'Value',5);
    case 'Weibull'
        set(handles.PopupEstim,'Value',6);
    case 'Pareto'
        set(handles.PopupEstim,'Value',7);
    end
    
    % Affichage de la frame estimation
    FrameEstimationVisible(handles);
    switch(NbParam)
    case 1
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','off');
        set(handles.TextEstimP3,'Visible','off');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','off');
        set(handles.TextP3,'Visible','off');
        set(handles.TextP4,'Visible','on');
        set(handles.TextP5,'Visible','off');
        set(handles.TextP6,'Visible','off');
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextEstimP5,'Visible','off');
        set(handles.TextEstimP6,'Visible','off');
        if handles.langue == 1
            set(handles.TextP1,'String',[param1 ' moyen']);
            set(handles.TextP4,'String',['variance de ' param1]);
        else
            set(handles.TextP1,'String',['mean ' param1]);
            set(handles.TextP4,'String',[param1 ' variance']);
        end
    case 2
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','on');
        set(handles.TextEstimP3,'Visible','off');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','on');
        set(handles.TextP3,'Visible','off');
        set(handles.TextP4,'Visible','on');
        set(handles.TextP5,'Visible','on');
        set(handles.TextP6,'Visible','off');
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextEstimP5,'Visible','on');
        set(handles.TextEstimP6,'Visible','off');
        if handles.langue == 1
            set(handles.TextP1,'String',[param1 ' moyen']);
            set(handles.TextP2,'String',[param2 ' moyen']);
            set(handles.TextP4,'String',['variance de ' param1]);
            set(handles.TextP5,'String',['variance de ' param2]);
        else
            set(handles.TextP1,'String',['mean ' param1]);
            set(handles.TextP2,'String',['mean ' param2]);
            set(handles.TextP4,'String',[param1 ' variance']);
            set(handles.TextP5,'String',[param2 ' variance']);
        end
    case 3
        set(handles.TextEstimP1,'Visible','on');
        set(handles.TextEstimP2,'Visible','on');
        set(handles.TextEstimP3,'Visible','on');
        set(handles.TextP1,'Visible','on');
        set(handles.TextP2,'Visible','on');
        set(handles.TextP3,'Visible','on');
        set(handles.TextP4,'Visible','on');
        set(handles.TextP5,'Visible','on');
        set(handles.TextP6,'Visible','on');
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextEstimP5,'Visible','on');
        set(handles.TextEstimP6,'Visible','on');
        
        if handles.langue == 1
            set(handles.TextP1,'String',[param1 ' moyen']);
            set(handles.TextP2,'String',[param2 ' moyen']);
            set(handles.TextP3,'String',[param3 ' moyen']);
            set(handles.TextP4,'String',['variance de ' param1]);
            set(handles.TextP5,'String',['variance de ' param2]);
            set(handles.TextP6,'String',['variance de ' param3]);
        else
            set(handles.TextP1,'String',['mean ' param1]);
            set(handles.TextP2,'String',['mean ' param2]);
            set(handles.TextP3,'String',['mean ' param3]);
            set(handles.TextP4,'String',[param1 ' variance']);
            set(handles.TextP5,'String',[param2 ' variance']);
            set(handles.TextP6,'String',[param3 ' variance']);
        end
    end
    
    % Histogramme du premier parametre
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(R(1:NbFichiers),NbClasse);
    Amp = X(2)-X(1);
    K = K/size(R(1:NbFichiers),1)/Amp;
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Affichage de l'estimation moyenne pour chacun des parametres
    switch(NbParam)
    case 1
        set(handles.TextEstimP1,'String',sprintf('%f',R(NbFichiers+1)));
        set(handles.TextEstimP4,'String',sprintf('%f',R(NbFichiers+2)));
        set(handles.Histo1Param,'Enable','on');
    case 2
        set(handles.TextEstimP1,'String',sprintf('%f',R(2*NbFichiers+1)));
        set(handles.TextEstimP4,'String',sprintf('%f',R(2*NbFichiers+2)));
        set(handles.TextEstimP2,'String',sprintf('%f',R(2*NbFichiers+3)));
        set(handles.TextEstimP5,'String',sprintf('%f',R(2*NbFichiers+4)));
        set(handles.Histo1Param,'Enable','on');
        set(handles.Histo2Param,'Enable','on');
    case 3
        set(handles.TextEstimP1,'String',sprintf('%f',R(3*NbFichiers+1)));
        set(handles.TextEstimP4,'String',sprintf('%f',R(3*NbFichiers+2)));
        set(handles.TextEstimP2,'String',sprintf('%f',R(3*NbFichiers+3)));
        set(handles.TextEstimP5,'String',sprintf('%f',R(3*NbFichiers+4)));
        set(handles.TextEstimP3,'String',sprintf('%f',R(3*NbFichiers+5)));
        set(handles.TextEstimP6,'String',sprintf('%f',R(3*NbFichiers+6)));
        set(handles.Histo1Param,'Enable','on');
        set(handles.Histo2Param,'Enable','on');
        set(handles.Histo3Param,'Enable','on');
    end
    
    % titre du graphique
    if handles.langue == 1
        title(['Histogramme du parametre ' param1],'Color','r');
    else
        title(['Histogram of parameter ' param1],'Color','r');
    end
    
% Simulation de la loi predictive
case 27
    
    % Invisibilite des frames
    FrameTestInvisible(handles);
    FrameParamInvisible(handles);
    FrameTestETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Lecture du fichier de donnees
    Rdonnees = load(FichierDonnees);
    
    % Environnment graphique
    if handles.langue == 1
        set(handles.TextParam4,'String','Taille de l''echantillon');
        set(handles.TextParam5,'String','Nb de jeux de donnees');
        set(handles.TextParam6,'String','Nb de classes');
    else
        set(handles.TextParam4,'String','Sample size');
        set(handles.TextParam5,'String','Nb of data files');
        set(handles.TextParam6,'String','Nb of bins');
    end
    
    % Affichage des parametres de la loi predictive
    set(handles.EditParam1,'String',num2str(sprintf('%f',str2num(char(Param(14))))));
    set(handles.EditParam2,'String',num2str(sprintf('%f',str2num(char(Param(15))))));
    set(handles.EditParam3,'String',num2str(sprintf('%f',str2num(char(Param(16))))));
    
    % Affichage de la taille de l'echantillon, du nombre de jeux de donner et nb de classe
    set(handles.EditParam4,'String',num2str(sprintf('%d',str2num(char(Param(9))))));
    set(handles.EditParam5,'String',num2str(sprintf('%d',str2num(char(Param(10))))));
    set(handles.EditParam6,'String',num2str(sprintf('%d',str2num(char(Param(11))))));
    
    % Nom de la loi predictive
    switch(char(Param(5)))
    case 'Normale'
        Loi = 'StudentApprochee';
    case 'Lognormale'
        Loi = 'StudentApprocheeTrans';
    case 'Exponentielle'
        Loi = 'GPD';
    case 'Gamma'
        Loi = 'Beta2Prop';
    case 'WeibullEchelle'
        Loi = 'GPDTrans';
    case 'WeibullForme'
        Loi = 'WeibPred';
    end
    
    % Noms et nb des parametres de la loi predictive
    [P1,P2,P3,NbParam] = NomDesParametres(handles,Loi);
    
    % Affichage de la frame des parametres
    AfficheFrameParam(handles,P1,P2,P3,NbParam);
    
    % Lecrure du fichier resultat
    R = load(FichierResult);
    
    % Affichage des informations
    if R(3) == -1 & R(1) == -1  %pas de moments thoriques
        if handles.langue == 1
            R1 = 'non';
            R3 = 'non';
        else
            R1 = 'no';
            R3 = 'no';
        end
    else
        if R(3) == -1
            if handles.langue == 1
                R3 = 'non';
            else
                R3 = 'no';
            end
        else
            R3 = sprintf('%f',R(3));
            R3 = num2str(R3);
        end
        R1 = sprintf('%f',R(1));
        R1 = num2str(R1);
    end
    set(handles.EditMoyTheo,'String',R1);
    R2 = sprintf('%f',R(2));
    R2 = num2str(R2);
    set(handles.EditMoyCal,'String',R2);
    set(handles.EditVarTheo,'String',R3);
    R4 = sprintf('%f',R(4));
    R4 = num2str(R4);
    set(handles.EditVarCal,'String',R4);
    R5 = sprintf('%f',R(5));
    R5 = num2str(R5);
    set(handles.EditQuartile1,'String',R5);
    R6 = sprintf('%f',R(6));
    R6 = num2str(R6);
    set(handles.EditQuartile3,'String',R6);
    R7 = sprintf('%f',R(7));
    R7 = num2str(R7);
    set(handles.EditMediane,'String',R7);
    
    % Histogramme normalise
    NbClasse = round(str2num(sprintf('%d',str2num(char(Param(11))))));
    [K,X] = hist(Rdonnees,NbClasse);
    Amp = X(2)-X(1);
    K = K/size(Rdonnees,1)/Amp;
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Titre du graphique
    if handles.langue == 1
        title(['Simulation selon la loi predictive d''un modele ' char(Param(5))],'Color','r');
    else
        LoiEn = LoiFrToEn(char(Param(5)));
        title(['Simulation of ' LoiEn ' predictive model'],'Color','r');
    end
    
% Estimation des parametres de la loi GPD ( 1 jeu - 1 nb d'exces - 1 methode)
case 28
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = char(Param(5));
    switch(Methode)
    case 'HW'
        set(handles.CBMomentsPonderes,'Value',1);
    case 'EMV'
        set(handles.CBEMV,'Value',1);
    case 'Hill'
        set(handles.CBHill,'Value',1);
    case 'HillG'
        set(handles.CBHillGeneralise,'Value',1);
    case 'Zipf'
        set(handles.CBZipf,'Value',1);
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(6))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
%     P = str2num(char(Param(end)));
%     set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = Param(5);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    NbMethode = 1;
    
    % Affichage des resultats obtenus avec la 1ere methode
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');
    set(handles.TextQGPD,'String','quantile');
    R1 = sprintf('%f',R(1,1));
    if str2num(R1) ~= -10
        set(handles.TextResultatGammaGPD,'String',R1);
    else
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    end
    R2 = sprintf('%f',R(1,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        if handles.langue == 1
            set(handles.TextResultatSigmaGPD,'String','non');
        else
            set(handles.TextResultatSigmaGPD,'String','no');
        end
    end
    %R3 = sprintf('%f',R(NbMethode+1,2));
    %set(handles.TextResultatQGPD,'String',R3);
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);
    
    % Affichage du qq-plot
%     Plage = 3:3+NbExces-1;
%     plot(R(Plage,1),R(Plage,2),'g.');
    Plage = 2:2+NbExces-1;
    PlageInv = 2+NbExces-1:-1:2;
    plot(R(PlageInv,1),R(Plage,2),'g.');
        
    % Titre du graphique
    if handles.langue == 1
        title('Graphe QQ-Plot - Estimation de gamma (GPD)','Color','r');
    else
        title('QQ-Plot graph - Gamma estimate (GPD)','Color','r');
    end
    
    % Menu contextuel du graphique active
    set(handles.Pente,'Enable','on');
    set(handles.QQPlotGPD,'Enable','on');
    
% Estimation des parametres de la loi GPD ( 1 jeu - 1 nb d'exces - N methode)
case 29
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = Param(5:end-3);
    NbMethode = size(Methode,1);
    for i=0:NbMethode-1
        Methode = char(Param(5+i));
        switch(Methode)
        case 'HW'
            set(handles.CBMomentsPonderes,'Value',1);
        case 'EMV'
            set(handles.CBEMV,'Value',1);
        case 'Hill'
            set(handles.CBHill,'Value',1);
        case 'HillG'
            set(handles.CBHillGeneralise,'Value',1);
        case 'Zipf'
            set(handles.CBZipf,'Value',1);
        end
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(end-2))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
%     P = str2num(char(Param(end)));
%     set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
        
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = Param(5:end-3);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Affichage des resultats obtenus avec la 1ere methode
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');
    set(handles.TextQGPD,'String','quantile');
    R1 = sprintf('%f',R(1,1));
    if str2num(R1) ~= -10
        set(handles.TextResultatGammaGPD,'String',R1);
    else
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    end
    R2 = sprintf('%f',R(1,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        if handles.langue == 1
            set(handles.TextResultatSigmaGPD,'String','non');
        else
            set(handles.TextResultatSigmaGPD,'String','no');
        end
    end
    %R3 = sprintf('%f',R(NbMethode+1,2));
    %set(handles.TextResultatQGPD,'String',R3);
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);

% Estimation des parametres de la loi GPD ( 1 jeu - N nb d'exces - 1 ou N methodes)
case 30
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = Param(5:end-3);
    NbMethode = size(Methode,1);
    for i=0:NbMethode-1
        Methode = char(Param(5+i));
        switch(Methode)
        case 'HW'
            set(handles.CBMomentsPonderes,'Value',1);
        case 'EMV'
            set(handles.CBEMV,'Value',1);
        case 'Hill'
            set(handles.CBHill,'Value',1);
        case 'HillG'
            set(handles.CBHillGeneralise,'Value',1);
        case 'Zipf'
            set(handles.CBZipf,'Value',1);
        end
    end  
    
    % Nb d'exces
    ExcesInf = round(str2num(char(Param(end-2))));
    ExcesSup = round(str2num(char(Param(end-1))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
        set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
    else
        set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
        set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
    end
    set(handles.EditExcesInfGPD,'String',ExcesInf);
    set(handles.EditExcesSupGPD,'String',ExcesSup);
%     P = str2num(char(Param(end)));
%     set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    set(handles.TextExcesSupGPD,'Visible','on');
    set(handles.EditExcesSupGPD,'Visible','on');
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Plage des exces
    Plage = ExcesSup - ExcesInf + 1;
    
    % Affichage
    couleur = strvcat('m','b','g','c','k');
    compt = 1;
%     for i=1:NbMethode
%         plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
%         hold on;
%         compt = compt + 1;
%     end
    MethodeInvalide = [];
    for i=1:NbMethode
        Rtemp = R(1+(i-1)*Plage:i*Plage,:);
        ktemp = find(Rtemp(:,2) == -10);
        ktemp1 = find(Rtemp(:,2) ~= -10);
        if isempty(ktemp1)
            MethodeInvalide = i;
        end
        if isempty(ktemp)
            plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
        else
            Rtemp1 = Rtemp(ktemp1,:);
            plot(Rtemp1(:,1),Rtemp1(:,2),[couleur(compt) '.']);
        end
%         plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
%         hold on;
%         compt = compt + 1;
        hold on;
        compt = compt + 1;
    end
    
    % Titre du graphique
    if handles.langue == 1
        title('Courbe des gamma estimes','Color','r');
    else
        title('Estimated gamma curve','Color','r');
    end
    
    % Legende
    Methode = Param(5:end-3);
%    Methode = cellstr(Methode);
    % si pour une methode (EMV), il n'y a aucun resultat corret
    if ~isempty(MethodeInvalide)
        Methode2 = [];
        for i=1:NbMethode
            if i ~= MethodeInvalide
                Methode2 = strvcat(Methode2,char(Methode(i)));
            end
        end
        NbMethode = size(Methode2,1);
        Methode = cellstr(Methode2);
    end
    
    switch(NbMethode)
    case 1
        legend(char(Methode(1)));
    case 2
        legend(char(Methode(1)),char(Methode(2)));
    case 3
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)));
    case 4
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)));
    case 5
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)),char(Methode(5)));
    end
    
    % Menu contextuel du graphique active
    set(handles.CourbeGamma,'Enable','on');
    set(handles.CourbeSigma,'Enable','on');
   % set(handles.CourbeQuantile,'Enable','on');

% Estimation des parametres de la loi GPD ( N jeu - 1 nb d'exces - 1 methode)
case 31
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = char(Param(5));
    switch(Methode)
    case 'HW'
        set(handles.CBMomentsPonderes,'Value',1);
    case 'EMV'
        set(handles.CBEMV,'Value',1);
    case 'Hill'
        set(handles.CBHill,'Value',1);
    case 'HillG'
        set(handles.CBHillGeneralise,'Value',1);
    case 'Zipf'
        set(handles.CBZipf,'Value',1);
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(6))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
%     P = str2num(char(Param(end)));
%     set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Nombre de fichiers traites
    NbFichiers = round(R(end));
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = char(Param(5));
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Affichage des resultats obtenus avec la 1ere methode
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','gamma moyen');
        set(handles.TextSigmaGPD,'String','sigma moyen');
        set(handles.TextQGPD,'String','variance de gamma');
        set(handles.TextVarSigmaGPD,'String','variance de sigma');
    else
        set(handles.TextGammaGPD,'String','mean gamma');
        set(handles.TextSigmaGPD,'String','mean sigma');
        set(handles.TextQGPD,'String','gamma variance');
        set(handles.TextVarSigmaGPD,'String','sigma variance');
    end
    R1 = sprintf('%f',R(end-4));
    set(handles.TextResultatGammaGPD,'String',R1);
    R2 = sprintf('%f',R(end-2));
    set(handles.TextResultatSigmaGPD,'String',R2);
    R3 = sprintf('%f',R(end-3));
    set(handles.TextResultatQGPD,'String',R3);
    R4 = sprintf('%f',R(end-1));
    set(handles.TextResultatVarSigmaGPD,'String',R4);
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextQGPD,'Visible','on');
    set(handles.TextResultatQGPD,'Visible','on');
    set(handles.TextResultatVarSigmaGPD,'Visible','on');
    set(handles.TextVarSigmaGPD,'Visible','on');
    
    % Histogramme de l'estimateur de gamma
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(R(1:NbFichiers),NbClasse);
    Amp = X(2)-X(1);
    K = K/size(R(1:NbFichiers),1)/Amp;
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Titre du graphique
    if handles.langue == 1
        title('Histogramme du parametre gamma','Color','r');
    else
        title('Histogram of gamma parameter','Color','r');
    end
    
    % menu contextuel du graphique active
    set(handles.Histo1Param,'Enable','on');
    set(handles.Histo2Param,'Enable','on');

% Quantile extreme ( 1 jeu - 1 nb d'exces - 1 methode)
case 32
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = char(Param(5));
    switch(Methode)
    case 'HW'
        set(handles.CBMomentsPonderes,'Value',1);
    case 'EMV'
        set(handles.CBEMV,'Value',1);
    case 'Hill'
        set(handles.CBHill,'Value',1);
    case 'HillG'
        set(handles.CBHillGeneralise,'Value',1);
    case 'Zipf'
        set(handles.CBZipf,'Value',1);
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(6))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
    P = str2num(char(Param(end)));
    set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    set(handles.TextQuantileGPD,'Visible','on');
    set(handles.TextPGPD,'Visible','on');
    set(handles.EditPGPD,'Visible','on');
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = Param(5);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    NbMethode = 1;
    
    % Affichage des resultats obtenus avec la 1ere methode
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');
    set(handles.TextQGPD,'String','quantile');
    R1 = sprintf('%f',R(1,1));
    if str2num(R1) ~= -10
        set(handles.TextResultatGammaGPD,'String',R1);
    else
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    end
    R2 = sprintf('%f',R(1,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        if handles.langue == 1
            set(handles.TextResultatSigmaGPD,'String','non');
        else
            set(handles.TextResultatSigmaGPD,'String','no');
        end
    end
    R3 = sprintf('%f',R(NbMethode+1,2));
    if str2num(R3) ~= -10
        set(handles.TextResultatQGPD,'String',R3);
    else
        if handles.langue == 1
            set(handles.TextResultatQGPD,'String','non');
        else
            set(handles.TextResultatQGPD,'String','no');
        end
    end
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextResultatQGPD,'Visible','on');
    set(handles.TextQGPD,'Visible','on');
    
% Quantile extreme ( 1 jeu - 1 nb d'exces - N methode)
case 33
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = Param(5:end-3);
    NbMethode = size(Methode,1);
    for i=0:NbMethode-1
        Methode = char(Param(5+i));
        switch(Methode)
        case 'HW'
            set(handles.CBMomentsPonderes,'Value',1);
        case 'EMV'
            set(handles.CBEMV,'Value',1);
        case 'Hill'
            set(handles.CBHill,'Value',1);
        case 'HillG'
            set(handles.CBHillGeneralise,'Value',1);
        case 'Zipf'
            set(handles.CBZipf,'Value',1);
        end
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(end-2))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
    P = str2num(char(Param(end)));
    set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    set(handles.TextQuantileGPD,'Visible','on');
    set(handles.TextPGPD,'Visible','on');
    set(handles.EditPGPD,'Visible','on');
        
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = Param(5:end-3);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Affichage des resultats obtenus avec la 1ere methode
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');
    set(handles.TextQGPD,'String','quantile');
    R1 = sprintf('%f',R(1,1));
    if str2num(R1) ~= -10
        set(handles.TextResultatGammaGPD,'String',R1);
    else
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    end
    R2 = sprintf('%f',R(1,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        if handles.langue == 1
            set(handles.TextResultatSigmaGPD,'String','non');
        else
            set(handles.TextResultatSigmaGPD,'String','no');
        end
    end
    R3 = sprintf('%f',R(NbMethode+1,2));
    if str2num(R3) ~= -10
        set(handles.TextResultatQGPD,'String',R3);
    else
        if handles.langue == 1
            set(handles.TextResultatQGPD,'String','non');
        else
            set(handles.TextResultatQGPD,'String','no');
        end
    end
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextResultatQGPD,'Visible','on');
    set(handles.TextQGPD,'Visible','on');
 
% Quantile extreme ( 1 jeu - N nb d'exces - 1 ou N methodes)
case 34
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = Param(5:end-3);
    NbMethode = size(Methode,1);
    for i=0:NbMethode-1
        Methode = char(Param(5+i));
        switch(Methode)
        case 'HW'
            set(handles.CBMomentsPonderes,'Value',1);
        case 'EMV'
            set(handles.CBEMV,'Value',1);
        case 'Hill'
            set(handles.CBHill,'Value',1);
        case 'HillG'
            set(handles.CBHillGeneralise,'Value',1);
        case 'Zipf'
            set(handles.CBZipf,'Value',1);
        end
    end  
    
    % Nb d'exces
    ExcesInf = round(str2num(char(Param(end-2))));
    ExcesSup = round(str2num(char(Param(end-1))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
        set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
    else
        set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
        set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
    end
    set(handles.EditExcesInfGPD,'String',ExcesInf);
    set(handles.EditExcesSupGPD,'String',ExcesSup);
    P = str2num(char(Param(end)));
    set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    set(handles.TextExcesSupGPD,'Visible','on');
    set(handles.EditExcesSupGPD,'Visible','on');
    set(handles.TextQuantileGPD,'Visible','on');
    set(handles.TextPGPD,'Visible','on');
    set(handles.EditPGPD,'Visible','on');
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Plage des exces
    Plage = ExcesSup - ExcesInf + 1;
    
    % Affichage
    couleur = strvcat('m','b','g','c','k');
    compt = 1;
%     for i=1:NbMethode
%         plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
%         hold on;
%         compt = compt + 1;
%     end
    for i=1:NbMethode
        Rtemp = R(1+(i-1)*Plage:i*Plage,:);
        ktemp = find(Rtemp(:,2) == -10);
        ktemp1 = find(Rtemp(:,2) ~= -10);
        if isempty(ktemp)
            plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
        else
            Rtemp1 = Rtemp(ktemp1,:);
            plot(Rtemp1(:,1),Rtemp1(:,2),[couleur(compt) '.']);
        end
%         plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
%         hold on;
%         compt = compt + 1;
        hold on;
        compt = compt + 1;
    end
    
    % Titre du graphique
    if handles.langue == 1
        title('Courbe des quantiles extremes','Color','r');
    else
        title('Extreme quantiles curve','Color','r');
    end
    
    % Legende
    Methode = Param(5:end-3);
%    Methode = cellstr(Methode);
    switch(NbMethode)
    case 1
        legend(char(Methode(1)));
    case 2
        legend(char(Methode(1)),char(Methode(2)));
    case 3
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)));
    case 4
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)));
    case 5
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)),char(Methode(5)));
    end
 
% Quantile extreme ( N jeu - 1 nb d'exces - 1 methode)
case 35
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    ViderFrameEstimGPD(handles);
    ViderFrameResultatEstimGPD(handles);
    
    % Methode selectionnee
    Methode = char(Param(5));
    switch(Methode)
    case 'HW'
        set(handles.CBMomentsPonderes,'Value',1);
    case 'EMV'
        set(handles.CBEMV,'Value',1);
    case 'Hill'
        set(handles.CBHill,'Value',1);
    case 'HillG'
        set(handles.CBHillGeneralise,'Value',1);
    case 'Zipf'
        set(handles.CBZipf,'Value',1);
    end
    
    % Nb d'exces
    NbExces = round(str2num(char(Param(6))));
    if handles.langue == 1
        set(handles.TextExcesInfGPD,'String','Nb d''exces');
    else
        set(handles.TextExcesInfGPD,'String','Nb of excesses');
    end
    set(handles.EditExcesInfGPD,'String',NbExces);
    P = str2num(char(Param(end)));
    set(handles.EditPGPD,'String',P);
    FrameEstimGPDVisible(handles);
    set(handles.TextQuantileGPD,'Visible','on');
    set(handles.TextPGPD,'Visible','on');
    set(handles.EditPGPD,'Visible','on');
    
    % Lecture du fichiers de donnees
    R = load(FichierResult);
    
    % Nombre de fichiers traites
    NbFichiers = round(R(end));
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = char(Param(5));
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Affichage des resultats obtenus avec la 1ere methode
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','quantile moyen');
        set(handles.TextSigmaGPD,'String','variance du quantile');
    else
        set(handles.TextGammaGPD,'String','mean quantile');
        set(handles.TextSigmaGPD,'String','quantile variance');
    end
    R1 = sprintf('%f',R(end-2));
    set(handles.TextResultatGammaGPD,'String',R1);
    R2 = sprintf('%f',R(end-1));
    set(handles.TextResultatSigmaGPD,'String',R2);
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Parametres GPD');
        set(handles.TextResultatMethodeGPD,'String','Methodes');
        set(handles.TextResultatParam,'String','Parametres');
    else
        set(handles.TextResultatEstimGPD,'String','GPD parameters');
        set(handles.TextResultatMethodeGPD,'String','Methods');
        set(handles.TextResultatParam,'String','Parameters');
    end
    FrameResultatEstimGPDVisible(handles);
    
    % Hiistogramme
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(R(1:NbFichiers),NbClasse);
    Amp = X(2)-X(1);
    K = K/NbFichiers/Amp;
    
    % question pour l'utilisateur
    if handles.langue == 1
        GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
    else
        GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
    end
        
    switch (GardeGraph)
    case {'Oui','Yes'}
                   
        % on affiche sur le meme graphe
        hold on;
    case {'Non','No'}
        % nouveau graphe
        hold off;
    end
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Titre du graphique
    if handles.langue == 1
        title('Histogramme des quantiles extremes','Color','r');
    else
        title('Extreme quantiles histogram','Color','r');
    end

% quantiles parametriques - donnees simples
case 36
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    set(handles.EditOrdreQuantileParam,'String','');
    ViderFrameResultatEstimGPD(handles);
    CBDecocheLois(handles);
    
    % bouton lancer desactive
    set(handles.BtLancerQuantileParam,'Enable','off');
    
    % Recuperations des lois selectionnees
    Loi = Param(5:end-7);
    
    % Affectation de l'ordre du quantile
    set(handles.EditOrdreQuantileParam,'String',Param(end));
    
    % Affectation e la frame des lois les lois selectionnees
    if size(Loi,1) == 11
        set(handles.CBCLToutes,'Value',1);
    end
    for i=1:size(Loi,1)
        LoiSelec = char(Loi(i));
        switch(LoiSelec)
        case 'Normale'
            set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
            set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
            set(handles.CBCLExpo,'Value',1);
        case 'Gamma'
            set(handles.CBCLGamma,'Value',1);
        case 'Weibull'
            set(handles.CBCLWeibull,'Value',1);
        case 'Chi2'
            set(handles.CBCLChi2,'Value',1);
        case 'Student'
            set(handles.CBCLStudent,'Value',1);
        case 'Pareto'
            set(handles.CBCLPareto,'Value',1);
        case 'GPD'
            set(handles.CBCLGPD,'Value',1);
        case 'Uniforme'
            set(handles.CBCLUnif,'Value',1);
        case 'Beta'
            set(handles.CBCLBeta,'Value',1);
        end
    end
    
    % Affichage de la Frame des quantiles parametriques
    FrameQuantileParamVisible(handles);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Loi = cellstr(Loi);
    set(handles.PopupResultatMethode,'Value',1);
    if handles.langue == 1
        set(handles.PopupResultatMethode,'String',Loi);
    else
        LoiEn = [];
        for i=1:size(Loi,1)
            LoiEnTemp = LoiFrToEn(char(Loi(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultatMethode,'String',LoiEn);
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Affichage du 1er quantile
    set(handles.TextGammaGPD,'String','q param');
    set(handles.TextSigmaGPD,'String','');
    set(handles.TextQGPD,'String','');
    if R(1) == -10
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    else
        R1 = sprintf('%f',R(1));
        set(handles.TextResultatGammaGPD,'String',R1);
    end
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Resultats Q Param');
        set(handles.TextResultatMethodeGPD,'String','Modeles');
    else
        set(handles.TextResultatEstimGPD,'String','Q Param Results');
        set(handles.TextResultatMethodeGPD,'String','Models');
    end
    set(handles.TextResultatParam,'String','Quantiles');
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextSigmaGPD,'Visible','off');
    set(handles.TextResultatSigmaGPD,'Visible','off');
    
% quantiles paraetriques - N jeux de donnees
case 37
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Reinitialisation des frames
    set(handles.EditOrdreQuantileParam,'String','');
    ViderFrameResultatEstimGPD(handles);
    CBDecocheLois(handles);
    
    % bouton lancer desactive
    set(handles.BtLancerQuantileParam,'Enable','off');
    
    % Recuperations des lois selectionnees
    Loi = Param(5);
    
    % Affectation de l'ordre du quantile
    set(handles.EditOrdreQuantileParam,'String',Param(end));
    
    % Affectation e la frame des lois les lois selectionnees
    LoiSelec = char(Loi);
    switch(LoiSelec)
    case 'Normale'
        set(handles.CBCLNormale,'Value',1);
    case 'Lognormale'
        set(handles.CBCLLognormale,'Value',1);
    case 'Exponentielle'
        set(handles.CBCLExpo,'Value',1);
    case 'Gamma'
        set(handles.CBCLGamma,'Value',1);
    case 'Weibull'
        set(handles.CBCLWeibull,'Value',1);
    case 'Chi2'
        set(handles.CBCLChi2,'Value',1);
    case 'Student'
        set(handles.CBCLStudent,'Value',1);
    case 'Pareto'
        set(handles.CBCLPareto,'Value',1);
    case 'GPD'
        set(handles.CBCLGPD,'Value',1);
    case 'Uniforme'
        set(handles.CBCLUnif,'Value',1);
    case 'Beta'
        set(handles.CBCLBeta,'Value',1);
    end
    
    % Affichage de la Frame des quantiles parametriques
    FrameQuantileParamVisible(handles);
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Loi);
    
    % Affichage du quantile moyen
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','q moyen');
        set(handles.TextSigmaGPD,'String','variance de q');
    else
        set(handles.TextGammaGPD,'String','mean q');
        set(handles.TextSigmaGPD,'String','q variance');
    end
    set(handles.TextQGPD,'String','');
    if R(end-2) == -10
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    else
        R1 = sprintf('%f',R(end-2));
        set(handles.TextResultatGammaGPD,'String',R1);
    end
    R2 = sprintf('%f',R(end-1));
    set(handles.TextResultatSigmaGPD,'String',R2);
    if handles.langue == 1
        set(handles.TextResultatEstimGPD,'String','Resultats Q Param');
        set(handles.TextResultatMethodeGPD,'String','Modeles');
    else
        set(handles.TextResultatEstimGPD,'String','Q Param Results');
        set(handles.TextResultatMethodeGPD,'String','Models');
    end
    set(handles.TextResultatParam,'String','Quantiles');
    FrameResultatEstimGPDVisible(handles);
    
    % histogramme des quantiles
    NbFichiers = R(end);
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    R1 = R(1:NbFichiers);
    k = find(R1 ~= -10);
    if isempty(k)
        if handles.langue == 1
            errordlg('Impossible de dessiner l''histogramme','Valeur de quantile invalide','modal');
        else
            errordlg('Histogram can''t be dranw','Invalid quantile value','modal');
        end
    else
        % question pour l'utilisateur
        if handles.langue == 1
            GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
        else
            GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
        end
        
        switch (GardeGraph)
        case {'Oui','Yes'}
            
            % on affiche sur le meme graphe
            hold on;
        case {'Non','No'}
            % nouveau graphe
            hold off;
        end
        R2 = R1(k);
        [K,X] = hist(R2,NbClasse);
        Amp = X(2)-X(1);
        K = K/size(k,1)/Amp;
        bar(X,K,'hist','r');
%    colormap(handles.CouleurHisto);

    % Titre du graphique
        if handles.langue == 1
            title('Histogramme des quantiles parametriques','Color','r');
        else
            title('Parametric quantiles histogram','Color','r');
        end
    end

% Test GPD - Donnees multiples
case {38,39,40}
    
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois
    CBDecocheLois(handles);
    CBDecocheMethodes(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-8),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
            set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
            set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
            set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
            set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
            set(handles.CBCLGamma,'Value',1);
        case 'Chi2'
            set(handles.CBCLChi2,'Value',1);
        case 'Student'
            set(handles.CBCLStudent,'Value',1);
        case 'Pareto'
            set(handles.CBCLPareto,'Value',1);
        case 'GPD'
            set(handles.CBCLGPD,'Value',1);
        case 'Uniforme'
            set(handles.CBCLUnif,'Value',1);
        case 'Beta'
            set(handles.CBCLBeta,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage de la methode utilisee
    NomMethode = char(Param(end));
    switch(NomMethode)
    case 'HW'
        set(handles.CBCMHW,'Value',1);
    case 'EMV'
        set(handles.CBCMEMV,'Value',1);
    case 'Hill'
        set(handles.CBCMHill,'Value',1);
    case 'HillG'
        set(handles.CBCMHillG,'Value',1);
    case 'Zipf'
        set(handles.CBCMZipf,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-6))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test (Asymptotique, BP ou BPS)
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-3))));
    
    % Affichage du nombre d'exces
    if handles.langue == 1
        set(handles.TextExcesSup,'String','Nb d''exces');
    else
        set(handles.TextExcesSup,'String','Nb of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-7));
    
    % Affichage de l'ordre qu quantile ET
    set(handles.EditPET,'String',Param(end-1));
    
    % Affichage de la Frame ET
    if handles.langue == 1
        set(handles.TextTestET,'String','Test GPD');
    else
        set(handles.TextTestET,'String','GPD test');
    end
    FrameTestETVisible(handles,'GPD');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nombre d'echantillons de bootstrap si test != Asymptotique
    if Tache ~= 38
        set(handles.EditBootstrapET,'String',Param(end-2));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Lecture du fichier resultat
    [R]=textread(FichierResult,'%s','delimiter','\n','whitespace','');
    
    % Conversion
    R1 = str2num(char(R));
    
    % Affichage du % de rejet et d'acceptation
    X = [0,1,2];
    bar(X(1:2),R1(1:2),'r');
    
    % on garde le meme graphe
    hold on;
    
    % Affichage du % d'ecart-type
    bar(X(3),R1(3),'y');
    if handles.langue == 1
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % de rejet'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % d''acceptation'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % d''ecart-type'],'HorizontalAlignment','center','Color','r');
    else
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % rejection'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % acceptance'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % standard deviation'],'HorizontalAlignment','center','Color','r');
    end
    
    % Borne du graphe
    axis([-1 3 0 110]);
    
    % Titre
    if handles.langue == 1
        title('Pourcentage d''acceptation et de rejet et Ecart-type','Color','r');
    else
        title('Acceptance and rejection percentage and standard deviation','Color','r');
    end
    
% Test GPD - 1 seul nombre d'exces
case {41,42,43}
    
    % Invisibilite des frames
    FrameTestInvisible(handles);
    FrameParamInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois
    CBDecocheLois(handles);
    CBDecocheMethodes(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-8),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
            set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
            set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
            set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
            set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
            set(handles.CBCLGamma,'Value',1);
        case 'Chi2'
            set(handles.CBCLChi2,'Value',1);
        case 'Student'
            set(handles.CBCLStudent,'Value',1);
        case 'Pareto'
            set(handles.CBCLPareto,'Value',1);
        case 'GPD'
            set(handles.CBCLGPD,'Value',1);
        case 'Uniforme'
            set(handles.CBCLUnif,'Value',1);
        case 'Beta'
            set(handles.CBCLBeta,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage de la methode utilisee
    NomMethode = char(Param(end));
    switch(NomMethode)
    case 'HW'
        set(handles.CBCMHW,'Value',1);
    case 'EMV'
        set(handles.CBCMEMV,'Value',1);
    case 'Hill'
        set(handles.CBCMHill,'Value',1);
    case 'HillG'
        set(handles.CBCMHillG,'Value',1);
    case 'Zipf'
        set(handles.CBCMZipf,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-6))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-3))));
    
    % Affichage du nombre d'exces
    if handles.langue == 1
        set(handles.TextExcesSup,'String','Nb d''exces');
    else
        set(handles.TextExcesSup,'String','Nb of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-7));
    
    % Affichage de l'ordre du quantile ET
    set(handles.EditPET,'String',Param(end-1));
    
    % Affichage de la Frame ET
    if handles.langue == 1
        set(handles.TextTestET,'String','Test GPD');
        set(handles.TextResultatET,'String','Test GPD');
    else
        set(handles.TextTestET,'String','GPD test');
        set(handles.TextResultatET,'String','GPD test');
    end
    FrameTestETVisible(handles,'GPD');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nombre d'echantillons de bootstrap si test != Asymptotique
    if Tache ~= 41
        set(handles.EditBootstrapET,'String',Param(end-2));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Affectation des lois slectionnees dans la popupresultatET
    Loi = Param(5:end-8);
    set(handles.PopupResultatET,'Value',1);
    
    if handles.langue == 1
        set(handles.PopupResultatET,'String',Loi);
    else
        LoiEn = [];
        for i=1:size(Loi,1)
            LoiEnTemp = LoiFrToEn(char(Loi(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultatET,'String',LoiEn);
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Affichage des resultats pour la 1ere loi
    R2 = sprintf('%f',R(2));
    R2 = num2str(R2);
    set(handles.TextResultatQET,'String',R2);   % qET
    R3 = sprintf('%f',R(3));
    R3 = num2str(R3);
    set(handles.TextResultatQParam,'String',R3);    % q parametrique
    qET = R(2);
    qParam = R(3);
    D = num2str(qET - qParam);
    set(handles.TextResultatStatET,'String',D);     % qET - q param
    R4 = sprintf('%f',R(4));
    R4 = num2str(R4);
    R5 = sprintf('%f',R(5));
    R5 = num2str(R5);
    Intervalle = ['[ ' R4 ' ; ' R5 ' ]'];
    set(handles.TextResultatIntervalle,'String',Intervalle);    % Intervalle de confiance
    
    % Affichage de la decision
    if R(1) == 1
        if handles.langue == 1
            R1 = 'Accepte';
        else
            R1 = 'Accepted';
        end
    else
        if handles.langue == 1
            R1 = 'Rejete';
        else
            R1 = 'Rejected';
        end  
    end
    set(handles.TextResultatDecisionET,'String',R1);
    
    % La statistique de test est affichee en rouge et change suivant la version du test
    switch(Tache)
    case {19,41}
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[1 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    case {20,42}
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[1 0 0]);
    case {21,43}
        set(handles.TextQET,'ForegroundColor',[1 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    end
    
    % Affichage de la frame resultat GPD
    FrameResultatETVisible(handles,'GPD');

% Test GPD - plusieurs exces
case {44,45,46}
    
    % Invisibilite des frames
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameParamInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % on decoche toutes les lois et les methodes
    CBDecocheLois(handles);
    CBDecocheMethodes(handles);
    
    % Affichage des lois selectionnees
    NbLoi = size(Param(5:end-8),1);
    for (i=0:NbLoi-1)
        NomLoi = char(Param(5+i));
        switch(NomLoi)
        case 'Normale'
            set(handles.CBCLNormale,'Value',1);
        case 'Lognormale'
            set(handles.CBCLLognormale,'Value',1);
        case 'Exponentielle'
            set(handles.CBCLExpo,'Value',1);
        case 'Weibull'
            set(handles.CBCLWeibull,'Value',1);
        case 'Gamma'
            set(handles.CBCLGamma,'Value',1);
        case 'Chi2'
            set(handles.CBCLChi2,'Value',1);
        case 'Student'
            set(handles.CBCLStudent,'Value',1);
        case 'Pareto'
            set(handles.CBCLPareto,'Value',1);
        case 'GPD'
            set(handles.CBCLGPD,'Value',1);
        case 'Uniforme'
            set(handles.CBCLUnif,'Value',1);
        case 'Beta'
            set(handles.CBCLBeta,'Value',1);
        end
    end
    if NbLoi == 11
        set(handles.CBCLToutes,'Value',1);
    end
    
    % Affichage de la methode utilisee
    NomMethode = char(Param(end));
    switch(NomMethode)
    case 'HW'
        set(handles.CBCMHW,'Value',1);
    case 'EMV'
        set(handles.CBCMEMV,'Value',1);
    case 'Hill'
        set(handles.CBCMHill,'Value',1);
    case 'HillG'
        set(handles.CBCMHillG,'Value',1);
    case 'Zipf'
        set(handles.CBCMZipf,'Value',1);
    end
    
    % Affichage du niveau du test ET
    switch(str2num(char(Param(end-6))))
    case 0.25
        set(handles.PopupNiveauET,'Value',1);
    case 0.1
        set(handles.PopupNiveauET,'Value',2);
    case 0.05
        set(handles.PopupNiveauET,'Value',3);
    case 0.025
        set(handles.PopupNiveauET,'Value',4);
    case 0.01
        set(handles.PopupNiveauET,'Value',5);
    end
    
    % Affichage de la version du test ET
    set(handles.PopupVersionET,'Value',str2num(char(Param(end-3))));
    
    % Affichage de l'intervalle des exces
    if handles.langue == 1
        set(handles.TextExcesInf,'String','Borne Inf des exces');
        set(handles.TextExcesSup,'String','Borne Sup des exces');
    else
        set(handles.TextExcesInf,'String','Inf limit of excesses');
        set(handles.TextExcesSup,'String','Sup limit of excesses');
    end
    set(handles.EditExcesSup,'String',Param(end-4));
    set(handles.EditExcesInf,'String',Param(end-5));
    
    % Affichage de l'ordre du quantile ET
    set(handles.EditPET,'String',Param(end-1));
    
    % Affichage de la frame test
    if handles.langue == 1
        set(handles.TextTestET,'String','Test GPD');
    else
        set(handles.TextTestET,'String','GPD test');
    end
    FrameTestETVisible(handles,'GPD');
    set(handles.TextExcesInf,'Visible','on');
    set(handles.EditExcesInf,'Visible','on');
    set(handles.TextExcesSup,'Visible','on');
    set(handles.EditExcesSup,'Visible','on');
    
    % Affichage du nb d'echantillons de bootstrap si test != asymptotique
    if Tache ~= 22
        set(handles.EditBootstrapET,'String',Param(end-2));
        set(handles.EditBootstrapET,'Visible','on');
        set(handles.TextBootstrapET,'Visible','on');
    end
    
    % Lecture du fichier resultat
    R = load(FichierResult);
    
    % Determinantion du nombre totral d'exces
    E1 = str2num(char(Param(end-5)));
    E2 = str2num(char(Param(end-4)));
    NbExces = E2 - E1 + 1;
    
    % Nombre de lois selectionnees
    M = size(Param(5:end-8),1);
    
    couleur = strvcat('r','g','b','c','m','y','k','g:','b:','m:','k:');
    couleur1 = [0.5 0.5 0.5; 0.1 0 0.569; 0.4 0.6325 0; 0.845 0.159 0.785];
    Leg = [];
    if M == 1
        area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
        axis([E1 E2 -0.5 1.5]);
        legend(char(Param(5)));
    else
        for i=M:-1:1
            if i >= 8
                area(R((i-1)*NbExces+1:i*NbExces,1),R((i-1)*NbExces+1:i*NbExces,2) + 2 *(i-1),'FaceColor',couleur1(i - 7,:),'EdgeColor',couleur1(i - 7,:));
            else
                area(R((i-1)*NbExces+1:i*NbExces,1),R((i-1)*NbExces+1:i*NbExces,2) + 2 *(i-1),'FaceColor',couleur(i,:),'EdgeColor',couleur(i,:));
            end
            hold on;
            area(R(NbExces+1:2*NbExces,1),repmat(2*(i-1),NbExces,1),'FaceColor','w','EdgeColor','w');
            Leg = strvcat(Leg,char(Param(5+(i-1))),' ');
        end
        LimiteAxe = -0.5 + 2 * M;
        axis([E1 E2 -0.5 LimiteAxe]);
        legend(Leg);
    end
    
%     % Affichage des plages d'acceptation du test
%     switch(M)
%     case 1
%         area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 1.5]);
%         legend(char(Param(5)));
%     case 2
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 3.5]);
%         legend(char(Param(6)),'',char(Param(5)));
%     case 3
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 5.5]);
%         legend(char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     case 4
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 7.5]);
%         legend(char(Param(8)),'',char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     case 5
%         area(R(4*NbExces+1:5*NbExces,1),R(4*NbExces+1:5*NbExces,2) + 8,'FaceColor','k','EdgeColor','k');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(8,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 9.5]);
%         legend(char(Param(9)),'',char(Param(8)),'',char(Param(7)),'',char(Param(6)),'',char(Param(5)));
%     end
    
    % Titre
    if handles.langue == 1
        title('Plage d''acceptation du test pour chaque modele','Color','r');
    else
        title('Test acceptance region for each model','Color','r');
    end    
end

% --------------------------------------------------------------------

%function varargout = ListFichiers_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.ListFichiers.
%if strcmp(get(handles.Extremes,'SelectionType'),'open') % If double click
%    IndexSelected = get(handles.ListFichiers,'Value');
%    FileList = get(handles.ListFichiers,'String');
%   filename = FileList{IndexSelected}; % Item selected in list box
%    if  handles.IsDir(handles.SortedIndex(IndexSelected)) % If directory
%        cd (filename);
%        LoadListFichiers(pwd,handles); % Load list box with new directory
%    else
%        [path,name,ext] = fileparts([pwd '\' filename]);
%        switch ext
%        case '.txt'
%            NouvelEspace(handles);
%            handles.NomFichier = fullfile(path,[name ext]);
%        case '.dat'
%            NouvelEspace(handles);
%            handles.NomFichier = fullfile(path,[name ext]);
%        otherwise
%            errordlg('Extension de fichiers non valide','Erreur d''ouveture','modal');
%        end
%    end
%end

% --------------------------------------------------------------------
% CHARGEMENT D'UN FICHIER

function varargout = MenuFichiersOuvrir_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Ouverture d''un fichier de donnees');

% Affichage de la boite de dialogue
if handles.langue == 1
    [filename, pathname] = uigetfile({'*.txt;*.dat;*.TXT;*.DAT', 'Fichiers de donnees (*.txt, *.dat, *.TXT, *.DAT)'},'Ouvrir...');
else
    [filename, pathname] = uigetfile({'*.txt;*.dat;*.TXT;*.DAT', 'Data file (*.txt, *.dat, *.TXT, *.DAT)'},'Open...');
end

% si le nom de fichier est valide
if ~isequal(pathname,0) & ~isequal(filename,0)
    FrameParamInvisible(handles);
    
    % Creation d'un nouvel espace de travail si new == 1
    [new,EspaceDeTravail] = NouvelEspace(handles);
    if new == 1
        
        % Supression du graphique et du titre en cours
        cla;
        title('');
        
        % Invisibilte des frames
        FrameResultatInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameTestETInvisible(handles);
        FrameTestInvisible(handles);
        FrameInfoInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Affectation des variables
        handles.NbParam = 0;
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);   % Affichage du nouvel espace de travail
        
        % Aucune action encore effectuee
        handles.Action = '';
        set(handles.PopupAction,'Value',1);
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        
        % Creation d'un nouveau repertoire sur le disque
        Index = get(handles.PopupTravail,'Value');
        ListeEspace = get(handles.PopupTravail,'String');
        Rep = ListeEspace{Index};
        [s,t]=mkdir(handles.path,Rep);
        
        % Nom de fichier e creer
        destination = [handles.path '/' Rep '/' 'Donnees.txt'];
        
        handles.NomFichier = destination;
        set(handles.MenuEstim,'Enable','on');
        set(handles.GraphHistogramme,'Enable','on');
        set(handles.MenuTests,'Enable','on');
        set(handles.RegBay,'Enable','on');
        
        % Lecture du fichier de donnees
        R = load([pathname filename]);
        
        % tri des donnees
        R = sort(R);
        
        % affectation du nb de donnees
        handles.Taille = size(R,1);
        
        % Duplication du fichier vers le bon repertoire
        fid = fopen(destination,'w');
        for i=1:size(R,1)-1
            fprintf(fid,'%24.17e\n',R(i));
        end
        fprintf(fid,'%24.17e',R(i+1));
        fclose(fid);
        
        % Sauvegarde des variables globales
        guidata(handles.Extremes,handles);
        
        % Message e l'utilisateur
        if handles.langue == 1
            msgbox(['Le fichier selectionne compte ' int2str(size(R,1)) ' elements. Le minimum est : ' num2str(R(1)) ' . Le maximum est : ' num2str(R(end)) ' .'],'Informations');
        else
            msgbox(['The selected file contains ' int2str(size(R,1)) ' elements. Minimum is : ' num2str(R(1)) ' . Maximum is : ' num2str(R(end)) ' .'],'Informations');
        end
        
    end
end
% Aucune action en cours
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% SAUVEGARDE D'UN ESPACE DE TRAVAIL

function varargout = EnregistrerEspace_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Sauvegarde de l''espace de travail');

% erreur flagrante
ListeEspace = get(handles.PopupTravail,'String');
if isempty(ListeEspace)
    if handles.langue == 1
        errordlg('Aucun espace de travail n''est selectionne','Impossible d''enregistrer','modal');
    else
        errordlg('No workspace selected','Saving is impossible','modal');
    end
    set(handles.TextEnCours,'String','');
    return;
end

% Affichage de la boite de dialogue
if handles.langue == 1
    [filename, pathname] = uiputfile({'*.*', 'Nom de repertoire'},'Enregistrer l''espace de travail sous...');
else
    [filename, pathname] = uiputfile({'*.*', 'Directory'},'Save workspace as...');
end

% si le nom du repertoire est correct
if ~isequal(pathname,0) & ~isequal(filename,0)
    
    % lecture de l'espace de travail
    Rep = LitRepEDT(handles);
    
    % DirStruct contient l'ensemble des noms de fichiers du repertoire Rep
    DirStruct = dir(Rep);
    
    % si le nom de repertoire n'existe pas
    if exist([pathname filename],'dir')==0
        
        % creation du repertoire de sauvegarde
        [s,t]=mkdir(pathname,filename);
        
        % Definition des noms complets des fichiers (depuis la racine)
        R = repmat([Rep '/'],size(DirStruct,1),1);
        N = char(DirStruct.name);
        fichiers = [R N];
        fichiers = cellstr(fichiers);
        
        % Copie des fichiers vers la destination
        for i = 3:size(fichiers,1)
            machin = char(fichiers(i));
            copyfile(machin,[pathname filename]);
        end
        
        % Aucune acton en cours
        set(handles.TextEnCours,'String','');
    else
        R = repmat([Rep '/'],size(DirStruct,1),1);
        N = char(DirStruct.name);
        fichiers = [R N];
        fichiers = cellstr(fichiers);
        for i = 3:size(fichiers,1)
            machin = char(fichier(i));
            copyfile(machin,[pathname filename]);
        end
        set(handles.TextEnCours,'String','');
    end
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% APERCU AVANT IMPRESSION

function varargout = MenuFichiersApercu_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Apereu avant impression');

printpreview(handles.Extremes);

set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% IMPRESSION

function varargout = MenuFichiersImprimer_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Impression');

printdlg(handles.Extremes);

set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% CHARGER UN ESPACE DE TRAVAIL

function varargout = ChargerEspace_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Chargement d''un espace');

% Affichage de la boite de dialogue
if handles.langue == 1
    [filename, pathname] = uigetfile({'*.*', 'Nom de repertoire'},'Charger un espace de travail...');
else
    [filename, pathname] = uigetfile({'*.*', 'Directory'},'Load a workspace...');
end

% si le nom du repertoire est correct
if ~isequal(pathname,0) & ~isequal(filename,0)
    
    % nouvel espace de travail
    [new,EspaceDeTravail] = NouvelEspace(handles);
    
    if new == 1
        
        % Affectation des variables
        handles.NbParam = 0;
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);   % Affichage du nouvel espace de travail
        
        % creation du repertoire sur le disque
        CreeRepEDT(handles,new);
        
        % Supression du graphique et du titre en cours
        cla;
        title('');
        
        % Invisibilte des frames
        FrameResultatInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameTestETInvisible(handles);
        FrameTestInvisible(handles);
        FrameInfoInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        FrameParamInvisible(handles);
        
        % DirStruct contient l'ensemble des noms de fichiers du repertoire Rep
        DirStruct = dir(pathname);
        
        % lecture de l'espace de travail
        Rep = LitRepEDT(handles);
        
        % Definition des noms complets des fichiers (depuis la racine)
        R = repmat(pathname,size(DirStruct,1),1);
        N = char(DirStruct.name);
        fichiers = [R N];
        fichiers = cellstr(fichiers);
        
        % copie des fichiers
        for i = 3:size(fichiers,1)
            machin = char(fichiers(i));
            copyfile(machin,Rep);
        end
        
        % Chargement des donnes
        FichierDonnees = [Rep '/Donnees.txt'];
        R = load(FichierDonnees);
    
        % Affectation du nombre d'elements
        handles.Taille = size(R,1);
    
        % Chargement des actions
        FichierAction = [Rep '/Action.txt'];
        [names]=textread(FichierAction,'%s','delimiter','\n','whitespace','');
    
        % Affectation des actions
        EA = flipud(names);
        handles.Action = cellstr(EA);
        set(handles.PopupAction,'Value',1);
        set(handles.PopupAction,'String',handles.Action);
    
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
    
        % Frame Info devient vide
        ViderEditInfo(handles);
        
        % menus actives
        set(handles.MenuEstim,'Enable','on');
        set(handles.GraphHistogramme,'Enable','on');
        set(handles.MenuTests,'Enable','on');
        set(handles.RegBay,'Enable','on');
        
    end    
end
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
%function LoadListFichiers(DirPath,handles)
%cd (DirPath) % Change to the specified directory
%DirStruct = dir(DirPath); % List contents of directory
%[SortedNames,SortedIndex] = sortrows({DirStruct.name}'); % Sort names
%handles.FileNames = SortedNames; % Save the sorted names
%handles.IsDir = [DirStruct.isdir]; % Save names of directories
%handles.SortedIndex = [SortedIndex]; % Save sorted index values
%guidata(handles.Extremes,handles) % Save the handles structure
%set(handles.ListFichiers,'String',handles.FileNames,'Value',1) % Load listbox
%set(handles.EditDir,'String',pwd) % Display current directory

% --------------------------------------------------------------------
% PREPARATION DENSITE NORMALE

function varargout = GraphDensiteNormale_Callback(h, eventdata, handles, varargin)

% Affichage de l'action en cours
AfficheActionEnCours(handles,'Densite Normale');

% Recuperation de la liste des espaces de travail
EDT = strvcat(char(handles.Workspace));

% Si la liste est vide
if isempty(EDT)
    % Creation d'un nouvel espace si new == 1
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end

% Preparation de la Frame des parametre (Passe == 0 : annulation | Passe == 1 : OK)
% NomFich = eventuel nom de fichier d'abscisse
[Passe,NomFich] = PrepareParamGraph(handles,new,0);

% Si on n'a pas annule
if Passe == 1
    
    % Invisibilite des frames
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Affectation des variables globales
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Normale';
    handles.NomFichier = NomFich;
    
    % si creation d'un nouvel espace
    if new == 1
        % Aucune action encore effectuees
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        
        % Actualisation de la liste des espaces de travail
        handles.Workspace = cellstr(EspaceDeTravail);
        
        % Affichage de celle-ci
        set(handles.PopupTravail,'String',handles.Workspace);
        
    end
    
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    
    % Si entrees manuelles a ete selectionnee
    if strcmp(NomFich,'*') == 1
        % Definition des valeurs par defaut
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
        
    end
    
    % Affichage de la frame des parametres
    AfficheFrameParam(handles,'m','sigma','',2);
    
    % Creation d'un nouveau repertoire sur le disque
    CreeRepEDT(handles,new);
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
else
    % Aucune action en cours
    set(handles.TextEnCours,'String','');
    
end

% --------------------------------------------------------------------
% PREPARATION DENSITE LOGNORMALE

function varargout = GraphDensiteLognormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Lognormale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Lognormale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE CHI2

function varargout = GraphDensiteChi2_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Chi2');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 2;
    handles.Nomloi = 'Chi2';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE STUDENT

function varargout = GraphDensiteStudent_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Student');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 2;
    handles.Nomloi = 'Student';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE BETA

function varargout = GraphDensiteBeta_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Beta');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Beta1espece';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE GAMMA

function varargout = GraphDensiteGamma_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Gamma');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Gamma';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);    
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','teta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE EXPONENTIELLE

function varargout = GraphDensiteExponentielle_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Exponentielle');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 2;
    handles.Nomloi = 'Exponentielle';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'alpha','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE WEIBULL

function varargout = GraphDensiteWeibull_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Weibull');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Weibull';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'eta','beta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE PARETO

function varargout = GraphDensitePareto_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Pareto');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Pareto';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'x0','alpha','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE GPD

function varargout = GraphDensiteGPD_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite GPD');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'GPD';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'gamma','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION DENSITE UNIFORME

function varargout = GraphDensiteUniforme_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Densite Uniforme');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 2;
    handles.Nomloi = 'Uniforme';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR NORMALE

function varargout = GraphFDRNormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Normale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Normale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR LOGNORMALE

function varargout = GraphFDRLognormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Lognormale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Lognormale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR CHI2

function varargout = GraphFDRChi2_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Chi2');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 3;
    handles.Nomloi = 'Chi2';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR STUDENT

function varargout = GraphFDRStudent_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Student');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 3;
    handles.Nomloi = 'Student';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR BETA

function varargout = GraphFDRBeta_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Beta');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Beta1espece';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR GAMMA

function varargout = GraphFDRGamma_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Gamma');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Gamma';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','teta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR EXPONENTIELLE

function varargout = GraphFDRExponentielle_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Exponentielle');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 3;
    handles.Nomloi = 'Exponentielle';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'alpha','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR WEIBULL

function varargout = GraphFDRWeibull_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Weibull');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Weibull';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'eta','beta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR PARETO

function varargout = GraphFDRPareto_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Pareto');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Pareto';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'x0','alpha','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR GPD

function varargout = GraphFDRGPD_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR GPD');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'GPD';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'gamma','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FDR UNIFORME

function varargout = GraphFDRUniforme_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'FDR Uniforme');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 3;
    handles.Nomloi = 'Uniforme';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE NORMALE

function varargout = GraphFQNormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Normale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Normale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE LOGNORMALE

function varargout = GraphFQLognormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Lognormale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Lognormale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE CHI2

function varargout = GraphFQChi2_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Chi2');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 4;
    handles.Nomloi = 'Chi2';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE STUDENT

function varargout = GraphFQStudent_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Student');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 4;
    handles.Nomloi = 'Student';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE BETA

function varargout = GraphFQBeta_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Beta');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Beta1espece';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE GAMMA

function varargout = GraphFQGamma_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Gamma');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Gamma';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','teta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE EXPONENTIELLE

function varargout = GraphFQExponentielle_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Exponentielle');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 4;
    handles.Nomloi = 'Exponentielle';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'alpha','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE WEIBULL

function varargout = GraphFQWeibull_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Weibull');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Weibull';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'eta','beta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE PARETO

function varargout = GraphFQPareto_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Pareto');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Pareto';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'x0','alpha','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE GPD

function varargout = GraphFQGPD_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile GPD');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'GPD';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'gamma','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION QUANTILE UNIFORME

function varargout = GraphFQUniforme_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction quantile Uniforme');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,1);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 4;
    handles.Nomloi = 'Uniforme';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE NORMALE

function varargout = GraphSurvieNormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Normale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Normale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE LOGNORMALE

function varargout = GraphSurvieLognormale_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Lognormale');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Lognormale';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'m','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE CHI2

function varargout = GraphSurvieChi2_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Chi2');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 8;
    handles.Nomloi = 'Chi2';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE STUDENT

function varargout = GraphSurvieStudent_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Student');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 8;
    handles.Nomloi = 'Student';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'n','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE BETA

function varargout = GraphSurvieBeta_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Beta');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Beta1espece';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE GAMMA

function varargout = GraphSurvieGamma_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Gamma');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Gamma';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','teta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE EXPONENTIELLE

function varargout = GraphSurvieExponentielle_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Exponentielle');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 1;
    handles.Tache = 8;
    handles.Nomloi = 'Exponentielle';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'alpha','','',1);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE WEIBULL

function varargout = GraphSurvieWeibull_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Weibull');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Weibull';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'eta','beta','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE PARETO

function varargout = GraphSurviePareto_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Pareto');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Pareto';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'x0','alpha','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE GPD

function varargout = GraphSurvieGPD_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie GPD');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'GPD';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'gamma','sigma','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION FONCTION DE SURVIE UNIFORME

function varargout = GraphSurvieUniforme_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Fonction de survie Uniforme');
EDT = strvcat(char(handles.Workspace));
if isempty(EDT)
    [new,EspaceDeTravail] = NouvelEspace(handles);
else
    new = -1;
end
[Passe,NomFich] = PrepareParamGraph(handles,new,0);
if Passe == 1
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    handles.NbParam = 2;
    handles.Tache = 8;
    handles.Nomloi = 'Uniforme';
    handles.NomFichier = NomFich;
    if new == 1
        handles.Action = '';
        if handles.langue == 1
            set(handles.PopupAction,'String','Aucune action');
        else
            set(handles.PopupAction,'String','No action');
        end
        handles.Workspace = cellstr(EspaceDeTravail);
        set(handles.PopupTravail,'String',handles.Workspace);
    end
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
    else
        set(handles.TextParam6,'String','Nb of points');
    end
    if strcmp(NomFich,'*') == 1
        ValeursParDefaut(handles,handles.Nomloi,handles.Tache);
    end
    AfficheFrameParam(handles,'a','b','',2);
    CreeRepEDT(handles,new);
    guidata(handles.Extremes,handles);
else
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% PREPARATION A ESTIMATION DES PARAMETRES PAR MAXIMUM DE VRAISEMBLANCE

function varargout = EstimationMV_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Estimation des parametres');

% Reinitialisation de la frame estimation
ViderFrameEstimation(handles);

% Environnment graphique
set(handles.TextP1,'Visible','off');
set(handles.TextP2,'Visible','off');
set(handles.TextP3,'Visible','off');
set(handles.TextEstimP1,'Visible','off');
set(handles.TextEstimP2,'Visible','off');
set(handles.TextEstimP3,'Visible','off');
set(handles.TextP4,'Visible','off');
set(handles.TextP5,'Visible','off');
set(handles.TextP6,'Visible','off');
set(handles.TextEstimP4,'Visible','off');
set(handles.TextEstimP5,'Visible','off');
set(handles.TextEstimP6,'Visible','off');
set(handles.PopupEstim,'Value',1);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];

% Si donnees multiples
if exist(Fichier)~=0
    % Question e l'utilisateur
    if handles.langue == 1
        Reponse = questdlg('Estimer sur l''ensemble des jeux de donnees simules ?','Estimations des parametres','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('estimate on all simulated data files ?','Parameters estimate','Yes','No','Cancel','Yes');
    end
    switch(Reponse)
    % sur plusieurs jeux de donnees    
    case {'Oui','Yes'}
        
        % Invisibilites des frames
        FrameParamInvisible(handles);
        FrameTestETInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameEstimationVisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Affectation du numero de tache
        handles.Tache = 26;
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % 1 seul jeux de donnees    
    case {'Non','No'}
        FrameParamInvisible(handles);
        FrameTestETInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameEstimationVisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
    
        % Affectation du numero de tache
        handles.Tache = 7;
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % Annulation de la part de l'utilisateur    
    case {'Annuler','Cancel'}
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        return;
    end
    
% Si un seul jeu de donnees est present
else
    FrameParamInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameEstimationVisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Affectation du numero de tache
    handles.Tache = 7;
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
end
    
% --------------------------------------------------------------------
% PREPARATION A ESTIMATION PAR NOYAU

function varargout = EstimationNoyau_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Estimation de la densite');

% Preparation de la frame des parametres
[Passe,Nomfich] = PrepareParamGraph(handles,-1,0);

% si l'utilisateur n'a pas annule
if Passe == 1
    
    % Invisibilite des frames
    FrameResultatInvisible(handles);
    FrameResultatETInvisible(handles);
    FrameTestETInvisible(handles);
    FrameTestInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Affectation des variables
    handles.Tache = 6;      % numero de tache
    handles.NbParam = 0;    % nb de parametres
    handles.NomFichier = Nomfich;   % nom de fichier
    handles.Nomloi = '*';   % nom de loi
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
    % Affichage de la frame des parametres
    if handles.langue == 1
        set(handles.TextParam6,'String','Nb de points');
        AfficheFrameParam(handles,'','','Parametre de lissage',0);
    else
        set(handles.TextParam6,'String','Nb of points');
        AfficheFrameParam(handles,'','','Smoothing parameter',0);
    end
    
% si annulation
else
    % Aucune action en cours
    set(handles.TextEnCours,'String','');
end

% --------------------------------------------------------------------
% EXECUTION DE LA TACHE HISTOGRAMME

function varargout = GraphHistogramme_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Histogramme');

% Demande un nombre de classes
if handles.langue == 1
    answer = inputdlg('Nombre de classes :','Histogramme');
else
    answer = inputdlg('Number of bins :','Histogram');
end

% Verification du nombre de classes
X = str2num(char(answer));
if ~isempty(X)
    while X<=1 & ~isempty(X)
        if handles.langue == 1
            answer = inputdlg('Entrer un nombre de classes strictement superieur e 1','Histogramme');
        else
            answer = inputdlg('Enter a number of bins strictly superior than 1','Histogram');
        end
        X = str2num(char(answer));
    end
    % si le nombre de classe est correct
    if ~isempty(X)
        
        % Invisibilite des frames
        FrameResultatInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameTestETInvisible(handles);
        FrameTestInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Affectation du numero de tache
        handles.Tache = 5;
        
        % Pas de nom de loi
        handles.Nomloi = '*';
        
        % Remplissage de l'espace des actions
        EspaceAction = strvcat(char(handles.Action));
        Action = TacheToAction(handles);
        EspaceAction = strvcat(Action,EspaceAction);
        
        % Construit le fichier de donnees
        Rep = LitRepEDT(handles);
        FichierDonnees = [Rep '/' 'Donnees.txt'];
        
        % Construit le fichier resultat
        N = int2str(size(EspaceAction,1));
        FichierResultat = [Rep '/' 'Result' N '.txt'];
        
        % Parametres
        Param1 = '*';
        Param2 = '*';
        Param3 = '*';
        NbIterBI = '*';
        NbSimulBS = '*';
        NbPointsCL = char(answer);
        
        % Cree le fichier d'echange Tmp
        FichierEchange = [Rep '/' 'Tmp' N '.txt'];
        fid3 = fopen(FichierEchange,'w');
        Rep1 = [Rep '/'];
        fprintf(fid3,'%s\n',Rep1);
        fprintf(fid3,'%s\n',FichierDonnees);
        fprintf(fid3,'%s\n','5');
        fprintf(fid3,'%s\n',FichierResultat);
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n',Param1);
        fprintf(fid3,'%s\n',Param2);
        fprintf(fid3,'%s\n',Param3);
        fprintf(fid3,'%s\n',NbIterBI);
        fprintf(fid3,'%s\n',NbSimulBS);
        fprintf(fid3,'%s\n',NbPointsCL);
        fclose(fid3);
        
        % Lancement du prog C++
        [status result] = unix([handles.Prog ' ' FichierEchange ' 1']);
        
        % Recuperation des resultats
        
        % Lecture du fichier d'erreur
        FichierErreur = [Rep '/' 'Erreur.txt'];
        if exist(FichierErreur)~=0
            fid4 = fopen(FichierErreur,'r');
            Message = fgets(fid4);
            fclose(fid4);
            delete(FichierErreur);
            if handles.langue == 1
                errordlg(Message,'Erreur de saisie utilisateur','modal');
            else
                errordlg(Message,'User write Error','modal');
            end
            return;
        end
    
        % Actualisation de la liste des actions
        handles.Action = cellstr(EspaceAction);
        set(handles.PopupAction,'String',handles.Action);
        set(handles.PopupAction,'Value',1);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
        % Question utilisateur
        if handles.langue == 1
            GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
        else
            GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
        end
        switch (GardeGraph)
        case {'Oui','Yes'}
            hold on;
        case {'Non','No'}
            hold off;
        end
        
        % Lecture du fichier resultat
        [R]=textread(FichierResultat,'%s','delimiter','\n','whitespace','');
        
        % Definition du fichier de donnees
        FichierDonnees = [Rep '/' 'Donnees.txt'];
        
        % Lecture du fichier de donnees
        Rbis = load(FichierDonnees);
        
        % Remplissage de la frame Info
        set(handles.EditMoyTheo,'String',R(1));
        R2 = sprintf('%f',str2num(char(R(2))));
        set(handles.EditMoyCal,'String',R2);
        set(handles.EditVarTheo,'String',R(3));
        R4 = sprintf('%f',str2num(char(R(4))));
        set(handles.EditVarCal,'String',R4);
        R5 = sprintf('%f',str2num(char(R(5))));
        set(handles.EditQuartile1,'String',R5);
        R6 = sprintf('%f',str2num(char(R(6))));
        set(handles.EditQuartile3,'String',R6);
        R7 = sprintf('%f',str2num(char(R(7))));
        set(handles.EditMediane,'String',R7);
        
        % Histogramme normalise
        [N,X1] = hist(Rbis,X);
        Amp = X1(2)-X1(1);
        N = N/size(Rbis,1)/Amp;        
        bar(X1,N,'hist');
        colormap(handles.CouleurHisto);
        
        % Affichage de la frame Info
        FrameInfoVisible(handles);
        
        % Titre
        if handles.langue == 1
            title(['Histogramme - ' NbPointsCL ' classes'],'Color','r');
        else
            title(['Histogram - ' NbPointsCL ' bins'],'Color','r');
        end
        
        % Actualise le fichier des actions
        FichierAction = [Rep '/' 'Action.txt'];
        fid1 = fopen(FichierAction,'a');
        fprintf(fid1,'%s\n',Action);
        fclose(fid1);
        
        % Actualise le fichier des numeros de taches
        FichierTache = [Rep '/' 'Tache.txt'];
        fid2 = fopen(FichierTache,'a');
        fprintf(fid2,'%d\n',5);
        fclose(fid2);
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    else
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
else
    % Aucune action en cours
    set(handles.TextEnCours,'String','');
    
end

% --------------------------------------------------------------------
% PREPARATION AU TEST ANDERSON-DARLING

function varargout = TestAndersonDarling_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Test d''Anderson-Darling');

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];

% si donnees multiples
if exist(Fichier)~=0
    
    % question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Tester sur l''ensemble des jeux de donnees simules ?','Test Anderson-Darling','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Test on all simulated data files ?','Anderson-Darling test','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples    
    case {'Oui','Yes'}
        
        % Mise ne garde
        if handles.langue == 1
            warndlg('Le test ne peut s''executer qu''avec une seule loi !','Attention !','modal');
        else
            warndlg('This test can run with only one distribution !','Warning !','modal');
        end
        
        % Invisibilite des frames
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilites du bouton Lancer
        set(handles.BtLancerTest,'Enable','on');
        
        % Affichage du type de test
        set(handles.TextTest,'String','Anderson-Darling');
        
        % Initialisation des lois (e vide)
        CBDecocheLois(handles);
        
        % Numero de tache
        handles.Tache = 11;
        
        % affichage de la frame test
        FrameTestVisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % 1 seul jeux de donnees    
    case {'Non','No'}
        
        % Invisibilite des frames
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilite du bouton Lancer
        set(handles.BtLancerTest,'Enable','on');
        
        % type de test
        set(handles.TextTest,'String','Anderson-Darling');
        
        % Initialisation des lois
        CBDecocheLois(handles);
        
        % Numero de tache
        handles.Tache = 9;
        
        % Affichage de la frame test
        FrameTestVisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % Annulation
    case {'Annuler','Cancel'}
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
        return;
    end

% Donnees simples    
else
    
    % Invisibilite des frames
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameTestETInvisible(handles);
    FrameParamInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    
    % Accessibilite du bouton Lancer
    set(handles.BtLancerTest,'Enable','on');
    
    % Type de test
    set(handles.TextTest,'String','Anderson-Darling');
    
    % Initialisation des lois
    CBDecocheLois(handles);
    
    % Numero de tache
    handles.Tache = 9;
    
    % Affichage de la frame test
    FrameTestVisible(handles);
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
end

% --------------------------------------------------------------------
% PREPARATION AU TEST CRAMER-VON MISES

function varargout = TestCramerVonMises_Callback(h, eventdata, handles, varargin)
AfficheActionEnCours(handles,'Test de Cramer-Von Mises');
Rep = LitRepEDT(handles);
Fichier = [Rep '/Donnees2.txt'];
if exist(Fichier)~=0
    if handles.langue == 1
        Reponse = questdlg('Tester sur l''ensemble des jeux de donnees simules ?','Test Cramer-Von Mises','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Test on all simulated data files ?','Cramer-Von Mises test','Yes','No','Cancel','Yes');
    end
    switch(Reponse)
    case {'Oui','Yes'}
        if handles.langue == 1
            warndlg('Le test ne peut s''executer qu''avec une seule loi !','Attention !','modal');
        else
            warndlg('This test can run with only one distribution !','Warning !','modal');
        end
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerTest,'Enable','on');
        set(handles.TextTest,'String','Cramer-Von Mises');
        CBDecocheLois(handles);
        handles.Tache = 12;
        FrameTestVisible(handles);
        guidata(handles.Extremes,handles);
    case {'Non','No'}
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerTest,'Enable','on');
        set(handles.TextTest,'String','Cramer-Von Mises');
        CBDecocheLois(handles);
        handles.Tache = 10;
        FrameTestVisible(handles);
        guidata(handles.Extremes,handles);
    case {'Annuler','Cancel'}
        set(handles.TextEnCours,'String','');
        return;
    end    
else
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameTestETInvisible(handles);
    FrameParamInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
    set(handles.BtLancerTest,'Enable','on');
    set(handles.TextTest,'String','Cramer-Von Mises');
    CBDecocheLois(handles);
    handles.Tache = 10;
    FrameTestVisible(handles);
    guidata(handles.Extremes,handles);
end

% --------------------------------------------------------------------
% PREPARATION AU TEST D'EXPONENTIALITE DES EXCES

function varargout = TestExpo_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Test d''exponentialite des exces');

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% reinitialisation du nombre d'exces
set(handles.EditExces,'String','');

Fichier = [Rep '/Donnees2.txt'];

% si donnees multiples
if exist(Fichier)~=0
    
    % question utilisateurs
    if handles.langue == 1
        Reponse = questdlg('Tester sur l''ensemble des jeux de donnees simules ?','Test d''exponentialite des exces','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Test on all simulated data files ?','Exponentiality test of excesses','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % Donnees multiples    
    case {'Oui','Yes'}
        % Numero de tache
        handles.Tache = 14;
        
        % Invisibilite des frames
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameTestExpoVisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
    
    % 1 seul jeu de donnees
    case {'Non','No'}
        
        % Question utilisateur
        if handles.langue == 1
            Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
        else
            Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
        end
        
        switch(Answer)
        % 1 seul nombre d'exces    
        case {'1 seul nombre d''exces','Only one number'}
            % Invisibilite des frames
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameTestETInvisible(handles);
            FrameParamInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Numero de tache
            handles.Tache = 13;
            
            % Affichage de la frame test
            FrameTestExpoVisible(handles);
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        % plusieurs exces    
        case {'Plusieurs nombres d''exces','Several numbers of excesses'}
            
            % Numero de tache
            handles.Tache = 15;
            
            % Invisibilite des frames
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameParamInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameTestETInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameTestExpoVisible(handles);
            FrameQuantileParamInvisible(handles);
            set(handles.TextExces,'Visible','off');
            set(handles.EditExces,'Visible','off');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        end
        
    % Annulation 
    case {'Annuler','Cancel'}
        % Aucune acrtion en cours
        set(handles.TextEnCours,'String','');
        
    end
    
% si donnees simples
else
    
    % question utilisateur
    if handles.langue == 1
        Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
    else
        Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
    end
    
    switch(Answer)
    % 1 seul nombre d'exces    
    case {'1 seul nombre d''exces','Only one number'}
        
        % Invisibilite des frames
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Numero de tache
        handles.Tache = 13;
        
        % Affichage de la frame test
        FrameTestExpoVisible(handles);
        
        % sauvegarde des vaiables
        guidata(handles.Extremes,handles);
        
    % plusieurs exces
    case {'Plusieurs nombres d''exces','Several numbers of excesses'}
        
        % Numero de tache
        handles.Tache = 15;
        
        % Invisibilite des frames
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameTestETInvisible(handles);
        FrameParamInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameTestExpoVisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.TextExces,'Visible','off');
        set(handles.EditExces,'Visible','off');
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    end
end

% --------------------------------------------------------------------
% PREPARATION AU TEST ET

function varargout = TestET_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Test ET');

% Reinitialisation de la frame test
ViderFrameTestET(handles);

% Test ET
if handles.langue == 1
    set(handles.TextTestET,'String','Test ET');
    set(handles.TextResultatET,'String','Test ET');
else
    set(handles.TextTestET,'String','ET test');
    set(handles.TextResultatET,'String','ET test');
end

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];
% si donnees multiples
if exist(Fichier)~=0
    
    % Question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Tester sur l''ensemble des jeux de donnees simules ?','Test ET','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Test on all simulated data files ?','ET test','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples    
    case {'Oui','Yes'}
        
        % Numereon de tache
        handles.Tache = 16;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilite du bouton Lancer
        set(handles.BtLancerET,'Enable','on');
        
        % Environnement graphique
        if handles.langue == 1
            set(handles.TextExcesSup,'String','Nb d''exces');
        
            % Avertissement
            warndlg('Le test ne peut s''executer qu''avec une seule loi !','Attention !','modal');
        else
            set(handles.TextExcesSup,'String','Nb of excesses');
            warndlg('This test can run with only one distribution !','Warning !','modal');
        end
        
        % Affichage de la frame test
        FrameTestETVisible(handles,'ET');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % donnees simples
    case {'Non','No'}
        
        % Question utilisateur
        if handles.langue == 1
            Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
        else
            Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
        end
        
        switch(Answer)
        % 1 seul nombre d'exces    
        case {'1 seul nombre d''exces','Only one number'}
            
            % Numero de tache
            handles.Tache = 19;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Accessibilite du bouton Lancer
            set(handles.BtLancerET,'Enable','on');
            
            % Affichage de la frame test
            if handles.langue == 1
                set(handles.TextExcesSup,'String','Nb d''exces');
            else
                set(handles.TextExcesSup,'String','Nb of excesses');
            end
            set(handles.PopupVersionET,'Value',1);
            FrameTestETVisible(handles,'ET');
            set(handles.TextExcesSup,'Visible','on');
            set(handles.EditExcesSup,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        % Plusieurs exces    
        case {'Plusieurs nombres d''exces','Several numbers of excesses'}
            
            % Numero de tache
            handles.Tache = 22;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Bouton Lancer active
            set(handles.BtLancerET,'Enable','on');
            
            % affichage de la frame test
            if handles.langue == 1
                set(handles.TextExcesInf,'String','Borne Inf des exces');
                set(handles.TextExcesSup,'String','Borne Sup des exces');
            else
                set(handles.TextExcesInf,'String','Inf limit of excesses');
                set(handles.TextExcesSup,'String','Sup limit of excesses');
            end
            set(handles.PopupVersionET,'Value',1);
            FrameTestETVisible(handles,'ET');
            set(handles.TextExcesInf,'Visible','on');
            set(handles.EditExcesInf,'Visible','on');
            set(handles.TextExcesSup,'Visible','on');
            set(handles.EditExcesSup,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        end
        
    % Annulation
    case {'Annuler','Cancel'}
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
    
% donnees simples
else
    if handles.langue == 1
        Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
    else
        Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
    end
    switch(Answer)
    case {'1 seul nombre d''exces','Only one number'}
        FrameParamInvisible(handles);
        handles.Tache = 19;
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerET,'Enable','on');
        if handles.langue == 1
            set(handles.TextExcesSup,'String','Nb d''exces');
        else
            set(handles.TextExcesSup,'String','Nb of excesses');
        end
        set(handles.PopupVersionET,'Value',1);
        FrameTestETVisible(handles,'ET');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        guidata(handles.Extremes,handles);
    case {'Plusieurs nombres d''exces','Several numbers of excesses'}
        handles.Tache = 22;
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameResultatInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerET,'Enable','on');
        if handles.langue == 1
            set(handles.TextExcesInf,'String','Borne Inf des exces');
            set(handles.TextExcesSup,'String','Borne Sup des exces');
        else
            set(handles.TextExcesInf,'String','Inf limit of excesses');
            set(handles.TextExcesSup,'String','Sup limit of excesses');
        end
        set(handles.PopupVersionET,'Value',1);
        FrameTestETVisible(handles,'ET');
        set(handles.TextExcesInf,'Visible','on');
        set(handles.EditExcesInf,'Visible','on');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        guidata(handles.Extremes,handles);
    end
end

% --------------------------------------------------------------------
% PREPARATION REGULARISATION BAYESIENNE

function varargout = RegBay_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Regularisation bayesienne');

% Numero de tache
handles.Tache = 25;

% Invisibilite des frames
FrameParamInvisible(handles);
FrameTestInvisible(handles);
FrameResultatETInvisible(handles);
FrameResultatInvisible(handles);
FrameEstimationInvisible(handles);
FrameTestETInvisible(handles);
FrameRegBayInvisible(handles);
FrameResultatRegBayInvisible(handles);
FrameEstimGPDInvisible(handles);
FrameResultatEstimGPDInvisible(handles);
FrameQuantileParamInvisible(handles);

% Reinitialisation de la frame reg bay
ViderFrameRegBay(handles);

% Menu contextuel desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% Variable de defilement des fenetres de reg bay
handles.Suite = 0;

% Affichage de la frame reg bay
if handles.langue == 1
    set(handles.BtSuiteRB,'String','Suite >>');
else
    set(handles.BtSuiteRB,'String','Next >>');
end
set(handles.BtSuiteRB,'Enable','on');
FrameRegBayVisible(handles);

% Sauvegarde des variables
guidata(handles.Extremes,handles);

% --------------------------------------------------------------------
% PREPARATION A L'ESTIMATION DES PARAMETRES DE LA LOI GPD

function varargout = EstimGPD_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Estimation parametres GPD');

% Reinitialisation de la frame estimGPD
ViderFrameEstimGPD(handles);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];
% si donnees multiples
if exist(Fichier)~=0
    
    % Question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Estimer sur l''ensemble des jeux de donnees simules ?','Estimation des parametres de la loi GPD','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Estimate on all simulated data files ?','GPD parameters estimate','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples
    case {'Oui','Yes'}
        
        % Numereon de tache
        handles.Tache = 31;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles)
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilite du bouton Lancer
        set(handles.BtLancerEstimGPD,'Enable','on');
        
        % Environnement graphique
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Nb d''exces');
        
            % Avertissement
            warndlg('L''estimation n''est possible qu''avec une seule methode !','Attention !','modal');
        else
            set(handles.TextExcesInfGPD,'String','Nb of excesses');
            warndlg('estimate can run with only one method !','Warning !','modal');
        end
        
        % Affichage de la frame estimGPD
        FrameEstimGPDVisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % donnees simples
    case {'Non','No'}
        
        % Question utilisateur
        if handles.langue == 1
            Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
        else
            Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
        end
        
        switch(Answer)
        % 1 seul nombre d'exces    
        case {'1 seul nombre d''exces','Only one number'}
            
            % Numero de tache
            handles.Tache = 28;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameTestETInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Accessibilite du bouton Lancer
            set(handles.BtLancerEstimGPD,'Enable','on');
            
            % Affichage de la frame estimGPD
            if handles.langue == 1
                set(handles.TextExcesInfGPD,'String','Nb d''exces');
            else
                set(handles.TextExcesInfGPD,'String','Nb of excesses');
            end
            FrameEstimGPDVisible(handles);
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        % Plusieurs exces    
        case {'Plusieurs nombres d''exces','Several numbers of excesses'}
            
            % Numero de tache
            handles.Tache = 30;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameTestETInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Bouton Lancer active
            set(handles.BtLancerEstimGPD,'Enable','on');
            
            % affichage de la frame test
            if handles.langue == 1
                set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
                set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
            else
                set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
                set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
            end
            FrameEstimGPDVisible(handles);
            set(handles.TextExcesSupGPD,'Visible','on');
            set(handles.EditExcesSupGPD,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        end
    % Annulation
    case {'Annuler','Cancel'}
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
    
% donnees simples
else        
    if handles.langue == 1
        Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
    else
        Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
    end
    switch(Answer)
    case {'1 seul nombre d''exces','Only one number'}
        % Numero de tache
        handles.Tache = 28;
            
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
            
        % Accessibilite du bouton Lancer
        set(handles.BtLancerEstimGPD,'Enable','on');
           
        % Affichage de la frame estimGPD
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Nb d''exces');
        else
            set(handles.TextExcesInfGPD,'String','Nb of excesses');
        end
        FrameEstimGPDVisible(handles);
           
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
            
    % Plusieurs exces    
    case {'Plusieurs nombres d''exces','Several numbers of excesses'}
        
        % Numero de tache
        handles.Tache = 30;
            
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
          
        % Bouton Lancer active
        set(handles.BtLancerEstimGPD,'Enable','on');
            
        % affichage de la frame test
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
            set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
        else
            set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
            set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
        end
        FrameEstimGPDVisible(handles);
        set(handles.TextExcesSupGPD,'Visible','on');
        set(handles.EditExcesSupGPD,'Visible','on');
            
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    end
end


% --------------------------------------------------------------------
% PREPARATION AU CALCUL DU QUANTILE EXTREME

function varargout = QuantileExtreme_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Quantile extreme');

% Reinitialisation de la frame estimGPD
ViderFrameEstimGPD(handles);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];
% si donnees multiples
if exist(Fichier)~=0
    
    % Question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Estimer sur l''ensemble des jeux de donnees simules ?','Quantile extreme','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Estimate on all simulated data files ?','Extreme quantile','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples
    case {'Oui','Yes'}
        
        % Numereon de tache
        handles.Tache = 35;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles)
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilite du bouton Lancer
        set(handles.BtLancerEstimGPD,'Enable','on');
        
        % Environnement graphique
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Nb d''exces');
        
            % Avertissement
            warndlg('L''estimation n''est possible qu''avec une seule methode !','Attention !','modal');
        else
            set(handles.TextExcesInfGPD,'String','Nb of excesses');
            warndlg('estimate can run with only one method !','Warning !','modal');
        end
        
        % Affichage de la frame estimGPD
        FrameEstimGPDVisible(handles);
        set(handles.TextQuantileGPD,'Visible','on');
        set(handles.TextPGPD,'Visible','on');
        set(handles.EditPGPD,'Visible','on');
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % donnees simples
    case {'Non','No'}
        
        % Question utilisateur
        if handles.langue == 1
            Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
        else
            Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
        end
        
        switch(Answer)
        % 1 seul nombre d'exces    
        case {'1 seul nombre d''exces','Only one number'}
            
            % Numero de tache
            handles.Tache = 32;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameTestETInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Accessibilite du bouton Lancer
            set(handles.BtLancerEstimGPD,'Enable','on');
            
            % Affichage de la frame estimGPD
            if handles.langue == 1
                set(handles.TextExcesInfGPD,'String','Nb d''exces');
            else
                set(handles.TextExcesInfGPD,'String','Nb of excesses');
            end
            FrameEstimGPDVisible(handles);
            set(handles.TextQuantileGPD,'Visible','on');
            set(handles.TextPGPD,'Visible','on');
            set(handles.EditPGPD,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        % Plusieurs exces    
        case {'Plusieurs nombres d''exces','Several numbers of excesses'}
            
            % Numero de tache
            handles.Tache = 34;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameTestETInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Bouton Lancer active
            set(handles.BtLancerEstimGPD,'Enable','on');
            
            % affichage de la frame test
            if handles.langue == 1
                set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
                set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
            else
                set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
                set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
            end
            FrameEstimGPDVisible(handles);
            set(handles.TextExcesSupGPD,'Visible','on');
            set(handles.EditExcesSupGPD,'Visible','on');
            set(handles.TextQuantileGPD,'Visible','on');
            set(handles.TextPGPD,'Visible','on');
            set(handles.EditPGPD,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        end
    % Annulation
    case {'Annuler','Cancel'}
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
    
% donnees simples
else        
    if handles.langue == 1
        Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
    else
        Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
    end
    
    switch(Answer)
    case {'1 seul nombre d''exces','Only one number'}
        % Numero de tache
        handles.Tache = 32;
            
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
            
        % Accessibilite du bouton Lancer
        set(handles.BtLancerEstimGPD,'Enable','on');
           
        % Affichage de la frame estimGPD
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Nb d''exces');
        else
            set(handles.TextExcesInfGPD,'String','Nb of excesses');
        end
        FrameEstimGPDVisible(handles);
        set(handles.TextQuantileGPD,'Visible','on');
        set(handles.TextPGPD,'Visible','on');
        set(handles.EditPGPD,'Visible','on');
           
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
            
    % Plusieurs exces    
    case {'Plusieurs nombres d''exces','Several numbers of excesses'}
        
        % Numero de tache
        handles.Tache = 34;
            
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
          
        % Bouton Lancer active
        set(handles.BtLancerEstimGPD,'Enable','on');
            
        % affichage de la frame test
        if handles.langue == 1
            set(handles.TextExcesInfGPD,'String','Borne Inf des exces');
            set(handles.TextExcesSupGPD,'String','Borne Sup des exces');
        else
            set(handles.TextExcesInfGPD,'String','Inf limit of excesses');
            set(handles.TextExcesSupGPD,'String','Sup limit of excesses');
        end
        FrameEstimGPDVisible(handles);
        set(handles.TextExcesSupGPD,'Visible','on');
        set(handles.EditExcesSupGPD,'Visible','on');
        set(handles.TextQuantileGPD,'Visible','on');
        set(handles.TextPGPD,'Visible','on');
        set(handles.EditPGPD,'Visible','on');
            
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    end
end

% --------------------------------------------------------------------
% PREPARATION AU CALCUL D'UN QUANTILE PARAMETRIQUE

function varargout = QuantileParam_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Quantile parametrique');

% Reinitialisation de la frame quantile parametrique
set(handles.EditOrdreQuantileParam,'String','');
CBDecocheLois(handles);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];
% si donnees multiples
if exist(Fichier)~=0
    
    % Question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Calculer sur l''ensemble des jeux de donnees simules ?','Quantile parametrique','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Compute on all simulated data files ?','Parametric quantile','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples
    case {'Oui','Yes'}
        
        % Numereon de tache
        handles.Tache = 37;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles)
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Avertissement
        if handles.langue == 1
            warndlg('Le calcul du quantile n''est possible qu''avec une seule Loi !','Attention !','modal');
        else
            warndlg('Quantile computing can run with only one distribution !','Warning !','modal');
        end
        
        % bouton lancer active
        set(handles.BtLancerQuantileParam,'Enable','on');
        
        % Affichage de la frame des quantiles parametriques
        FrameQuantileParamVisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    case {'Non','No'}
        
        % Numereon de tache
        handles.Tache = 36;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameTestETInvisible(handles)
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % bouton lancer active
        set(handles.BtLancerQuantileParam,'Enable','on');
        
        % Affichage de la frame des quantiles parametriques
        FrameQuantileParamVisible(handles);
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    case {'Annuler','Cancel'}
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
else
    
    % Numereon de tache
    handles.Tache = 36;
        
    % Invisibilite des frames
    FrameParamInvisible(handles);
    FrameTestInvisible(handles);
    FrameTestETInvisible(handles)
    FrameResultatETInvisible(handles);
    FrameResultatInvisible(handles);
    FrameEstimationInvisible(handles);
    FrameRegBayInvisible(handles);
    FrameResultatRegBayInvisible(handles);
    FrameEstimGPDInvisible(handles);
    FrameResultatEstimGPDInvisible(handles);
    FrameQuantileParamInvisible(handles);
        
    % bouton lancer active
    set(handles.BtLancerQuantileParam,'Enable','on');
    
    % Affichage de la frame des quantiles parametriques
    FrameQuantileParamVisible(handles);
        
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
end

% --------------------------------------------------------------------
% PREPARATION AU TEST GPD

function varargout = TestGPD_Callback(h, eventdata, handles, varargin)

% Action en cours
AfficheActionEnCours(handles,'Quantile parametrique');

% Reinitialisation de la frame test
ViderFrameTestET(handles);

% Test GPD
if handles.langue == 1
    set(handles.TextTestET,'String','Test GPD');
    set(handles.TextResultatET,'String','Test GPD');
else
    set(handles.TextTestET,'String','GPD test');
    set(handles.TextResultatET,'String','GPD test');
end

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

Fichier = [Rep '/Donnees2.txt'];
% si donnees multiples
if exist(Fichier)~=0
    
    % Question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Tester sur l''ensemble des jeux de donnees simules ?','Test GPD','Oui','Non','Annuler','Oui');
    else
        Reponse = questdlg('Test on all simulated data files ?','GPD test','Yes','No','Cancel','Yes');
    end
    
    switch(Reponse)
    % donnees multiples    
    case {'Oui','Yes'}
        
        % Numereon de tache
        handles.Tache = 38;
        
        % Invisibilite des frames
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        
        % Accessibilite du bouton Lancer
        set(handles.BtLancerET,'Enable','on');
        
        % Environnement graphique
        if handles.langue == 1
            set(handles.TextExcesSup,'String','Nb d''exces');
        
            % Avertissement
            warndlg('Le test ne peut s''executer qu''avec une seule loi !','Attention !','modal');
        else
            set(handles.TextExcesSup,'String','Nb of excesses');
            warndlg('This test can run with only one distribution !','Warning !','modal');
        end
        
        % Affichage de la frame test
        FrameTestETVisible(handles,'GPD');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        
        % Sauvegarde des variables
        guidata(handles.Extremes,handles);
        
    % donnees simples
    case {'Non','No'}
        
        % Question utilisateur
        if handles.langue == 1
            Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
        else
            Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
        end
        
        switch(Answer)
        % 1 seul nombre d'exces    
        case {'1 seul nombre d''exces','Only one number'}
            
            % Numero de tache
            handles.Tache = 41;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Accessibilite du bouton Lancer
            set(handles.BtLancerET,'Enable','on');
            
            % Affichage de la frame test
           if handles.langue == 1
                set(handles.TextExcesSup,'String','Nb d''exces');
            else
                set(handles.TextExcesSup,'String','Nb of excesses');
            end
            set(handles.PopupVersionET,'Value',1);
            FrameTestETVisible(handles,'GPD');
            set(handles.TextExcesSup,'Visible','on');
            set(handles.EditExcesSup,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        % Plusieurs exces    
        case {'Plusieurs nombres d''exces','Several numbers of excesses'}
            
            % Numero de tache
            handles.Tache = 44;
            
            % Invisibilite des frames
            FrameParamInvisible(handles);
            FrameTestInvisible(handles);
            FrameResultatETInvisible(handles);
            FrameResultatInvisible(handles);
            FrameEstimationInvisible(handles);
            FrameRegBayInvisible(handles);
            FrameResultatRegBayInvisible(handles);
            FrameEstimGPDInvisible(handles);
            FrameResultatEstimGPDInvisible(handles);
            FrameQuantileParamInvisible(handles);
            
            % Bouton Lancer active
            set(handles.BtLancerET,'Enable','on');
            
            % affichage de la frame test
            if handles.langue == 1
                set(handles.TextExcesInf,'String','Borne Inf des exces');
                set(handles.TextExcesSup,'String','Borne Sup des exces');
            else
                set(handles.TextExcesInf,'String','Inf limit of excesses');
                set(handles.TextExcesSup,'String','Sup limit of excesses');
            end
            set(handles.PopupVersionET,'Value',1);
            FrameTestETVisible(handles,'GPD');
            set(handles.TextExcesInf,'Visible','on');
            set(handles.EditExcesInf,'Visible','on');
            set(handles.TextExcesSup,'Visible','on');
            set(handles.EditExcesSup,'Visible','on');
            
            % Sauvegarde des variables
            guidata(handles.Extremes,handles);
            
        end
        
    % Annulation
    case {'Annuler','Cancel'}
        
        % Aucune action en cours
        set(handles.TextEnCours,'String','');
        
    end
    
% donnees simples
else
    if handles.langue == 1
        Answer = questdlg('Nombre d''exces :','Choix du nombre d''exces','1 seul nombre d''exces','Plusieurs nombres d''exces','1 seul nombre d''exces');
    else
        Answer = questdlg('Number of excesses :','Choice of number of excesses','Only one number','Several numbers of excesses','Only one number');
    end
    switch(Answer)
    case {'1 seul nombre d''exces','Only one number'}
        FrameParamInvisible(handles);
        handles.Tache = 41;
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameResultatInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerET,'Enable','on');
        if handles.langue == 1
            set(handles.TextExcesSup,'String','Nb d''exces');
        else
            set(handles.TextExcesSup,'String','Nb of excesses');
        end
        set(handles.PopupVersionET,'Value',1);
        FrameTestETVisible(handles,'GPD');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        guidata(handles.Extremes,handles);
    case {'Plusieurs nombres d''exces','Several numbers of excesses'}
        handles.Tache = 44;
        FrameParamInvisible(handles);
        FrameTestInvisible(handles);
        FrameResultatETInvisible(handles);
        FrameEstimationInvisible(handles);
        FrameResultatInvisible(handles);
        FrameRegBayInvisible(handles);
        FrameResultatRegBayInvisible(handles);
        FrameEstimGPDInvisible(handles);
        FrameResultatEstimGPDInvisible(handles);
        FrameQuantileParamInvisible(handles);
        set(handles.BtLancerET,'Enable','on');
        if handles.langue == 1
            set(handles.TextExcesInf,'String','Borne Inf des exces');
            set(handles.TextExcesSup,'String','Borne Sup des exces');
        else
            set(handles.TextExcesInf,'String','Inf limit of excesses');
            set(handles.TextExcesSup,'String','Sup limit of excesses');
        end
        set(handles.PopupVersionET,'Value',1);
        FrameTestETVisible(handles,'GPD');
        set(handles.TextExcesInf,'Visible','on');
        set(handles.EditExcesInf,'Visible','on');
        set(handles.TextExcesSup,'Visible','on');
        set(handles.EditExcesSup,'Visible','on');
        guidata(handles.Extremes,handles);
    end
end

% --------------------------------------------------------------------
% NOMS ET NOMBRE DES PARAMETRES D'UNE LOI DONNEE

% Nomloi = nom de la loi
% param1 = nom du 1er parametre
% param2 = nom du 2eme parametre
% param3 = nom du 3eme parametre
% NbParam = nombre de parametres

function [param1,param2,param3,NbParam] = NomDesParametres(handles,Nomloi)

% Initialisation des noms et du nombre
param1 = '';
param2 = '';
param3 = '';
NbParam = 0;

% Affectation suivant la loi
switch(Nomloi)
case {'Normale','Normal'}
    param1 = 'm';
    param2 = 'sigma';
    NbParam = 2;
case {'Lognormale','Lognormal'}
    param1 = 'm';
    param2 = 'sigma';
    NbParam = 2;
case 'Chi2'
    param1 = 'n';
    NbParam = 1;
case 'Student'
    param1 = 'n';
    NbParam = 1;
case 'Beta1espece'
    param1 = 'a';
    param2 = 'b';
    NbParam = 2;
case 'Beta'
    param1 = 'a';
    param2 = 'b';
    NbParam = 2;
case 'Gamma'
    param1 = 'a';
    param2 = 'teta';
    NbParam = 2;
case {'Exponentielle','Exponential'}
    param1 = 'alpha';
    NbParam = 1;
case 'Weibull'
    param1 = 'eta';
    param2 = 'beta';
    NbParam = 2;
case 'Pareto'
    param1 = 'x0';
    param2 = 'alpha';
    NbParam = 2;
case 'GPD'
    param1 = 'gamma';
    param2 = 'sigma';
    NbParam = 2;
case {'Uniforme','Uniform'}
    param1 = 'a';
    param2 = 'b';
    NbParam = 2;
case 'UniformeContinue'
    param1 = 'a';
    param2 = 'b';
    NbParam = 2;
case 'StudentApprochee'
    param1 = 'm';
    param2 = 'stap1';
    param3 = 'stap2';
    NbParam = 3;
case 'StudentApprocheeTrans'
    param1 = 'm';
    param2 = 'stapt1';
    param3 = 'stapt2';
    NbParam = 3;
case 'GPDTrans'
    param1 = 'gpdt1';
    param2 = 'gpdt2';
    param3 = 'gpdt3';
    NbParam = 3;
case 'Beta2Prop'
    param1 = 'betap1';
    param2 = 'betap2';
    param3 = 'betap3';
    NbParam = 3;
case 'WeibPred'
    param1 = 'wpf1';
    param2 = 'wpf2';
    param3 = 'wpf3';
    NbParam = 3;
    
% cas de l'estimation par noyau
otherwise
    param1 = '';
    param2 = '';
    if handles.langue == 1
        param3 = 'Parametre de lissage';
    else
        param3 = 'Smoothing parameter';
    end
    NbParam = 0;
end

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES PARAMETRES

% param1 = nom du 1er parametre
% param2 = nom du 2eme parametre
% param3 = nom du 3eme parametre
% TotalParam = nombre de parametres

function AfficheFrameParam(handles,param1,param2,param3,TotalParam)

% si les noms existent
if TotalParam~=0
   set(handles.Radio1,'Visible','off');
   set(handles.Radio2,'Visible','off');
   set(handles.FrameParam,'Visible','on');
   set(handles.TextParam,'Visible','on');
   set(handles.BtLancer,'Visible','on');
   set(handles.TextParam4,'Visible','on');
   set(handles.TextParam5,'Visible','on');
   set(handles.EditParam4,'Visible','on');
   set(handles.EditParam5,'Visible','on');
   set(handles.TextParam6,'Visible','on');
   set(handles.EditParam6,'Visible','on');  
   if TotalParam==1
      set(handles.TextParam1,'String',param1);
      set(handles.TextParam1,'Visible','on');
      set(handles.TextParam2,'Visible','off');
      set(handles.EditParam1,'Visible','on');
      set(handles.EditParam2,'Visible','off');
      set(handles.TextParam3,'Visible','off');
      set(handles.EditParam3,'Visible','off');
   end
   if TotalParam==2
      set(handles.TextParam1,'String',param1);
      set(handles.TextParam2,'String',param2);
      set(handles.TextParam1,'Visible','on');
      set(handles.TextParam2,'Visible','on');
      set(handles.EditParam1,'Visible','on');
      set(handles.EditParam2,'Visible','on');
      set(handles.TextParam3,'Visible','off');
      set(handles.EditParam3,'Visible','off');
   end
   if TotalParam==3
      set(handles.TextParam1,'String',param1);
      set(handles.TextParam2,'String',param2);
      set(handles.TextParam3,'String',param3);
      set(handles.TextParam1,'Visible','on');
      set(handles.TextParam2,'Visible','on');
      set(handles.TextParam3,'Visible','on');      
      set(handles.EditParam1,'Visible','on');
      set(handles.EditParam2,'Visible','on');
      set(handles.EditParam3,'Visible','on');
   end
   
% cas de l'estimation par noyau
else
   set(handles.FrameParam,'Visible','on');
   set(handles.TextParam,'Visible','on');
   set(handles.BtLancer,'Visible','on');
   set(handles.TextParam4,'Visible','on');
   set(handles.TextParam5,'Visible','on');
   set(handles.EditParam4,'Visible','on');
   set(handles.EditParam5,'Visible','on');
   set(handles.TextParam6,'Visible','on');
   set(handles.EditParam6,'Visible','on');
   set(handles.TextParam3,'String',param3);
   set(handles.TextParam3,'Visible','on');
   set(handles.EditParam3,'Visible','on');
   set(handles.TextParam1,'Visible','off');
   set(handles.TextParam2,'Visible','off');
   set(handles.EditParam1,'Visible','off');
   set(handles.EditParam2,'Visible','off');
   set(handles.Radio1,'Value',1);
   set(handles.Radio2,'Value',0);
   set(handles.Radio1,'Visible','on');
   set(handles.Radio2,'Visible','on');
end

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES PARAMETRES

function FrameParamInvisible(handles)
set(handles.FrameParam,'Visible','off');
set(handles.TextParam,'Visible','off');
set(handles.BtLancer,'Visible','off');
set(handles.TextParam4,'Visible','off');
set(handles.TextParam5,'Visible','off');
set(handles.TextParam6,'Visible','off');
set(handles.EditParam4,'Visible','off');
set(handles.EditParam5,'Visible','off');
set(handles.EditParam6,'Visible','off');
set(handles.TextParam1,'Visible','off');
set(handles.TextParam2,'Visible','off');
set(handles.TextParam3,'Visible','off');
set(handles.EditParam1,'Visible','off');
set(handles.EditParam2,'Visible','off');
set(handles.EditParam3,'Visible','off');
set(handles.Radio1,'Visible','off');
set(handles.Radio2,'Visible','off');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES ESPACES DE TRAVAIL

function FrameTravailInvisible(handles)
set(handles.FrameAction,'Visible','off');
set(handles.PopupTravail,'Visible','off');
set(handles.PopupAction,'Visible','off');
set(handles.TextTravail,'Visible','off');
set(handles.TextAction,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES ESPACES DE TRAVAIL

function FrameTravailVisible(handles)
set(handles.FrameAction,'Visible','on');
set(handles.PopupTravail,'Visible','on');
set(handles.PopupAction,'Visible','on');
set(handles.TextTravail,'Visible','on');
set(handles.TextAction,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME OUVRIR

function FrameOuvrirInvisible(handles)
set(handles.FrameOuvrir,'Visible','off');
set(handles.TextOuvrir,'Visible','off');
set(handles.EditDir,'Visible','off');
set(handles.ListFichiers,'Visible','off');
set(handles.BtAnnulerOuvrir,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME OUVRIR

function FrameOuvrirVisible(handles)
set(handles.FrameOuvrir,'Visible','on');
set(handles.TextOuvrir,'Visible','on');
set(handles.EditDir,'Visible','on');
set(handles.ListFichiers,'Visible','on');
set(handles.BtAnnulerOuvrir,'Visible','on');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME INFO

function FrameInfoVisible(handles)
set(handles.FrameInfo,'Visible','on');
set(handles.TextInfo,'Visible','on');
set(handles.TextMoyTheo,'Visible','on');
set(handles.EditMoyTheo,'Visible','on');
set(handles.TextVarTheo,'Visible','on');
set(handles.EditVarTheo,'Visible','on');
set(handles.TextMoyCal,'Visible','on');
set(handles.EditMoyCal,'Visible','on');
set(handles.TextVarCal,'Visible','on');
set(handles.EditVarCal,'Visible','on');
set(handles.TextQuartile1,'Visible','on');
set(handles.EditQuartile1,'Visible','on');
set(handles.TextMediane,'Visible','on');
set(handles.EditMediane,'Visible','on');
set(handles.TextQuartile3,'Visible','on');
set(handles.EditQuartile3,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME INFO

function FrameInfoInvisible(handles)
set(handles.FrameInfo,'Visible','off');
set(handles.TextInfo,'Visible','off');
set(handles.TextMoyTheo,'Visible','off');
set(handles.EditMoyTheo,'Visible','off');
set(handles.TextVarTheo,'Visible','off');
set(handles.EditVarTheo,'Visible','off');
set(handles.TextMoyCal,'Visible','off');
set(handles.EditMoyCal,'Visible','off');
set(handles.TextVarCal,'Visible','off');
set(handles.EditVarCal,'Visible','off');
set(handles.TextQuartile1,'Visible','off');
set(handles.EditQuartile1,'Visible','off');
set(handles.TextMediane,'Visible','off');
set(handles.EditMediane,'Visible','off');
set(handles.TextQuartile3,'Visible','off');
set(handles.EditQuartile3,'Visible','off');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME ESTIMATION

function FrameEstimationInvisible(handles)
set(handles.FrameEstimation,'Visible','off');
set(handles.TextEstimation,'Visible','off');
set(handles.TextLoi,'Visible','off');
set(handles.TextP1,'Visible','off');
set(handles.TextP2,'Visible','off');
set(handles.TextP3,'Visible','off');
set(handles.TextP4,'Visible','off');
set(handles.TextP5,'Visible','off');
set(handles.TextP6,'Visible','off');
set(handles.PopupEstim,'Visible','off');
set(handles.TextEstimP1,'Visible','off');
set(handles.TextEstimP2,'Visible','off');
set(handles.TextEstimP3,'Visible','off');
set(handles.TextEstimP4,'Visible','off');
set(handles.TextEstimP5,'Visible','off');
set(handles.TextEstimP6,'Visible','off');
set(handles.BtLanceEstim,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME ESTIMATION

function FrameEstimationVisible(handles)
set(handles.FrameEstimation,'Visible','on');
set(handles.TextEstimation,'Visible','on');
set(handles.TextLoi,'Visible','on');
set(handles.PopupEstim,'Visible','on');
set(handles.BtLanceEstim,'Visible','on');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME TEST

function FrameTestVisible(handles)
set(handles.FrameTest,'Visible','on');
set(handles.TextTest,'Visible','on');
set(handles.TextChoixLoi,'Visible','on');
set(handles.BtChoixLoisTests,'Visible','on');
set(handles.BtChoixLoisTests,'Enable','on');
set(handles.TextNiveau,'Visible','on');
set(handles.PopupNiveau,'Visible','on');
set(handles.BtLancerTest,'Visible','on');
set(handles.TextExces,'Visible','off');
set(handles.EditExces,'Visible','off');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME TEST

function FrameTestInvisible(handles)
set(handles.FrameTest,'Visible','off');
set(handles.TextTest,'Visible','off');
set(handles.TextChoixLoi,'Visible','off');
set(handles.BtChoixLoisTests,'Visible','off');
set(handles.TextNiveau,'Visible','off');
set(handles.PopupNiveau,'Visible','off');
set(handles.BtLancerTest,'Visible','off');
set(handles.TextExces,'Visible','off');
set(handles.EditExces,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DE TEST D'EXPONENTIALITE

function FrameTestExpoVisible(handles)
set(handles.BtLancerTest,'Enable','on');
set(handles.TextTest,'String','Anderson-Darling');
CBDecocheLois(handles);
set(handles.FrameTest,'Visible','on');
set(handles.TextTest,'Visible','on');
set(handles.TextChoixLoi,'Visible','on');
set(handles.BtChoixLoisTests,'Visible','on');
set(handles.BtChoixLoisTests,'Enable','off');
set(handles.CBCLExpo,'Value',1);
set(handles.TextNiveau,'Visible','on');
set(handles.PopupNiveau,'Visible','on');
set(handles.BtLancerTest,'Visible','on');
set(handles.TextExces,'Visible','on');
set(handles.EditExces,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DE RESULTAT DES TESTS CENTRAUX

function FrameResultatInvisible(handles)
set(handles.FrameResultat,'Visible','off');
set(handles.TextResultat,'Visible','off');
set(handles.TextResultatLoi,'Visible','off');
set(handles.TextResultatP1,'Visible','off');
set(handles.TextResultatP2,'Visible','off');
set(handles.TextResultatP3,'Visible','off');
set(handles.TextDecision,'Visible','off');
set(handles.TextStat,'Visible','off');
set(handles.TextRejet,'Visible','off');
set(handles.PopupResultat,'Visible','off');
set(handles.TextResultatValeurP1,'Visible','off');
set(handles.TextResultatValeurP2,'Visible','off');
set(handles.TextResultatValeurP3,'Visible','off');
set(handles.TextResultatDecision,'Visible','off');
set(handles.TextResultatStat,'Visible','off');
set(handles.TextResultatRejet,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES RESULTATS DES TESTS CENTRAUX

function FrameResultatVisible(handles)
set(handles.FrameResultat,'Visible','on');
set(handles.TextResultat,'Visible','on');
set(handles.TextResultatLoi,'Visible','on');
set(handles.TextResultatP1,'Visible','on');
set(handles.TextResultatP2,'Visible','on');
set(handles.TextResultatP3,'Visible','on');
set(handles.TextDecision,'Visible','on');
set(handles.TextStat,'Visible','on');
set(handles.TextRejet,'Visible','on');
set(handles.PopupResultat,'Visible','on');
set(handles.TextResultatValeurP1,'Visible','on');
set(handles.TextResultatValeurP2,'Visible','on');
set(handles.TextResultatValeurP3,'Visible','on');
set(handles.TextResultatDecision,'Visible','on');
set(handles.TextResultatStat,'Visible','on');
set(handles.TextResultatRejet,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DU TEST ET / GPD

function FrameTestETInvisible(handles);
set(handles.FrameTestET,'Visible','off');
set(handles.TextTestET,'Visible','off');
set(handles.TextLoiET,'Visible','off');
set(handles.TextVersionET,'Visible','off');
set(handles.PopupVersionET,'Visible','off');
set(handles.TextNiveauET,'Visible','off');
set(handles.PopupNiveauET,'Visible','off');
set(handles.TextExcesInf,'Visible','off');
set(handles.EditExcesInf,'Visible','off');
set(handles.TextExcesSup,'Visible','off');
set(handles.EditExcesSup,'Visible','off');
set(handles.TextBootstrapET,'Visible','off');
set(handles.EditBootstrapET,'Visible','off');
set(handles.TextQuantileET,'Visible','off');
set(handles.TextPET,'Visible','off');
set(handles.EditPET,'Visible','off');
set(handles.BtLancerET,'Visible','off');
set(handles.BtSelectLoisGPD,'Visible','off');
set(handles.BtSelectMethode,'Visible','off');
set(handles.TextMethodesGPD,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DU TEST ET

function FrameTestETVisible(handles,Version);
set(handles.FrameTestET,'Visible','on');
set(handles.TextTestET,'Visible','on');
set(handles.TextLoiET,'Visible','on');
set(handles.BtSelectLoisGPD,'Visible','on');
switch(Version)
case 'ET'
    set(handles.BtSelectMethode,'Visible','off');
    set(handles.TextMethodesGPD,'Visible','off');
case 'GPD'
    set(handles.BtSelectMethode,'Visible','on');
    set(handles.TextMethodesGPD,'Visible','on');
end    
set(handles.TextVersionET,'Visible','on');
set(handles.PopupVersionET,'Visible','on');
set(handles.TextNiveauET,'Visible','on');
set(handles.PopupNiveauET,'Visible','on');
set(handles.TextExcesInf,'Visible','off');
set(handles.EditExcesInf,'Visible','off');
set(handles.TextExcesSup,'Visible','off');
set(handles.EditExcesSup,'Visible','off');
set(handles.TextBootstrapET,'Visible','off');
set(handles.EditBootstrapET,'Visible','off');
set(handles.TextQuantileET,'Visible','on');
set(handles.TextPET,'Visible','on');
set(handles.EditPET,'Visible','on');
set(handles.BtLancerET,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES RESULTATS DU TEST ET

function FrameResultatETInvisible(handles)
set(handles.FrameResultatET,'Visible','off');
set(handles.TextResultatET,'Visible','off');
set(handles.TextLoiResultatET,'Visible','off');
set(handles.PopupResultatET,'Visible','off');
set(handles.TextQET,'Visible','off');
set(handles.TextResultatQET,'Visible','off');
set(handles.TextQParam,'Visible','off');
set(handles.TextResultatQParam,'Visible','off');
set(handles.TextStatET,'Visible','off');
set(handles.TextResultatStatET,'Visible','off');
set(handles.TextIntervalle,'Visible','off');
set(handles.TextResultatIntervalle,'Visible','off');
set(handles.TextDecisionET,'Visible','off');
set(handles.TextResultatDecisionET,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES RESULTATS DU TEST ET

function FrameResultatETVisible(handles,Version)
switch(Version)
case 'ET'
    if handles.langue == 1
        set(handles.TextQET,'String','quantile ET estime');
    else
        set(handles.TextQET,'String','Estimated ET quantile');
    end
    set(handles.TextStatET,'String','qET - qParam');
case 'GPD'
    if handles.langue == 1
        set(handles.TextQET,'String','quantile GPD estime');
    else
        set(handles.TextQET,'String','Estimated GPD quantile');
    end
    set(handles.TextStatET,'String','qGPD - qParam');
end    
set(handles.FrameResultatET,'Visible','on');
set(handles.TextResultatET,'Visible','on');
set(handles.TextLoiResultatET,'Visible','on');
set(handles.PopupResultatET,'Visible','on');
set(handles.TextQET,'Visible','on');
set(handles.TextResultatQET,'Visible','on');
set(handles.TextQParam,'Visible','on');
set(handles.TextResultatQParam,'Visible','on');
set(handles.TextStatET,'Visible','on');
set(handles.TextResultatStatET,'Visible','on');
set(handles.TextIntervalle,'Visible','on');
set(handles.TextResultatIntervalle,'Visible','on');
set(handles.TextDecisionET,'Visible','on');
set(handles.TextResultatDecisionET,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DE REGULARISATION BAYESIENNE

function FrameRegBayInvisible(handles)
set(handles.FrameRegBay,'Visible','off');
set(handles.TextRegBay,'Visible','off');
set(handles.BtSuiteRB,'Visible','off');
set(handles.BtRetourRB,'Visible','off');
set(handles.TextModeleRB,'Visible','off');
set(handles.PopupModeleRB,'Visible','off');
set(handles.TextBetaRB,'Visible','off');
set(handles.TextBinfRB,'Visible','off');
set(handles.TextBsupRB,'Visible','off');
set(handles.EditBinfRB,'Visible','off');
set(handles.EditBsupRB,'Visible','off');
set(handles.TextDonneesSimulees,'Visible','off');
set(handles.RBOui,'Visible','off');
set(handles.RBNon,'Visible','off');
set(handles.TextVraieLoiRB,'Visible','off');
set(handles.PopupVraieLoiRB,'Visible','off');
set(handles.TextParam1RB,'Visible','off');
set(handles.TextParam2RB,'Visible','off');
set(handles.TextParam3RB,'Visible','off');
set(handles.EditParam1RB,'Visible','off');
set(handles.EditParam2RB,'Visible','off');
set(handles.EditParam3RB,'Visible','off');
set(handles.TextAvisExpert,'Visible','off');
set(handles.RBExpertNon,'Visible','off');
set(handles.RBExpertOui,'Visible','off');
set(handles.TextQmax,'Visible','off');
set(handles.EditQmax,'Visible','off');
set(handles.TextOrdrep1,'Visible','off');
set(handles.EditOrdrep1,'Visible','off');
set(handles.TextOrdrep2,'Visible','off');
set(handles.EditOrdrep2,'Visible','off');
set(handles.TextConfiance,'Visible','off');
set(handles.EditConfiance,'Visible','off');
set(handles.TextConfianceWeibull,'Visible','off');
set(handles.PopupConfianceWeibull,'Visible','off');
set(handles.TextTypeTest,'Visible','off');
set(handles.PopupTypeTest,'Visible','off');
set(handles.TextNiveauCentraux,'Visible','off');
set(handles.PopupNiveauCentraux,'Visible','off');
set(handles.TextNiveauETRB,'Visible','off');
set(handles.PopupNiveauETRB,'Visible','off');
set(handles.TextExcesRB,'Visible','off');
set(handles.EditExcesRB,'Visible','off');
set(handles.TextPETRB,'Visible','off');
set(handles.EditPETRB,'Visible','off');
set(handles.TextQuantilesRB,'Visible','off');
set(handles.TextQuantileP1,'Visible','off');
set(handles.EditQuantileP1,'Visible','off');
set(handles.TextQuantileP2,'Visible','off');
set(handles.EditQuantileP2,'Visible','off');
set(handles.TextQuantileP3,'Visible','off');
set(handles.EditQuantileP3,'Visible','off');
set(handles.TextQuantileP4,'Visible','off');
set(handles.EditQuantileP4,'Visible','off');
set(handles.TextQuantileP5,'Visible','off');
set(handles.EditQuantileP5,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DE REGULARISATION BAYESIENNE

function FrameRegBayVisible(handles)
set(handles.FrameRegBay,'Visible','on');
set(handles.TextRegBay,'Visible','on');
set(handles.BtSuiteRB,'Visible','on');
set(handles.TextModeleRB,'Visible','on');
set(handles.PopupModeleRB,'Visible','on');
R = LitPopupModeleRB(handles);
if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1 
    set(handles.TextBetaRB,'Visible','on');
    set(handles.TextBinfRB,'Visible','on');
    set(handles.TextBsupRB,'Visible','on');
    set(handles.EditBinfRB,'Visible','on');
    set(handles.EditBsupRB,'Visible','on');
end

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES RESULTATS DE LA REGULARISATION BAYESIENNE

function FrameResultatRegBayInvisible(handles)
set(handles.FrameResultatRegBay,'Visible','off');
set(handles.TextResultatRB,'Visible','off');
set(handles.TextTheta1Theta2,'Visible','off');
set(handles.TextIntervalleTheta,'Visible','off');
set(handles.TextLoiAPriori,'Visible','off');
set(handles.TextP1LoiAPriori,'Visible','off');
set(handles.TextP2LoiAPriori,'Visible','off');
set(handles.TextResultatP1LAP,'Visible','off');
set(handles.TextResultatP2LAP,'Visible','off');
set(handles.TextDistanceCVM,'Visible','off');
set(handles.TextDistanceModele,'Visible','off');
set(handles.TextResultatDistModele,'Visible','off');
set(handles.TextDistanceRejet,'Visible','off');
set(handles.TextResultatDistRejet,'Visible','off');
set(handles.TextDistancePred,'Visible','off');
set(handles.TextResultatDistPred,'Visible','off');
set(handles.TextTestCentral,'Visible','off');
set(handles.TextResultatTestCentral,'Visible','off');
set(handles.TextTestETRB,'Visible','off');
set(handles.TextResultatTestETRB,'Visible','off');
set(handles.TextTestETLoiPred,'Visible','off');
set(handles.TextResultatTestETLoiPred,'Visible','off');
set(handles.TextQETPred,'Visible','off');
set(handles.TextResultatQETPred,'Visible','off');
set(handles.TextICPred,'Visible','off');
set(handles.TextResultatICPred,'Visible','off');
set(handles.TextResultatQuantilesRB,'Visible','off');
set(handles.PopupResultatQuantilesRB,'Visible','off');
set(handles.TextQEstime,'Visible','off');
set(handles.TextResultatQEstime,'Visible','off');
set(handles.TextqET,'Visible','off');
set(handles.TextResultatqET,'Visible','off');
set(handles.TextqPred,'Visible','off');
set(handles.TextResultatqPred,'Visible','off');
set(handles.TextQVrai,'Visible','off');
set(handles.TextResultatQVrai,'Visible','off');
set(handles.TextQVraiEstime,'Visible','off');
set(handles.TextResultatQVraiEstime,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES RESULTATS DE LA REGULARISATION BAYESIENNE

function FrameResultatRegBayVisible(handles)
set(handles.FrameResultatRegBay,'Visible','on');
set(handles.TextResultatRB,'Visible','on');
set(handles.TextTheta1Theta2,'Visible','on');
set(handles.TextIntervalleTheta,'Visible','on');
set(handles.TextLoiAPriori,'Visible','on');
set(handles.TextP1LoiAPriori,'Visible','on');
set(handles.TextP2LoiAPriori,'Visible','on');
set(handles.TextResultatP1LAP,'Visible','on');
set(handles.TextResultatP2LAP,'Visible','on');
set(handles.TextDistanceCVM,'Visible','on');
set(handles.TextDistanceModele,'Visible','on');
set(handles.TextResultatDistModele,'Visible','on');
set(handles.TextDistanceRejet,'Visible','on');
set(handles.TextResultatDistRejet,'Visible','on');
set(handles.TextDistancePred,'Visible','on');
set(handles.TextResultatDistPred,'Visible','on');
set(handles.TextTestCentral,'Visible','on');
set(handles.TextResultatTestCentral,'Visible','on');
set(handles.TextTestETRB,'Visible','on');
set(handles.TextResultatTestETRB,'Visible','on');
set(handles.TextTestETLoiPred,'Visible','on');
set(handles.TextResultatTestETLoiPred,'Visible','on');
set(handles.TextQETPred,'Visible','on');
set(handles.TextResultatQETPred,'Visible','on');
set(handles.TextICPred,'Visible','on');
set(handles.TextResultatICPred,'Visible','on');
set(handles.TextResultatQuantilesRB,'Visible','on');
set(handles.PopupResultatQuantilesRB,'Visible','on');
set(handles.TextQEstime,'Visible','on');
set(handles.TextResultatQEstime,'Visible','on');
set(handles.TextqET,'Visible','on');
set(handles.TextResultatqET,'Visible','on');
set(handles.TextqPred,'Visible','on');
set(handles.TextResultatqPred,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME D'ESTIMATION DES PARAMETRES DE LA LOI GPD

function FrameEstimGPDInvisible(handles)
set(handles.FrameEstimGPD,'Visible','off');
set(handles.TextEstimGPD,'Visible','off');
set(handles.TextMethodeGPD,'Visible','off');
set(handles.FrameMethodeGPD,'Visible','off');
set(handles.CBMomentsPonderes,'Visible','off');
set(handles.CBEMV,'Visible','off');
set(handles.CBHill,'Visible','off');
set(handles.CBHillGeneralise,'Visible','off');
set(handles.CBZipf,'Visible','off');
set(handles.CBToutesGPD,'Visible','off');
set(handles.TextExcesGPD,'Visible','off');
set(handles.TextExcesInfGPD,'Visible','off');
set(handles.TextExcesSupGPD,'Visible','off');
set(handles.EditExcesInfGPD,'Visible','off');
set(handles.EditExcesSupGPD,'Visible','off');
set(handles.TextQuantileGPD,'Visible','off');
set(handles.TextPGPD,'Visible','off');
set(handles.EditPGPD,'Visible','off');
set(handles.BtLancerEstimGPD,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME D'ESTIMATION DES PARAMETRES DE LA LOI GPD

function FrameEstimGPDVisible(handles)
set(handles.FrameEstimGPD,'Visible','on');
set(handles.TextEstimGPD,'Visible','on');
set(handles.TextMethodeGPD,'Visible','on');
set(handles.FrameMethodeGPD,'Visible','on');
set(handles.CBMomentsPonderes,'Visible','on');
set(handles.CBEMV,'Visible','on');
set(handles.CBHill,'Visible','on');
set(handles.CBHillGeneralise,'Visible','on');
set(handles.CBZipf,'Visible','on');
set(handles.CBToutesGPD,'Visible','on');
set(handles.TextExcesGPD,'Visible','on');
set(handles.TextExcesInfGPD,'Visible','on');
set(handles.TextExcesSupGPD,'Visible','off');
set(handles.EditExcesInfGPD,'Visible','on');
set(handles.EditExcesSupGPD,'Visible','off');
set(handles.TextQuantileGPD,'Visible','off');
set(handles.TextPGPD,'Visible','off');
set(handles.EditPGPD,'Visible','off');
set(handles.BtLancerEstimGPD,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES RESULTATS DE L'ESTIMATION DES PARAMETRES
% D'UNE LOI GPD

function FrameResultatEstimGPDInvisible(handles)
set(handles.FrameResultatEstimGPD,'Visible','off');
set(handles.TextResultatEstimGPD,'Visible','off');
set(handles.TextResultatMethodeGPD,'Visible','off');
set(handles.PopupResultatMethode,'Visible','off');
set(handles.TextResultatParam,'Visible','off');
set(handles.TextGammaGPD,'Visible','off');
set(handles.TextSigmaGPD,'Visible','off');
set(handles.TextQGPD,'Visible','off');
set(handles.TextVarSigmaGPD,'Visible','off');
set(handles.TextResultatGammaGPD,'Visible','off');
set(handles.TextResultatSigmaGPD,'Visible','off');
set(handles.TextResultatQGPD,'Visible','off');
set(handles.TextResultatVarSigmaGPD,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES RESULTATS DE L'ESTIMATION DES PARAMETRES
% D'UNE LOI GPD

function FrameResultatEstimGPDVisible(handles)
set(handles.FrameResultatEstimGPD,'Visible','on');
set(handles.TextResultatEstimGPD,'Visible','on');
set(handles.TextResultatMethodeGPD,'Visible','on');
set(handles.PopupResultatMethode,'Visible','on');
set(handles.TextResultatParam,'Visible','on');
set(handles.TextGammaGPD,'Visible','on');
set(handles.TextSigmaGPD,'Visible','on');
set(handles.TextQGPD,'Visible','off');
set(handles.TextVarSigmaGPD,'Visible','off');
set(handles.TextResultatGammaGPD,'Visible','on');
set(handles.TextResultatSigmaGPD,'Visible','on');
set(handles.TextResultatQGPD,'Visible','off');
set(handles.TextResultatVarSigmaGPD,'Visible','off');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME DES QUANTILES PARAMETRIQUES

function FrameQuantileParamInvisible(handles)
set(handles.FrameQuantileParam,'Visible','off');
set(handles.TextQuantileParam,'Visible','off');
set(handles.BtChoixLois,'Visible','off');
set(handles.TextOrdre,'Visible','off');
set(handles.TextOrdreQuantileParam,'Visible','off');
set(handles.EditOrdreQuantileParam,'Visible','off');
set(handles.BtLancerQuantileParam,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME DES QUANTILES PARAMETRIQUES

function FrameQuantileParamVisible(handles)
set(handles.FrameQuantileParam,'Visible','on');
set(handles.TextQuantileParam,'Visible','on');
set(handles.BtChoixLois,'Visible','on');
set(handles.TextOrdre,'Visible','on');
set(handles.TextOrdreQuantileParam,'Visible','on');
set(handles.EditOrdreQuantileParam,'Visible','on');
set(handles.BtLancerQuantileParam,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME CHOIX DES LOIS

function FrameChoixLoisInvisible(handles)
set(handles.FrameChoixLois,'Visible','off');
set(handles.TextChoixLois,'Visible','off');
set(handles.CBCLNormale,'Visible','off');
set(handles.CBCLLognormale,'Visible','off');
set(handles.CBCLExpo,'Visible','off');
set(handles.CBCLGamma,'Visible','off');
set(handles.CBCLWeibull,'Visible','off');
set(handles.CBCLChi2,'Visible','off');
set(handles.CBCLStudent,'Visible','off');
set(handles.CBCLPareto,'Visible','off');
set(handles.CBCLGPD,'Visible','off');
set(handles.CBCLUnif,'Visible','off');
set(handles.CBCLBeta,'Visible','off');
set(handles.CBCLToutes,'Visible','off');
set(handles.BtCLOK,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME CHOIX DES LOIS

function FrameChoixLoisVisible(handles)
set(handles.FrameChoixLois,'Visible','on');
set(handles.TextChoixLois,'Visible','on');
set(handles.CBCLNormale,'Visible','on');
set(handles.CBCLLognormale,'Visible','on');
set(handles.CBCLExpo,'Visible','on');
set(handles.CBCLGamma,'Visible','on');
set(handles.CBCLWeibull,'Visible','on');
set(handles.CBCLChi2,'Visible','on');
set(handles.CBCLStudent,'Visible','on');
set(handles.CBCLPareto,'Visible','on');
set(handles.CBCLGPD,'Visible','on');
set(handles.CBCLUnif,'Visible','on');
set(handles.CBCLBeta,'Visible','on');
set(handles.CBCLToutes,'Visible','on');
set(handles.BtCLOK,'Visible','on');

% --------------------------------------------------------------------
% INVISIBILITE DE LA FRAME CHOIX DES METHODES (GPD)

function FrameMethodesInvisible(handles)
set(handles.FrameMethodes,'Visible','off');
set(handles.TextMethode,'Visible','off');
set(handles.CBCMHW,'Visible','off');
set(handles.CBCMEMV,'Visible','off');
set(handles.CBCMHill,'Visible','off');
set(handles.CBCMHillG,'Visible','off');
set(handles.CBCMZipf,'Visible','off');
set(handles.BtCMOK,'Visible','off');

% --------------------------------------------------------------------
% AFFICHAGE DE LA FRAME CHOIX DES METHODES (GPD)

function FrameMethodesVisible(handles)
set(handles.FrameMethodes,'Visible','on');
set(handles.TextMethode,'Visible','on');
set(handles.CBCMHW,'Visible','on');
set(handles.CBCMEMV,'Visible','on');
set(handles.CBCMHill,'Visible','on');
set(handles.CBCMHillG,'Visible','on');
set(handles.CBCMZipf,'Visible','on');
set(handles.BtCMOK,'Visible','on');

% --------------------------------------------------------------------
% CREATION D'UN NOUVEL ESPACE DE TRAVAIL

% new : 0 == annulation | 1 == nouvel espace
% EspaceDeTravail : liste actualisee des espaces de travail

function [new,EspaceDeTravail] = NouvelEspace(handles)

% Lecture de la liste des espaces de travail
EspaceDeTravail = strvcat(char(handles.Workspace));

% Nb d'espaces de travail
m = size(EspaceDeTravail,1);

% Demande un nouveau nom d'espace de travail
if handles.langue == 1
    answer = inputdlg('Nouvel espace de travail :','Espace de travail');
else
    answer = inputdlg('New workspace :','Workspace');
end

% Verification du nom
X = char(answer);

% si nouveau nom
if ~isempty(X)
    if length(X)<=size(EspaceDeTravail,2)
        k = find(sum(EspaceDeTravail~=repmat([X 32*ones(1,size(EspaceDeTravail,2)-length(X))],size(EspaceDeTravail,1),1),2)==0);
    else
        k = [];
    end
    while ~isempty(k)
        if handles.langue == 1
            answer = inputdlg('Ce nom est deje utilise. Veuillez saisir un nouveau nom d''espace de travail :','Nom incorrect (deje existant)');
        else
            answer = inputdlg('This name already exists. Please enter a new name for your workspace :','Incorrect name (already exists)');
        end
        X = char(answer);
        if ~isempty(X)
            if length(X)<=size(EspaceDeTravail,2)
                k = find(sum(EspaceDeTravail~=repmat([X 32*ones(1,size(EspaceDeTravail,2)-length(X))],size(EspaceDeTravail,1),1),2)==0);
            else
                k = [];
            end
        else
            k = [];
        end
    end
    
    % Actualisation de la liste des espaces
    EspaceDeTravail = strvcat(char(answer),EspaceDeTravail);
end

% si un nouveau nom a ete donne
if m~=size(EspaceDeTravail,1)
    
    new = 1;
    
    % reinitailisation de la frame des parametres
    ViderEditParam(handles);
    
% si annulation
else
    
    new = 0;
    
end

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME DES PARAMETRES

function ViderEditParam(handles)
set(handles.EditParam1,'String','');
set(handles.EditParam2,'String','');
set(handles.EditParam3,'String','');
set(handles.EditParam4,'String','');
set(handles.EditParam5,'String','');
set(handles.EditParam6,'String','');
set(handles.TextEstimP1,'String','');
set(handles.TextEstimP2,'String','');
set(handles.TextEstimP3,'String','');
set(handles.TextP1,'String','Param1');
set(handles.TextP2,'String','Param2');
set(handles.TextP3,'String','Param3');

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME INFO

function ViderEditInfo(handles)
set(handles.EditMoyTheo,'String','');
set(handles.EditMoyCal,'String','');
set(handles.EditVarTheo,'String','');
set(handles.EditVarCal,'String','');
set(handles.EditQuartile1,'String','');
set(handles.EditMediane,'String','');
set(handles.EditQuartile3,'String','');

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME DES RESULTATS DES TESTS CENTRAUX

function ViderFrameResultat(handles)
set(handles.TextResultatValeurP1,'String','');
set(handles.TextResultatValeurP2,'String','');
set(handles.TextResultatValeurP3,'String','');
set(handles.TextResultatDecision,'String','');
set(handles.TextResultatStat,'String','');
set(handles.TextResultatRejet,'String','');

% --------------------------------------------------------------------
% REINITILISATION DE LA FRAME ESTIMATION

function ViderFrameEstimation(handles)
set(handles.TextP1,'String','');
set(handles.TextP2,'String','');
set(handles.TextP3,'String','');
set(handles.TextEstimP1,'String','');
set(handles.TextEstimP2,'String','');
set(handles.TextEstimP3,'String','');
set(handles.TextP4,'String','');
set(handles.TextP5,'String','');
set(handles.TextP6,'String','');
set(handles.TextEstimP4,'String','');
set(handles.TextEstimP5,'String','');
set(handles.TextEstimP6,'String','');


% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME TEST ET

function ViderFrameTestET(handles)
set(handles.EditBootstrapET,'String','');
set(handles.EditExcesSup,'String','');
set(handles.EditExcesInf,'String','');
set(handles.EditPET,'String','');
CBDecocheLois(handles);
CBDecocheMethodes(handles);

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME DES RESULTATS DU TEST ET

function ViderFrameResultatET(handles)
set(handles.TextResultatQET,'String','');
set(handles.TextResultatQParam,'String','');
set(handles.TextResultatStatET,'String','');
set(handles.TextResultatIntervalle,'String','');
set(handles.TextResultatDecisionET,'String','');

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME DE REGULARISATION BAYESIENNE

function ViderFrameRegBay(handles)
set(handles.EditBinfRB,'String','');
set(handles.EditBsupRB,'String','');
set(handles.EditParam1RB,'String','');
set(handles.EditParam2RB,'String','');
set(handles.EditParam3RB,'String','');
set(handles.EditConfiance,'String','');
set(handles.EditQmax,'String','');
set(handles.EditOrdrep1,'String','');
set(handles.EditOrdrep2,'String','');
set(handles.EditExcesRB,'String','');
set(handles.EditPETRB,'String','');
set(handles.EditQuantileP1,'String','');
set(handles.EditQuantileP2,'String','');
set(handles.EditQuantileP3,'String','');
set(handles.EditQuantileP4,'String','');
set(handles.EditQuantileP5,'String','');
set(handles.RBOui,'Value',0);
set(handles.RBNon,'Value',1);
set(handles.RBExpertOui,'Value',0);
set(handles.RBExpertNon,'Value',1);

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME D'ESTIMATION DES PARAMETRES DE LA LOI GPD

function ViderFrameEstimGPD(handles)
CBDecocheGPD(handles)
set(handles.EditExcesInfGPD,'String','');
set(handles.EditExcesSupGPD,'String','');
set(handles.EditPGPD,'String','');

% --------------------------------------------------------------------
% REINITIALISATION DE LA FRAME DES RESULTATS DE L'ESTIMATION DES PARAMETRES
% D'UNE LOI GPD

function ViderFrameResultatEstimGPD(handles)
set(handles.TextGammaGPD,'String','');
set(handles.TextSigmaGPD,'String','');
set(handles.TextQGPD,'String','');
set(handles.TextVarSigmaGPD,'String','');
set(handles.TextResultatGammaGPD,'String','');
set(handles.TextResultatSigmaGPD,'String','');
set(handles.TextResultatQGPD,'String','');
set(handles.TextResultatVarSigmaGPD,'String','');

% --------------------------------------------------------------------
% DECOCHE TOUTES LES LOIS POUR LES TESTS CENTRAUX

function CBDecoche(handles)
set(handles.CBNormale,'Value',0);
set(handles.CBLognormale,'Value',0);
set(handles.CBExponentielle,'Value',0);
set(handles.CBWeibull,'Value',0);
set(handles.CBGamma,'Value',0);
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% DECOCHE TOUTES LES LOIS POUR LE TEST ET

% function CBDecocheET(handles)
% set(handles.CBNormaleET,'Value',0);
% set(handles.CBLognormaleET,'Value',0);
% set(handles.CBExponentielleET,'Value',0);
% set(handles.CBWeibullET,'Value',0);
% set(handles.CBGammaET,'Value',0);
% set(handles.CBToutesET,'Value',0);

% --------------------------------------------------------------------
% DECOCHE TOUTES LES METHODES POUR L'ESTIMATION DES PARAMETRES DE LA LOI GPD

function CBDecocheGPD(handles)
set(handles.CBMomentsPonderes,'Value',0);
set(handles.CBEMV,'Value',0);
set(handles.CBHill,'Value',0);
set(handles.CBHillGeneralise,'Value',0);
set(handles.CBZipf,'Value',0);
set(handles.CBToutesGPD,'Value',0);

% --------------------------------------------------------------------
% DECOCHE TOUTES LES LOIS DANS LA FRAME CHOIX DES LOIX
function CBDecocheLois(handles)
set(handles.CBCLNormale,'Value',0);
set(handles.CBCLLognormale,'Value',0);
set(handles.CBCLExpo,'Value',0);
set(handles.CBCLGamma,'Value',0);
set(handles.CBCLWeibull,'Value',0);
set(handles.CBCLChi2,'Value',0);
set(handles.CBCLStudent,'Value',0);
set(handles.CBCLPareto,'Value',0);
set(handles.CBCLGPD,'Value',0);
set(handles.CBCLUnif,'Value',0);
set(handles.CBCLBeta,'Value',0);
set(handles.CBCLToutes,'Value',0);

% --------------------------------------------------------------------
% DECOCHE (AUSSI) TOUTES LES METHODES GPD

function CBDecocheMethodes(handles)
set(handles.CBCMHW,'Value',0);
set(handles.CBCMEMV,'Value',0);
set(handles.CBCMHill,'Value',0);
set(handles.CBCMHillG,'Value',0);
set(handles.CBCMZipf,'Value',0);

% --------------------------------------------------------------------
% CREATION D'UN NOUVEAU REPERTOIRE SUR LE DISQUE

% new : 0 == rien | 1 == creation

function CreeRepEDT(handles,new)
if new == 1
    set(handles.PopupTravail,'Value',1);
    Index = get(handles.PopupTravail,'Value');
    ListeEspace = get(handles.PopupTravail,'String');
    Rep = ListeEspace{Index};
    [s,t]=mkdir(handles.path,Rep);
end

% --------------------------------------------------------------------
% LECTURE DE L'ESPACE DE TRAVAIL COURANT

% Rep = nom complet de l'espace de travail (ex : c:\truc\Temp\EspaceDeTravail )

function Rep = LitRepEDT(handles)
Index = get(handles.PopupTravail,'Value');
ListeEspace = get(handles.PopupTravail,'String');
R = ListeEspace{Index};
Rep = [handles.path '/' R];   

% --------------------------------------------------------------------
% LECTURE DE LA LOI DONT ON ESTIME LES PARAMETRES

% R = Nom de loi

function R = LitPopupEstim(handles)
Index = get(handles.PopupEstim,'Value');
ListeLoi = get(handles.PopupEstim,'String');
R = ListeLoi{Index};   

% --------------------------------------------------------------------
% LECTURE DE L'ACTION SELECTIONNEE

% R = nom d'une action (ex : simulation loi normale)

function R = LitPopupAction(handles)
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
R = ListeAction{Index};   

% --------------------------------------------------------------------
% LECTURE DU NIVEAU DES TESTS CENTRAUX

% R = niveau du test (ex : 0.05)

function R = LitPopupNiveau(handles)
Index = get(handles.PopupNiveau,'Value');
ListeNiveau = get(handles.PopupNiveau,'String');
R = ListeNiveau{Index};   

% --------------------------------------------------------------------
% LECTURE DU NIVEAU DU TEST ET

% R = niveau du test

function R = LitPopupNiveauET(handles)
Index = get(handles.PopupNiveauET,'Value');
ListeNiveauET = get(handles.PopupNiveauET,'String');
R = ListeNiveauET{Index};   

% --------------------------------------------------------------------
% LECTURE DE LA VERSION DU TEST ET

% R = Asymptotique, Bootstrap, Bootstrap simplifie

function R = LitPopupVersionET(handles)
Index = get(handles.PopupVersionET,'Value');
ListeVersion = get(handles.PopupVersionET,'String');
R = ListeVersion{Index};   

% --------------------------------------------------------------------
% LECTURE DU MODELE POUR LA REGULARISATION BAYESIENNE

% R = nom de loi

function R = LitPopupModeleRB(handles)
Index = get(handles.PopupModeleRB,'Value');
ListeRB = get(handles.PopupModeleRB,'String');
R = ListeRB{Index};   

% --------------------------------------------------------------------
% LECTURE DE LA LOI DE SIMULATION POUR LA Reg Bay

% R = nom de loi

function R = LitPopupVraieLoiRB(handles)
Index = get(handles.PopupVraieLoiRB,'Value');
ListeLoi = get(handles.PopupVraieLoiRB,'String');
R = ListeLoi{Index};   

% --------------------------------------------------------------------
% LECTURE DE LA CONFIANCE EN L'EXPERT

% R = Forte, Moyenne, Faible

function R = LitPopupConfianceWeibull(handles)
Index = get(handles.PopupConfianceWeibull,'Value');
ListeLoi = get(handles.PopupConfianceWeibull,'String');
R = ListeLoi{Index};   

% --------------------------------------------------------------------
% LECTURE DU TYPE DE TEST POUR Reg Bay

% R = Anderson-Darling ou Cramer-Von Mises 

function R = LitPopupTypeTest(handles)
Index = get(handles.PopupTypeTest,'Value');
Test = get(handles.PopupTypeTest,'String');
R = Test{Index};

% --------------------------------------------------------------------
% LECTURE DU NIVEAU DU TEST CENTRAL POUR Reg Bay

% R = niveau du test (ex : 0.05)

function R = LitPopupNiveauCentraux(handles)
Index = get(handles.PopupNiveauCentraux,'Value');
Niveau = get(handles.PopupNiveauCentraux,'String');
R = Niveau{Index};   

% --------------------------------------------------------------------
% LECTURE DU NIVEAU DU TEST ET POUR Reg Bay

% R = niveau du test

function R = LitPopupNiveauETRB(handles)
Index = get(handles.PopupNiveauETRB,'Value');
Niveau = get(handles.PopupNiveauETRB,'String');
R = Niveau{Index};   

% --------------------------------------------------------------------

function varargout = FrameParam_CreateFcn(h, eventdata, handles, varargin)
% Stub for CreateFcn of the uicontrol handles.FrameParam.

% --------------------------------------------------------------------
% VERIFICATION DE LA SAISIE DES PARAMETRES
% V : 1 == aucune erreur | 2..9 = erreur

function V = VerifParam(handles)

% Aucune erreur
V = 1;

% si estimation par noyau
if handles.NbParam == 0
    
    % si parametre de lissage vide
    if isempty(get(handles.EditParam3,'String')) | ~isnumeric(str2double(get(handles.EditParam3,'String')))
        V = 0;
    else
        % si parametre de lissage negatif
        if str2double(get(handles.EditParam3,'String')) <= 0
            V = 6;
        end
    end
    
    % si borne inferieure vide
    if isempty(get(handles.EditParam4,'String')) | ~isnumeric(str2double(get(handles.EditParam4,'String')))
        V = 0;
    end
    
    % si borne superieure vide
    if isempty(get(handles.EditParam5,'String')) | ~isnumeric(str2double(get(handles.EditParam5,'String')))
        V = 0;
    end
    
    % si nombre de points vide
    if isempty(get(handles.EditParam6,'String')) | ~isnumeric(str2double(get(handles.EditParam6,'String')))
        V = 0;
    end
    
end

% si 1 seul parametre
if handles.NbParam == 1
    
    % si vide
    if isempty(get(handles.EditParam1,'String')) | ~isnumeric(str2double(get(handles.EditParam1,'String')))
        V = 0;
    end
    
    % si taille de l'echantillon vide
    if isempty(get(handles.EditParam4,'String')) | ~isnumeric(str2double(get(handles.EditParam4,'String')))
        V = 0;
    end
    
    % si nb de jeux de donnees vide
    if isempty(get(handles.EditParam5,'String')) | ~isnumeric(str2double(get(handles.EditParam5,'String')))
        V = 0;
    end
    
    % si nb de classes vide
    if isempty(get(handles.EditParam6,'String')) | ~isnumeric(str2double(get(handles.EditParam6,'String')))
        V = 0;
    end
end

% si 2 parametres
if handles.NbParam == 2
    if isempty(get(handles.EditParam1,'String')) | ~isnumeric(str2double(get(handles.EditParam1,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam2,'String')) | ~isnumeric(str2double(get(handles.EditParam2,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam4,'String')) | ~isnumeric(str2double(get(handles.EditParam4,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam5,'String')) | ~isnumeric(str2double(get(handles.EditParam5,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam6,'String')) | ~isnumeric(str2double(get(handles.EditParam6,'String')))
        V = 0;
    end
end

% si 3 parametres
if handles.NbParam == 3
    if isempty(get(handles.EditParam1,'String')) | ~isnumeric(str2double(get(handles.EditParam1,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam2,'String')) | ~isnumeric(str2double(get(handles.EditParam2,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam3,'String')) | ~isnumeric(str2double(get(handles.EditParam3,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam4,'String')) | ~isnumeric(str2double(get(handles.EditParam4,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam5,'String')) | ~isnumeric(str2double(get(handles.EditParam5,'String')))
        V = 0;
    end
    if isempty(get(handles.EditParam6,'String')) | ~isnumeric(str2double(get(handles.EditParam6,'String')))
        V = 0;
    end
end

% Verification des bornes, quantiles, taille.
% si la tache n'est pas simulation
if handles.Tache ~= 1 & handles.Tache ~= 27
    
    % Recuperation de la saisie
    A = str2double(get(handles.EditParam4,'String'));
    B = str2double(get(handles.EditParam5,'String'));
    C = str2num(get(handles.EditParam6,'String'));
    
    % si borne inf est > e borne sup
    if A>B
        V = 2;
    else
        % si elles sont egales et que nb de points > 1
        if A==B & C~=1
            V = 3;
        end
    end
    
    % si nb de points est <= 0
    if C<=0
        V = 4;
    end
    
    % si quantile min est <= 0 et quantile max => 1
    if handles.Tache == 4
        if A<=0 | B>=1
            V = 7;
        end
    end
    
else
    
    % si nb de classes <= 0 
    if str2num(get(handles.EditParam6,'String'))<=0
        V = 5;
    end
    
    % si taille de l'echantillon <= 0
    if str2num(get(handles.EditParam4,'String'))<=0
        V = 8;
    end

    % si nb de jeux de donnees <= 0
    if str2num(get(handles.EditParam5,'String')) < 1
        V = 9;
    end
end

% --------------------------------------------------------------------
% VERIFICATION DE LA SAISIE POUR LES TESTS
% V == 1 : aucune erreur | sinon erreur

function V = VerifTest(handles)

% Aucune erreur
V = 1;

% Modeles coches
Norm = get(handles.CBCLNormale,'Value');
Logn = get(handles.CBCLLognormale,'Value');
Expo = get(handles.CBCLExpo,'Value');
Gamma = get(handles.CBCLGamma,'Value');
Weib = get(handles.CBCLWeibull,'Value');
Chi2 = get(handles.CBCLChi2,'Value');
Stu = get(handles.CBCLStudent,'Value');
Par = get(handles.CBCLPareto,'Value');
GPD = get(handles.CBCLGPD,'Value');
Unif = get(handles.CBCLUnif,'Value');
Beta = get(handles.CBCLBeta,'Value');

% si aucun modele n'est coche
if Norm + Logn + Expo + Gamma + Weib + Chi2 + Stu + Par + GPD + Unif + Beta == 0
    V = 2;
    return;
end

% si donnees multiples
if handles.Tache == 11 | handles.Tache == 12 | handles.Tache == 16 | handles.Tache == 17 | handles.Tache == 18 ...
        handles.Tache == 38 | handles.Tache == 39 | handles.Tache == 40
    
    if Norm + Logn + Expo + Gamma + Weib + Chi2 + Stu + Par + GPD + Unif + Beta > 1
        V = 3;
        return;
    end
end

% si test d'exponentialite
if handles.Tache == 13 | handles.Tache == 14
    
    % si Exces vide
    if isempty(get(handles.EditExces,'String'))
        V = 4;
        return;
    else
        % si Exces < 2 ou > taille de l'echantillon
        if (str2num(get(handles.EditExces,'String')) < 2) | (str2num(get(handles.EditExces,'String')) > handles.Taille)
            V = 5;
            return;
        end
    end
    
end

if handles.Tache >= 38 & handles.Tache <= 46
    
    % Methodes cochees
    HW = get(handles.CBCMHW,'Value');
    EMV = get(handles.CBCMEMV,'Value');
    Hill = get(handles.CBCMHill,'Value');
    HillG = get(handles.CBCMHillG,'Value');
    Zipf = get(handles.CBCMZipf,'Value');

    % si aucune methode n'est cochee
    if HW + EMV + Hill + HillG + Zipf == 0
        V = 9;
        return;
    end
    
    if HW + EMV + Hill + HillG + Zipf > 1
        V = 10;
        return;
    end
    
    if handles.Tache == 38 | handles.Tache == 41 | handles.Tache == 44
        V = 11;
        return;
    end
    
end

% Cherche quel test ET (ou GPD) est lance
if handles.Tache >= 38 & handles.Tache <= 46
    k = find([38:46] == handles.Tache);
else
    k = find([16:24] == handles.Tache);
end

% si un test ET (ou GPD)
if ~isempty(k)
    
    % si test avec 1 seul nombre d'exces
    if k == 1 | k == 2 | k == 3 | k == 4 | k == 5 | k == 6
        
        % si vide
        if isempty(get(handles.EditExcesSup,'String'))
            V = 4;
            return;
        else
            % si Exces < 2 ou > taille de l'echantillon
            if (str2num(get(handles.EditExcesSup,'String')) < 2) | (str2num(get(handles.EditExcesSup,'String')) > handles.Taille)
                V = 5;
                return;
            end
        end
        
    end
    
    % si version du test ET != asymptotique
    if k == 2 | k == 3 | k == 5 | k == 6 | k == 8 | k == 9
        
        % si nombre d'echantillons de bootstrap vide
        if isempty(get(handles.EditBootstrapET,'String'))
            V = 4;
            return;
        else
            % si nb echant. de bootstrap <= 0
            if str2num(get(handles.EditBootstrapET,'String')) <= 0
                V = 6;
                return;
            end
        end
        
    end
    
    % si Exces multiples
    if k == 7 | k == 8 | k == 9
        
        % si borne inf des exces vide ou borne sup vide
        if isempty(get(handles.EditExcesInf,'String')) | isempty(get(handles.EditExcesSup,'String'))
            V = 4;
            return;
        else
            
            % si borne inf des exces > e borne sup
            if str2num(get(handles.EditExcesInf,'String')) > str2num(get(handles.EditExcesSup,'String'))
                V = 7;
                return;
            end
            % si borne des exces < 2 ou > taille de l'echantillon
            if str2num(get(handles.EditExcesSup,'String')) < 2 | str2num(get(handles.EditExcesSup,'String')) > handles.Taille | str2num(get(handles.EditExcesInf,'String')) < 2 | str2num(get(handles.EditExcesInf,'String')) > handles.Taille
                V = 5;
                return;
            end
            
        end
        
    end
    
    % si ordre du quantile ET vide
    if isempty(get(handles.EditPET,'String'))
        V = 4;
        return;
    else
        
        % si ordre <= 0 ou >= 1
        if str2num(get(handles.EditPET,'String')) <= 0 | str2num(get(handles.EditPET,'String')) >= 1
            V = 8;
            return;
        end
    end
end
            
% --------------------------------------------------------------------
% VERIFICATION DE TOUS LES PARAMETRES POUR REGLARISATION BAYESIENNE
    
function V = VerifRegBay(handles)

% Aucune erreur
V = 1;
R = LitPopupModeleRB(handles);

% cas de weibull parametre de forme
if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1
    
    % si les bornes inf ou sup sont vides
    if (isempty(get(handles.EditBinfRB,'String')) | isempty(get(handles.EditBsupRB,'String')))
        V = 2;
        return;
    end
    
    %si les bornes sont negatives ou nulles (pour borne sup)
    if (str2num(get(handles.EditBinfRB,'String')) < 0 | str2num(get(handles.EditBsupRB,'String')) <= 0)
        V = 3;
        return;
    end
    
    % si borne inf est >= e borne sup
    if str2num(get(handles.EditBinfRB,'String')) >= str2num(get(handles.EditBsupRB,'String'))
        V = 4;
        return;
    end
end

% cas de donnees simulees
if get(handles.RBOui,'Value') == 1
    
    R = LitPopupVraieLoiRB(handles);
    [param1,param2,param3,NbParam] = NomDesParametres(handles,R);
    
    % si les parametres de la vraie loi sont manquants
    % 1 seul parametre
    if NbParam == 1
        if isempty(get(handles.EditParam1RB,'String'))
            V = 2;
            return;
        end
    end
    
    % 2 parametres
    if NbParam == 2
        if isempty(get(handles.EditParam1RB,'String')) | isempty(get(handles.EditParam2RB,'String')) 
            V = 2;
            return;
        end
    end
    
    % 3 parametres
    if NbParam == 3
        if isempty(get(handles.EditParam1RB,'String')) | isempty(get(handles.EditParam2RB,'String')) | isempty(get(handles.EditParam3RB,'String'))
            V = 2;
            return;
        end
    end
end

% si avis d'expert
if get(handles.RBExpertOui,'Value') == 1
    
    % si vides
    if isempty(get(handles.EditQmax,'String')) | isempty(get(handles.EditOrdrep1,'String')) | isempty(get(handles.EditOrdrep2,'String'))
        V = 2;
        return;
    end
    
    % si p1 ou p2 negatifs ou >= e 1
    if str2num(get(handles.EditOrdrep1,'String')) <= 0 | str2num(get(handles.EditOrdrep2,'String')) <= 0 | str2num(get(handles.EditOrdrep1,'String')) >= 1 | str2num(get(handles.EditOrdrep2,'String')) >= 1
        V = 5;
        return;
    end
    
    % si p1 <= p2
    if str2num(get(handles.EditOrdrep1,'String')) <= str2num(get(handles.EditOrdrep2,'String'))
        V = 6;
        return;
    end
end

% degre de defiance
% si vide
if isempty(get(handles.EditConfiance,'String'))
    V = 2;
    return;
else
    
    % si confiance <= 0 ou >= 1 
    if str2num(char(get(handles.EditConfiance,'String'))) <= 0 | str2num(char(get(handles.EditConfiance,'String'))) >= 1
        V = 8;
        return;
    end
end

% si nombres d'exces ou ordre du quantile ET vides
if isempty(get(handles.EditExcesRB,'String')) | isempty(get(handles.EditPETRB,'String'))
    V = 2;
    return;
end

% si nombre d'exces < 2 ou > taille de l'echantillon
if str2num(char(get(handles.EditExcesRB,'String'))) < 2 | str2num(char(get(handles.EditExcesRB,'String'))) > handles.Taille
    V = 7;
    return;
end

% si ordre du quantile ET <= 0 ou si >= 1
if str2num(char(get(handles.EditPETRB,'String'))) <= 0 | str2num(char(get(handles.EditPETRB,'String'))) >= 1
    V = 5;
    return;
end

% quantiles e calculer dont on donne l'ordre
% si le 1er est vide
if isempty(get(handles.EditQuantileP1,'String'))
    V = 2;
    return;
else
    
    % si <= 0 ou >=1
    if str2num(char(get(handles.EditQuantileP1,'String'))) <= 0 | str2num(char(get(handles.EditQuantileP1,'String'))) >= 1
        V = 5;
        return;
    end
    
    % 2eme quantile
    if ~isempty(get(handles.EditQuantileP2,'String'))
        if str2num(char(get(handles.EditQuantileP2,'String'))) <= 0 | str2num(char(get(handles.EditQuantileP2,'String'))) >= 1
            V = 5;
            return;
        end
    end
    
    % 3eme
    if ~isempty(get(handles.EditQuantileP3,'String'))
        if str2num(char(get(handles.EditQuantileP3,'String'))) <= 0 | str2num(char(get(handles.EditQuantileP3,'String'))) >= 1
            V = 5;
            return;
        end
    end
    
    % 4eme
    if ~isempty(get(handles.EditQuantileP4,'String'))
        if str2num(char(get(handles.EditQuantileP4,'String'))) <= 0 | str2num(char(get(handles.EditQuantileP4,'String'))) >= 1
            V = 5;
            return;
        end
    end
    
    % 5eme
    if ~isempty(get(handles.EditQuantileP5,'String'))
        if str2num(char(get(handles.EditQuantileP5,'String'))) <= 0 | str2num(char(get(handles.EditQuantileP5,'String'))) >= 1
            V = 5;
            return;
        end
    end
end

% --------------------------------------------------------------------
% VERIFICATION DES ENTREES UILISATEUR POUR L'INDICE DES VALEURS EXTREMES ET QUANTILE EXTREME

function V = VerifEstimGPD(handles)

T = handles.Tache;
% Aucune erreur
V = 1;

% Methodes cochees
HW = get(handles.CBMomentsPonderes,'Value');
EMV = get(handles.CBEMV,'Value');
Hill = get(handles.CBHill,'Value');
HillG = get(handles.CBHillGeneralise,'Value');
Zipf = get(handles.CBZipf,'Value');

% si aucune methode n'est cochee
if HW + EMV + Hill + HillG + Zipf == 0
    V = 2;
    return;
end

% si donnees multiples
if T == 31 | T == 35
    
    % si plusieurs methodes sont cochees
    if HW + EMV + Hill + HillG + Zipf > 1
        V = 3;
        return;
    end
end

% borne inf des exces vide
if isempty(get(handles.EditExcesInfGPD,'String'))
    V = 4;
    return;
end

if T == 30 | T == 34
        
% borne sup des exces vide
    if isempty(get(handles.EditExcesSupGPD,'String'))
        V = 4;
         return;
    end
end
    
if T == 32 | T == 33 | T == 34 | T == 35
        
    % ordre du quantile vide
    if isempty(get(handles.EditPGPD,'String'))
        V = 4;
        return
    end
    
    % ordre non valide
    if str2num(char(get(handles.EditPGPD,'String'))) <= 0 | str2num(char(get(handles.EditPGPD,'String'))) >= 1
        V = 7;
        return;
    end
end

% si 1 jeu - 1 nb d'exces - 1 methode
if T == 28 | T == 32
    
    % si NbExces < 2 ou > taille de l'echantillon - 1 et si ni EMV et ni HW ne sont cochees
    if ((str2num(char(get(handles.EditExcesInfGPD,'String'))) < 2) | (str2num(char(get(handles.EditExcesInfGPD,'String'))) > handles.Taille - 1)) & ((HW == 0) & (EMV == 0))
        V = 5;
        return;
    end
    
    % si NbExces < 2 ou > taille de l'echantillon lorsque EMV ou HW sont coches
    if ((str2num(char(get(handles.EditExcesInfGPD,'String'))) < 2) | (str2num(char(get(handles.EditExcesInfGPD,'String'))) > handles.Taille)) & ((HW == 1) | (EMV == 1))
        V = 6;
        return;
    end
    
else
    if str2num(char(get(handles.EditExcesInfGPD,'String'))) < 2 | str2num(char(get(handles.EditExcesInfGPD,'String'))) > handles.Taille - 1
        V = 5;
        return;
    end
    if str2num(char(get(handles.EditExcesSupGPD,'String'))) < 2 | str2num(char(get(handles.EditExcesSupGPD,'String'))) > handles.Taille - 1
        V = 5;
        return;
    end
    if str2num(char(get(handles.EditExcesInfGPD,'String'))) >= str2num(char(get(handles.EditExcesSupGPD,'String')))
        V = 8;
        return;
    end
end

% --------------------------------------------------------------------
% VERIFICATION DES ENTREES UILISATEUR POUR LE CALCUL D'UN QUANTILE PARAMETRIQUE

function V = VerifQParam(handles)

T = handles.Tache;
% Aucune erreur
V = 1;

% Modeles coches
Norm = get(handles.CBCLNormale,'Value');
Logn = get(handles.CBCLLognormale,'Value');
Expo = get(handles.CBCLExpo,'Value');
Gamma = get(handles.CBCLGamma,'Value');
Weib = get(handles.CBCLWeibull,'Value');
Chi2 = get(handles.CBCLChi2,'Value');
Stu = get(handles.CBCLStudent,'Value');
Par = get(handles.CBCLPareto,'Value');
GPD = get(handles.CBCLGPD,'Value');
Unif = get(handles.CBCLUnif,'Value');
Beta = get(handles.CBCLBeta,'Value');

% si aucun modele n'est coche
if Norm + Logn + Expo + Gamma + Weib + Chi2 + Stu + Par + GPD + Unif + Beta == 0
    V = 2;
    return;
end

% donnees multiples
if T == 37
    % si plusieurs modeles coches
    if Norm + Logn + Expo + Gamma + Weib + Chi2 + Stu + Par + GPD + Unif + Beta > 1
        V = 3;
        return;
    end
end

% si l'ordre du quantile est vide
if isempty(get(handles.EditOrdreQuantileParam,'String'))
    V = 4
    return;
end

% si l'ordre est <= 0 ou >= 1
if ((str2num(char(get(handles.EditOrdreQuantileParam,'String'))) <= 0) | (str2num(char(get(handles.EditOrdreQuantileParam,'String'))) >=1))
    V = 5;
    return;
end

% --------------------------------------------------------------------
% CONVERSION D'UN NUMERO DE TACHE EN NOM D'ACTION

% A : nom d'action (ex : simulation Loi Normale)

function A = TacheToAction(handles)

% Initialisation
A = '';

% Nom de la loi
Loi = handles.Nomloi;

if handles.Tache == 1
    if handles.langue == 1
        A = ['Simulation ' Loi];
    else
        Loi = LoiFrToEn(Loi);
        A = [Loi ' simulation'];
    end
end
if handles.Tache == 2
    if handles.langue == 1
        A = ['Densite ' Loi];
    else
        Loi = LoiFrToEn(Loi);
        A = [Loi ' PDF'];
    end
end
if handles.Tache == 3
    if handles.langue == 1
        A = ['FDR ' Loi];
    else
        Loi = LoiFrToEn(Loi);
        A = [Loi ' CDF'];
    end
end
if handles.Tache == 4
    if handles.langue == 1
        A = ['Fonction quantile ' Loi];
    else
        Loi = LoiFrToEn(Loi);
        A = [Loi ' quantile function'];
    end
end
if handles.Tache == 5
    if handles.langue == 1
        A = 'Histogramme';
    else
        A = 'Histogram';
    end
end
if handles.Tache == 6
    if handles.langue == 1
        A = 'Estimation de la densite';
    else
        A = 'Density estimate';
    end
end
if handles.Tache == 7
    if handles.langue == 1
        A = 'Estimation des parametres';
    else
        A = 'Parameter estimates';
    end
end
if handles.Tache == 8
    if handles.langue == 1
        A = ['Fonction de survie ' Loi];
    else
        Loi = LoiFrToEn(Loi);
        A = [Loi ' survival function'];
    end
end
if handles.Tache == 9
    if handles.langue == 1
        A = 'Test Anderson-Darling';
    else
        A = 'Anderson-Darling test';
    end
end
if handles.Tache == 10
    if handles.langue == 1
        A = 'Test Cramer-Von Mises';
    else
        A = 'Cramer-Von Mises test';
    end
end
if handles.Tache == 11
    A = 'Anderson-Darling';
end
if handles.Tache == 12
    A = 'Cramer-Von Mises';
end
if handles.Tache == 13
    A = 'QQ-Plot';
end
if handles.Tache == 14
    if handles.langue == 1
        A = 'Test d''exponentialite';
    else
        A = 'Exponentiality test';
    end
end
if handles.Tache == 15
    if handles.langue == 1
        A = 'Exponentialite des exces';
    else
        A = 'Exponentiality of excesses';
    end
end
if handles.Tache == 16
    if handles.langue == 1
        A = 'Test ET - Donnees multiples - A';
    else
        A = 'ET test - Multiple data - A';
    end
end
if handles.Tache == 17
    if handles.langue == 1
        A = 'Test ET - Donnees multiples - BP';
    else
        A = 'ET test - Multiple data - BP';
    end
end
if handles.Tache == 18
    if handles.langue == 1
        A = 'Test ET - Donnees multiples - BPS';
    else
        A = 'ET test - Multiple data - BPS';
    end
end
if handles.Tache == 19
    if handles.langue == 1
        A = 'Test ET - Exces unique - A';
    else
        A = 'ET test - Single excess - A';
    end
end
if handles.Tache == 20
    if handles.langue == 1
        A = 'Test ET - Exces unique - BP';
    else
        A = 'ET test - Single excess - BP';
    end
end
if handles.Tache == 21
    if handles.langue == 1
        A = 'Test ET - Exces unique - BPS';
    else
        A = 'ET test - Single excess - BPS';
    end
end
if handles.Tache == 22
    if handles.langue == 1
        A = 'Test ET - Exces multiples - A';
    else
        A = 'ET test - Multiple excesses - A';
    end
end
if handles.Tache == 23
    if handles.langue == 1
        A = 'Test ET - Exces multiples - BP';
    else
        A = 'ET test - Multiple excesses - BP';
    end
end
if handles.Tache == 24
    if handles.langue == 1
        A = 'Test ET - Exces multiples - BPS';
    else
        A = 'ET test - Multiple excesses - BPS';
    end
end
if handles.Tache == 25
    if handles.langue == 1
        A = 'Regularisation bayesienne';
    else
        A = 'Bayesian regularisation';
    end
end
if handles.Tache == 26
    if handles.langue == 1
        A = 'Estimation des parametres - DM';
    else
        A = 'Parameter estimates - MD';
    end
end
if handles.Tache == 27
    if handles.langue == 1
        A = 'Simulation loi predictive';
    else
        A = 'Predictive distribution simulation';
    end
end
if handles.Tache == 28
    A = 'QQ-Plot GPD';
end
if handles.Tache == 29
    if handles.langue == 1
        A = 'Estimation GPD - Exces unique';
    else
        A = 'GPD estimate - Single excess';
    end
end
if handles.Tache == 30
    if handles.langue == 1
        A = 'Estimation GPD - Exces multiples';
    else
        A = 'GPD estimate - Multiple excesses';
    end
end
if handles.Tache == 31
    if handles.langue == 1
        A = 'Estimation GPD - Donnees multiples';
    else
        A = 'GPD estimate - Multiple data';
    end
end
if handles.Tache == 32
    if handles.langue == 1
        A = 'Quantile extreme';
    else
        A = 'Extreme quantile';
    end
end
if handles.Tache == 33
    if handles.langue == 1
        A = 'Quantile extreme - Exces unique';
    else
        A = 'Extreme quantile - Single excess';
    end
end
if handles.Tache == 34
    if handles.langue == 1
        A = 'Quantile extreme - Exces multiples';
    else
        A = 'Extreme quantile - Multiple excesses';
    end
end
if handles.Tache == 35
    if handles.langue == 1
        A = 'Quantile extreme - Donnees multiples';
    else
        A = 'Extreme quantile - Multiple data';
    end
end
if handles.Tache == 36
    if handles.langue == 1
        A = 'Quantile parametrique';
    else
        A = 'Parametric quantile';
    end
end
if handles.Tache == 37
    if handles.langue == 1
        A = 'Quantile parametrique - DM';
    else
        A = 'Parametric quantile - MD';
    end
end
if handles.Tache == 38
    if handles.langue == 1
        A = 'Test GPD - Donnees multiples - A';
    else
        A = 'GPD test - Multiple data - A';
    end
end
if handles.Tache == 39
    if handles.langue == 1
        A = 'Test GPD - Donnees multiples - BP';
    else
        A = 'GPD test - Multiple data - BP';
    end
end
if handles.Tache == 40
    if handles.langue == 1
        A = 'Test GPD - Donnees multiples - BPS';
    else
        A = 'GPD test - Multiple data - BPS';
    end
end
if handles.Tache == 41
    if handles.langue == 1
        A = 'Test GPD - Exces unique - A';
    else
        A = 'GPD test - Single excess - A';
    end
end
if handles.Tache == 42
    if handles.langue == 1
        A = 'Test GPD - Exces unique - BP';
    else
        A = 'GPD test - Single excess - BP';
    end
end
if handles.Tache == 43
    if handles.langue == 1
        A = 'Test GPD - Exces unique - BPS';
    else
        A = 'GPD test - Single excess - BPS';
    end
end
if handles.Tache == 44
    if handles.langue == 1
        A = 'Test GPD - Exces multiples - A';
    else
        A = 'GPD test - Multiple excesses - A';
    end
end
if handles.Tache == 45
    if handles.langue == 1
        A = 'Test GPD - Exces multiples - BP';
    else
        A = 'GPD test - Multiple excesses - BP';
    end
end
if handles.Tache == 46
    if handles.langue == 1
        A = 'Test GPD - Exces multiples - BPS';
    else
        A = 'GPD test - Multiple excesses - BPS';
    end
end

% --------------------------------------------------------------------
% PREPARATION A L'AFFICHAGE DE LA FRAME DES PARAMETRES

% new : 0 == rien | 1 == un nouvel espace a ete cree
% IsQuantile : 0 == non | 1 == oui
% Passe : 0 == annulation | 1 == OK
% NomFich : nom du fichier d'abscisse, "*" sinon

function [Passe,NomFich] = PrepareParamGraph(handles,new,IsQuantile)

% Initialisation
Passe = 0;
NomFich = '*';

% si un nouvel espace a ete cree
if new ~= 0
    
    % question utilisateur
    if handles.langue == 1
        Reponse = questdlg('Tracer avec :','Choix des donnees','Entrees manuelles','Fichier d''abcisses','Annuler','Entrees manuelles');
    else
        Reponse = questdlg('Draw with :','Data selection','Manual entries','X-coordinates file','Cancel','Manual entries');
    end
    
    switch (Reponse)
    % ouverture d'un fichier d'abscisses    
    case {'Fichier d''abcisses','X-coordinates file'}
        
        % boite de dialogue pour l'ouverture
        if handles.langue == 1
            [filename, pathname] = uigetfile({'*.txt;*.dat;*.TXT;*.DAT', 'Fichiers de donnees (*.txt, *.dat, *.TXT, *.DAT)'},'Ouvrir...');
        else
            [filename, pathname] = uigetfile({'*.txt;*.dat;*.TXT;*.DAT', 'Data file (*.txt, *.dat, *.TXT, *.DAT)'},'Open...');
        end
        
        % si le nom est valide
        if ~isequal(pathname,0) & ~isequal(filename,0)
            
            % Reinitialisation de la frame des parametres
            ViderEditParam(handles);
            
            % Affectation du nom de fichier choisi
            NomFich = [pathname filename];
            
            % Bouton Lancer active
            set(handles.BtLancer,'Enable','on');
            
            % s'il s'agit de la tache fonction quantile
            if IsQuantile == 1
                if handles.langue == 1
                    set(handles.TextParam4,'String','Quantile minimum');
                    set(handles.TextParam5,'String','Quantile maximum');
                else
                    set(handles.TextParam4,'String','Minimal quantile');
                    set(handles.TextParam5,'String','Maximal quantile');
                end
            else
                if handles.langue == 1
                    set(handles.TextParam4,'String','Borne inferieure');
                    set(handles.TextParam5,'String','Borne superieure');
                else
                    set(handles.TextParam4,'String','Inferior limit');
                    set(handles.TextParam5,'String','Superior limit');
                end
            end
            
            % ouverture du fichier
            fid = fopen(NomFich,'r');
            
            % lecture du fichier
            [Abcisses,compteur] = fscanf(fid,'%f');
            
            % fermeture du fichier
            fclose(fid);
            
            % tri des donnees recueillies
            Abcisses = sort(Abcisses);
            
            % borne inf
            set(handles.EditParam4,'String',num2str(Abcisses(1)));
            
            % borne sup
            set(handles.EditParam5,'String',num2str(Abcisses(compteur)));
            
            % nb de points
            set(handles.EditParam6,'String',int2str(compteur));
            
            % OK
            Passe = 1;
        end
        
        
    % pas de fichiers d'abscisses
    case {'Entrees manuelles','Manual entries'}
        
        % Reinitialisation de la frame des parametres
        ViderEditParam(handles);
        
        % Bouton Lancer active
        set(handles.BtLancer,'Enable','on');
        
        % si fonction quantile
        if IsQuantile == 1
                if handles.langue == 1
                    set(handles.TextParam4,'String','Quantile minimum');
                    set(handles.TextParam5,'String','Quantile maximum');
                else
                    set(handles.TextParam4,'String','Minimal quantile');
                    set(handles.TextParam5,'String','Maximal quantile');
                end
            else
                if handles.langue == 1
                    set(handles.TextParam4,'String','Borne inferieure');
                    set(handles.TextParam5,'String','Borne superieure');
                else
                    set(handles.TextParam4,'String','Inferior limit');
                    set(handles.TextParam5,'String','Superior limit');
                end
            end
        
        % OK
        Passe = 1;
        
    % Annulation
    case {'Annuler','Cancel'}
    end
end        

% --------------------------------------------------------------------

function varargout = EditParam3_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam3.

% --------------------------------------------------------------------
% HISTOGRAMME AVEC UN NB DE CLASSES DIFFERENT

function varargout = EditParam6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam6.

% si simulation
if handles.Tache == 1
    
    % nouveau graphe
    hold off;
    
    % lecture de l'espace de travail
    Rep = LitRepEDT(handles);
    
    % fichier de donnees
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    
    % lecture du fichier de donnees
    Rbis = load(FichierDonnees);
    
    % Nb de classe
    NbClasse = round(str2double(get(handles.EditParam6,'String')));
    
    % Histogramme normalise
    [N,X] = hist(Rbis,NbClasse);
    Amp = X(2)-X(1);
    N = N/size(Rbis,1)/Amp;
    bar(X,N,'hist');
    colormap(handles.CouleurHisto);
    
end

% --------------------------------------------------------------------
% AFFICHAGE DANS LA FRAME ESTIMAION SUIVANT LA LOI

function varargout = PopupEstim_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupEstim.

% Nom de la loi selectionnee
NomLoi = LitPopupEstim(handles);

% Noms et nombres de ses parametres
[P1,P2,P3,NbParam]=NomDesParametres(handles,NomLoi);

switch(NbParam)
% 1 seul parametre
case 1
    
    set(handles.TextEstimP1,'Visible','on');
    set(handles.TextEstimP2,'Visible','off');
    set(handles.TextEstimP3,'Visible','off');
    set(handles.TextP1,'Visible','on');
    set(handles.TextP2,'Visible','off');
    set(handles.TextP3,'Visible','off');
    
    % si estimation avec donnees multiples
    if handles.Tache == 26
        if handles.langue == 1
            set(handles.TextP1,'String',[P1 ' moyen']);
            set(handles.TextP4,'String',['variance de ' P1]);
        else
            set(handles.TextP1,'String',['Mean ' P1]);
            set(handles.TextP4,'String',[P1 ' variance']);
        end
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextP4,'Visible','on');
    else
        set(handles.TextP1,'String',P1);
    end
    
case 2
    set(handles.TextEstimP1,'Visible','on');
    set(handles.TextEstimP2,'Visible','on');
    set(handles.TextEstimP3,'Visible','off');
    set(handles.TextP1,'Visible','on');
    set(handles.TextP2,'Visible','on');
    set(handles.TextP3,'Visible','off');
    if handles.Tache == 26
        if handles.langue == 1
            set(handles.TextP1,'String',[P1 ' moyen']);
            set(handles.TextP2,'String',[P2 ' moyen']);
            set(handles.TextP4,'String',['variance de ' P1]);
            set(handles.TextP5,'String',['variance de ' P2]);
        else
            set(handles.TextP1,'String',['Mean ' P1]);
            set(handles.TextP2,'String',['Mean ' P2]);
            set(handles.TextP4,'String',[P1 ' variance']);
            set(handles.TextP5,'String',[P2 ' variance']);
        end
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextP4,'Visible','on');
        set(handles.TextEstimP5,'Visible','on');
        set(handles.TextP5,'Visible','on');
    else
        set(handles.TextP1,'String',P1);
        set(handles.TextP2,'String',P2);
    end
case 3
    set(handles.TextEstimP1,'Visible','on');
    set(handles.TextEstimP2,'Visible','on');
    set(handles.TextEstimP3,'Visible','on');
    set(handles.TextP1,'Visible','on');
    set(handles.TextP2,'Visible','on');
    set(handles.TextP3,'Visible','on');
    if handles.Tache == 26
        if handles.langue == 1
            set(handles.TextP1,'String',[P1 ' moyen']);
            set(handles.TextP2,'String',[P2 ' moyen']);
            set(handles.TextP3,'String',[P3 ' moyen']);
            set(handles.TextP4,'String',['variance de ' P1]);
            set(handles.TextP5,'String',['variance de ' P2]);
            set(handles.TextP6,'String',['variance de ' P3]);
        else
            set(handles.TextP1,'String',['Mean ' P1]);
            set(handles.TextP2,'String',['Mean ' P2]);
            set(handles.TextP3,'String',['Mean ' P3]);
            set(handles.TextP4,'String',[P1 ' variance']);
            set(handles.TextP5,'String',[P2 ' variance']);
            set(handles.TextP6,'String',[P3 ' variance']);
        end
        set(handles.TextEstimP4,'Visible','on');
        set(handles.TextP4,'Visible','on');
        set(handles.TextEstimP5,'Visible','on');
        set(handles.TextP5,'Visible','on');
        set(handles.TextEstimP6,'Visible','on');
        set(handles.TextP6,'Visible','on');
    else
        set(handles.TextP1,'String',P1);
        set(handles.TextP2,'String',P2);
        set(handles.TextP3,'String',P3);
    end
end

% Affectation du nom de la loi
if handles.langue == 1
    handles.Nomloi = NomLoi;
else
    LoiFr = LoiEnToFr(NomLoi);
    handles.Nomloi = LoiFr;
end

% Bouton Lancer active
set(handles.BtLanceEstim,'Enable','on');

% Sauvagarde des variables
guidata(handles.Extremes,handles);

% --------------------------------------------------------------------
% VALEURS PAR DEFAUT

% Loi : nom de la loi (ex : Normale)
% T = tache (ex : 2)

function ValeursParDefaut(handles,Loi,T)
switch (Loi)
case {'Normale','Normal'}
    % parametres de la loi par defaut
    set(handles.EditParam1,'String','0');
    set(handles.EditParam2,'String','1');
    
    % suivant la tache
    switch(T)
        
    % Simulation
    case 1
        
        % Taille de l'echantillon par defaut
        set(handles.EditParam4,'String','10000');
        
        % Nb de jeux de donnees par defaut
        set(handles.EditParam5,'String','1');
        
        % Nb de classes de l'histo par defaut
        set(handles.EditParam6,'String','50');
        
    % Densite, FDR, Survie 
    case {2,3,8}
        
        % Bornes par defaut
        set(handles.EditParam4,'String','-3');
        set(handles.EditParam5,'String','3');
        
        % NB de points par defaut
        set(handles.EditParam6,'String','1000');
        
    % Fonction quantile
    case 4
        
        % quantile min et mas
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        
        % nb de quantiles
        set(handles.EditParam6,'String','1000');
        
    case 5
    case 6
        
    end
    
case {'Lognormale','Lognormal'}
    set(handles.EditParam1,'String','0');
    set(handles.EditParam2,'String','1');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','5');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Chi2'
    set(handles.EditParam1,'String','4');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','10');
        set(handles.EditParam6,'String','2000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Student'
    set(handles.EditParam1,'String','10');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','-5');
        set(handles.EditParam5,'String','5');
        set(handles.EditParam6,'String','2000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Beta1espece'
    set(handles.EditParam1,'String','2');
    set(handles.EditParam2,'String','3');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Gamma'
    set(handles.EditParam1,'String','2');
    set(handles.EditParam2,'String','0.5');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','5');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case {'Exponentielle','Exponential'}
    set(handles.EditParam1,'String','0.5');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','3');
        set(handles.EditParam6,'String','2000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Weibull'
    set(handles.EditParam1,'String','0.5');
    set(handles.EditParam2,'String','2');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','2');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'Pareto'
    set(handles.EditParam1,'String','2');
    set(handles.EditParam2,'String','3');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','10');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case 'GPD'
    set(handles.EditParam1,'String','0.2');
    set(handles.EditParam2,'String','5');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','0');
        set(handles.EditParam5,'String','40');
        set(handles.EditParam6,'String','5000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
case {'Uniforme','Uniform'}
    set(handles.EditParam1,'String','0');
    set(handles.EditParam2,'String','1');
    switch(T)        
    case 1
        set(handles.EditParam4,'String','10000');
        set(handles.EditParam5,'String','1');
        set(handles.EditParam6,'String','50');
    case {2,3,8}
        set(handles.EditParam4,'String','-0.1');
        set(handles.EditParam5,'String','1.1');
        set(handles.EditParam6,'String','1000');
    case 4
        set(handles.EditParam4,'String','0.01');
        set(handles.EditParam5,'String','0.99');
        set(handles.EditParam6,'String','1000');
    case 5
    case 6
    end
end

% --------------------------------------------------------------------
% CHOIX DE LA DENSITE POUR ESTIMATION PAR NOYAU - NORMALE

function varargout = Radio1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Radio1.

% autre densite desactivee
set(handles.Radio2,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA DENSITE POUR ESTIMATION PAR NOYAU - 0.75(1 - xe)

function varargout = Radio2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Radio2.

% autre densite desactivee
set(handles.Radio1,'Value',0);


% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - NORMALE

function varargout = CBNormale_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBNormale.

% desactive "Toutes"
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - LOGNORMALE

function varargout = CBLognormale_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBLognormale.
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - EXPONENTIELLE

function varargout = CBExponentielle_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBExponentielle.
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - GAMMA

function varargout = CBGamma_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBGamma.
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - WEIBULL

function varargout = CBWeibull_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBWeibull.
set(handles.CBToutes,'Value',0);

% --------------------------------------------------------------------
% CHOIX DE LA LOI A TESTER POUR TESTS CENTRAUX - TOUTES

function varargout = CBToutes_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBToutes.

% activation de toutes les lois
set(handles.CBNormale,'Value',1);
set(handles.CBLognormale,'Value',1);
set(handles.CBExponentielle,'Value',1);
set(handles.CBWeibull,'Value',1);
set(handles.CBGamma,'Value',1);

% --------------------------------------------------------------------
function varargout = PopupNiveau_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupNiveau.
disp('PopupNiveau Callback not implemented yet.')


% --------------------------------------------------------------------
% EXECUTION D'UN TEST CENTRAL OU EXPONENTIALITE

function varargout = BtLancerTest_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLancerTest.

% Verification des entrees
V = VerifTest(handles);
if V ~= 1
    switch(V)
    case 2
        if handles.langue == 1
            errordlg('Au moins une loi doit etre cochee','Erreur de saisie','modal');
        else
            errordlg('One or more models must be checked','Error','modal');
        end
    case 3
        if handles.langue == 1
            errordlg('Une seule loi doit etre cochee','Erreur de saisie','modal');
        else
            errordlg('Only one model must be checked','Error','modal');
        end
    case 4
        if handles.langue == 1
            errordlg('Un ou plusieurs champs sont vides','Erreur de saisie','modal');
        else
            errordlg('Empty entries found','Error','modal');
        end
    case 5
        if handles.langue == 1
            errordlg('Le nombre d''exces doit etre compris entre 2 et la taille totale de l''echantillon','Erreur de saisie','modal');
        else
            errordlg('Number of excesses must be between 2 and total sample size','Error','modal');
        end
    case 6
        if handles.langue == 1
            errordlg('Le nombre d''echantillons de bootstrap doit etre strictement positif','Erreur de saisie','modal');
        else
            errordlg('Number of bootstrap samples must be strictly a positive integer','Erreur de saisie','modal');
        end
    case 7
        if handles.langue == 1
            errordlg('La borne inferieure des exces doit toujours etre inferieure e la borne superieure','Erreur de saisie','modal');
        else
            errordlg('Inferior limit of excesses must always be smaller than superior limit.','Error','modal');
        end
    case 8
        if handles.langue == 1
            errordlg('p doit etre compris strictement entre 0 et 1','Erreur de saisie','modal');
        else
            errordlg('p must be strictly between 0 and 1','Error','modal');
        end
    end
    return;
end

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Reinitialisation de la frame de resultats des tests
ViderFrameResultat(handles);

% Actualisation de l'espace des actions
EspaceAction = strvcat(char(handles.Action));
Action = TacheToAction(handles);
EspaceAction = strvcat(Action,EspaceAction);

% Construit le fichier de donnees
if handles.Tache == 11 | handles.Tache == 12
    FichierDonnees = 'Tous';
else
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
end

% DEBUT Construit le fichier resultat

    % Indice du fichier
N = int2str(size(EspaceAction,1));

    % Nom du fichier resulat
FichierResultat = [Rep '/' 'Result' N '.txt'];

% FIN

% Lecture du niveau du test
alpha = LitPopupNiveau(handles);

% DEBUT - Creation du fichier d'echange Tmp
FichierEchange = [Rep '/' 'Tmp' N '.txt'];
fid3 = fopen(FichierEchange,'w');
Rep1 = [Rep '/'];
fprintf(fid3,'%s\n',Rep1);
fprintf(fid3,'%s\n',FichierDonnees);
t = handles.Tache;
t1 = int2str(t);
fprintf(fid3,'%s\n',t1);
fprintf(fid3,'%s\n',FichierResultat);

    % Lois cochees 
Loi = [];
if get(handles.CBCLNormale,'Value') == 1
    fprintf(fid3,'%s\n','Normale');
    Loi = strvcat(Loi,'Normale');
end
if get(handles.CBCLLognormale,'Value') == 1
    fprintf(fid3,'%s\n','Lognormale');
    Loi = strvcat(Loi,'Lognormale');
end
if get(handles.CBCLExpo,'Value') == 1
    fprintf(fid3,'%s\n','Exponentielle');
    Loi = strvcat(Loi,'Exponentielle');
end
if get(handles.CBCLWeibull,'Value') == 1
    fprintf(fid3,'%s\n','Weibull');
    Loi = strvcat(Loi,'Weibull');
end
if get(handles.CBCLGamma,'Value') == 1
    fprintf(fid3,'%s\n','Gamma');
    Loi = strvcat(Loi,'Gamma');
end
if get(handles.CBCLChi2,'Value') == 1
    fprintf(fid3,'%s\n','Chi2');
    Loi = strvcat(Loi,'Chi2');
end
if get(handles.CBCLStudent,'Value') == 1
    fprintf(fid3,'%s\n','Student');
    Loi = strvcat(Loi,'Student');
end
if get(handles.CBCLPareto,'Value') == 1
    fprintf(fid3,'%s\n','Pareto');
    Loi = strvcat(Loi,'Pareto');
end
if get(handles.CBCLGPD,'Value') == 1
    fprintf(fid3,'%s\n','GPD');
    Loi = strvcat(Loi,'GPD');
end
if get(handles.CBCLUnif,'Value') == 1
    fprintf(fid3,'%s\n','Uniforme');
    Loi = strvcat(Loi,'Uniforme');
end
if get(handles.CBCLBeta,'Value') == 1
    fprintf(fid3,'%s\n','Beta');
    Loi = strvcat(Loi,'Beta');
end
    % si 1 seul nb d'exces
if t == 13 | t == 14
    NbExces = get(handles.EditExces,'String');
    fprintf(fid3,'%s\n',NbExces);
else
    fprintf(fid3,'%s\n','0');
end

fprintf(fid3,'%s\n',alpha);
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fclose(fid3);

% FIN Constuction du fichier Tmp

% Bouton Lancer desactive
set(handles.BtLancerTest,'Enable','off');

% Lancement du prog C++
[status result] = unix([handles.Prog ' ' FichierEchange ' 2']);

% Recuperation des resultats

FichierErreur = [Rep '/' 'Erreur.txt'];
if exist(FichierErreur)~=0
    fid4 = fopen(FichierErreur,'r');
    Message = fgets(fid4);
    fclose(fid4);
    delete(FichierErreur);
    if handles.langue == 1
        errordlg(Message,'Erreur de saisie utilisateur','modal');
    else
        errordlg(Message,'User write error','modal');
    end
    set(handles.BtLancerTest,'Enable','on');
    return;
end

% Nouveau graphe
hold off;

% si test centraux donnees simples
if t == 9 | t == 10
    
    % Lecture du fichier resultat
    R = load(FichierResultat);
    
    % Lecture du fichier de donnees
    Rdonnees = load(FichierDonnees);
    
    % Recherche de donnees negatives
    %k = find(Rdonnees <= 0);
    
    % si pas de donnees negatives
%     if isempty(k)
%         
%         % Autres actions faites par le C++
%         ActionEnPlus = repmat('Densite ',size(Loi,1),1);
%         ActionEnPlus = [ActionEnPlus Loi];
%         ActionEnPlus = flipud(ActionEnPlus);
%         
%         % Actualisation de la liste des actions
%         EspaceAction = strvcat(ActionEnPlus,EspaceAction);
%         
%     % si donnees negatives 
%     else
%         % Recherche de la loi Normale
%         L = strvcat(char(Loi));
%         if length('Normale') <= size(L,2)
%             k = find(sum(L~=repmat(['Normale' 32*ones(1,size(L,2)-length('Normale'))],size(L,1),1),2)==0);
%         else
%             k = [];
%         end
%         if ~isempty(k)
%             ActionEnPlus = ['Densite ' Loi(k,:)];
%             EspaceAction = strvcat(ActionEnPlus,EspaceAction);
%         end
%     end

%     if ~isempty(k)
%         L = strvcat(char(Loi));
%         if length('Normale') <= size(L,2)
%             k = find(sum(L~=repmat(['Normale' 32*ones(1,size(L,2)-length('Normale'))],size(L,1),1),2)==0);
%         else
%             k = [];
%         end
%         if ~isempty(k)
%             ActionEnPlus = ['Densite ' Loi(k,:)];
%             EspaceAction = strvcat(ActionEnPlus,EspaceAction);
%         end
%         
%     end

    NbLoiNonPDF = round(R(end));
    if NbLoiNonPDF ~= size(Loi,1)
        if NbLoiNonPDF ~= 0
            if handles.langue == 1
                ActionEnPlus = repmat('Densite ',size(Loi,1) - NbLoiNonPDF,1);
                ListeLoiPDF = R(end - (size(Loi,1) - NbLoiNonPDF) : (end - 1));
                ActionEnPlus = [ActionEnPlus Loi(ListeLoiPDF,:)];
            else
                ActionEnPlus = repmat(' PDF',size(Loi,1) - NbLoiNonPDF,1);
                ListeLoiPDF = R(end - (size(Loi,1) - NbLoiNonPDF) : (end - 1));
                
                Loi = cellstr(Loi);
                LoiEn = [];
                for i=1:size(Loi,1)
                    LoiEnTemp = LoiFrToEn(char(Loi(i)));
                    LoiEn = strvcat(LoiEn,LoiEnTemp);
                end
                LoiEn = cellstr(LoiEn);
                
                ActionEnPlus = strcat(LoiEn(ListeLoiPDF),ActionEnPlus);
                %ActionEnPlus = [Loi(ListeLoiPDF,:) ActionEnPlus];
            end
            ActionEnPlus = flipud(ActionEnPlus);
       
            % Actualisation de la liste des actions
            EspaceAction = strvcat(char(ActionEnPlus),EspaceAction);
        else
            if handles.langue == 1
                ActionEnPlus = repmat('Densite ',size(Loi,1),1);
                ActionEnPlus = [ActionEnPlus Loi];
            else
                ActionEnPlus = repmat(' PDF',size(Loi,1),1);
                Loi = cellstr(Loi);
                LoiEn = [];
                for i=1:size(Loi,1)
                    LoiEnTemp = LoiFrToEn(char(Loi(i)));
                    LoiEn = strvcat(LoiEn,LoiEnTemp);
                end
                LoiEn = cellstr(LoiEn);
                ActionEnPlus = strcat(LoiEn,ActionEnPlus);
            end
            
            %ActionEnPlus = [Loi ActionEnPlus];
            ActionEnPlus = flipud(ActionEnPlus);
        
            % Actualisation de la liste des actions
            EspaceAction = strvcat(char(ActionEnPlus),EspaceAction);
        end
    end
        
    % Affichage des lois selectionnees
    Loi = cellstr(Loi);    
    if handles.langue == 1
        set(handles.PopupResultat,'Value',1);
        set(handles.PopupResultat,'String',Loi);
    else
        LoiEn = [];
        for i=1:size(Loi,1)
            LoiEnTemp = LoiFrToEn(char(Loi(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultat,'Value',1);
        set(handles.PopupResultat,'String',LoiEn);
    end
   
    % Affichage des noms et des valeurs des parametres de la 1ere loi
    [P1,P2,P3,NbParam]=NomDesParametres(handles,char(Loi(1)));
    
    % si 1 seul parametre
    if NbParam == 1
        R1 = sprintf('%f',R(1));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);  % Affiache du parametre estime
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);  % Affiache du parametre estime
        if R(2) == 1
            if handles.langue == 1
                R2 = 'Accepte';
            else
                R2 = 'Accepted';
            end
        else
            if handles.langue == 1
                R2 = 'Rejete';
            else
                R2 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R2);  % Affichage de la decision
        R3 = sprintf('%f',R(3));
        if str2num(R3) ~= 0
            set(handles.TextResultatStat,'String',R3);      % affichage de la statistique de test
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatStat,'String',R3);      % affichage de la statistique de test
        R4 = sprintf('%f',R(4));
        if str2num(R4) ~= 0
            set(handles.TextResultatRejet,'String',R4);     % Affichage de la valeur de rejet
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatRejet,'String',R4);     % Affichage de la valeur de rejet
    end
    if NbParam == 2
        R1 = sprintf('%f',R(1));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        if R(3) == 1
            if handles.langue == 1
                R3 = 'Accepte';
            else
                R3 = 'Accepted';
            end
        else
            if handles.langue == 1
                R3 = 'Rejete';
            else
                R3 = 'Rejected';
            end   
        end
        set(handles.TextResultatDecision,'String',R3);
        R4 = sprintf('%f',R(4));
        if str2num(R4) ~= 0
            set(handles.TextResultatStat,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatStat,'String',R4);
        R5 = sprintf('%f',R(5));
        if str2num(R5) ~= 0
            set(handles.TextResultatRejet,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatRejet,'String',R5);
    end    
    if NbParam == 3
        R1 = sprintf('%f',R(1));
        if str2num(R1)
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        R3 = sprintf('%f',R(3));
        if str2num(R3) ~= 0
            set(handles.TextResultatValeurP3,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP3,'String','non');
            else
                set(handles.TextResultatValeurP3,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatValeurP3,'String',R3);
        if R(4) == 1
            if handles.langue == 1
                R4 = 'Accepte';
            else
                R4 = 'Accepted';
            end
        else
            if handles.langue == 1
                R4 = 'Rejete';
            else
                R4 = 'Rejected';
            end   
        end
        set(handles.TextResultatDecision,'String',R4);
        R5 = sprintf('%f',R(5));
        if str2num(R5) ~= 0
            set(handles.TextResultatStat,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatStat,'String',R5);
        R6 = sprintf('%f',R(6));
        if str2num(R6) ~= 0
            set(handles.TextResultatRejet,'String',R6);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R6 = num2str(R6);
        %set(handles.TextResultatRejet,'String',R6);
    end
    
    % Noms des parametres
    if handles.langue == 1
        P1 = [P1 ' estime'];
        if ~isempty(P2)
            P2 = [P2 ' estime'];
        end
        if ~isempty(P3)
            P3 = [P3 ' estime'];
        end
    else
        P1 = ['estimated ' P1];
        if ~isempty(P2)
            P2 = ['estimated ' P2];
        end
        if ~isempty(P3)
            P3 = ['estimated ' P3];
        end
    end
    
    % Affichage du noms des parametres
    set(handles.TextResultatP1,'String',P1);
    set(handles.TextResultatP2,'String',P2);
    set(handles.TextResultatP3,'String',P3);
    
    % affichage des resultats
    FrameResultatVisible(handles);
    switch(NbParam)
    case 1
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','off');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','off');
        set(handles.TextResultatValeurP3,'Visible','off');
    case 2
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','off');
    case 3
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','on');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','on');
    end
    
    % Histogramme normalise
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(Rdonnees,NbClasse);
    Amp = X(2)-X(1);
    K = K/size(Rdonnees,1)/Amp;
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % on garde le meme graphique
    hold on;
    
    % Recherche du nombre d'actions faites en plus
    M = size(EspaceAction,1);
    N = str2num(N);
    
    % courbes des densites
    couleur = strvcat('r','g','b','c','m','y','k','g:','b:','m:','k:');
    compt = 1;
    for i=N+1:M
        j = int2str(i);
        FichierResultat = [Rep '/' 'Result' j '.txt'];
        R = load(FichierResultat);
        plot(R(:,1),R(:,2),couleur(compt,:));
        compt = compt + 1;
    end
    
    % Titre du graphique
    if NbLoiNonPDF ~= size(Loi,1)
        if handles.langue == 1
            title('Histogramme - Densites avec parametres estimes','Color','r');
        else
            title('Histogram - Probability density functions with estimated parameters','Color','r');
        end
    else
        if handles.langue == 1
            title('Histogramme','Color','r');
        else
            title('Histogram','Color','r');
        end
    end
    
    % Legende
%     switch(M-N)
%     case 1
%         legend(char(Loi(1)));
%     case 2
%         legend(char(Loi(1)),char(Loi(2)));
%     case 3
%         legend(char(Loi(1)),char(Loi(2)),char(Loi(3)));
%     case 4
%         legend(char(Loi(1)),char(Loi(2)),char(Loi(3)),char(Loi(4)));
%     case 5
%         legend(char(Loi(1)),char(Loi(2)),char(Loi(3)),char(Loi(4)),char(Loi(5)));
%     end
    if NbLoiNonPDF ~= size(Loi,1)
        if NbLoiNonPDF ~= 0
            legende = strvcat(char(Loi(ListeLoiPDF,:)));
            if handles.langue == 1
                legend(legende);
            else
                LoiEn = [];
                legende = cellstr(legende);
                for i=1:size(legende,1)
                    LoiTemp = LoiFrToEn(char(legende(i)));
                    LoiEn = strvcat(LoiEn,LoiTemp);
                end
                legend(LoiEn);
            end
        else
            if handles.langue == 1
                legend(char(Loi));
            else
                LoiEn = [];
                for i=1:size(Loi,1)
                    LoiTemp = LoiFrToEn(char(Loi(i)));
                    LoiEn = strvcat(LoiEn,LoiTemp);
                end
                legend(LoiEn);
            end
        end
    end
  
end

% si donnees multiples
if t == 11 | t == 12 | t == 14;
    
    % Lecture du fichiers resultats
    [R]=textread(FichierResultat,'%s','delimiter','\n','whitespace','');
    
    % Nouveau graphe
    hold off;
    
    % Affichage du % de rejet et d'acception et d'ecart-type
    X = [0,1,2];
    R1 = str2num(char(R));
    bar(X(1:2),R1(1:2),'r');
    hold on;
    bar(X(3),R1(3),'y');
    if handles.langue == 1
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % de rejet'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % d''acceptation'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % d''ecart-type'],'HorizontalAlignment','center','Color','r');
    else
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % rejection'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % acceptance'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % standard deviation'],'HorizontalAlignment','center','Color','r');
    end
    
    % Bornes du graphique
    axis([-1 3 0 110]);
    
    % titre
    if handles.langue == 1
        title('Pourcentage d''acceptation et de rejet et Ecart-type','Color','r');
    else
        title('Acceptance and rejection percentage and standard deviation','Color','r');
    end
    
end

% QQ-Plot
if t == 13
    
    % Lecture du fichier resultat
    R = load(FichierResultat);
    
    hold off;
    
    % affichage de la droite y = muchap * x
    Abscisse = 0:0.1:R(end-2,1);
    plot(Abscisse,R(end-1,1)*Abscisse,'b');
    
    hold on;
    
    % test accepte
    if R(end,1) == 1
        % qq-plot
        plot(R(1:end-2,1),R(1:end-2,2),'g.');
        if handles.langue == 1
            legend('droite y = muchap * x','test accepte');
        else
            legend('curve y = muchap * x','test accepted');
        end
        
    % test rejete
    else
        % qq-plot
        plot(R(1:end-2,1),R(1:end-2,2),'r.');
        if handles.langue == 1
            legend('droite y = muchap * x','test refuse');
        else
            legend('curve y = muchap * x','test rejected');
        end
    end
    % Titre du graphique
    if handles.langue == 1
        title('Graphe QQ-Plot','Color','r');
    else
        title('QQ-Plot graph','Color','r');
    end
    
end

% Test d'exponentialite avec plusieurs nb d'exces
if t == 15
    
    % lecture du fichier resultat
    R = load(FichierResultat);
    
    hold off;
    
    % test accepte
    area(R(:,1),R(:,2),'FaceColor','g','EdgeColor','g');
    
    hold on;
    
    % test rejete
    area(R(:,1),1-R(:,2),'FaceColor','r','EdgeColor','r');
    
    % bornes du graphique
    axis([R(1,1) R(end,1) -0.5 1.5]);
    
    if handles.langue == 1
        % Titre du graphique
        title('Plage d''acceptation du test','Color','r');
        
        % Legende
        legend('Test accepte','Test rejete');
    else
        title('Test acceptance region','Color','r');
        legend('Test accepted','Test rejected');
    end
end

% Affichage de la nouvelle liste des actions
handles.Action = cellstr(EspaceAction);
set(handles.PopupAction,'String',handles.Action);
set(handles.PopupAction,'Value',1);

% Sauvegarde des variables
guidata(handles.Extremes,handles);

% Actualise le fichier des actions
FichierAction = [Rep '/' 'Action.txt'];
fid1 = fopen(FichierAction,'a');
fprintf(fid1,'%s\n',Action);
if (t == 9 | t == 10) & (NbLoiNonPDF ~= size(Loi,1))
    ActionEnPlus = flipud(ActionEnPlus);
    ActionEnPlus = cellstr(ActionEnPlus);
    for i=1:size(ActionEnPlus,1)
        fprintf(fid1,'%s\n',char(ActionEnPlus(i)));
    end
end
fclose(fid1);

% Actualise le fichier des numeros de taches
FichierTache = [Rep '/' 'Tache.txt'];
fid2 = fopen(FichierTache,'a');
fprintf(fid2,'%d\n',t);
if (t == 9 | t == 10) & (NbLoiNonPDF ~= size(Loi,1))
    for i=1:size(ActionEnPlus,1)
        fprintf(fid1,'%d\n',2);
    end
end
fclose(fid2);

hold off;

% Aucune action en cours
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% AFFICHAGE DES RESULTATS DES TESTS CENTRAUX SUIVANT LA LOI SELECTIONNEE

function varargout = popupmenu8_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.popupmenu8.

% Reinitilisation de la frame des resultats des tests
ViderFrameResultat(handles);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recuperation de la listes des actions
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;

% Index de l'action affichee 
IndexInverse = IndexInverse';

% Recherche de la bonne action
if (strcmp(get(handles.TextTest,'String'),'Anderson-Darling')==1)
    if handles.langue == 1
        X = 'Test Anderson-Darling';
    else
        X = 'Anderson-Darling test';
    end
end
if (strcmp(get(handles.TextTest,'String'),'Cramer-Von Mises')==1)
    if handles.langue == 1
        X = 'Test Cramer-Von Mises';
    else
        X = 'Cramer-Von Mises test';
    end
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end

% Bon Index
k1 = int2str(k(end));

% Bon fichier resultat
FichierResult = [Rep '/' 'Result' k1 '.txt'];

% Lecture du fichier resultat
R = load(FichierResult);

% Index de la loi selectionnee
I = get(handles.PopupResultat,'Value');

% Liste des lois testees
ListeLoi = get(handles.PopupResultat,'String');

% Nom de la loi selectionnee
LoiSelect = ListeLoi{I};

% Noms et nb des parametres de la loi selectionnee
[P1,P2,P3,NbParam] = NomDesParametres(handles,LoiSelect);

% Affichage des noms des parametres
if handles.langue == 1
    P1 = [P1 ' estime'];
    if ~isempty(P2)
        P2 = [P2 ' estime'];
    end
    if ~isempty(P3)
        P3 = [P3 ' estime'];
    end
else
    P1 = ['estimated ' P1];
    if ~isempty(P2)
        P2 = ['estimated ' P2];
    end
    if ~isempty(P3)
        P3 = ['estimated ' P3];
    end
end
set(handles.TextResultatP1,'String',P1);
set(handles.TextResultatP2,'String',P2);
set(handles.TextResultatP3,'String',P3);

% Recherche dans la liste la loi exponentielle (car 1 seul parametre)
if handles.langue == 1
    X = 'Exponentielle';
else
    X = 'Exponential';
end
ListeLoi = strvcat(char(ListeLoi));
if length(X)<=size(ListeLoi,2)
    k1 = find(sum(ListeLoi~=repmat([X 32*ones(1,size(ListeLoi,2)-length(X))],size(ListeLoi,1),1),2)==0);
else
    k1 = [];
end

% Recherche dans la liste la loi Chi2 (car 1 seul parametre)
X = 'Chi2';
%ListeLoi = strvcat(char(ListeLoi));
if length(X)<=size(ListeLoi,2)
    k2 = find(sum(ListeLoi~=repmat([X 32*ones(1,size(ListeLoi,2)-length(X))],size(ListeLoi,1),1),2)==0);
else
    k2 = [];
end

% Recherche dans la liste la loi de student (car 1 seul parametre)
X = 'Student';
%ListeLoi = strvcat(char(ListeLoi));
if length(X)<=size(ListeLoi,2)
    k3 = find(sum(ListeLoi~=repmat([X 32*ones(1,size(ListeLoi,2)-length(X))],size(ListeLoi,1),1),2)==0);
else
    k3 = [];
end

k = [k1 k2 k3];

% si exponentielle,chi2 ou student pas presentes ou apres celle selectionnee, pas de decalage
if isempty(k) | min(k)>=I
    
    % 1 seul parametre
    if NbParam == 1
        
        % Affichage des resultats
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','off');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','off');
        set(handles.TextResultatValeurP3,'Visible','off');
        R1 = sprintf('%f',R(1 + (I-1) * 5));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        if R(2 + (I-1) * 5) == 1
            if handles.langue == 1
                R2 = 'Accepte';
            else
                R2 = 'Accepted';
            end
        else
            if handles.langue == 1
                R2 = 'Rejete';
            else
                R2 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R2);
        R3 = sprintf('%f',R(3 + (I-1) * 5));
        if str2num(R3) ~= 0
            set(handles.TextResultatStat,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatStat,'String',R3);
        R4 = sprintf('%f',R(4 + (I-1) * 5));
        if str2num(R4) ~= 0
            set(handles.TextResultatRejet,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatRejet,'String',R4);
    end
    if NbParam == 2
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','off');
        R1 = sprintf('%f',R(1 + (I-1) * 5));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2 + (I-1) * 5));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        if R(3 + (I-1) * 5) == 1
            if handles.langue == 1
                R3 = 'Accepte';
            else
                R3 = 'Accepted';
            end
        else
            if handles.langue == 1
                R3 = 'Rejete';
            else
                R3 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R3);
        R4 = sprintf('%f',R(4 + (I-1) * 5));
        if str2num(R4) ~= 0
            set(handles.TextResultatStat,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatStat,'String',R4);
        R5 = sprintf('%f',R(5 + (I-1) * 5));
        if str2num(R5) ~= 0
            set(handles.TextResultatRejet,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatRejet,'String',R5);
    end    
    if NbParam == 3
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','on');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','on');
        R1 = sprintf('%f',R(1 + (I-1) * 5));
        if str2num(R1)
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(2 + (I-1) * 5));
        if str2num(R2)
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        R3 = sprintf('%f',R(3 + (I-1) * 5));
        if str2num(R3) ~= 0
            set(handles.TextResultatValeurP3,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP3,'String','non');
            else
                set(handles.TextResultatValeurP3,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatValeurP3,'String',R3);
        if R(4 + (I-1) * 5) == 1
            if handles.langue == 1
                R4 = 'Accepte';
            else
                R4 = 'Accepted';
            end
        else
            if handles.langue == 1
                R4 = 'Rejete';
            else
                R4 = 'Rejected';
            end
        end
        R4 = sprintf('%d',R(4 + (I-1) * 5));
        R4 = num2str(R4);
        set(handles.TextResultatDecision,'String',R4);
        R5 = sprintf('%f',R(5 + (I-1) * 5));
        if str2num(R5) ~= 0
            set(handles.TextResultatStat,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatStat,'String',R5);
        R6 = sprintf('%f',R(6 + (I-1) * 5));
        if str2num(R6)
            set(handles.TextResultatRejet,'String',R6);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R6 = num2str(R6);
        %set(handles.TextResultatRejet,'String',R6);   
    end

% sinon, decalage
else
    k4 = find(I > k);
    Decale = size(k4,2) - 1;
    if NbParam == 1
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','off');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','off');
        set(handles.TextResultatValeurP3,'Visible','off');
        R1 = sprintf('%f',R((I-1) * 5 - Decale));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        if R(1 + (I-1) * 5 - Decale) == 1
            if handles.langue == 1
                R2 = 'Accepte';
            else
                R2 = 'Accepted';
            end
        else
            if handles.langue == 1
                R2 = 'Rejete';
            else
                R2 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R2);
        R3 = sprintf('%f',R(2 + (I-1) * 5 - Decale));
        if str2num(R3) ~= 0
            set(handles.TextResultatStat,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatStat,'String',R3);
        R4 = sprintf('%f',R(3 + (I-1) * 5 - Decale));
        if str2num(R4) ~= 0
            set(handles.TextResultatRejet,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatRejet,'String',R4);
    end
    if NbParam == 2
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','off');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','off');
        R1 = sprintf('%f',R((I-1) * 5 - Decale));
        if str2num(R1) ~= 0
            %R1 = num2str(R1);
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(1 + (I-1) * 5 - Decale));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        if R(2 + (I-1) * 5 - Decale) == 1
            if handles.langue == 1
                R3 = 'Accepte';
            else
                R3 = 'Accepted';
            end
        else
            if handles.langue == 1
                R3 = 'Rejete';
            else
                R3 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R3);
        R4 = sprintf('%f',R(3 + (I-1) * 5 - Decale));
        if str2num(R4) ~= 0
            set(handles.TextResultatStat,'String',R4);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R4 = num2str(R4);
        %set(handles.TextResultatStat,'String',R4);
        R5 = sprintf('%f',R(4 + (I-1) * 5 - Decale));
        if str2num(R5) ~= 0
            set(handles.TextResultatRejet,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatRejet,'String',R5);
    end    
    if NbParam == 3
        set(handles.TextResultatP1,'Visible','on');
        set(handles.TextResultatP2,'Visible','on');
        set(handles.TextResultatP3,'Visible','on');
        set(handles.TextResultatValeurP1,'Visible','on');
        set(handles.TextResultatValeurP2,'Visible','on');
        set(handles.TextResultatValeurP3,'Visible','on');
        R1 = sprintf('%f',R((I-1) * 5 - Decale));
        if str2num(R1) ~= 0
            set(handles.TextResultatValeurP1,'String',R1);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP1,'String','non');
            else
                set(handles.TextResultatValeurP1,'String','no');
            end
        end
        %R1 = num2str(R1);
        %set(handles.TextResultatValeurP1,'String',R1);
        R2 = sprintf('%f',R(1 + (I-1) * 5 - Decale));
        if str2num(R2) ~= 0
            set(handles.TextResultatValeurP2,'String',R2);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP2,'String','non');
            else
                set(handles.TextResultatValeurP2,'String','no');
            end
        end
        %R2 = num2str(R2);
        %set(handles.TextResultatValeurP2,'String',R2);
        R3 = sprintf('%f',R(2 + (I-1) * 5 - Decale));
        if str2num(R3) ~= 0
            set(handles.TextResultatValeurP3,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatValeurP3,'String','non');
            else
                set(handles.TextResultatValeurP3,'String','no');
            end
        end
        %R3 = num2str(R3);
        %set(handles.TextResultatValeurP3,'String',R3);
        if R(3 + (I-1) * 5 - Decale) == 1
            if handles.langue == 1
                R4 = 'Accepte';
            else
                R4 = 'Accepted';
            end
        else
            if handles.langue == 1
                R4 = 'Rejete';
            else
                R4 = 'Rejected';
            end
        end
        set(handles.TextResultatDecision,'String',R4);
        R5 = sprintf('%f',R(4 + (I-1) * 5 - Decale));
        if str2num(R5) ~= 0
            set(handles.TextResultatStat,'String',R5);
        else
            if handles.langue == 1
                set(handles.TextResultatStat,'String','non');
            else
                set(handles.TextResultatStat,'String','no');
            end
        end
        %R5 = num2str(R5);
        %set(handles.TextResultatStat,'String',R5);
        R6 = sprintf('%f',R(5 + (I-1) * 5 - Decale));
        if str2num(R6) ~= 0
            set(handles.TextResultatRejet,'String',R6);
        else
            if handles.langue == 1
                set(handles.TextResultatRejet,'String','non');
            else
                set(handles.TextResultatRejet,'String','no');
            end
        end
        %R6 = num2str(R6);
        %set(handles.TextResultatRejet,'String',R6);   
    end
end


% --------------------------------------------------------------------
function varargout = EditExces_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExces.
disp('EditExces Callback not implemented yet.')


% --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - NORMALE
% 
% function varargout = checkbox8_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox8.
% set(handles.CBToutesET,'Value',0);
% 
% 
% % --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - LOGNORMALE
% 
% function varargout = checkbox9_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox9.
% set(handles.CBToutesET,'Value',0);
% 
% 
% % --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - EXPONENTIELLE
% 
% function varargout = checkbox10_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox10.
% set(handles.CBToutesET,'Value',0);
% 
% 
% % --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - WEIBULL
% 
% function varargout = checkbox11_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox11.
% set(handles.CBToutesET,'Value',0);
% 
% 
% % --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - GAMMA
% 
% function varargout = checkbox12_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox12.
% set(handles.CBToutesET,'Value',0);


% --------------------------------------------------------------------
% % CHOIX DE LA LOI A TESTER POUR TESTS ET - TOUTES
% 
% function varargout = checkbox13_Callback(h, eventdata, handles, varargin)
% % Stub for Callback of the uicontrol handles.checkbox13.
% 
% % toutes les lois activees
% set(handles.CBNormaleET,'Value',1);
% set(handles.CBLognormaleET,'Value',1);
% set(handles.CBExponentielleET,'Value',1);
% set(handles.CBWeibullET,'Value',1);
% set(handles.CBGammaET,'Value',1);

% --------------------------------------------------------------------
% PREPARATION POUR L'AFFICHAGE EN FONCTION DE LA VERSION DU TEST ET CHOISIE

function varargout = PopupVersionET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupVersionET.

% Lecture de la version du test
R = LitPopupVersionET(handles);

% Determination du bon numero de tache
if handles.Tache >= 16 & handles.Tache <= 24
    Version = 'ET';
    k = find([16:1:24] == handles.Tache);
else
    Version = 'GPD';
    k = find([38:1:46] == handles.Tache);
end

switch(R)
    
case {'Asymptotique','Asymptotic'}
    
    % Pas d'echantillons de bootstrap
    set(handles.TextBootstrapET,'Visible','off');
    set(handles.EditBootstrapET,'Visible','off');
    
    switch (Version)
    case 'ET'
        if k <= 3
            handles.Tache = 16;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 19;
        end
        if k > 6
            handles.Tache = 22;
        end
    case 'GPD'
        if k <= 3
            handles.Tache = 38;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 41;
        end
        if k > 6
            handles.Tache = 44;
        end
    end
        
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
case {'Bootstrap parametrique','Parametric bootstrap'}
    
    % Echantillons de bootstrap permis
    set(handles.TextBootstrapET,'Visible','on');
    set(handles.EditBootstrapET,'Visible','on');
    
    switch(Version)
    case 'ET'
        if k <= 3
            handles.Tache = 17;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 20;
        end
        if k > 6
            handles.Tache = 23;
        end
    case 'GPD'
        if k <= 3
            handles.Tache = 39;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 42;
        end
        if k > 6
            handles.Tache = 45;
        end
    end
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
case {'Bootstrap parametrique simplifie','Simplified parametric bootstrap'}
    
    % Echntilloons de bootstrap permis
    set(handles.TextBootstrapET,'Visible','on');
    set(handles.EditBootstrapET,'Visible','on');
    
    switch(Version)
    case 'ET'
        if k <= 3
            handles.Tache = 18;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 21;
        end
        if k > 6
            handles.Tache = 24;
        end
    case 'GPD'
        if k <= 3
            handles.Tache = 40;
        end
        if (k > 3) & (k <= 6)
            handles.Tache = 43;
        end
        if k > 6
            handles.Tache = 46;
        end
    end
   
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
    
end

% --------------------------------------------------------------------

function varargout = PopupNiveauET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupNiveauET.
disp('PopupNiveauET Callback not implemented yet.')

% --------------------------------------------------------------------
function varargout = EditExcesInf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExcesInf.
disp('EditExcesInf Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditExcesSup_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExcesSup.
disp('EditExcesSup Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditBootstrapET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditBootstrapET.
disp('EditBootstrapET Callback not implemented yet.')


% --------------------------------------------------------------------
% EXECUTION DU TEST ET ou GPD

function varargout = BtLancerET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLancerET.
V = VerifTest(handles);
if V ~= 1
    switch(V)
        case 2
            if handles.langue == 1
                errordlg('Au moins une loi doit etre cochee','Erreur de saisie','modal');
            else
                errordlg('One or more models must be checked','Error','modal');
            end
        case 3
            if handles.langue == 1
                errordlg('Une seule loi doit etre cochee','Erreur de saisie','modal');
            else
                errordlg('Only one model must be checked','Error','modal');
            end
        case 4
            if handles.langue == 1
                errordlg('Un ou plusieurs champs sont vides','Erreur de saisie','modal');
            else
                errordlg('Empty entries found','Error','modal');
            end
        case 5
            if handles.langue == 1
                errordlg('Le nombre d''exces doit etre compris entre 2 et la taille totale de l''echantillon','Erreur de saisie','modal');
            else
                errordlg('Number of excesses must be between 2 and total sample size','Error','modal');
            end
        case 6
            if handles.langue == 1
                errordlg('Le nombre d''echantillons de bootstrap doit etre strictement positif','Erreur de saisie','modal');
            else
                errordlg('Number of bootstrap samples must be strictly a positive integer','Erreur de saisie','modal');
            end
        case 7
            if handles.langue == 1
                errordlg('La borne inferieure des exces doit toujours etre inferieure e la borne superieure','Erreur de saisie','modal');
            else
                errordlg('Inferior limit of excesses must always be smaller than superior limit.','Error','modal');
            end
        case 8
            if handles.langue == 1
                errordlg('L''ordre du quantile ET doit etre compris entre 0 et 1 strictement','Erreur de saisie','modal');
            else
                errordlg('Order of ET quantile must be strictly between 0 and 1','Error','modal');
            end
        case 9
            if handles.langue == 1
                errordlg('Une methode d''estimation du couple (gamma,sigma) doit etre cochee','Erreur de saisie','modal');
            else
                errordlg('One or more estimate method of (gamma,sigma) must be checked','Error','modal');
            end
        case 10
            if handles.langue == 1
                errordlg('Une seule methode d''estimation du couple (gamma,sigma) doit etre cochee','Erreur de saisie','modal');
            else
                errordlg('Only one estimate method of (gamma,sigma) must be checked','Error','modal');
            end
        case 11
            if handles.langue == 1
                errordlg('Cette version du test n''est pas disponible','Erreur de saisie','modal');
            else
                errordlg('This version of test is not available','Error','modal');
            end
    end
    return;
end

EspaceAction = strvcat(char(handles.Action));
Action = TacheToAction(handles);
EspaceAction = strvcat(Action,EspaceAction);
%Construit le fichier de donnees
Rep = LitRepEDT(handles);
if handles.Tache == 16 | handles.Tache == 17 | handles.Tache == 18 | handles.Tache == 38 | handles.Tache == 39 | handles.Tache == 40
    FichierDonnees = 'Tous';
else
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
end
%Construit le fichier resultat
N = int2str(size(EspaceAction,1));
FichierResultat = [Rep '/' 'Result' N '.txt'];
%Parametres
alpha = LitPopupNiveauET(handles);
%Cree le fichier d'echange Tmp
FichierEchange = [Rep '/' 'Tmp' N '.txt'];
fid3 = fopen(FichierEchange,'w');
Rep1 = [Rep '/'];
fprintf(fid3,'%s\n',Rep1);
fprintf(fid3,'%s\n',FichierDonnees);
t = handles.Tache;
t1 = int2str(t);
fprintf(fid3,'%s\n',t1);
fprintf(fid3,'%s\n',FichierResultat);
Loi = [];
if get(handles.CBCLNormale,'Value') == 1
    fprintf(fid3,'%s\n','Normale');
    Loi = strvcat(Loi,'Normale');
end
if get(handles.CBCLLognormale,'Value') == 1
    fprintf(fid3,'%s\n','Lognormale');
    Loi = strvcat(Loi,'Lognormale');
end
if get(handles.CBCLExpo,'Value') == 1
    fprintf(fid3,'%s\n','Exponentielle');
    Loi = strvcat(Loi,'Exponentielle');
end
if get(handles.CBCLWeibull,'Value') == 1
    fprintf(fid3,'%s\n','Weibull');
    Loi = strvcat(Loi,'Weibull');
end
if get(handles.CBCLGamma,'Value') == 1
    fprintf(fid3,'%s\n','Gamma');
    Loi = strvcat(Loi,'Gamma');
end
if get(handles.CBCLChi2,'Value') == 1
    fprintf(fid3,'%s\n','Chi2');
    Loi = strvcat(Loi,'Chi2');
end
if get(handles.CBCLStudent,'Value') == 1
    fprintf(fid3,'%s\n','Student');
    Loi = strvcat(Loi,'Student');
end
if get(handles.CBCLPareto,'Value') == 1
    fprintf(fid3,'%s\n','Pareto');
    Loi = strvcat(Loi,'Pareto');
end
if get(handles.CBCLGPD,'Value') == 1
    fprintf(fid3,'%s\n','GPD');
    Loi = strvcat(Loi,'GPD');
end
if get(handles.CBCLUnif,'Value') == 1
    fprintf(fid3,'%s\n','Uniforme');
    Loi = strvcat(Loi,'Uniforme');
end
if get(handles.CBCLBeta,'Value') == 1
    fprintf(fid3,'%s\n','Beta');
    Loi = strvcat(Loi,'Beta');
end

if t == 16 | t == 17 | t == 18 | t == 19 | t == 20 | t == 21 | t == 38 | t == 39 | t == 40 | t == 41 | t == 42 | t == 43
    NbExces = get(handles.EditExcesSup,'String');
    fprintf(fid3,'%s\n',NbExces);
else
    fprintf(fid3,'%s\n','0');
end

fprintf(fid3,'%s\n',alpha);

if t == 22 | t == 23 | t == 24 | t == 44 | t == 45 | t == 46
    ExcesInf = get(handles.EditExcesInf,'String');
    ExcesSup = get(handles.EditExcesSup,'String');
    fprintf(fid3,'%s\n',ExcesInf);
    fprintf(fid3,'%s\n',ExcesSup);
else
    fprintf(fid3,'%s\n','0');
    fprintf(fid3,'%s\n','0');
end

Version = LitPopupVersionET(handles);
switch(Version)
case {'Asymptotique','Asymptotic'}
    fprintf(fid3,'%s\n','1');
    fprintf(fid3,'%s\n','0');
case {'Bootstrap parametrique','Parametric bootstrap'}
    NbBP = get(handles.EditBootstrapET,'String');
    fprintf(fid3,'%s\n','2');
    fprintf(fid3,'%s\n',NbBP);
case {'Bootstrap parametrique simplifie','Simplified parametric bootstrap'}
    NbBP = get(handles.EditBootstrapET,'String');
    fprintf(fid3,'%s\n','3');
    fprintf(fid3,'%s\n',NbBP);
end
p = get(handles.EditPET,'String');
fprintf(fid3,'%s\n',p);

% lecture de la methode employee
if handles.Tache >= 38 & handles.Tache <= 46
    if get(handles.CBCMHW,'Value') == 1
        fprintf(fid3,'%s\n','HW');
        Methode = 'HW'; 
    end
    if get(handles.CBCMEMV,'Value') == 1
        fprintf(fid3,'%s\n','EMV');
        Methode = 'EMV';
    end
    if get(handles.CBCMHill,'Value') == 1
        fprintf(fid3,'%s\n','Hill');
        Methode = 'Hill';
    end
    if get(handles.CBCMHillG,'Value') == 1
        fprintf(fid3,'%s\n','HillG');
        Methode = 'HillG';
    end
    if get(handles.CBCMZipf,'Value') == 1
        fprintf(fid3,'%s\n','Zipf');
        Methode = 'Zipf';
    end
end
fclose(fid3);
set(handles.BtLancerET,'Enable','off');

%lancement du prog C++
[status result] = unix([handles.Prog ' ' FichierEchange ' 2']);

FichierErreur = [Rep '/' 'Erreur.txt'];
if exist(FichierErreur)~=0
    fid4 = fopen(FichierErreur,'r');
    Message = fgets(fid4);
    fclose(fid4);
    delete(FichierErreur);
    if handles.langue == 1
        errordlg(Message,'Erreur de saisie utilisateur','modal');
    else
        errordlg(Message,'User write error','modal');
    end
    set(handles.BtLancerET,'Enable','on');
    return;
end

%Resultat
if t == 19 | t == 20 | t == 21 | t == 41 | t == 42 | t == 43 
    %[R]=textread(FichierResultat,'%s','delimiter','\n','whitespace','');
    R = load(FichierResultat);
    %affectation de la PopupResultat
    Loi = cellstr(Loi);
    set(handles.PopupResultatET,'Value',1);
    
    if handles.langue == 1
        set(handles.PopupResultatET,'String',Loi);
    else
        LoiEn = [];
        for i=1:size(Loi,1)
            LoiEnTemp = LoiFrToEn(char(Loi(i)));
            LoiEn = strvcat(LoiEn,LoiEnTemp);
        end
        LoiEn = cellstr(LoiEn);
        set(handles.PopupResultatET,'String',LoiEn);
    end
    
    R2 = sprintf('%f',R(2));
    R2 = num2str(R2);
    set(handles.TextResultatQET,'String',R2);
    R3 = sprintf('%f',R(3));
    R3 = num2str(R3);
    set(handles.TextResultatQParam,'String',R3);
    qET = R(2);
    qParam = R(3);
    D = num2str(qET - qParam);
    set(handles.TextResultatStatET,'String',D);
    R4 = sprintf('%f',R(4));
    R4 = num2str(R4);
    R5 = sprintf('%f',R(5));
    R5 = num2str(R5);
    Intervalle = ['[ ' R4 ' ; ' R5 ' ]'];
    set(handles.TextResultatIntervalle,'String',Intervalle);
    %R1 = sprintf('%d',R(1));
    %R1 = num2str(R1);
    if R(1) == 1
        if handles.langue == 1
            R1 = 'Accepte';
        else
            R1 = 'Accepted';
        end
    else
        if handles.langue == 1
            R1 = 'Rejete';
        else
            R1 = 'Rejected';
        end
    end
    set(handles.TextResultatDecisionET,'String',R1);
    switch(t)
    case {19,41}
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[1 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    case {20,42}
        set(handles.TextQET,'ForegroundColor',[0 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[1 0 0]);
    case {21,43}
        set(handles.TextQET,'ForegroundColor',[1 0 0]);
        set(handles.TextQParam,'ForegroundColor',[0 0 0]);
        set(handles.TextStatET,'ForegroundColor',[0 0 0]);
    end
    if t == 19 | t == 20 | t == 21
        FrameResultatETVisible(handles,'ET');
    else
        FrameResultatETVisible(handles,'GPD');
    end
end
if t == 16 | t == 17 | t == 18 | t == 38 | t == 39 | t == 40
    [R]=textread(FichierResultat,'%s','delimiter','\n','whitespace','');
    hold off;
    X = [0,1,2];
    R1 = str2num(char(R));
    bar(X(1:2),R1(1:2),'r');
    hold on;
    bar(X(3),R1(3),'y');
    if handles.langue == 1
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % de rejet'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % d''acceptation'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % d''ecart-type'],'HorizontalAlignment','center','Color','r');
    else
        text(X(1),R1(1)+5,[num2str(R1(1)) ' % rejection'],'HorizontalAlignment','center','Color','r');
        text(X(2),R1(2)+5,[num2str(R1(2)) ' % acceptance'],'HorizontalAlignment','center','Color','r');
        text(X(3),R1(3)+5,[num2str(R1(3)) ' % standard deviation'],'HorizontalAlignment','center','Color','r');
    end
    axis([-1 3 0 110]);
    if handles.langue == 1
        title('Pourcentage d''acceptation et de rejet et Ecart-type','Color','r');
    else
        title('Acceptance and rejection percentage and standard deviation','Color','r');
    end
end
if t == 22 | t == 23 | t == 24 | t == 44 | t == 45 | t == 46
    R = load(FichierResultat);
    hold off;
    E1 = str2num(ExcesInf);
    E2 = str2num(ExcesSup);
    NbExces = E2 - E1 + 1;
    NbLoi = size(Loi,1);
    
    couleur = strvcat('r','g','b','c','m','y','k','g:','b:','m:','k:');
    couleur1 = [0.5 0.5 0.5; 0.1 0 0.569; 0.4 0.6325 0; 0.845 0.159 0.785];
    Leg = [];
    if NbLoi == 1
        area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
        axis([E1 E2 -0.5 1.5]);
        legend(Loi(1,:));
    else
        for i=NbLoi:-1:1
            if i >= 8
                area(R((i-1)*NbExces+1:i*NbExces,1),R((i-1)*NbExces+1:i*NbExces,2) + 2 *(i-1),'FaceColor',couleur1(i - 7,:),'EdgeColor',couleur1(i - 7,:));
            else
                area(R((i-1)*NbExces+1:i*NbExces,1),R((i-1)*NbExces+1:i*NbExces,2) + 2 *(i-1),'FaceColor',couleur(i,:),'EdgeColor',couleur(i,:));
            end
            hold on;
            area(R(NbExces+1:2*NbExces,1),repmat(2*(i-1),NbExces,1),'FaceColor','w','EdgeColor','w');
            Leg = strvcat(Leg,Loi(i,:),' ');
        end
        LimiteAxe = -0.5 + 2 * NbLoi;
        axis([E1 E2 -0.5 LimiteAxe]);
        legend(Leg);
    end
            
%     switch(NbLoi)
%     case 1
%         area(R(:,1),R(:,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 1.5]);
%         legend(Loi(1,:));
%     case 2
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 3.5]);
%         legend(Loi(2,:),'',Loi(1,:));
%     case 3
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 5.5]);
%         legend(Loi(3,:),'',Loi(2,:),'',Loi(1,:));
%     case 4
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 7.5]);
%         legend(Loi(4,:),'',Loi(3,:),'',Loi(2,:),'',Loi(1,:));
%     case 5
%         area(R(4*NbExces+1:5*NbExces,1),R(4*NbExces+1:5*NbExces,2) + 8,'FaceColor','k','EdgeColor','k');
%         hold on;
%         area(R(NbExces+1:2*NbExces,1),repmat(8,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(3*NbExces+1:4*NbExces,1),R(3*NbExces+1:4*NbExces,2) + 6,'FaceColor','c','EdgeColor','c');
%         area(R(NbExces+1:2*NbExces,1),repmat(6,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(2*NbExces+1:3*NbExces,1),R(2*NbExces+1:3*NbExces,2) + 4,'FaceColor','g','EdgeColor','g');
%         area(R(NbExces+1:2*NbExces,1),repmat(4,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(NbExces+1:2*NbExces,1),R(NbExces+1:2*NbExces,2) + 2,'FaceColor','b','EdgeColor','b');
%         area(R(NbExces+1:2*NbExces,1),repmat(2,NbExces,1),'FaceColor','w','EdgeColor','w');
%         area(R(1:NbExces,1),R(1:NbExces,2),'FaceColor','r','EdgeColor','r');
%         axis([E1 E2 -0.5 9.5]);
%         legend(Loi(5,:),'',Loi(4,:),'',Loi(3,:),'',Loi(2,:),'',Loi(1,:));
%     end
    if handles.langue == 1
        title('Plage d''acceptation du test pour chaque modele','Color','r');
    else
        title('Test acceptance region for each model','Color','r');
    end
end
handles.Action = cellstr(EspaceAction);
set(handles.PopupAction,'String',handles.Action);
set(handles.PopupAction,'Value',1);
guidata(handles.Extremes,handles);
%Actualise le fichier des actions
FichierAction = [Rep '/' 'Action.txt'];
fid1 = fopen(FichierAction,'a');
fprintf(fid1,'%s\n',Action);
fclose(fid1);
%Actualise le fichier des numeros de taches
FichierTache = [Rep '/' 'Tache.txt'];
fid2 = fopen(FichierTache,'a');
fprintf(fid2,'%d\n',t);
fclose(fid2);
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------

function varargout = EditPET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditPET.
disp('EditPET Callback not implemented yet.')


% --------------------------------------------------------------------

function varargout = PopupResultatET_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupResultatET.
ViderFrameResultatET(handles);
Rep = LitRepEDT(handles);
%ListeAction = get(handles.PopupAction,'String');
%ListeAction = flipud(ListeAction);
%LA = strvcat(char(ListeAction));
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
%if (strcmp(char(ListeAction{Index}),'Test ET - Exces unique - A') == 1) | (strcmp(char(ListeAction{Index}),'Test ET - Exces unique - BP') == 1) | (strcmp(char(ListeAction{Index}),'Test ET - Exces unique - BPS') == 1) 
    k = IndexInverse(Index);
    %else
    %X = 'Test ET - Exces unique - A';
    %k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
    %if isempty(k)
    %    X = 'Test ET - Exces unique - BP';
    %    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
    %end
    %if isempty(k)
    %    X = 'Test ET - Exces unique - BPS';
    %    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
    %end
    %end
k1 = int2str(k(1));
FichierResult = [Rep '/' 'Result' k1 '.txt'];
R = load(FichierResult);
I = get(handles.PopupResultatET,'Value');
ListeLoi = get(handles.PopupResultatET,'String');
LoiSelect = ListeLoi{I};
R2 = sprintf('%f',R(2 + (I-1) * 5));
R2 = num2str(R2);
set(handles.TextResultatQET,'String',R2);
R3 = sprintf('%f',R(3 + (I-1) * 5));
R3 = num2str(R3);
set(handles.TextResultatQParam,'String',R3);
qET = R(2 + (I-1) * 5);
qParam = R(3 + (I-1) * 5);
D = sprintf('%f',qET - qParam);
D = num2str(D);
set(handles.TextResultatStatET,'String',D);
R4 = sprintf('%f',R(4+ (I-1) * 5));
R4 = num2str(R4);
R5 = sprintf('%f',R(5 + (I-1) * 5));
R5 = num2str(R5);
Intervalle = ['[ ' R4 ' ; ' R5 ' ]'];
set(handles.TextResultatIntervalle,'String',Intervalle);
%R1 = sprintf('%d',R(1 + (I-1) * 5));
%R1 = num2str(R1);
if R(1 + (I-1) * 5) == 1
    if handles.langue == 1
        R1 = 'Accepte';
    else
        R1 = 'Accepted';
    end
else
    if handles.langue == 1
        R1 = 'Rejete';
    else
        R1 = 'Rejected';
    end
end
set(handles.TextResultatDecisionET,'String',R1);


% --------------------------------------------------------------------
function varargout = PopupModeleRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupModeleRB.
R = LitPopupModeleRB(handles);
if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1
    set(handles.TextBetaRB,'Visible','on');
    set(handles.TextBinfRB,'Visible','on');
    set(handles.TextBsupRB,'Visible','on');
    set(handles.EditBinfRB,'Visible','on');
    set(handles.EditBsupRB,'Visible','on');
else
    set(handles.TextBetaRB,'Visible','off');
    set(handles.TextBinfRB,'Visible','off');
    set(handles.TextBsupRB,'Visible','off');
    set(handles.EditBinfRB,'Visible','off');
    set(handles.EditBsupRB,'Visible','off');
end

% --------------------------------------------------------------------
function varargout = EditBinfRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditBinfRB.
disp('EditBinfRB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditBsupRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditBsupRB.
disp('EditBsupRB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = BtSuiteRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtSuiteRB.
switch(handles.Suite)
case 0
    set(handles.TextModeleRB,'Visible','off');
    set(handles.PopupModeleRB,'Visible','off');
    set(handles.TextBetaRB,'Visible','off');
    set(handles.TextBinfRB,'Visible','off');
    set(handles.TextBsupRB,'Visible','off');
    set(handles.EditBinfRB,'Visible','off');
    set(handles.EditBsupRB,'Visible','off');
    set(handles.TextDonneesSimulees,'Visible','on');
    set(handles.RBOui,'Visible','on');
    set(handles.RBNon,'Visible','on');
    set(handles.TextParam1RB,'Visible','off');
    set(handles.TextParam2RB,'Visible','off');
    set(handles.TextParam3RB,'Visible','off');
    set(handles.EditParam1RB,'Visible','off');
    set(handles.EditParam2RB,'Visible','off');
    set(handles.EditParam3RB,'Visible','off');
    if get(handles.RBOui,'Value') == 1
        set(handles.TextVraieLoiRB,'Visible','on');
        set(handles.PopupVraieLoiRB,'Visible','on');
    end
    set(handles.BtRetourRB,'Visible','on');
    handles.Suite = handles.Suite + 1;
    guidata(handles.Extremes,handles);
case 1
    set(handles.TextDonneesSimulees,'Visible','off');
    set(handles.RBOui,'Visible','off');
    set(handles.RBNon,'Visible','off');
    set(handles.TextVraieLoiRB,'Visible','off');
    set(handles.PopupVraieLoiRB,'Visible','off');
    set(handles.TextParam1RB,'Visible','off');
    set(handles.TextParam2RB,'Visible','off');
    set(handles.TextParam3RB,'Visible','off');
    set(handles.EditParam1RB,'Visible','off');
    set(handles.EditParam2RB,'Visible','off');
    set(handles.EditParam3RB,'Visible','off');
    set(handles.TextAvisExpert,'Visible','on');
    set(handles.RBExpertNon,'Visible','on');
    set(handles.RBExpertOui,'Visible','on');
    set(handles.TextConfiance,'Visible','on');
    set(handles.EditConfiance,'Visible','on');
    if get(handles.RBExpertOui,'Value') == 1
        set(handles.TextQmax,'Visible','on');
        set(handles.EditQmax,'Visible','on');
        set(handles.TextOrdrep1,'Visible','on');
        set(handles.EditOrdrep1,'Visible','on');
        set(handles.TextOrdrep2,'Visible','on');
        set(handles.EditOrdrep2,'Visible','on');
    end
    R = LitPopupModeleRB(handles);
    if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1
        set(handles.TextConfianceWeibull,'Visible','on');
        set(handles.PopupConfianceWeibull,'Visible','on');
    end
    handles.Suite = handles.Suite + 1;
    guidata(handles.Extremes,handles);
case 2
    set(handles.TextAvisExpert,'Visible','off');
    set(handles.RBExpertNon,'Visible','off');
    set(handles.RBExpertOui,'Visible','off');
    set(handles.TextQmax,'Visible','off');
    set(handles.EditQmax,'Visible','off');
    set(handles.TextOrdrep1,'Visible','off');
    set(handles.EditOrdrep1,'Visible','off');
    set(handles.TextOrdrep2,'Visible','off');
    set(handles.EditOrdrep2,'Visible','off');
    set(handles.TextConfiance,'Visible','off');
    set(handles.EditConfiance,'Visible','off');
    set(handles.TextConfianceWeibull,'Visible','off');
    set(handles.PopupConfianceWeibull,'Visible','off');
    set(handles.TextTypeTest,'Visible','on');
    set(handles.PopupTypeTest,'Visible','on');
    set(handles.TextNiveauCentraux,'Visible','on');
    set(handles.PopupNiveauCentraux,'Visible','on');
    set(handles.TextNiveauETRB,'Visible','on');
    set(handles.PopupNiveauETRB,'Visible','on');
    set(handles.TextExcesRB,'Visible','on');
    set(handles.EditExcesRB,'Visible','on');
    set(handles.TextPETRB,'Visible','on');
    set(handles.EditPETRB,'Visible','on');
    handles.Suite = handles.Suite + 1;
    guidata(handles.Extremes,handles);
case 3
    if handles.langue == 1
        set(handles.BtSuiteRB,'String','Terminer');
    else
        set(handles.BtSuiteRB,'String','Finish');
    end
    if isempty(get(handles.TextEnCours,'String'))
        set(handles.BtSuiteRB,'Enable','off');
    end
    set(handles.TextTypeTest,'Visible','off');
    set(handles.PopupTypeTest,'Visible','off');
    set(handles.TextNiveauCentraux,'Visible','off');
    set(handles.PopupNiveauCentraux,'Visible','off');
    set(handles.TextNiveauETRB,'Visible','off');
    set(handles.PopupNiveauETRB,'Visible','off');
    set(handles.TextExcesRB,'Visible','off');
    set(handles.EditExcesRB,'Visible','off');
    set(handles.TextPETRB,'Visible','off');
    set(handles.EditPETRB,'Visible','off');
    set(handles.TextQuantilesRB,'Visible','on');
    set(handles.TextQuantileP1,'Visible','on');
    set(handles.EditQuantileP1,'Visible','on');
    set(handles.TextQuantileP2,'Visible','on');
    set(handles.EditQuantileP2,'Visible','on');
    set(handles.TextQuantileP3,'Visible','on');
    set(handles.EditQuantileP3,'Visible','on');
    set(handles.TextQuantileP4,'Visible','on');
    set(handles.EditQuantileP4,'Visible','on');
    set(handles.TextQuantileP5,'Visible','on');
    set(handles.EditQuantileP5,'Visible','on');
    handles.Suite = handles.Suite + 1;
    guidata(handles.Extremes,handles);
case 4
    V = VerifRegBay(handles);
    if V ~= 1
        switch(V)
        case 2
            if handles.langue == 1
                errordlg('Un ou plusieurs champs sont vides','Erreur de saisie','modal');
            else
                errordlg('Empty entries found','Error','modal');
            end
        case 3
            if handles.langue == 1
                errordlg('La borne inferieure de la loi beta doit etre positive ou nulle et la borne superieure strictement positive','Erreur de saisie','modal');
            else
                errordlg('Inferior limit of beta distribution must be a positive real or 0 and superior limit strictly positive','Error','modal');
            end
        case 4
            if handles.langue == 1
                errordlg('La borne inferieure de la loi beta doit etre inferieure e la borne superieure','Erreur de saisie','modal');
            else
                errordlg('Inferior limit of beta distribution must be superior than superior limit','Error','modal');
            end
        case 5
            if handles.langue == 1
                errordlg('Les ordres des quantiles doivent etre compris entre 0 et 1 strictement','Erreur de saisie','modal');
            else
                errordlg('Orders of quantiles must be strictly between 0 and 1','Error','modal');
            end
        case 6
            if handles.langue == 1
                errordlg('Pour cet encadrement, l''ordre p1 du 1er quantile doit etre strictement superieur e l''ordre p2 du 2eme quantile','Erreur de saisie','modal');
            else
                errordlg('Here, order p1 of first quantile must be strictly superior than order p2 of second quantile ','Error','modal');
            end
        case 7
            if handles.langue == 1
                errordlg('Le nombre d''exces doit etre compris entre 2 et la taille totale de l''echantillon','Erreur de saisie','modal');
            else
                errordlg('Number of excesses must be between 2 and total sample size','Error','modal');
            end
        case 8
            if handles.langue == 1
                errordlg('Le niveau de defiance doit etre compris entre 0 et 1 strictement','Erreur de saisie','modal');
            else
                errordlg('Distrust level must be strictly between 0 and 1','Erreur de saisie','modal');
            end
        end
        return;
    end
    EspaceAction = strvcat(char(handles.Action));
    Action = TacheToAction(handles);
    EspaceAction = strvcat(Action,EspaceAction);
    %Construit le fichier de donnees
    Rep = LitRepEDT(handles);
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    %Construit le fichier resultat
    N = int2str(size(EspaceAction,1));
    FichierResultat = [Rep '/' 'Result' N '.txt'];
    %Cree le fichier d'echange Tmp
    FichierEchange = [Rep '/' 'Tmp' N '.txt'];
    fid3 = fopen(FichierEchange,'w');
    Rep1 = [Rep '/'];
    fprintf(fid3,'%s\n',Rep1);
    fprintf(fid3,'%s\n',FichierDonnees);
    t = handles.Tache;
    t1 = int2str(t);
    fprintf(fid3,'%s\n',t1);
    fprintf(fid3,'%s\n',FichierResultat);
    LoiModele = LitPopupModeleRB(handles);
    if strcmp(LoiModele,'Weibull parametre de forme') == 1 | strcmp(LoiModele,'Weibull form parameter') == 1
        LoiModele = 'WeibullForme';
        fprintf(fid3,'%s\n',LoiModele);
    else
        if strcmp(LoiModele,'Weibull parametre d''echelle') == 1 | strcmp(LoiModele,'Weibull scale parameter') == 1
            LoiModele = 'WeibullEchelle';
            fprintf(fid3,'%s\n',LoiModele);
        else
            fprintf(fid3,'%s\n',LoiModele);
        end
    end        
    B = char(get(handles.EditBinfRB,'String'));
    if isempty(B)
        B = '*';
    end
    fprintf(fid3,'%s\n',B);
    B = char(get(handles.EditBsupRB,'String'));
    if isempty(B)
        B = '*';
    end
    fprintf(fid3,'%s\n',B);
    Simulees = get(handles.RBOui,'Value');
    fprintf(fid3,'%s\n',int2str(Simulees));
    if Simulees == 1
        VraieLoi = LitPopupVraieLoiRB(handles);
        fprintf(fid3,'%s\n',VraieLoi);
        fprintf(fid3,'%s\n',char(get(handles.EditParam1RB,'String')));
        P = char(get(handles.EditParam2RB,'String'));
        if isempty(P)
            P = '*';
        end
        fprintf(fid3,'%s\n',P);
        P = char(get(handles.EditParam3RB,'String'));
        if isempty(P)
            P = '*';
        end
        fprintf(fid3,'%s\n',P);
    else
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n','*');
    end
    Expert = get(handles.RBExpertOui,'Value');
    fprintf(fid3,'%s\n',int2str(Expert));
    if Expert == 1
        fprintf(fid3,'%s\n',get(handles.EditQmax,'String'));
        fprintf(fid3,'%s\n',get(handles.EditOrdrep1,'String'));
        fprintf(fid3,'%s\n',get(handles.EditOrdrep2,'String'));
    else
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n','*');
        fprintf(fid3,'%s\n','*');
    end
    fprintf(fid3,'%s\n',char(get(handles.EditConfiance,'String')));
    R = LitPopupModeleRB(handles);
    if strcmp(LoiModele,'Weibull parametre de forme') == 1 | strcmp(LoiModele,'Weibull form parameter') == 1
        R = LitPopupConfianceWeibull(handles);
        fprintf(fid3,'%s\n',R);
    else
        fprintf(fid3,'%s\n','*');
    end
    R = LitPopupTypeTest(handles);
    if strcmp(R,'Cramer-Von Mises') == 1
        R = 'CVM';
    else
        R = 'AD';
    end
    fprintf(fid3,'%s\n',R);
    R = LitPopupNiveauCentraux(handles);
    fprintf(fid3,'%s\n',R);
    R = LitPopupNiveauETRB(handles);
    fprintf(fid3,'%s\n',R);
    fprintf(fid3,'%s\n',char(get(handles.EditExcesRB,'String')));
    fprintf(fid3,'%s\n',char(get(handles.EditPETRB,'String')));
    Quantiles = [];
    P = char(get(handles.EditQuantileP1,'String'));
    if isempty(P)
        P = '0';
    else
        Quantiles = strvcat(Quantiles,P);
    end
    fprintf(fid3,'%s\n',P);
    P = char(get(handles.EditQuantileP2,'String'));
    if isempty(P)
        P = '0';
    else
        Quantiles = strvcat(Quantiles,P);
    end
    fprintf(fid3,'%s\n',P);
    P = char(get(handles.EditQuantileP3,'String'));
    if isempty(P)
        P = '0';
    else
        Quantiles = strvcat(Quantiles,P);
    end
    fprintf(fid3,'%s\n',P);
    P = char(get(handles.EditQuantileP4,'String'));
    if isempty(P)
        P = '0';
    else
        Quantiles = strvcat(Quantiles,P);
    end
    fprintf(fid3,'%s\n',P);
    P = char(get(handles.EditQuantileP5,'String'));
    if isempty(P)
        P = '0';
    else
        Quantiles = strvcat(Quantiles,P);
    end
    fprintf(fid3,'%s\n',P);
    fclose(fid3);
    set(handles.BtSuiteRB,'Enable','off');
    
    %lancement du prog C++
    [status result] = unix([handles.Prog ' ' FichierEchange ' 3']);
    
    % Resultats
    FichierErreur = [Rep '/' 'Erreur.txt'];
    if exist(FichierErreur)==0
        % Resultats Reg Bay
        R = load(FichierResultat);
        R1 = sprintf('%f',R(1));
        R2 = sprintf('%f',R(2));
        Intervalle = ['[ ' num2str(R1) ' ; ' num2str(R2) ' ]'];
        set(handles.TextIntervalleTheta,'String',Intervalle);
        if strcmp(LoiModele,'WeibullForme') == 1
            if handles.langue == 1
                set(handles.TextLoiAPriori,'String','Loi a priori Beta');
            else
                set(handles.TextLoiAPriori,'String','A priori Beta model');
            end
        else
            if handles.langue == 1
                set(handles.TextLoiAPriori,'String','Loi a priori Gamma');
            else
                set(handles.TextLoiAPriori,'String','A priori Gamma model');
            end
        end
        R5 = sprintf('%f',R(5));
        set(handles.TextResultatP1LAP,'String',R5);
        R6 = sprintf('%f',R(6));
        set(handles.TextResultatP2LAP,'String',R6);
        if strcmp(LoiModele,'Exponentielle') == 1 | strcmp(LoiModele,'Exponential') == 1
            Decale = 0;
        else
            Decale = 1;
        end
        %R9 = sprintf('%f',R(9+Decale));
        %set(handles.TextResultatTestCentral,'String',R9);
        if R(9+Decale) == 1
            if handles.langue == 1
                set(handles.TextResultatTestCentral,'String','Accepte');   % Affichage de la decision du test central
            else
                set(handles.TextResultatTestCentral,'String','Accepted');
            end
        else
            if handles.langue == 1
                set(handles.TextResultatTestCentral,'String','Rejete');
            else
                set(handles.TextResultatTestCentral,'String','Rejected');   % Affichage de la decision du test central
            end
        end
        R10 = sprintf('%f',R(10+Decale));
        set(handles.TextResultatDistModele,'String',R10);
        R11 = sprintf('%f',R(11+Decale));
        set(handles.TextResultatDistRejet,'String',R11);
        R12 = sprintf('%f',R(12+Decale));
        set(handles.TextResultatDistPred,'String',R12);
%         R13 = sprintf('%f',R(13+Decale));
%         set(handles.TextResultatTestETRB,'String',R13);
        if R(13+Decale) == 1
            if handles.langue == 1
                set(handles.TextResultatTestETRB,'String','Accepte');     % Affichage de la decision du test ET
            else
                set(handles.TextResultatTestETRB,'String','Accepted');     % Affichage de la decision du test ET
            end
        else
            if handles.langue == 1
                set(handles.TextResultatTestETRB,'String','Rejete');
            else
                set(handles.TextResultatTestETRB,'String','Rejected');
            end
        end
        if R(14+Decale) == 1
            if handles.langue == 1
                set(handles.TextResultatTestETLoiPred,'String','Accepte');    % Affichage de la decision du test ET pour la loi predictive
            else
                set(handles.TextResultatTestETLoiPred,'String','Accepted');    % Affichage de la decision du test ET pour la loi predictive
            end
        else
            if handles.langue == 1
                set(handles.TextResultatTestETLoiPred,'String','Rejete');
            else
                set(handles.TextResultatTestETLoiPred,'String','Rejected');
            end
        end
%         R14 = sprintf('%f',R(14+Decale));
%         set(handles.TextResultatTestETLoiPred,'String',R14);
        R15 = sprintf('%f',R(15+Decale));
        set(handles.TextResultatQETPred,'String',R15);
        R16 = sprintf('%f',R(16+Decale));
        R17 = sprintf('%f',R(17+Decale));
        Intervalle = ['[ ' num2str(R16) ' ; ' num2str(R17) ' ]'];
        set(handles.TextResultatICPred,'String',Intervalle);
        
        %affectation de la PopupResultatQuantilesRB
        Quantiles = cellstr(Quantiles);
        set(handles.PopupResultatQuantilesRB,'Value',1);
        set(handles.PopupResultatQuantilesRB,'String',Quantiles);

        %Affichage du premier quantile calcule
        DecaleQuantile = size(Quantiles,1);
        R18 = sprintf('%f',R(18+Decale));
        set(handles.TextResultatQEstime,'String',R18);
        R19 = sprintf('%f',R(18+Decale+DecaleQuantile));
        set(handles.TextResultatqET,'String',R19);
        R20 = sprintf('%f',R(18+Decale+2*DecaleQuantile));
        set(handles.TextResultatqPred,'String',R20);
        if Simulees == 1
            R21 = sprintf('%f',R(18+Decale+3*DecaleQuantile));
            set(handles.TextResultatQVrai,'String',R21);
            R22 = sprintf('%f',R(18+Decale+4*DecaleQuantile));
            set(handles.TextResultatQVraiEstime,'String',R22);
            set(handles.TextQVrai,'Visible','on');
            set(handles.TextResultatQVrai,'Visible','on');
            set(handles.TextQVraiEstime,'Visible','on');
            set(handles.TextResultatQVraiEstime,'Visible','on');
        end
        FrameResultatRegBayVisible(handles);
        
        % Histogramme
        hold off;
        Rdonnees = load(FichierDonnees);
        if handles.langue == 1
            NbClasse = inputdlg('Nombre de classes :','Histogramme');
        else
            NbClasse = inputdlg('Number of bins :','Histogram');
        end
        NbClasse = str2num(char(NbClasse));
        [K,X] = hist(Rdonnees,NbClasse);
        Amp = X(2)-X(1);
        K = K/size(Rdonnees,1)/Amp;
        bar(X,K,'hist');
        colormap(handles.CouleurHisto);
        hold on;
        % Affichage des densites
        N = str2num(N);
        couleur = strvcat('m','b','g','c','k');
        compt = 1;
        
        if Simulees == 1
            Debut = N+1;
            Fin = N+3;
            if handles.langue == 1
                Loi = strvcat(LoiModele,VraieLoi,'predictive');
            else
                Loi = strvcat(LoiModele,VraieLoi,'predictive');
            end
        else
            Debut = N+1;
            Fin = N+2;;
            if handles.langue == 1
                Loi = strvcat(LoiModele,'predictive');
            else
                Loi = strvcat(LoiModele,'predictive');
            end
        end
        
        for i=Debut:Fin
            j = int2str(i);
            FichierResultat = [Rep '/' 'Result' j '.txt'];
            R = load(FichierResultat);
            plot(R(:,1),R(:,2),couleur(compt));
            compt = compt + 1;
        end
        if Simulees == 1
            if handles.langue == 1
                legend('Densite du modele','Densite de simulation','Densite predictive');
            else
                legend('Model PDF','Simulation PDF','Predictive PDF');
            end
        else
            if handles.langue == 1
                legend('Densite du modele','Densite predictive');
            else
                legend('Model PDF','Predictive PDF');
            end
        end
        if handles.langue == 1
            title(['Regularisation bayesienne - Modele ' LoiModele],'Color','r');
        else
            title(['Bayesian regularisation - ' LoiModele ' model'],'Color','r');
        end
        
        if handles.langue == 1
            ActionEnPlus = repmat('Densite ',Fin-Debut+1,1);
            ActionEnPlus = [ActionEnPlus Loi];
            ActionEnPlusSurvie = repmat('Fonction de survie ',Fin-Debut+1,1);
            ActionEnPlusSurvie = [ActionEnPlusSurvie Loi];
        else
            ActionEnPlus = repmat(' PDF',Fin-Debut+1,1);
            ActionEnPlusSurvie = repmat(' survival function',Fin-Debut+1,1);
            Loi = cellstr(Loi);
            LoiEn = [];
            for i=1:size(Loi,1)
                LoiEnTemp = LoiFrToEn(char(Loi(i)));
                LoiEn = strvcat(LoiEn,LoiEnTemp);
            end
            LoiEn = cellstr(LoiEn);
            ActionEnPlus = strcat(LoiEn,ActionEnPlus);
            
            %ActionEnPlus = [Loi ActionEnPlus];
            
            ActionEnPlusSurvie = strcat(LoiEn,ActionEnPlusSurvie);
        end
        ActionEnPlus = flipud(ActionEnPlus);
        EspaceAction = strvcat(char(ActionEnPlus),EspaceAction);
        ActionEnPlusSurvie = flipud(ActionEnPlusSurvie);
        EspaceAction = strvcat(char(ActionEnPlusSurvie),EspaceAction);
        
        handles.Action = cellstr(EspaceAction);
        set(handles.PopupAction,'String',handles.Action);
        set(handles.PopupAction,'Value',1);
        guidata(handles.Extremes,handles);
        
        % Menu contextuel active
        set(handles.DensitesRB,'Enable','on');
        set(handles.SurvieRB,'Enable','on');
        
        % simulation selon loi predictive permise
        set(handles.MenuSimulationsPred,'Enable','on');
        
        %Actualise le fichier des actions
        FichierAction = [Rep '/' 'Action.txt'];
        fid1 = fopen(FichierAction,'a');
        fprintf(fid1,'%s\n',Action);
        ActionEnPlus = flipud(ActionEnPlus);
        ActionEnPlus = cellstr(ActionEnPlus);
        for i=1:size(ActionEnPlus,1)
            fprintf(fid1,'%s\n',char(ActionEnPlus(i)));
        end
        ActionEnPlusSurvie = flipud(ActionEnPlusSurvie);
        ActionEnPlusSurvie = cellstr(ActionEnPlusSurvie);
        for i=1:size(ActionEnPlusSurvie,1)
            fprintf(fid1,'%s\n',char(ActionEnPlusSurvie(i)));
        end
        fclose(fid1);
        
        %Actualise le fichier des numeros de taches
        FichierTache = [Rep '/' 'Tache.txt'];
        fid2 = fopen(FichierTache,'a');
        fprintf(fid2,'%d\n',t);
        for i=1:size(ActionEnPlus,1)
            fprintf(fid1,'%d\n',2);
        end
        for i=1:size(ActionEnPlusSurvie,1)
            fprintf(fid1,'%d\n',8);
        end
        fclose(fid2);
        set(handles.TextEnCours,'String','');
    else
        fid4 = fopen(FichierErreur,'r');
        Message = fgets(fid4);
        fclose(fid4);
        delete(FichierErreur);
        if handles.langue == 1
            errordlg(Message,'Erreur de saisie utilisateur','modal');
        else
            errordlg(Message,'User write error','modal');
        end
        set(handles.BtSuiteRB,'Enable','on');
    end
    %FrameRegBayInvisible(handles);
    set(handles.TextEnCours,'String','');
    hold off;
end
    

% --------------------------------------------------------------------
function varargout = BtRetourRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtRetourRB.
switch(handles.Suite)
case 1
    set(handles.TextDonneesSimulees,'Visible','off');
    set(handles.RBOui,'Visible','off');
    set(handles.RBNon,'Visible','off');
    set(handles.TextVraieLoiRB,'Visible','off');
    set(handles.PopupVraieLoiRB,'Visible','off');
    set(handles.TextParam1RB,'Visible','off');
    set(handles.TextParam2RB,'Visible','off');
    set(handles.TextParam3RB,'Visible','off');
    set(handles.EditParam1RB,'Visible','off');
    set(handles.EditParam2RB,'Visible','off');
    set(handles.EditParam3RB,'Visible','off');
    set(handles.TextModeleRB,'Visible','on');
    set(handles.PopupModeleRB,'Visible','on');
    R = LitPopupModeleRB(handles);
    if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1
        set(handles.TextBetaRB,'Visible','on');
        set(handles.TextBinfRB,'Visible','on');
        set(handles.TextBsupRB,'Visible','on');
        set(handles.EditBinfRB,'Visible','on');
        set(handles.EditBsupRB,'Visible','on');
    else
        set(handles.TextBetaRB,'Visible','off');
        set(handles.TextBinfRB,'Visible','off');
        set(handles.TextBsupRB,'Visible','off');
        set(handles.EditBinfRB,'Visible','off');
        set(handles.EditBsupRB,'Visible','off');
    end
    set(handles.BtRetourRB,'Visible','off');
    handles.Suite = handles.Suite - 1;
    guidata(handles.Extremes,handles);
case 2
    set(handles.TextDonneesSimulees,'Visible','on');
    set(handles.RBOui,'Visible','on');
    set(handles.RBNon,'Visible','on');
    if get(handles.RBOui,'Value') == 1
        set(handles.TextVraieLoiRB,'Visible','on');
        set(handles.PopupVraieLoiRB,'Visible','on');
        NomLoi = LitPopupVraieLoiRB(handles);
        [P1,P2,P3,NbParam]=NomDesParametres(handles,NomLoi);
        switch(NbParam)
        case 1
            set(handles.TextParam1RB,'Visible','on');
            set(handles.TextParam2RB,'Visible','off');
            set(handles.TextParam3RB,'Visible','off');
            set(handles.EditParam1RB,'Visible','on');
            set(handles.EditParam2RB,'Visible','off');
            set(handles.EditParam3RB,'Visible','off');
        case 2
            set(handles.TextParam1RB,'Visible','on');
            set(handles.TextParam2RB,'Visible','on');
            set(handles.TextParam3RB,'Visible','off');
            set(handles.EditParam1RB,'Visible','on');
            set(handles.EditParam2RB,'Visible','on');
            set(handles.EditParam3RB,'Visible','off');
        case 3
            set(handles.TextParam1RB,'Visible','on');
            set(handles.TextParam2RB,'Visible','on');
            set(handles.TextParam3RB,'Visible','on');
            set(handles.EditParam1RB,'Visible','on');
            set(handles.EditParam2RB,'Visible','on');
            set(handles.EditParam3RB,'Visible','on');
        end
    end
    set(handles.TextAvisExpert,'Visible','off');
    set(handles.RBExpertNon,'Visible','off');
    set(handles.RBExpertOui,'Visible','off');
    set(handles.TextQmax,'Visible','off');
    set(handles.EditQmax,'Visible','off');
    set(handles.TextOrdrep1,'Visible','off');
    set(handles.EditOrdrep1,'Visible','off');
    set(handles.TextOrdrep2,'Visible','off');
    set(handles.EditOrdrep2,'Visible','off');
    set(handles.TextConfiance,'Visible','off');
    set(handles.EditConfiance,'Visible','off');
    set(handles.TextConfianceWeibull,'Visible','off');
    set(handles.PopupConfianceWeibull,'Visible','off');
    handles.Suite = handles.Suite - 1;
    guidata(handles.Extremes,handles);
case 3
    set(handles.TextAvisExpert,'Visible','on');
    set(handles.RBExpertNon,'Visible','on');
    set(handles.RBExpertOui,'Visible','on');
    if get(handles.RBExpertOui,'Value') == 1
        set(handles.TextQmax,'Visible','on');
        set(handles.EditQmax,'Visible','on');
        set(handles.TextOrdrep1,'Visible','on');
        set(handles.EditOrdrep1,'Visible','on');
        set(handles.TextOrdrep2,'Visible','on');
        set(handles.EditOrdrep2,'Visible','on');
    end
    set(handles.TextConfiance,'Visible','on');
    set(handles.EditConfiance,'Visible','on');
    R = LitPopupModeleRB(handles);
    if strcmp(R,'Weibull parametre de forme') == 1 | strcmp(R,'Weibull form parameter') == 1
        set(handles.TextConfianceWeibull,'Visible','on');
        set(handles.PopupConfianceWeibull,'Visible','on');
    end
    set(handles.TextTypeTest,'Visible','off');
    set(handles.PopupTypeTest,'Visible','off');
    set(handles.TextNiveauCentraux,'Visible','off');
    set(handles.PopupNiveauCentraux,'Visible','off');
    set(handles.TextNiveauETRB,'Visible','off');
    set(handles.PopupNiveauETRB,'Visible','off');
    set(handles.TextExcesRB,'Visible','off');
    set(handles.EditExcesRB,'Visible','off');
    set(handles.TextPETRB,'Visible','off');
    set(handles.EditPETRB,'Visible','off');
    handles.Suite = handles.Suite - 1;
    guidata(handles.Extremes,handles);
case 4
    if handles.langue == 1
        set(handles.BtSuiteRB,'String','Suite >>');
    else
        set(handles.BtSuiteRB,'String','Next >>');
    end
    if isempty(get(handles.TextEnCours,'String'))
        set(handles.BtSuiteRB,'Enable','on');
    end
    set(handles.TextQuantilesRB,'Visible','off');
    set(handles.TextQuantileP1,'Visible','off');
    set(handles.EditQuantileP1,'Visible','off');
    set(handles.TextQuantileP2,'Visible','off');
    set(handles.EditQuantileP2,'Visible','off');
    set(handles.TextQuantileP3,'Visible','off');
    set(handles.EditQuantileP3,'Visible','off');
    set(handles.TextQuantileP4,'Visible','off');
    set(handles.EditQuantileP4,'Visible','off');
    set(handles.TextQuantileP5,'Visible','off');
    set(handles.EditQuantileP5,'Visible','off');
    set(handles.TextTypeTest,'Visible','on');
    set(handles.PopupTypeTest,'Visible','on');
    set(handles.TextNiveauCentraux,'Visible','on');
    set(handles.PopupNiveauCentraux,'Visible','on');
    set(handles.TextNiveauETRB,'Visible','on');
    set(handles.PopupNiveauETRB,'Visible','on');
    set(handles.TextExcesRB,'Visible','on');
    set(handles.EditExcesRB,'Visible','on');
    set(handles.TextPETRB,'Visible','on');
    set(handles.EditPETRB,'Visible','on');
    handles.Suite = handles.Suite - 1;
    guidata(handles.Extremes,handles);
end

% --------------------------------------------------------------------
function varargout = RBOui_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.RBOui.
set(handles.RBNon,'Value',0);
set(handles.TextVraieLoiRB,'Visible','on');
set(handles.PopupVraieLoiRB,'Visible','on');
set(handles.TextParam1RB,'Visible','off');
set(handles.TextParam2RB,'Visible','off');
set(handles.TextParam3RB,'Visible','off');
set(handles.EditParam1RB,'Visible','off');
set(handles.EditParam2RB,'Visible','off');
set(handles.EditParam3RB,'Visible','off');

% --------------------------------------------------------------------
function varargout = radiobutton5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.radiobutton5.
set(handles.RBOui,'Value',0);
set(handles.TextVraieLoiRB,'Visible','off');
set(handles.PopupVraieLoiRB,'Visible','off');
set(handles.TextParam1RB,'Visible','off');
set(handles.TextParam2RB,'Visible','off');
set(handles.TextParam3RB,'Visible','off');
set(handles.EditParam1RB,'Visible','off');
set(handles.EditParam2RB,'Visible','off');
set(handles.EditParam3RB,'Visible','off');

% --------------------------------------------------------------------
function varargout = PopupLoiSimuleeRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupLoiSimuleeRB.
NomLoi = LitPopupVraieLoiRB(handles);
[P1,P2,P3,NbParam]=NomDesParametres(handles,NomLoi);
switch(NbParam)
case 1
    set(handles.TextParam1RB,'String',P1);
    set(handles.TextParam1RB,'Visible','on');
    set(handles.TextParam2RB,'Visible','off');
    set(handles.TextParam3RB,'Visible','off');
    set(handles.EditParam1RB,'Visible','on');
    set(handles.EditParam2RB,'Visible','off');
    set(handles.EditParam3RB,'Visible','off');
case 2
    set(handles.TextParam1RB,'String',P1);
    set(handles.TextParam2RB,'String',P2);
    set(handles.TextParam1RB,'Visible','on');
    set(handles.TextParam2RB,'Visible','on');
    set(handles.TextParam3RB,'Visible','off');
    set(handles.EditParam1RB,'Visible','on');
    set(handles.EditParam2RB,'Visible','on');
    set(handles.EditParam3RB,'Visible','off');
case 3
    set(handles.TextParam1RB,'String',P1);
    set(handles.TextParam2RB,'String',P2);
    set(handles.TextParam3RB,'String',P3);
    set(handles.TextParam1RB,'Visible','on');
    set(handles.TextParam2RB,'Visible','on');
    set(handles.TextParam3RB,'Visible','on');
    set(handles.EditParam1RB,'Visible','on');
    set(handles.EditParam2RB,'Visible','on');
    set(handles.EditParam3RB,'Visible','on');
end

% --------------------------------------------------------------------
function varargout = EditParam1RB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam1RB.
disp('EditParam1RB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditParam2RB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam2RB.
disp('EditParam2RB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditParam3RB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditParam3RB.
disp('EditParam3RB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = RBExpertOui_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.RBExpertOui.
set(handles.RBExpertNon,'Value',0);
set(handles.TextQmax,'Visible','on');
set(handles.EditQmax,'Visible','on');
set(handles.TextOrdrep1,'Visible','on');
set(handles.EditOrdrep1,'Visible','on');
set(handles.TextOrdrep2,'Visible','on');
set(handles.EditOrdrep2,'Visible','on');

% --------------------------------------------------------------------
function varargout = RBExpertNon_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.RBExpertNon.
set(handles.RBExpertOui,'Value',0);
set(handles.TextQmax,'Visible','off');
set(handles.EditQmax,'Visible','off');
set(handles.TextOrdrep1,'Visible','off');
set(handles.EditOrdrep1,'Visible','off');
set(handles.TextOrdrep2,'Visible','off');
set(handles.EditOrdrep2,'Visible','off');

% --------------------------------------------------------------------
function varargout = EditQmax_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditQmax.
disp('EditQmax Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditOrdrep1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditOrdrep1.
disp('EditOrdrep1 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditOrdrep2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditOrdrep2.
disp('EditOrdrep2 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditConfiance_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditConfiance.
disp('EditConfiance Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = PopupConfianceWeibull_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupConfianceWeibull.
disp('PopupConfianceWeibull Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = PopupTypeTest_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupTypeTest.
disp('PopupTypeTest Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = PopupNiveauCentraux_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupNiveauCentraux.
disp('PopupNiveauCentraux Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = PopupNiveauEtRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupNiveauEtRB.
disp('PopupNiveauEtRB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditExcesRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExcesRB.
disp('EditExcesRB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditPETRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditPETRB.
disp('EditPETRB Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = edit33_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit33.
disp('edit33 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = edit34_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit34.
disp('edit34 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = edit35_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit35.
disp('edit35 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = edit36_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit36.
disp('edit36 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditQuantileP5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditQuantileP5.
disp('EditQuantileP5 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = PopupResultatQuantilesRB_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupResultatQuantilesRB.
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Regularisation bayesienne';
else
    X = 'Bayesian regularisation';
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end
k1 = int2str(k(end));
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
RTmp=textread(FichierTmp,'%s','delimiter','\n','whitespace','');
R = load(FichierResult);
I = get(handles.PopupResultatQuantilesRB,'Value');
ListeQuantiles = get(handles.PopupResultatQuantilesRB,'String');
NbQuantiles = size(ListeQuantiles,1);
if strcmp(RTmp(5),'Exponentielle') == 1 | strcmp(RTmp(5),'Exponential') == 1
    Decale = 0;
else
    Decale = 1;
end
Depart = 17 + Decale;
R1 = sprintf('%f',R(Depart + I));
set(handles.TextResultatQEstime,'String',R1);
R2 = sprintf('%f',R(Depart + I + NbQuantiles));
set(handles.TextResultatqET,'String',R2);
R3 = sprintf('%f',R(Depart + I + 2 * NbQuantiles));
set(handles.TextResultatqPred,'String',R3);
if str2num(char(RTmp(8))) == 1
    R4 = sprintf('%f',R(Depart + I + 3 * NbQuantiles));
    set(handles.TextResultatQVrai,'String',R4);
    R5 = sprintf('%f',R(Depart + I + 4 * NbQuantiles));
    set(handles.TextResultatQVraiEstime,'String',R5);
end

% --------------------------------------------------------------------

function varargout = DensitesRB_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Regularisation bayesienne';
else
    X = 'Bayesian regularisation';
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end
k1 = int2str(k(end));
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');
hold off;
%histogramme
Rdonnees = load(FichierDonnees);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(Rdonnees,NbClasse);
Amp = X(2)-X(1);
K = K/size(Rdonnees,1)/Amp;
bar(X,K,'hist');
colormap(handles.CouleurHisto);
hold on;
% Affichage des densites
couleur = strvcat('m','b','g','c','k');
compt = 1;
     
if str2num(char(Param(8))) == 1
    Debut = k(end)+1;
    Fin = k(end)+3;
else
    Debut = k(end)+1;
    Fin = k(end)+2;;
end
     
for i=Debut:Fin
    j = int2str(i);
    FichierResultat = [Rep '/' 'Result' j '.txt'];
    R = load(FichierResultat);
    plot(R(:,1),R(:,2),couleur(compt));
    compt = compt + 1;
end
if str2num(char(Param(8))) == 1
    if handles.langue == 1
        legend('Densite du modele','Densite de simulation','Densite predictive');
    else
        legend('Model PDF','Simulation PDF','Predictive PDF');
    end
else
    if handles.langue == 1
        legend('Densite du modele','Densite predictive');
    else
        legend('Model PDF','Predictive PDF');
    end
end
if handles.langue == 1
    title(['Regularisation bayesienne - Modele ' char(Param(5))],'Color','r');
else
    title(['Bayesian regularisation - ' char(Param(5)) ' model'],'Color','r');
end

% --------------------------------------------------------------------

function varargout = SurvieRB_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Regularisation bayesienne';
else
    X = 'Bayesian regularisation';
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end
k1 = int2str(k(end));
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');
hold off;

Rdonnees = load(FichierDonnees);
NbDonnees = size(Rdonnees,1);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(Rdonnees,NbClasse);
HistoSurvie = zeros(size(K));
HistoSurvie(1) = 1;
for i=2:size(K,2)+1
    HistoSurvie(i) = HistoSurvie(i-1) - K(i-1)/NbDonnees;
end
Amp = X(2)-X(1);
X(end+1) = X(end) + Amp;
bar(X,HistoSurvie,'hist');
colormap(handles.CouleurHisto);
hold on;
couleur = strvcat('m','b','g','c','k');
compt = 1;
     
if str2num(char(Param(8))) == 1
    Debut = k(end)+4;
    Fin = k(end)+6;
else
    Debut = k(end)+3;
    Fin = k(end)+4;
end
     
for i=Debut:Fin
    j = int2str(i);
    FichierResultat = [Rep '/' 'Result' j '.txt'];
    R = load(FichierResultat);
    plot(R(:,1),R(:,2),couleur(compt));
    compt = compt + 1;
end
if str2num(char(Param(8))) == 1
    if handles.langue == 1
        legend('Fonction de survie du modele','Fonction de survie de simulation','Fonction de survie predictive');
    else
        legend('Model survival function','Simulation survival function','Predictive survival function');
    end
    
else
    if handles.langue == 1
        legend('Fonction de survie du modele','Fonction de survie predictive');
    else
        legend('Model survival function','Predictive survival function');
    end
end
if handles.langue == 1
    title(['Regularisation bayesienne - Modele ' char(Param(5))],'Color','r');
else
    title(['Bayesian regularisation - ' char(Param(5)) ' model'],'Color','r');
end
hold off;

% --------------------------------------------------------------------

function varargout = MenuFichiers_Callback(h, eventdata, handles, varargin)
% Menu contextuel desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% --------------------------------------------------------------------

function varargout = MenuSimul_Callback(h, eventdata, handles, varargin)
% Menu contextuel desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
%set(handles.MenuSimulationsPred,'Enable','off');

% --------------------------------------------------------------------

function varargout = MenuGraph_Callback(h, eventdata, handles, varargin)
% Menu contextuel desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% --------------------------------------------------------------------

function varargout = MenuTests_Callback(h, eventdata, handles, varargin)
% Menu contextuel desactive
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% --------------------------------------------------------------------

function varargout = MenuEstim_Callback(h, eventdata, handles, varargin)
% Menu contextuel active
set(handles.DensitesRB,'Enable','off');
set(handles.SurvieRB,'Enable','off');
set(handles.Histo1Param,'Enable','off');
set(handles.Histo2Param,'Enable','off');
set(handles.Histo3Param,'Enable','off');
set(handles.DensiteEstim,'Enable','off');
set(handles.SurvieEstim,'Enable','off');
set(handles.Pente,'Enable','off');
set(handles.QQPlotGPD,'Enable','off');
set(handles.CourbeGamma,'Enable','off');
set(handles.CourbeSigma,'Enable','off');
% simulation selon loi predictive non permise
set(handles.MenuSimulationsPred,'Enable','off');

% --------------------------------------------------------------------

function varargout = BtZoom_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtZoom.
[x,y] = ginput(2);
handles.ZoomMoins = [handles.ZoomMoins ; get(gca,'XLim') get(gca,'YLim')];
guidata(handles.Extremes,handles);
Zoom = [x(1) x(2) y(1) y(2)];
axis(Zoom);

% --------------------------------------------------------------------

function varargout = BtZoomMoins_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtZoomMoins.
Zoom = handles.ZoomMoins(end,:);
handles.ZoomMoins = handles.ZoomMoins(1:end-1,:);
guidata(handles.Extremes,handles);
axis(Zoom);

% --------------------------------------------------------------------

function varargout = Histo1Param_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);
FichierResult = [Rep '/' 'Result' k1 '.txt'];
R = load(FichierResult);
NbFichiers = R(end);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(R(1:NbFichiers),NbClasse);
Amp = X(2)-X(1);
K = K/size(R(1:NbFichiers),1)/Amp;
bar(X,K,'hist');
colormap(handles.CouleurHisto);
if handles.Tache ~= 31
    Loi = LitPopupEstim(handles);
    [param1,param2,param3,NbParam] = NomDesParametres(handles,Loi);
    if handles.langue == 1
        title(['Histogramme du parametre ' param1],'Color','r');
    else
        title(['Histogram of parameter ' param1],'Color','r');
    end
else
    if handles.langue == 1
        title('Histogramme du parametre gamma','Color','r');
    else
        title('Histogram of gamma parameter','Color','r');
    end
end

% --------------------------------------------------------------------

function varargout = Histo2Param_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);
FichierResult = [Rep '/' 'Result' k1 '.txt'];
R = load(FichierResult);
NbFichiers = R(end);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(R(NbFichiers+1:2*NbFichiers),NbClasse);
Amp = X(2)-X(1);
K = K/size(R(NbFichiers+1:2*NbFichiers),1)/Amp;
bar(X,K,'hist');
colormap(handles.CouleurHisto);
if handles.Tache ~= 31
    Loi = LitPopupEstim(handles);
    [param1,param2,param3,NbParam] = NomDesParametres(handles,Loi);
    if handles.langue == 1
        title(['Histogramme du parametre ' param2],'Color','r');
    else
        title(['Histogram of parameter ' param2],'Color','r');
    end
else
    if handles.langue == 1
        title('Histogramme du parametre sigma','Color','r');
    else
        title('Histogram of sigma parameter','Color','r');
    end
end    

% --------------------------------------------------------------------

function varargout = Histo3Param_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);
FichierResult = [Rep '/' 'Result' k1 '.txt'];
R = load(FichierResult);
NbFichiers = R(end);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(R(2*NbFichiers+1:3*NbFichiers),NbClasse);
Amp = X(2)-X(1);
K = K/size(R(2*NbFichiers+1:3*NbFichiers),1)/Amp;
bar(X,K,'hist');
colormap(handles.CouleurHisto);
Loi = LitPopupEstim(handles);
[param1,param2,param3,NbParam] = NomDesParametres(handles,Loi);
if handles.langue == 1
    title(['Histogramme du parametre ' param3],'Color','r');
else
    title(['Histogram of parameter ' param3],'Color','r');
end



% --------------------------------------------------------------------

function varargout = BtGrille_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtGrille.
grid on;    

% --------------------------------------------------------------------

function varargout = BtGrilleOff_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtGrilleOff.
grid off;

% --------------------------------------------------------------------

function varargout = BtCouleurHisto_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtCouleurHisto.
% coul = cmapui(2);
% if ~isempty(coul)
%     handles.CouleurHisto = coul(2,:);
%     guidata(handles.Extremes,handles);
% end
coul = uisetcolor;
[L,C] = size(coul);
if C == 1
    return;
else
    handles.CouleurHisto = coul;
    guidata(handles.Extremes,handles);
end


% --------------------------------------------------------------------

function varargout = SurvieEstim_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Estimation des parametres';
else
    X = 'Parameter estimates';
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end
k1 = int2str(k(end));
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');
hold off;

Rdonnees = load(FichierDonnees);
NbDonnees = size(Rdonnees,1);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(Rdonnees,NbClasse);
HistoSurvie = zeros(size(K));
HistoSurvie(1) = 1;
for i=2:size(K,2)+1
    HistoSurvie(i) = HistoSurvie(i-1) - K(i-1)/NbDonnees;
end
Amp = X(2)-X(1);
X(end+1) = X(end) + Amp;
bar(X,HistoSurvie,'hist');
colormap(handles.CouleurHisto);
hold on;
%affichage de la fonction de survie
j = int2str(k(end)+2);
FichierResultat = [Rep '/' 'Result' j '.txt'];
R = load(FichierResultat);
plot(R(:,1),R(:,2),'b');
Loi = char(Param(5));
if handles.langue == 1
    title(['Fonction de survie empirique et fonction de survie de la loi ' Loi],'Color','r');
else
    title([Loi ' empirical survival function and survival function'],'Color','r');
end
hold off;

% --------------------------------------------------------------------

function varargout = DensiteEstim_Callback(h, eventdata, handles, varargin)
Rep = LitRepEDT(handles);
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
if handles.langue == 1
    X = 'Estimation des parametres';
else
    X = 'Parameter estimates';
end
if strcmp(ListeAction{Index},X) == 1
    k = IndexInverse(Index);
else
    ListeAction = flipud(ListeAction);
    LA = strvcat(char(ListeAction));
    k = find(sum(LA~=repmat([X 32*ones(1,size(LA,2)-length(X))],size(LA,1),1),2)==0);
end
k1 = int2str(k(end));
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierDonnees = [Rep '/' 'Donnees.txt'];
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');
hold off;
%histogramme
Rdonnees = load(FichierDonnees);
if handles.langue == 1
    NbClasse = inputdlg('Nombre de classes :','Histogramme');
else
    NbClasse = inputdlg('Number of bins :','Histogram');
end
NbClasse = str2num(char(NbClasse));
[K,X] = hist(Rdonnees,NbClasse);
Amp = X(2)-X(1);
K = K/size(Rdonnees,1)/Amp;
bar(X,K,'hist');
colormap(handles.CouleurHisto);
hold on;
% Affichage de la densite
j = int2str(k(end)+1);
FichierResultat = [Rep '/' 'Result' j '.txt'];
R = load(FichierResultat);
plot(R(:,1),R(:,2),'b');
Loi = char(Param(5));
if handles.langue == 1
    title(['Histogramme et densite de la loi ' Loi],'Color','r');
else
    title([Loi ' probability density function and histogram'],'Color','r');
end
hold off;


% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES" POUR ESTIMATION GPD

function varargout = CBMomentsPonderes_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBMomentsPonderes.
set(handles.CBToutesGPD,'Value',0);


% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES" POUR ESTIMATION GPD

function varargout = CBEMV_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBEMV.
set(handles.CBToutesGPD,'Value',0);


% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES" POUR ESTIMATION GPD

function varargout = CBHill_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBHill.
set(handles.CBToutesGPD,'Value',0);


% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES" POUR ESTIMATION GPD

function varargout = CBHillGeneralise_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBHillGeneralise.
set(handles.CBToutesGPD,'Value',0);


% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES" POUR ESTIMATION GPD

function varargout = CBZipf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBZipf.
set(handles.CBToutesGPD,'Value',0);


% --------------------------------------------------------------------
function varargout = EditExcesInfGPD_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExcesInfGPD.
disp('EditExcesInfGPD Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = EditExcesSupGPD_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditExcesSupGPD.
disp('EditExcesSupGPD Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = edit40_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit40.
disp('edit40 Callback not implemented yet.')


% --------------------------------------------------------------------

function varargout = BtLancerEstimGPD_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLancerEstimGPD.

% Verification des entrees
V = VerifEstimGPD(handles);
if V ~= 1
    switch(V)
    case 2
        if handles.langue == 1
            errordlg('Il faut selectionner au moins une methode','Erreur de saisie','modal');
        else
            errordlg('One or more methods must be checked','Error','modal');
        end
    case 3
        if handles.langue == 1
            errordlg('Il n''est possible de selectionner qu''une seule methode','Erreur de saisie','modal');
        else
            errordlg('Only one method can be checked','Error','modal');
        end
    case 4
        if handles.langue == 1
            errordlg('Un ou plusieurs champs sont vides','Erreur de saisie','modal');
        else
            errordlg('Empty entries found','Error','modal');
        end;
    case 5
        if handles.langue == 1
            errordlg('Le nombre d''exces doit etre compris entre 2 et la taille totale de l''echantillon moins 1','Erreur de saisie','modal');
        else
            errordlg('Number of excesses must be between 2 and total sample size minus 1','Error','modal');
        end
    case 6
        if handles.langue == 1
            errordlg('Le nombre d''exces doit etre compris entre 2 et la taille totale de l''echantillon','Erreur de saisie','modal');
        else
            errordlg('Number of excesses must be between 2 and total sample size','Error','modal');
        end
    case 7
        if handles.langue == 1
            errordlg('L''ordre du quantile doit etre strictement compris entre 0 et 1','Erreur de saisie','modal');
        else
            errordlg('Order of quantile must be strictly between 0 and 1','Error','modal');
        end
    case 8
        if handles.langue == 1
            errordlg('La borne inferieure du nombre d''exces doit toujours etre inferieure e la borne superieure','Erreur de saisie','modal');
        else
            errordlg('Inferior limit of excesses must always be smaller than superior limit.','Error','modal');
        end
    end
    return;
end

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Reinitialisation de la frame de resultats des tests
ViderFrameResultatEstimGPD(handles);

% Si plusieurs methodes
if handles.Tache == 28 & (get(handles.CBMomentsPonderes,'Value') + get(handles.CBEMV,'Value') + get(handles.CBHill,'Value') + get(handles.CBHillGeneralise,'Value') + get(handles.CBZipf,'Value') >= 2)
    handles.Tache = 29;
end
if handles.Tache == 32 & (get(handles.CBMomentsPonderes,'Value') + get(handles.CBEMV,'Value') + get(handles.CBHill,'Value') + get(handles.CBHillGeneralise,'Value') + get(handles.CBZipf,'Value') >= 2)
    handles.Tache = 33;
end

% Actualisation de l'espace des actions
EspaceAction = strvcat(char(handles.Action));
Action = TacheToAction(handles);
EspaceAction = strvcat(Action,EspaceAction);

% Construit le fichier de donnees
if handles.Tache == 31 | handles.Tache == 35
    FichierDonnees = 'Tous';
else
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
end

% DEBUT Construit le fichier resultat

    % Indice du fichier
N = int2str(size(EspaceAction,1));

    % Nom du fichier resulat
FichierResultat = [Rep '/' 'Result' N '.txt'];

% FIN

% DEBUT - Creation du fichier d'echange Tmp

FichierEchange = [Rep '/' 'Tmp' N '.txt'];
fid3 = fopen(FichierEchange,'w');
Rep1 = [Rep '/'];
fprintf(fid3,'%s\n',Rep1);
fprintf(fid3,'%s\n',FichierDonnees);
t = handles.Tache;
t1 = int2str(t);
fprintf(fid3,'%s\n',t1);
fprintf(fid3,'%s\n',FichierResultat);

    % Methodes cochees 
Methode = [];
if get(handles.CBMomentsPonderes,'Value') == 1
    fprintf(fid3,'%s\n','HW');
    Methode = strvcat(Methode,'HW');
end
if get(handles.CBEMV,'Value') == 1
    fprintf(fid3,'%s\n','EMV');
    Methode = strvcat(Methode,'EMV');
end
if get(handles.CBHill,'Value') == 1
    fprintf(fid3,'%s\n','Hill');
    Methode = strvcat(Methode,'Hill');
end
if get(handles.CBHillGeneralise,'Value') == 1
    fprintf(fid3,'%s\n','HillG');
    Methode = strvcat(Methode,'HillG');
end
if get(handles.CBZipf,'Value') == 1
    fprintf(fid3,'%s\n','Zipf');
    Methode = strvcat(Methode,'Zipf');
end
    % si 1 seul nb d'exces
if t == 28 | t == 29 | t == 31 | t == 32 | t == 33 | t == 35
    NbExces = get(handles.EditExcesInfGPD,'String');
    fprintf(fid3,'%s\n',NbExces);
    fprintf(fid3,'%s\n','0');
else
    ExcesInf = get(handles.EditExcesInfGPD,'String');
    ExcesSup = get(handles.EditExcesSupGPD,'String');
    fprintf(fid3,'%s\n',ExcesInf);
    fprintf(fid3,'%s\n',ExcesSup);
end

if t == 28 | t == 29 | t == 30 | t == 31
    fprintf(fid3,'%s\n','0');    
else
    Ordre = get(handles.EditPGPD,'String');
    fprintf(fid3,'%s\n',Ordre);
end
fclose(fid3);

% FIN Constuction du fichier Tmp

% Bouton Lancer active
set(handles.BtLancerEstimGPD,'Enable','off');

% Lancement du prog C++
[status result] = unix([handles.Prog ' ' FichierEchange ' 5']);

FichierErreur = [Rep '/' 'Erreur.txt'];
if exist(FichierErreur)~=0
    fid4 = fopen(FichierErreur,'r');
    Message = fgets(fid4);
    fclose(fid4);
    delete(FichierErreur);
    if handles.langue == 1
        errordlg(Message,'Erreur de saisie utilisateur','modal');
    else
        errordlg(Message,'User write error','modal');
    end
    set(handles.BtLancerEstimGPD,'Enable','on');
    return;
end    

% Recuperation des resultats
% Nouveau graphe
hold off;

% Conversion de la frame des resultats
if handles.langue == 1
    set(handles.TextResultatEstimGPD,'String','Parametres GPD');
    set(handles.TextResultatMethodeGPD,'String','Methodes');
    set(handles.TextResultatParam,'String','Parametres');
else
    set(handles.TextResultatEstimGPD,'String','GPD parameters');
    set(handles.TextResultatMethodeGPD,'String','Methods');
    set(handles.TextResultatParam,'String','Parameters');
end

if t == 28 | t == 29 | t == 32 | t == 33  % 1 jeu - 1 nb d'exces - 1 ou N methodes
    
    % Lecture du fichiers de donnees
    R = load(FichierResultat);
    
    % Affichage des methodes selectionnees dans la Popup des methodes
    Methode = cellstr(Methode);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    NbMethode = size(Methode,1);
    
    % Affichage des resultats obtenus avec la 1ere methode
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');
    set(handles.TextQGPD,'String','quantile');
    R1 = sprintf('%f',R(1,1));
    if str2num(R1) ~= -10
        set(handles.TextResultatGammaGPD,'String',R1);
    else
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    end
    R2 = sprintf('%f',R(1,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        if handles.langue == 1
            set(handles.TextResultatSigmaGPD,'String','non');
        else
            set(handles.TextResultatSigmaGPD,'String','no');
        end
    end
    if t == 32 | t == 33
        R3 = sprintf('%f',R(NbMethode+1,2));
        if str2num(R3) ~= -10
            set(handles.TextResultatQGPD,'String',R3);
        else
            if handles.langue == 1
                set(handles.TextResultatQGPD,'String','non');
            else
                set(handles.TextResultatQGPD,'String','no');
            end
        end
        FrameResultatEstimGPDVisible(handles);
        set(handles.TextResultatQGPD,'Visible','on');
        set(handles.TextQGPD,'Visible','on');
    else
        FrameResultatEstimGPDVisible(handles);
    end
    
    if t == 28
        % Affichage du qq-plot
%         Plage = 3:3+str2num(NbExces)-1;
%         plot(R(Plage,1),R(Plage,2),'g.');
        Plage = 2:2+str2num(NbExces)-1;
        PlageInv = 2+str2num(NbExces)-1:-1:2;
        plot(R(PlageInv,1),R(Plage,2),'g.');
    end
    
    % Titre du graphique
    if t == 28 | t == 29
        if handles.langue == 1
            title('Graphe QQ-Plot - Estimation de gamma (GPD)','Color','r');
        else
            title('QQ-Plot graph - Gamma estimate (GPD)','Color','r');
        end
    end        
    
    % Menu contextuel du graphique active
    set(handles.Pente,'Enable','on');
    set(handles.QQPlotGPD,'Enable','on');
    
end

if t == 30 | t == 34 % 1 jeu - N exces - 1 ou N methodes

    % Lecture du fichiers de donnees
    R = load(FichierResultat);
    
    % Nombre de methodes et plage des exces
    NbMethode = size(Methode,1);
    Plage = str2num(ExcesSup) - str2num(ExcesInf) + 1;
    
    % Affichage
    couleur = strvcat('m','b','g','c','k');
    compt = 1;
    MethodeInvalide = [];
    for i=1:NbMethode
        Rtemp = R(1+(i-1)*Plage:i*Plage,:);
        ktemp = find(Rtemp(:,2) == -10);
        ktemp1 = find(Rtemp(:,2) ~= -10);
        if isempty(ktemp1)
            MethodeInvalide = i;
        end
        if isempty(ktemp)
            plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
        else
            Rtemp1 = Rtemp(ktemp1,:);
            plot(Rtemp1(:,1),Rtemp1(:,2),[couleur(compt) '.']);
        end
%         plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
%         hold on;
%         compt = compt + 1;
        hold on;
        compt = compt + 1;
    end
    
    % Titre du graphique
    if t == 30
        if handles.langue == 1
            title('Courbe des gamma estimes','Color','r');
        else
            title('Estimated gamma curve','Color','r');
        end
    else
        if handles.langue == 1
            title('Courbe des quantiles extremes','Color','r');
        else
            title('Extreme quantiles curve','Color','r');
        end
    end
    
    % Legende
    Methode = cellstr(Methode);
    % si pour une methode (EMV), il n'y a aucun resultat corret
    if ~isempty(MethodeInvalide)
        Methode2 = [];
        for i=1:NbMethode
            if i ~= MethodeInvalide
                Methode2 = strvcat(Methode2,char(Methode(i)));
            end
        end
        NbMethode = size(Methode2,1);
        Methode = cellstr(Methode2);
    end
    
    switch(NbMethode)
    case 1
        legend(char(Methode(1)));
    case 2
        legend(char(Methode(1)),char(Methode(2)));
    case 3
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)));
    case 4
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)));
    case 5
        legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)),char(Methode(5)));
    end
    
    % Menu contextuel du graphique active
    if t == 30
        set(handles.CourbeGamma,'Enable','on');
        set(handles.CourbeSigma,'Enable','on');
    end
    %set(handles.CourbeQuantile,'Enable','on');
    
end

if t == 31  % N jeu - 1 nb d'exces - 1 methode

    % Lecture du fichiers de donnees
    R = load(FichierResultat);
    
    % Affichage de la methode selectionnee dans la Popup des methodes
    Methode = cellstr(Methode);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Nombre de fichiers traites
    NbFichiers = round(R(end));
    
    % Affichage des resultats obtenus avec la 1ere methode
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','gamma moyen');
        set(handles.TextSigmaGPD,'String','sigma moyen');
        set(handles.TextQGPD,'String','variance de gamma');
        set(handles.TextVarSigmaGPD,'String','variance de sigma');
    else
        set(handles.TextGammaGPD,'String','mean gamma');
        set(handles.TextSigmaGPD,'String','mean sigma');
        set(handles.TextQGPD,'String','gamma variance');
        set(handles.TextVarSigmaGPD,'String','sigma variance');
    end
    R1 = sprintf('%f',R(end-4));
    set(handles.TextResultatGammaGPD,'String',R1);
    R2 = sprintf('%f',R(end-2));
    set(handles.TextResultatSigmaGPD,'String',R2);
    R3 = sprintf('%f',R(end-3));
    set(handles.TextResultatQGPD,'String',R3);
    R4 = sprintf('%f',R(end-1));
    set(handles.TextResultatVarSigmaGPD,'String',R4);
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextQGPD,'Visible','on');
    set(handles.TextResultatQGPD,'Visible','on');
    set(handles.TextResultatVarSigmaGPD,'Visible','on');
    set(handles.TextVarSigmaGPD,'Visible','on');
    
    % Histogramme de l'estimateur de gamma
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(R(1:NbFichiers),NbClasse);
    Amp = X(2)-X(1);
    K = K/size(R(1:NbFichiers),1)/Amp;
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Titre du graphique
    if handles.langue == 1
        title('Histogramme du parametre gamma','Color','r');
    else
        title('Gamma parameter histogram','Color','r');
    end
    % menu contextuel du graphique active
    set(handles.Histo1Param,'Enable','on');
    set(handles.Histo2Param,'Enable','on');
end

if t == 35
    
    % Lecture du fichiers de donnees
    R = load(FichierResultat);
    
    % Affichage de la methode selectionnee dans la Popup des methodes
    Methode = cellstr(Methode);
    set(handles.PopupResultatMethode,'Value',1);
    set(handles.PopupResultatMethode,'String',Methode);
    
    % Nombre de fichiers traites
    NbFichiers = round(R(end));
    
    % Affichage des resultats obtenus avec la 1ere methode
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','quantile moyen');
        set(handles.TextSigmaGPD,'String','variance du quantile');
    else
        set(handles.TextGammaGPD,'String','mean quantile');
        set(handles.TextSigmaGPD,'String','quantile variance');
    end
    R1 = sprintf('%f',R(end-2));
    set(handles.TextResultatGammaGPD,'String',R1);
    R2 = sprintf('%f',R(end-1));
    set(handles.TextResultatSigmaGPD,'String',R2);
    FrameResultatEstimGPDVisible(handles);
    
    % Hiistogramme
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    [K,X] = hist(R(1:NbFichiers),NbClasse);
    Amp = X(2)-X(1);
    K = K/NbFichiers/Amp;
    
    % question pour l'utilisateur
    if handles.langue == 1
        GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
    else
        GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
    end
        
    switch (GardeGraph)
    case {'Oui','Yes'}
                   
        % on affiche sur le meme graphe
        hold on;
    case {'Non','No'}
        % nouveau graphe
        hold off;
    end
        
    bar(X,K,'hist');
    colormap(handles.CouleurHisto);
    
    % Titre du graphique
    if handles.langue == 1
        title('Histogramme des quantiles extremes','Color','r');
    else
        title('Extreme quantiles histogram','Color','r');
    end
    
end

% Affichage de la nouvelle liste des actions
handles.Action = cellstr(EspaceAction);
set(handles.PopupAction,'String',handles.Action);
set(handles.PopupAction,'Value',1);

% Sauvegarde des variables
guidata(handles.Extremes,handles);

% Actualise le fichier des actions
FichierAction = [Rep '/' 'Action.txt'];
fid1 = fopen(FichierAction,'a');
fprintf(fid1,'%s\n',Action);
fclose(fid1);

% Actualise le fichier des numeros de taches
FichierTache = [Rep '/' 'Tache.txt'];
fid2 = fopen(FichierTache,'a');
fprintf(fid2,'%d\n',t);
fclose(fid2);

hold off;

% Aucune action en cours
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% COCHE TOUTES LES METHODES POUR L'ESTIMATION DES PARAMETRES DE LA LOI GPD

function varargout = checkbox19_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.checkbox19.
set(handles.CBMomentsPonderes,'Value',1);
set(handles.CBEMV,'Value',1);
set(handles.CBHill,'Value',1);
set(handles.CBHillGeneralise,'Value',1);
set(handles.CBZipf,'Value',1);


% --------------------------------------------------------------------

function varargout = PopupResultatMethode_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PopupResultatMethode.

% Si donnees multiples
if handles.Tache == 31 | handles.Tache == 35 | handles.Tache == 37
    return;
end

% Reinitialisation de la frame resultats estimGPD
ViderFrameResultatEstimGPD(handles);

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recherche de l'indice du fichier resultat
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k(1));

% Nom du fichier Resultat 
FichierResult = [Rep '/' 'Result' k1 '.txt'];

% lecture du fichier resultat
R = load(FichierResult);


if handles.Tache ~= 36
    % Methode selectionnee
    I = get(handles.PopupResultatMethode,'Value');
    ListeMethode = get(handles.PopupResultatMethode,'String');
    NbMethode = size(ListeMethode,1);

    % Affichage
    set(handles.TextGammaGPD,'String','gamma');
    set(handles.TextSigmaGPD,'String','sigma');

    R1 = sprintf('%f',R(I,1));
    if str2num(R1) == -10
        set(handles.TextResultatGammaGPD,'String','non');
    else
        set(handles.TextResultatGammaGPD,'String',R1);
    end
    R2 = sprintf('%f',R(I,2));
    if str2num(R2) ~= -10
        set(handles.TextResultatSigmaGPD,'String',R2);
    else
        set(handles.TextResultatSigmaGPD,'String','non');
    end
    %R3 = sprintf('%f',R(NbMethode+I,2));
    %set(handles.TextResultatQGPD,'String',R3);
    if handles.Tache == 32 | handles.Tache == 33
        set(handles.TextQGPD,'String','quantile');
        R3 = sprintf('%f',R(NbMethode+I,2));
        if str2num(R3) ~= -10
            set(handles.TextResultatQGPD,'String',R3);
        else
            set(handles.TextResultatQGPD,'String','non');
        end
    end
    
else
    set(handles.TextGammaGPD,'String','q param');
    
    % Loi selectionnee
    I = get(handles.PopupResultatMethode,'Value');
    if R(I) == -10
        set(handles.TextResultatGammaGPD,'String','non');
    else
        R1 = sprintf('%f',R(I));
        set(handles.TextResultatGammaGPD,'String',R1);
    end
end
    
% --------------------------------------------------------------------
% MENU CONTEXTUEL DU GRAPHIQUE : MISE EN EVIDENCE DE SIGMA PAR LA PENTE

function varargout = Pente_Callback(h, eventdata, handles, varargin)

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recherche de l'indice des fichiers concernes
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);

% Nom du fichier resultat et Tmp
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];

% Lecture du fichier resultat
R = load(FichierResult);

% Lecture du fichier des parametres
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Nouveau graphe
hold off;

% Nombre d'exces
NbExces = round(str2num(char(Param(end-2))));

% Affichage du graphe
Plage = 2+NbExces:2+2*NbExces-1;
%Plage = 2+2*NbExces-1:-1:2+NbExces;
plot(R(Plage,1),R(Plage,2),'g');
%text(R(3+2*NbExces-1,1),R(3+2*NbExces-1,2),['Pente estimee = ' num2str(R(end,2))],'HorizontalAlignment','left','Color','r');

% Titre du graphique
if handles.langue == 1
    title('Mise en evidence de gamma par la pente','Color','r');
else
    title('Gamma illustration by curve slope','Color','r');
end
% --------------------------------------------------------------------
% MENU CONTEXTUEL DU GRAPHIQUE : QQ-Plot GPD

function varargout = QQPlotGPD_Callback(h, eventdata, handles, varargin)

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recherche de l'indice des fichiers concernes
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);

% Nom du fichier resultat et Tmp
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];

% Lecture du fichier resultat
R = load(FichierResult);

% Lecture du fichier des parametres
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Nouveau graphe
hold off;

% Nombre d'exces
NbExces = round(str2num(char(Param(end-2))));

% Affichage du qq-plot
Plage = 2:2+NbExces-1;
PlageInv = 2+NbExces-1:-1:2;
plot(R(PlageInv,1),R(Plage,2),'g.');

% Titre du graphique
if handles.langue == 1
    title('Graphe QQ-Plot - Estimation de gamma (GPD)','Color','r');
else
    title('QQ-Plot graph - Gamma estimate (GPD)','Color','r');
end

% --------------------------------------------------------------------
% MENU CONTEXTUEL DU GRAPHIQUE : COURBE DES GAMMA ESTIMES

function varargout = CourbeGamma_Callback(h, eventdata, handles, varargin)

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recherche de l'indice des fichiers concernes
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);

% Nom du fichier resultat et Tmp
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];

% Lecture du fichier resultat
R = load(FichierResult);

% Lecture du fichier des parametres
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Nouveau graphe
hold off;

% Methode
Methode = Param(5:end-3);
NbMethode = size(Methode,1);

% Nb d'exces
ExcesInf = round(str2num(char(Param(end-2))));
ExcesSup = round(str2num(char(Param(end-1))));

% Plage des exces
Plage = ExcesSup - ExcesInf + 1;
  
% Affichage
couleur = strvcat('m','b','g','c','k');
compt = 1;
MethodeInvalide = [];
for i=1:NbMethode
    Rtemp = R(1+(i-1)*Plage:i*Plage,:);
    ktemp = find(Rtemp(:,2) == -10);
    ktemp1 = find(Rtemp(:,2) ~= -10);
    if isempty(ktemp1)
        MethodeInvalide = i;
    end
    if isempty(ktemp)
        plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
    else
        Rtemp1 = Rtemp(ktemp1,:);
        plot(Rtemp1(:,1),Rtemp1(:,2),[couleur(compt) '.']);
    end
    %plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
    hold on;
    compt = compt + 1;
end
    
% Titre du graphique
if handles.langue == 1
    title('Courbe des gamma estimes','Color','r');
else
    title('Estimated gamma curve','Color','r');
end
% Legende
Methode = Param(5:end-3);
% si pour une methode (EMV), il n'y a aucun resultat corret
if ~isempty(MethodeInvalide)
    Methode2 = [];
    for i=1:NbMethode
        if i ~= MethodeInvalide
           Methode2 = strvcat(Methode2,char(Methode(i)));
        end
    end
    NbMethode = size(Methode2,1);
    Methode = cellstr(Methode2);
end

switch(NbMethode)
case 1
    legend(char(Methode(1)));
case 2
    legend(char(Methode(1)),char(Methode(2)));
case 3
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)));
case 4
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)));
case 5
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)),char(Methode(5)));
end

% --------------------------------------------------------------------
% MENU CONTEXTUEL DU GRAPHIQUE : COURBE DES SIGMA ESTIMES

function varargout = CourbeSigma_Callback(h, eventdata, handles, varargin)

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Recherche de l'indice des fichiers concernes
ListeAction = get(handles.PopupAction,'String');
Index = get(handles.PopupAction,'Value');
ListeAction = get(handles.PopupAction,'String');
IndexInverse = size(ListeAction,1):-1:1;
IndexInverse = IndexInverse';
k = IndexInverse(Index);
k1 = int2str(k);

% Nom du fichier resultat et Tmp
FichierResult = [Rep '/' 'Result' k1 '.txt'];
FichierTmp = [Rep '/' 'Tmp' k1 '.txt'];

% Lecture du fichier resultat
R = load(FichierResult);

% Lecture du fichier des parametres
[Param]=textread(FichierTmp,'%s','delimiter','\n','whitespace','');

% Nouveau graphe
hold off;

% Methode
Methode = Param(5:end-3);
NbMethode = size(Methode,1);

% Nb d'exces
ExcesInf = round(str2num(char(Param(end-2))));
ExcesSup = round(str2num(char(Param(end-1))));

% Plage des exces
Plage = ExcesSup - ExcesInf + 1;
  
% Affichage
couleur = strvcat('m','b','g','c','k');
compt = 1;
MethodeInvalide = [];
for i=NbMethode+1:2*NbMethode
    Rtemp = R(1+(i-1)*Plage:i*Plage,:);
    ktemp = find(Rtemp(:,2) == -10);
    ktemp1 = find(Rtemp(:,2) ~= -10);
    if isempty(ktemp1)
        MethodeInvalide = i - NbMethode;
    end
    if isempty(ktemp)
        plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
    else
        Rtemp1 = Rtemp(ktemp1,:);
        plot(Rtemp1(:,1),Rtemp1(:,2),[couleur(compt) '.']);
    end
    %plot(R(1+(i-1)*Plage:i*Plage,1),R(1+(i-1)*Plage:i*Plage,2),couleur(compt));
    hold on;
    compt = compt + 1;
end
    
% Titre du graphique
if handles.langue == 1
    title('Courbe des sigma estimes','Color','r');
else
    title('Estimated sigma curve','Color','r');
end
% Legende
Methode = Param(5:end-3);
% si pour une methode (EMV), il n'y a aucun resultat corret
if ~isempty(MethodeInvalide)
    Methode2 = [];
    for i=1:NbMethode
        if i ~= MethodeInvalide
            Methode2 = strvcat(Methode2,char(Methode(i)));
        end
    end
    NbMethode = size(Methode2,1);
    Methode = cellstr(Methode2);
end

switch(NbMethode)
case 1
    legend(char(Methode(1)));
case 2
    legend(char(Methode(1)),char(Methode(2)));
case 3
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)));
case 4
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)));
case 5
    legend(char(Methode(1)),char(Methode(2)),char(Methode(3)),char(Methode(4)),char(Methode(5)));
end

% --------------------------------------------------------------------
% CLICK SUR LE BOUTON CHOIX DES LOIS

function varargout = BtChoixLois_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtChoixLois.

% affichage de la frame choix des lois
FrameChoixLoisVisible(handles);


% --------------------------------------------------------------------
function varargout = EditOrdreQuantileParam_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.EditOrdreQuantileParam.
disp('EditOrdreQuantileParam Callback not implemented yet.')


% --------------------------------------------------------------------
% EXECUTION DU CALCUL DE QUANTILES PARAMETRIQUES

function varargout = BtLancerQuantileParam_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtLancerQuantileParam.

% Verification des entrees
V = VerifQParam(handles);
if V ~= 1
    switch(V)
    case 2
        if handles.langue == 1
            errordlg('Il faut selectionner au moins un modele','Erreur de saisie','modal');
        else
            errordlg('One or more models must be checked','Error','modal');
        end
    case 3
        if handles.langue == 1
            errordlg('Il n''est possible de selectionner qu''un seul modele','Erreur de saisie','modal');
        else
            errordlg('Only one model can be checked','Error','modal');
        end
    case 4
        if handles.langue == 1
            errordlg('Un ou plusieurs champs sont vides','Erreur de saisie','modal');
        else
            errordlg('Empty entries found','Error','modal');
        end;
    case 5
        if handles.langue == 1
            errordlg('L''ordre du quantile doit etre strictement compris entre 0 et 1','Erreur de saisie','modal');
        else
            errordlg('Order of quantile must be strictly between 0 and 1','Error','modal');
        end
    end
    return;
end

% Lecture de l'espace de travail
Rep = LitRepEDT(handles);

% Reinitialisation de la frame de resultats (estim GPD)
ViderFrameResultatEstimGPD(handles);

% Actualisation de l'espace des actions
EspaceAction = strvcat(char(handles.Action));
Action = TacheToAction(handles);
EspaceAction = strvcat(Action,EspaceAction);

% Construit le fichier de donnees
if handles.Tache == 37
    FichierDonnees = 'Tous';
else
    FichierDonnees = [Rep '/' 'Donnees.txt'];
    if exist(FichierDonnees)==0
        FichierDonnees = '*';
    end
end

% DEBUT Construit le fichier resultat

    % Indice du fichier
N = int2str(size(EspaceAction,1));

    % Nom du fichier resulat
FichierResultat = [Rep '/' 'Result' N '.txt'];

% FIN

% DEBUT - Creation du fichier d'echange Tmp
FichierEchange = [Rep '/' 'Tmp' N '.txt'];
fid3 = fopen(FichierEchange,'w');
Rep1 = [Rep '/'];
fprintf(fid3,'%s\n',Rep1);
fprintf(fid3,'%s\n',FichierDonnees);
t = handles.Tache;
t1 = int2str(t);
fprintf(fid3,'%s\n',t1);
fprintf(fid3,'%s\n',FichierResultat);

    % Lois cochees 
Loi = [];
if get(handles.CBCLNormale,'Value') == 1
    fprintf(fid3,'%s\n','Normale');
    Loi = strvcat(Loi,'Normale');
end
if get(handles.CBCLLognormale,'Value') == 1
    fprintf(fid3,'%s\n','Lognormale');
    Loi = strvcat(Loi,'Lognormale');
end
if get(handles.CBCLExpo,'Value') == 1
    fprintf(fid3,'%s\n','Exponentielle');
    Loi = strvcat(Loi,'Exponentielle');
end
if get(handles.CBCLWeibull,'Value') == 1
    fprintf(fid3,'%s\n','Weibull');
    Loi = strvcat(Loi,'Weibull');
end
if get(handles.CBCLGamma,'Value') == 1
    fprintf(fid3,'%s\n','Gamma');
    Loi = strvcat(Loi,'Gamma');
end
if get(handles.CBCLChi2,'Value') == 1
    fprintf(fid3,'%s\n','Chi2');
    Loi = strvcat(Loi,'Chi2');
end
if get(handles.CBCLStudent,'Value') == 1
    fprintf(fid3,'%s\n','Student');
    Loi = strvcat(Loi,'Student');
end
if get(handles.CBCLPareto,'Value') == 1
    fprintf(fid3,'%s\n','Pareto');
    Loi = strvcat(Loi,'Pareto');
end
if get(handles.CBCLGPD,'Value') == 1
    fprintf(fid3,'%s\n','GPD');
    Loi = strvcat(Loi,'GPD');
end
if get(handles.CBCLUnif,'Value') == 1
    fprintf(fid3,'%s\n','Uniforme');
    Loi = strvcat(Loi,'Uniforme');
end
if get(handles.CBCLBeta,'Value') == 1
    fprintf(fid3,'%s\n','Beta');
    Loi = strvcat(Loi,'Beta');
end

% on met des 0 e la place des entrees dont on ne se sert pas
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
fprintf(fid3,'%s\n','0');
Ordre = get(handles.EditOrdreQuantileParam,'String');
fprintf(fid3,'%s\n',Ordre);
fclose(fid3);

% FIN Constuction du fichier Tmp

% bouton Lancer desactive
set(handles.BtLancerQuantileParam,'Enable','off');

% Lancement du prog C++
[status result] = unix([handles.Prog ' ' FichierEchange ' 2']);

% si erreur
FichierErreur = [Rep '/' 'Erreur.txt'];
if exist(FichierErreur)~=0
    fid4 = fopen(FichierErreur,'r');
    Message = fgets(fid4);
    fclose(fid4);
    delete(FichierErreur);
    if handles.langue == 1
        errordlg(Message,'Erreur de saisie utilisateur','modal');
    else
        errordlg(Message,'User write error','modal');
    end
    set(handles.BtLancerQuantileParam,'Enable','on');
    return;
end

% Lecture du fichiers de donnees
R = load(FichierResultat);
    
% Affichage des methodes selectionnees dans la Popup des methodes
Loi = cellstr(Loi);
set(handles.PopupResultatMethode,'Value',1);
if handles.langue == 1
    set(handles.PopupResultatMethode,'String',Loi);
else
    LoiEn = [];
    for i=1:size(Loi,1)
        LoiEnTemp = LoiFrToEn(char(Loi(i)));
        LoiEn = strvcat(LoiEn,LoiEnTemp);
    end
    LoiEn = cellstr(LoiEn);
    set(handles.PopupResultatMethode,'String',LoiEn);
end
NbLoi = size(Loi,1);

% Conversion de la Frame des resultats de l'estimation GPD
if handles.langue == 1
    set(handles.TextResultatEstimGPD,'String','Resultats Q Param');
    set(handles.TextResultatMethodeGPD,'String','Modeles');
    set(handles.TextResultatParam,'String','Quantiles');
else
    set(handles.TextResultatEstimGPD,'String','Q Param results');
    set(handles.TextResultatMethodeGPD,'String','Models');
    set(handles.TextResultatParam,'String','Quantiles');
end

if t == 36
    
    % Affichage du premier quantile calcule
    set(handles.TextGammaGPD,'String','q param');
    set(handles.TextSigmaGPD,'String','');
    set(handles.TextQGPD,'String','');
    if R(1) == -10
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    else
        R1 = sprintf('%f',R(1));
        set(handles.TextResultatGammaGPD,'String',R1);
    end
    FrameResultatEstimGPDVisible(handles);
    set(handles.TextSigmaGPD,'Visible','off');
    set(handles.TextResultatSigmaGPD,'Visible','off');
    
end

if t == 37
    
    % Affichage du quantile moyen
    if handles.langue == 1
        set(handles.TextGammaGPD,'String','q moyen');
        set(handles.TextSigmaGPD,'String','variance de q');
    else
        set(handles.TextGammaGPD,'String','mean q');
        set(handles.TextSigmaGPD,'String','q variance');
    end
    set(handles.TextQGPD,'String','');
    if R(end-2) == -10
        if handles.langue == 1
            set(handles.TextResultatGammaGPD,'String','non');
        else
            set(handles.TextResultatGammaGPD,'String','no');
        end
    else
        R1 = sprintf('%f',R(end-2));
        set(handles.TextResultatGammaGPD,'String',R1);
    end
    R2 = sprintf('%f',R(end-1));
    set(handles.TextResultatSigmaGPD,'String',R2);
    FrameResultatEstimGPDVisible(handles);
    
    % histogramme des quantiles
    NbFichiers = R(end);
    if handles.langue == 1
        NbClasse = inputdlg('Nombre de classes :','Histogramme');
    else
        NbClasse = inputdlg('Number of bins :','Histogram');
    end
    NbClasse = str2num(char(NbClasse));
    R1 = R(1:NbFichiers);
    k = find(R1 ~= -10);
    if isempty(k)
        if handles.langue == 1
            errordlg('Impossible de dessiner l''histogramme','Valeur de quantile invalide','modal');
        else
            errordlg('Histogram can''t be drawn','Invalid quantile value','modal');
        end
    else
        % question pour l'utilisateur
        if handles.langue == 1
            GardeGraph = questdlg('Afficher en gardant le graphique precedent ?','Affichage','Oui','Non','Non');
        else
            GardeGraph = questdlg('Draw on the same graph ?','Drawing','Yes','No','No');
        end
        
        switch (GardeGraph)
        case {'Oui','Yes'}
            
            % on affiche sur le meme graphe
            hold on;
        case {'Non','No'}
            % nouveau graphe
            hold off;
        end
        R2 = R1(k);
        [K,X] = hist(R2,NbClasse);
        Amp = X(2)-X(1);
        K = K/size(k,1)/Amp;
        bar(X,K,'hist','r');
%    colormap(handles.CouleurHisto);

    % Titre du graphique
        if handles.langue == 1
            title('Histogramme des quantiles parametriques','Color','r');
        else
            title('Parametric quantiles histogram','Color','r');
        end
    end
    
end
        
% Affichage de la nouvelle liste des actions
handles.Action = cellstr(EspaceAction);
set(handles.PopupAction,'String',handles.Action);
set(handles.PopupAction,'Value',1);

% Sauvegarde des variables
guidata(handles.Extremes,handles);

% Actualise le fichier des actions
FichierAction = [Rep '/' 'Action.txt'];
fid1 = fopen(FichierAction,'a');
fprintf(fid1,'%s\n',Action);
fclose(fid1);

% Actualise le fichier des numeros de taches
FichierTache = [Rep '/' 'Tache.txt'];
fid2 = fopen(FichierTache,'a');
fprintf(fid2,'%d\n',t);
fclose(fid2);

hold off;

% Aucune action en cours
set(handles.TextEnCours,'String','');

% --------------------------------------------------------------------
% DECOCHE LA CASE "TOUTES3 POUR LE CALCUL DES QUANTILES PARAMETRIQUES

function varargout = CBCLNormale_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLNormale.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLLognormale_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLLognormale.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLExpo_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLExpo.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLGamma_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLGamma.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLWeibull_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLWeibull.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLChi2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLChi2.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLStudent_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLStudent.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLPareto_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLPareto.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLGPD_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLGPD.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLUnif_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLUnif.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
function varargout = CBCLBeta_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLBeta.
set(handles.CBCLToutes,'Value',0);


% --------------------------------------------------------------------
% COCHE TOUTES LES LOIS

function varargout = CBCLToutes_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCLToutes.
set(handles.CBCLNormale,'Value',1);
set(handles.CBCLLognormale,'Value',1);
set(handles.CBCLExpo,'Value',1);
set(handles.CBCLGamma,'Value',1);
set(handles.CBCLWeibull,'Value',1);
set(handles.CBCLChi2,'Value',1);
set(handles.CBCLStudent,'Value',1);
set(handles.CBCLPareto,'Value',1);
set(handles.CBCLGPD,'Value',1);
set(handles.CBCLUnif,'Value',1);
set(handles.CBCLBeta,'Value',1);
set(handles.CBCLToutes,'Value',1);

% --------------------------------------------------------------------
% CLICK SUR LE BOUTON OK DE LA FRAME CHOIX DES LOIS

function varargout = BtCLOK_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtCLOK.

% frame choix des lois invisible
FrameChoixLoisInvisible(handles);

% lois de nouveau activees
set(handles.CBCLNormale,'Enable','on');
set(handles.CBCLLognormale,'Enable','on');
set(handles.CBCLExpo,'Enable','on');
set(handles.CBCLWeibull,'Enable','on');
set(handles.CBCLGamma,'Enable','on');
set(handles.CBCLChi2,'Enable','on');
set(handles.CBCLStudent,'Enable','on');
set(handles.CBCLPareto,'Enable','on');
set(handles.CBCLGPD,'Enable','on');
set(handles.CBCLUnif,'Enable','on');
set(handles.CBCLBeta,'Enable','on');
set(handles.CBCLToutes,'Enable','on');


% --------------------------------------------------------------------
% CLICK SUR LE BOUTON SELECTION DES MODELES

function varargout = BtChoixLoisTests_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtChoixLoisTests.

% affichage de la frame choix des lois
FrameChoixLoisVisible(handles);


% --------------------------------------------------------------------
% CLICK SUR LE BOUTON SELECTION DES MODELES (GPD)

function varargout = BtSelectLoisGPD_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtSelectLoisGPD.

if handles.Tache == 16 | handles.Tache == 17 | handles.Tache == 18 | handles.Tache == 19 | handles.Tache == 20 | handles.Tache == 21 | handles.Tache == 22 | handles.Tache == 23 | handles.Tache == 24
    set(handles.CBCLNormale,'Enable','on');
    set(handles.CBCLLognormale,'Enable','on');
    set(handles.CBCLExpo,'Enable','on');
    set(handles.CBCLWeibull,'Enable','on');
    set(handles.CBCLGamma,'Enable','on');
    set(handles.CBCLChi2,'Enable','off');
    set(handles.CBCLStudent,'Enable','off');
    set(handles.CBCLPareto,'Enable','off');
    set(handles.CBCLGPD,'Enable','off');
    set(handles.CBCLUnif,'Enable','off');
    set(handles.CBCLBeta,'Enable','off');
    set(handles.CBCLToutes,'Enable','off');
else
    set(handles.CBCLNormale,'Enable','on');
    set(handles.CBCLLognormale,'Enable','on');
    set(handles.CBCLExpo,'Enable','on');
    set(handles.CBCLWeibull,'Enable','on');
    set(handles.CBCLGamma,'Enable','on');
    set(handles.CBCLChi2,'Enable','on');
    set(handles.CBCLStudent,'Enable','on');
    set(handles.CBCLPareto,'Enable','on');
    set(handles.CBCLGPD,'Enable','on');
    set(handles.CBCLUnif,'Enable','on');
    set(handles.CBCLBeta,'Enable','on');
    set(handles.CBCLToutes,'Enable','on');
end
    
% affichage de la frame choix des lois
FrameChoixLoisVisible(handles);

% --------------------------------------------------------------------
% CLICK SUR LE BOUTON SELECTION DES MODELES

function varargout = BtSelectMethode_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtSelectMethode.

% affichage de la frame des methodes
FrameMethodesVisible(handles);

% --------------------------------------------------------------------
function varargout = CBCMHW_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCMHW.
disp('CBCMHW Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = CBCMEMV_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCMEMV.
disp('CBCMEMV Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = CBCMHill_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCMHill.
disp('CBCMHill Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = CBCMHillG_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCMHillG.
disp('CBCMHillG Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = CBCMZipf_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CBCMZipf.
disp('CBCMZipf Callback not implemented yet.')


% --------------------------------------------------------------------
% CLICK SUR LE BOUTON OK DE LA FRAME CHOIX DES METHODES

function varargout = BtCMOK_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BtCMOK.

% invisibilite de la frame des methodes
FrameMethodesInvisible(handles);

% --------------------------------------------------------------------
function varargout = UserGuide_Callback(h, eventdata, handles, varargin)
unix(['konqueror ' handles.Aide]);

function varargout = MenuAide_Callback(h, eventdata, handles, varargin)


% --------------------------------------------------------------------
function MenuLangue_Callback(hObject, eventdata, handles)
% hObject    handle to MenuLangue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function MenuLangueFr_Callback(hObject, eventdata, handles)

% si anglais
if handles.langue == 2
    % chargement du fichier MenuFr.txt
    ChargeMenus(handles,handles.CheminLangueFr);
    
    % changement de langue
    handles.langue = 1;
    
    % recuperation de la liste des actions
    ListeAction = get(handles.PopupAction,'String');
    if ~isempty(ListeAction)
        ListeAction = cellstr(ListeAction);
        
        % construction de la nouvelle liste en franeais
        ListeConvertie = [];
        for i=1:size(ListeAction,1)
            ActionTemp = ConvertAction(char(ListeAction(i)),1);
            ListeConvertie = strvcat(ListeConvertie,ActionTemp); 
        end
        ListeConvertie = cellstr(ListeConvertie);
        
        % affectation de la nouvelle liste dans la popup action
        set(handles.PopupAction,'String',ListeConvertie);
        
        % Inversion de la liste
        ListeConvertie = flipud(ListeConvertie);
        
        % Lit l'espace de travail dans lequel on se trouve
        Rep = LitRepEDT(handles);
        
        % destruction de l'ancien fichier des actions, puis sauvegarde du
        % nouveau
        FichierAction = [Rep '/' 'Action.txt'];
        delete(FichierAction);
        fid = fopen(FichierAction,'a');
        for i=1:size(ListeConvertie,1)
            fprintf(fid,'%s\n',char(ListeConvertie(i)));
        end
        fclose(fid)    
        
        % message pour rafraichir l'ecarn
        warndlg('Please clic on the last action to refresh the screen','Warning !','modal');
    end
    
    % actualisation des menus
    set(handles.MenuLangueFr,'Checked','on');
    set(handles.MenuLangueEn,'Checked','off');
    
    % sauvegarde dans le fichier langue.txt
    fid = fopen(handles.CheminLangue,'w');
    fprintf(fid,'%d',1);
    fclose(fid);
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
end


% --------------------------------------------------------------------
function MenuLangueEn_Callback(hObject, eventdata, handles)

% si franeais
if handles.langue == 1
    % chargement du fichier MenuFr.txt
    ChargeMenus(handles,handles.CheminLangueEn);
    
    % changement de langue
    handles.langue = 2;
    
    % recuperation de la liste des actions
    ListeAction = get(handles.PopupAction,'String');
    if ~isempty(ListeAction)
        ListeAction = cellstr(ListeAction);
        
        % construction de la nouvelle liste en anglais
        ListeConvertie = [];
        for i=1:size(ListeAction,1)
            ActionTemp = ConvertAction(char(ListeAction(i)),2);
            ListeConvertie = strvcat(ListeConvertie,ActionTemp); 
        end
        ListeConvertie = cellstr(ListeConvertie);
        
        % affectation de la nouvelle liste dans la popup action
        set(handles.PopupAction,'String',ListeConvertie);
        
        % Inversion de la liste
        ListeConvertie = flipud(ListeConvertie);
        
        % Lit l'espace de travail dans lequel on se trouve
        Rep = LitRepEDT(handles);
        
        % destruction de l'ancien fichier des actions, puis sauvegarde du
        % nouveau
        FichierAction = [Rep '/' 'Action.txt'];
        delete(FichierAction);
        fid = fopen(FichierAction,'a');
        for i=1:size(ListeConvertie,1)
            fprintf(fid,'%s\n',char(ListeConvertie(i)));
        end
        fclose(fid)    
        
        % message pour rafraichir l'ecarn
        warndlg('Please clic on the last action to refresh the screen','Warning !','modal');
    end
    
    % actualisation des menus
    set(handles.MenuLangueFr,'Checked','off');
    set(handles.MenuLangueEn,'Checked','on');
    
    % sauvegarde dans le fichier langue.txt
    fid = fopen(handles.CheminLangue,'w');
    fprintf(fid,'%d',2);
    fclose(fid);
    
    % Sauvegarde des variables
    guidata(handles.Extremes,handles);
end

